C ---- originally obtained from Emily Maverick 15-08-98
C
C  compilation ftn77 thma14 /intl/dreal/link/silent/save/zeroise
C
C  CHANGES made to allow compilation using Salford Software FTN77
C  1. removed ENCODE statements, replaced with corresponding write
C     statements
C  2. FORMAT 18 in routine OTHR modified (count of Hollerith constants
C     (30) incorrect as given because blanks up to column 72 count as
C     extra constants)
C  3. declare the elements in common /INOUTC/ as character in routine
C     INTERP
C  4. added variable SYML(3) to end of common /SYM/ in routine STAS and
C     variable INEGL to end of common /NEW/ in routine TRAN14 to ensure
C     these common blocks have the same size in all routines
C  5. Change to routine NFREQ (sent by E.M. 11-09-98) implemented
C  6. Changes sent by E.M 03-10-98 implemented
C  7. common LOCC split up because variables are real/character
C  8. variable MULT declared as real in all subroutines with common ATPAR
C  9. Changes sent by E.M. 03-11-98 implemented.

C CHANGES to allow operation under MS-DOS
C  1. change unit numbers for input files - see cljf-units
C  2. add new routines openf,openf1 to explicity open required files
C  3. replaced all carriage control writes 1H0 1H+ with ' '
C  4. replaced carriage control 1H1 with write char(12) see cljf-char12
C  5. routines added to read command line

      PROGRAM THMA14c
C *** Version of March 11, 1999
C *** Modified version of THMA14 of 6.V.96, solving for ARG params in CCS
C *** Modification 10/29/98, PC-required changes for double precision
C *** include MULT declared real in all subroutines with common/atpar
C *** and breaking up common/locc into two parts
C *** Modified by EFM 9/1, 9/10/98, first to make PC-required changes
C *** (Louis Farrugia) and then to correct index in subroutine NFREQ
C *** then 9/21/98 to correct the same index in subroutine DISCOR
C *** NFREQ and DISCOR altered again 10/27/98 for case of icorl.lt.0
C *** DERNON altered 10/27/98 for the case icorl.lt.0
C *** further modifications by EFM 9/25/98 in subroutine OUTP entry OUTP15
C *** HEADING in OTHR (Call from ANGLES)(format 19) EFM 9/28/98
C *** EFM 9/29/98 changed SUBROUTINE XASIGN to include atoms with
C *** negative weights in the list of atoms excluded from the analysis
C *** note 'old input' atoms must have weights other than 0, neg, 800,
C *** 999.9 if IBYP NE 0, because assignment of atomic weights bypassed
C *** SUBROUTINE XASIGN changed by EFM 12/10/98; variable after DO 3520
C *** changed from j to ii
C *** EFM skipped isotropic atoms 1/4/99. 311/99 in XASIGN
C *** SUBROUTINE INTERP corrected per Charles Ross, 1/11/99
C *** Headings added 9/30/98 by EFM in MAIN before CALL OUTR2
C *** Also cannot use IRECA NE 0, if value of IBYP is changed from 
C *** that in first run with same structure
C ***   Will handle "OLD input" as well as NEW input

C      ***************************************************************
C      *   TYPICAL JCL FOR  XX.COM  FILE for NEW input               *
C      *                                                             *
C      *         $SET NOVERIFY					     *
C      *         $ASS/U   STRUC1.PAR FOR001                          *
C      *         $ASS/U   STRUC1.ESD FOR002                          *
C      *     (UNITS FOR further structures OPTIONAL)                 *
C      *        ($ASS/U   STRUC2.PAR FOR003)			     *
C      *        ($ASS/U   STRUC2.ESD FOR004)			     *
C      *        ($ASS/U   STRUC3.PAR FOR009)			     *
C      *        ($ASS/U   STRUC3.ESD FOR010)			     *
C      *         $RUN [TRUEBLOOD]thma14                              *
C      *          TITL    (these three lines must be present for     *
C      *          CELL      "NEW INPUT".  Others are optional.       *
C      *          END       See instructions.)                       *
C      *         $EXIT                                               *
C      ***************************************************************
      CHARACTER DAT*10, TIM*8
      COMMON//AIDX(3000)
      COMMON/AMPCLN/NVIB,ICSVIB,NVAT1(40),NVAT2(40),
     1 NCSVIB(10), DCOS(10,3)
      COMMON/AMPCLC/VBAT1(40),VBAT2(40),CSATNM(10,12)
      CHARACTER*4 CSATNM,VBAT1,VBAT2
      COMMON/AIDPAR/AX(150,3),AUOBS(150,6),AUCALC(150,6),WU(150,6),
     1  WU1(150,6)
      COMMON/AMAT/AN(80,80)
      COMMON/ATPAR/X(150,3),WT(150),MULT(150),UOBS(150,6),SIGU(150,6),UC
     1ALC(150,6),NUORB(150),SIGB(150,6)
      COMMON/CELLP/CD(12),RCD(12),VOL,VST,GST(3,3)
      COMMON /CONT1/ISET,NO,NMULT,NA,ICOUNT,NINPAR,NPARS,NINOBS,NANG,NTO
     1T,NPULT,NA1,IFU,IB,NONRIG,NS,ISIG,ISYM,ICORL,IFU1,N8,
     2 IEIG, IMAT, IOUT, IRECAL, IFREQ
      COMMON/CONT2/NP1,NNP1,IORIG,IWU,INOPAR
      COMMON/CONT3/ISOLV,NTOTS,CONSLV,SUMW,RWUDI,RMS,RMU,gof,sumsig,
     1  iscm,msd8
      COMMON/FORM/IFMX,IFMB, ILIST
C     COMMON/FORMC/ FMTX(18), FMTB(18)
      COMMON/IAID1/ IAIDX1(1000)
      COMMON/INOUTN/ NPAGE, KOUTP,  DIS, IAW
      COMMON/INOUTC/ NAME1, ATNAME(150),TISET(80),TITLE(80),ITBL(29),
     1 NAME2
      COMMON/IPAR/ NP(80)
      common/new/isigx,ETA, TK,I11, isigu,nafa(7),NONSY(7),AXMOM(7),
     1  NRBP(150),NCPD,NDAT,NESD, IBYP, IEXU, inegl
      COMMON/SYM/SYMOP(23,3,3),TMAT(3,3),RTMAT(3,3),EPSIJK(3,3,3),
     1 SYML(3)
      COMMON/TMCSIS/TCIC(3,3),TCIU(3,3),TCINVC(3,3),TCINVU(3,3),SCG(3),
     1 OMIN(3,3), TROI(3,3), oma(3,3)
      DIMENSION SIGP(80), FIRST(80)
      EQUIVALENCE (SIGP(1),AIDX(881))
      EQUIVALENCE (SUMSGU,AIDX(2486))
      EQUIVALENCE(IATEX,IAIDX1(500))
      EQUIVALENCE (IPAREX,IAIDX1(500)) 
      CHARACTER*4 NAME1, ATNAME, TITLE*1, TISET*1, ITBL*3, NAME2*5
      REAL   MULT
      DOUBLE PRECISION AN
      character FIRST*1
C
C *** PRESET IFU1 TO ZERO BEFORE FIRST RUN; IF TO CONTINUE WITH SAME
C ***    ATOMIC PARAMETERS, IT WILL THEN BE SET = IRECAL FOR ANY
C ***    GIVEN RUN AT END OF THAT RUN (SEE END OF MAIN PROGRAM)
      IFU1 = 0
C ***  PRESET NCPD,NDAT,NESD before first run; if 'another compound follows'
C ***   these quantities will be changed in RD14A3 and RD14A5 so that the 
C ***   parameters and esds of these compounds can be properly found
      NCPD = 0

C ---- cljf-units starting unit numbers changed from 1,2 to 11,12 
      NDAT = 11
      NESD = 12
C ---- cljf-new_call to openf1
      call cmdlin
      call openf1

    1 NPAGE = 0
      CALL DATE(DAT)
      CALL TIME(TIM)
      PRINT  101, DAT, TIM
  101 FORMAT(' THMA14c (FOR MS-DOS), VERSION OF March 11, 1999,'
     1,3X, '16:30 PST',8X,'RUN ON ',A10,' AT ',A8/
     2 15x,'ARG parameters now solved for in CCS. IBYP added for OLD 
     3 input, as well as NEW.') 
 9000 FORMAT(80A1)
 9001 format(I1)
      IWU = 0
      inegl = 0
      ISOLV = 0
      ILIST = 0
      I11 = 0
C ***  I11 will be changed to 1 if input is of the "OLD" style
      read(5,9000,end=999,err=999) FIRST
 9002 format(1x,80A1)
      print 9002, first
C ***  See if first four characters are TITL
      IF(FIRST(1).NE.'T'.OR.FIRST(2).NE.'I'.OR.FIRST(3).NE.'T'.
     1   OR.FIRST(4).NE.'L')  I11 = 1
      IF(I11.EQ.0) GO TO 103
C ***  OLD INPUT -- CHECK IF FIRST FOUR LETTERS ARE "FREE"
      IF(FIRST(1).NE.'F'.OR.FIRST(2).NE.'R'.OR.FIRST(3).NE.'E'.
     1   OR.FIRST(4).NE.'E')  GO TO 104
      ILIST = 1
  103 DO 8103 I = 1,4
      FIRST(I) = ' '
 8103 CONTINUE
C *** If FIRST FOUR CHARACTERS OF FIRST LINE WERE 'FREE' OR 'TITL', THEY
C ***   HAVE NOW BEEN CLEARED.  NOW EQUATE ALL OF 'FIRST' TO 'TITLE'
  104 DO 8104 I = 1,80
      TITLE(I) = FIRST(I)
 8104 CONTINUE
 9003 FORMAT(' ',10X,'USING "OLD FORMAT" INPUT')
 9004 FORMAT(' ',10X,'USING "NEW FORMAT" INPUT')
      IF(I11.EQ.0) PRINT 9004
      IF(I11.NE.0) PRINT 9003
      if(i11.eq.1) go to 106
C ***  IF I11 = 1, OLD INPUT, SO USE RDIN1; FOR NEW INPUT, USE RD14A1
      call rd14a1
      go to 107
  106 CALL RDIN1
  107 IF(IFU1.EQ.0)  CALL CELLDI
C     CALCULATE REAL AND RECIPROCAL CELL
      CALL OUTP12
C     PRINT CELL DIMENSIONS
      IF(I11.NE.0) CALL RDIN2
C     READ CONTROL LINE AND IF NECESSARY SYM.TRANSF.MATRICES TMAT, RTMAT
C ***   CONTROL VARIABLES FOR THMA14 READ IN RD14A1
C     		WITH SUBMITTED TITLE FOR SPECIAL SETTING
      if(i11.ne.0) CALL OUTP14
C     PRINT CONTROL LINE INFORMATION AND, IF SUBMITTED, TMAT AND RTMAT
      IF(NTOT.LE.150)  GO TO 20
      CALL OUTH13
C     TOO MANY ATOMS
      CALL EXIT
   20 IF(IB.EQ.0.OR.IB.EQ.1) GO TO 95
      IF(IB.EQ.4.OR.IB.EQ.8) GO TO 95
C        EXIT IF IB HAS VALUE OTHER THAN 0, 1, 4, OR 8.
   25 FORMAT(38H   IB VALUE OTHER THAN 0, 1, 4, OR 8.    )
      PRINT 25
      CALL EXIT
C     READ COORD.,AT.WEIGHTS, U(I,J) OR B(I,J),NUORB(I)
   95 IF(IFU1.EQ.0) THEN
C *** IF IFU1 NON-ZERO, THIS IS 2ND (OR LATER) RUN WITH SAME AT. PARAMS
       IF(I11.EQ.1) CALL RDIN3
       IF(I11.NE.1) CALL RD14A3
       DO 90 I = 1,NTOT
        IF(MULT(I).EQ.0.0) MULT(I) = 1.0
        MULT(I) = 1./MULT(I)
   90  CONTINUE
      ENDIF
      IF(IB.NE.8)  CALL CONVER
      IF(IFU1.EQ.0) THEN
C   WHEN IFU NON-ZERO, ATOMS ALREADY SORTED (2ND OR LATER RUN)
       CALL SORT
C     SORT ATOMS INTO SEQUENCE  POS.WT,ZERO WT,NEG.WT,WT 999.9
C     COUNT NUMBER OF INDEPENDENT OBSERVATIONS
       NINOBS = 0
       DO 10 J = 1,NA
        IF(NUORB(J).EQ.0)  NUORB(J) = 6
        IF(WT(J).EQ.800.0) NUORB(J) = 0
C   DUMMY ATOMS (WT = 800.) SHOULD NOT CONTRIBUTE TO CALC OF
C     NUMBER OF INDEP OBSERV.  ATOMS WITH WT 999.9 OR NEGATIVE
C     HAVE ALREADY BEEN PLACED AT END (NOT IN COUNT NA) BY 'SORT'.
        NINOBS = NINOBS + NUORB(J)
   10  CONTINUE
      ENDIF
      NSIG = IABS(ISIG)
      IF(IFU1.NE.0) GO TO 140
      if(i11.ne.0) then
        CALL OUTH6
        CALL OUTH8
        KOUTP = 1
        CALL OUTP15
C ***  PRINT COORD.,UOBS,WT
        ENDIF
      IF(I11.NE.0.AND.ISIG.EQ.0)  GO TO 140
      IF(I11.NE.0) CALL RDIN5
      IF(I11.EQ.0) THEN
        CALL OUTP22
        CALL OUTH6
        CALL OUTH8
        KOUTP = 1
        CALL OUTP15
        ENDIF
      IF(I11.EQ.0.AND.ISIGU.EQ.0) GO TO 140
      if(i11.eq.0) CALL RD14A5
      NSIG = IABS(ISIG)
C ***   Previous line appears duplicated; perhaps needed for old input here
C     READ SIGMA U'S, ATOMNAME IN SEQUENCE SIGU11,SIGU22,...SIGU23,ATNAM
C      THESE ASSUMED TO BE SIG(B) IF IB = 0 OR 1 ; converted in RDIN5
      CALL SORTSG(NSIG)
C ***   SORTSG   SORTS ESD'S INTO SAME ORDER AS THAT DONE BY   SORT
C ***     IT ALSO GENERATES SIGU(I,K) = 1.0 FOR ATOMS OF WEIGHT 800 
      IF(NTOT.GT.20) CALL OUTH6
C      NEW PAGE IF MORE THAN 20 ATOMS
      CALL OUTH21
      KOUTP = 2
      CALL OUTP17
      IF(ISIG.LE.0.AND.I11.NE.0)  GO TO 140
      IF(ISIGU.LE.0.AND.I11.EQ.0)  GO TO 140
C ***   IF ISIG NEGATIVE FOR OLD INPUT, OR ISIGU NEGATIVE FOR NEW INPUT,
C ***          INPUT WORKING WEIGHTS FOR ATOMS
  145 SUMSIG = 0.
      SUMSGU = 0.
C ***  SUMSIG IS SUM OF ALL ESD TERMS; SUMSGU IS SUM OF SQUARES
      ISEG = NA - N8
      NSIGU = 0
      DO 155 I = 1,ISEG
      DO 155 K = 1,6
      SUMSIG = SUMSIG + SIGB(I,K)
      IF(SIGB(I,K).EQ.0.)  NSIGU = NSIGU + 1
C ***   NSIGU IS TALLY OF NUMBER OF ESD's INPUT AS 0.0 FOR ATOMS
C ***     OTHER THAN THOSE WITH WEIGHT 800. (CORRECTION FOR THEM
C ***     IS MADE SEPARATELY.)  IT IS USED ONLY IN THIS MAIN ROUTINE
      SUMSGU = SUMSGU + SIGB(I,K)*SIGB(I,K)
  155 CONTINUE
      SUMSIG = SUMSIG/FLOAT(6*ISEG - NSIGU)
C     SUMSIG GIVES MEAN SIGMA U, USED FOR THE WU(I,K)
C     SUMSGU WILL BE USED TO CALCULATE THE MEAN STANDARD DEVIATION OF
C        THE U'S.
  140 CALL RDIN4
C ***    no need to distinguish RD14A and RDIN here
C     READ INPUT FOR ATTACHED RIGID GROUPS (IF ANY) OR FOR DESIRED
C          CORRECTIONS FOR RIDING, MINIMUM, UNCORRELD MOTION
C ***  FOR NEW INPUT, ANY ARG INPUT WILL HAVE BEEN READ IN RD14A1
      IF (NONRIG.EQ.0) GO TO 80
      CALL OUTP16
C     PRINT ARG INPUT
      CALL NRBPAR
C     PRODUCE LIST NRBP(150) OF ARGs in which each atom participates
      GO TO 100
   80 DO 85 I = 1,NTOT
      NRBP(I) = 0
   85 CONTINUE
  100 IF(IEXU.EQ.0.AND.NS.GE.0.AND.NONRIG.GT.2)  CALL OUTH6
      IF(I11.NE.0.AND.ISYM.NE.0) CALL RDIN6
C      ISYM .NE.0 MEANS ORIGIN DOES NOT LIE ON ALL SYMMETRY ELEMENTS SO
C          MUST READ IN COORDINATES OF A POINT THAT DOES.
C ***   no need to differentiate here between RD14A and RDIN
      IF(ICSVIB.NE.0.OR.NVIB.GT.0) CALL RDIN7
C      WHEN NVIB IS POSITIVE OR ICSVIB.NE.0, CALCULATION OF MEAN SQUARE
C        DISPLACEMENT AMPLITUDES FOR ATOMS IN CERTAIN DIRECTIONS WANTED.
      IF(IEXU.EQ.0.AND.NS.GE.0) CALL OUTP10
C     PRINT  NTOT, NA, NAH (= NUMBER OF ATOMS TO BE INTERPRETED ONLY)
C        THESE QUANTITIES ARE PRODUCED BY SUBROUTINE SORT
      IF(ISET.GT.5)  GO TO 105
      IF(IEXU.EQ.0.AND.NS.GE.0) CALL OUTH2
C     PRINT SETTING OF PRINCIPAL AXIS
      GO TO 115
  105 IF(IEXU.EQ.0.AND.NS.GE.0) CALL OUTH1
C     PRINT  TISET
  115 CALL SYMET     ! WHICH CALLS SYMPOS, WHICH CALLS SGTRAN
C     CALCULATE SET OF COORDINATES FOR THE COMPLETE MOLECULE IN THE
C         DESIRED SETTING OF THE PRINCIPAL AXIS
      IF(IATEX.EQ.-1)  GO TO 997
      CALL NPAR
C ***  NPAR EVENTUALLY CALLS ORTHO, AND INERT, WHICH CALLS SGTRAN
      IF(NS.GE.(-1).OR.NS.EQ.(-3)) CALL DIST(NTOTS)
      CALL WEIGHT(NSIG)
      IF (NO.EQ.1) GO TO 160
C     SET NRBP(I) FOR THE EXPANDED SET OF ATOMS
      NTOT1 = NTOT + 1
      J1 = 0
      DO 165 K = NTOT1,NTOTS
      J1 = J1 + 1
      NRBP(K) = NRBP(J1)
      IF(J1.EQ.NA)  J1 = 0
  165 CONTINUE
  160 IF(IEXU.EQ.1.OR.NS.LT.0) GO TO 125
      IF(ISIG.EQ.0)  GO TO 120
C     PRINT SIGU IF INPUT.  THESE ARE NOW SIGU AFTER TRANSFORMATION TO
C        CARTESIAN SYSTEM (BY  SGTRAN , CALLED BY  INERT ).
      IF(IWU.NE.1) CALL OUTP21
  120 KOUTP = 3
      IF(ISIG.EQ.0.OR.NTOT.GT.20) CALL OUTH6
      CALL OUTH28
      CALL OUTP17
C     PRINT WORKING WEIGHTS OF U'S USED IN THE SOLUTION OF THE SYSTEM
C         OF LINEAR EQUATIONS
  125 NP1 = 21
      IF(NPARS.EQ.0)  NP1 = 12
      IF(NONRIG.EQ.0) GO TO 110
C ***  Set NP(I) for parameters for all possible ARGs, assuming no SYM
  130 MMM = NP1 + 1
      Do 135 I = MMM,80 
      NP(I) = I
  135 CONTINUE
  110 CONTINUE
      IPAREX = 0
  190 IORIG = 1
  310 CALL SOLVE
C     SOLVE CALLS MANY SUBROUTINES , SETS UP SYSTEM OF NORMAL EQUATIONS
C        AND SOLVES IT.
      IF(IPAREX.NE.-1)  GO TO 200
      CALL OUTH22
C     NUMBER OF PARAMETERS EXCEEDS DIMENSION OF MATRIX OF EQUATIONS
      GO TO 997
  200 IF(NPARS.EQ.0) GO TO 206
      CALL STEST
C     TEST FOR SYMMETRICAL S-TENSOR, IF YES , IORIG = 0
  206 CALL CALCUS
C     CALCULATE U'S
C     PRINT L,T,S RESULTS IN CARTESIAN CRYSTAL FRAME.
      CALL OTHR3
      IF(NONRIG.EQ.0) GO TO 215
      CALL OUTR13
C ***  Subroutine TRAN14 transforms CCS results to each LOCAL system
      if(ICORL.GE.0) call TRAN14
  215 KOUTP = 2
      CALL OUTR1
      if(ibyp.eq.2) call origts
      CALL EIGVLT
C     DETERMINE EIGENVECTORS AND EIGENVALUES OF T- AND L-TENSOR
      CALL DISCOR
      NCOR = 0
      IF(NONRIG.NE.0.AND.IFREQ.NE.0) CALL NFREQ(NCOR)
C *** Subroutine NFREQ was called NRCOR in earlier versions (pre 1997)
C  NCOR GOVERNS PATH THROUGH NFREQ; LATER NFREQ USED TO GET FREQUENCIES
C     FOR OVERALL MOLECULAR LIBRATION (AFTER GET L IN INERTIAL SYSTEM),
C     USING THEN NCOR = 1
      NCOR = 1
  205 CALL CORMAT(NS)
C     CALCULATE CORRELATION MATRIX
  240 IF(IEXU.EQ.1.OR.NS.LT.0) GO TO 245
      CALL OUTH6
      CALL OTHR6
      KOUTP = 1
C     PRINT UOBS AND UCALC IN CARTESIAN CRYSTAL FRAME
      CALL OUTR4
C     PRINT RMS OF DELTA U'S
  245 PRINT 9005 
 9005 format ('0',10X,'Cartesian Crystal Frame')
      CALL OUTR2


      IF(NVIB.NE.0.OR.ICSVIB.NE.0) CALL VIBAMP
      IF(I11.NE.0.AND.ISIG.LE.0)  GO TO 235
      IF(I11.EQ.0.AND.ISIGU.LE.0)  GO TO 235
C     SUMSGU = SQRT(SUM OF INPUT SIGMA U'S SQUARED DIVIDED BY THE NUMBER
C         OF OBSERVATIONS WITH SIGMA U.NE.0, OMITTING THOSE FOR ATOMS
C         WITH WEIGHT 800.)
      ASIGU = FLOAT((NA-N8)*6 - NSIGU)
      SUMSGU = SQRT(SUMSGU/ASIGU)
C     PRINT MEAN STANDARD DEVIATION OF THE U OBSERVED
      CALL OUTR11
  235 CALL UCRYST
      IF(NANG.EQ.0) GO TO 255
C     TRANSFORMATION OF U'S FROM CARTESIAN FRAME TO CRYSTAL FRAME
      IF(NS.EQ.(-2).OR.NS.LT.(-3)) GO TO 254
C     PRINT U'S IN CRYSTAL SYSTEM
  250 CALL OUTH6
      CALL OTHR26
      KOUTP = 2
      CALL OUTR4
      MM=NA+NTOTS
      IF(MM.GT.150) GOTO 255
C     PRINT RMS OF DELTA U'S IN CRYSTAL SYSTEM
  254 PRINT 9006
 9006 FORMAT ('0',10X,'Crystal System')
      CALL OUTR2
  255 CALL INERT
C ***  when BYPASSING INERTIAL system, FOLLOWING CALCS DONE FOR CARTES
C ***     XTAL SYSTEM, NOT FOR INERTIAL (MOLECULAR) AXES
      CALL ATINT(NCOR)
C ***   AT THIS POINT NCOR IS 1 AND NOW CALLING ATINT FOR GETTING T,L,S
C ***       IN MOLECULAR AXIAL (INERTIAL) SYSTEM
C     RBM PARAMETERS IN THE INERTIAL SYSTEM AND, IF (IFU.NE.0),
C     INTERPRETATION OF THE INDIVIDUAL ATOMS' 'THERMAL' PARAMETERS
  258 CALL STAS
C     CALCULATE ALTERNATE SYSTEM OF INTERP, DISPLACED AXES SYSTEM
      IF(NPARS.EQ.0) GO TO 260
      IF(IORIG.EQ.0)  GO TO 260
C ***  don't call LFRAME if S = 0 or S symmetrical or one eigenvalue of
C ***    L was found to be zero or negative (in which case INEGL = 1)
      if(inegl.eq.0) CALL LFRAME
  260 IF(IEXU.EQ.0.AND.(NS.GT.(-2).OR.NS.EQ.(-3))) CALL ANGLES
  500 IF(NS.GE.0.OR.IOUT.NE.0) CALL LIBCOR
C     CALCULATE LIBRATION CORRECTION FOR ATOMIC COORDINATES IF NS IS NOT
C          NEGATIVE OR IF WANT CORRECTED PARAMETERS OUTPUT
C ***  SAVE IRECAL AS IFU1 (IF IRECAL.NE.0 IN THIS RUN, IFU1 BECOMES SO)
  997 IFU1 = IRECAL
      IF(NS.LT.(-2).OR.NS.GT.0.OR.IRECAL.NE.0)  GO TO 1
C ***  ANOTHER CYCLE WITH SAME PARAMS (IRECAL.NE.0) OR ANOTHER COMPOUND
C ***    FOLLOWS  (NS EITHER POSITIVE OR LESS THAN -2)
  999 CONTINUE
      STOP
      END
C
      SUBROUTINE ANGLES
C     CALCULATE ANGULAR RELATIONSHIPS
C **** this subroutine not changed, rather the format statement
C **** in OTHR16 called from OUTR8
C
      COMMON//AIDX(3000)
      COMMON/CELLP/CD(12),RCD(12),VOL,VST,G(3,3)
      COMMON /CONT1/ISET,NO,NMULT,NA,ICOUNT,NINPAR,NPARS,NINOBS,NANG,NTO
     1T,NPULT,NA1,IFU,IB,NONRIG,NS,ISIG,ISYM,ICORL,IFU1,N8,
     2 IEIG, IMAT, IOUT, IRECAL, IFREQ
      COMMON /CONT2/NP1,NNP1,IORIG,IWU,INOPAR
      common/new/isigx,ETA, TK,I11, isigu,nafa(7),NONSY(7),AXMOM(7),
     1  NRBP(150),NCPD,NDAT,NESD, IBYP, IEXU, inegl
      COMMON/TMCSIS/TCIC(3,3),TCIU(3,3),TCINVC(3,3),TCINVU(3,3),SCG(3),
     1 OMIN(3,3), TROI(3,3), oma(3,3)
      DIMENSION TNEWV(3,3),ATCIC(3,3),VLT(3,3),ALC(3,3),ATC(3,3)
      DIMENSION ALM(3,3),ATM(3,3),TTNEWV(3,3),COARG(5), VT(3,3)
      EQUIVALENCE(VLT(1,1),AIDX(2821)),(VT(1,1), AIDX(2651))
      EQUIVALENCE (TNEWV(1,1),AIDX(611))
      EQUIVALENCE (ATCIC(1,1),AIDX(621)),(ALC(1,1),AIDX(631))
      EQUIVALENCE (ATC(1,1),AIDX(641)),(ALM(1,1),AIDX(651))
      EQUIVALENCE (ATM(1,1),AIDX(661))
      EQUIVALENCE (COARG(1),AIDX(671)),(TTNEWV(1,1),AIDX(681))
C
      PIDIV = 3.14159265359/180.
      DO 5 I = 1,3
      DO 5 J = 1,3
      ATCIC(I,J) = TCIC(I,J)
    5 CONTINUE
      IF(NPARS.EQ.0) GO TO 40
      IF(IORIG.EQ.0) GO TO 40
C     IF NPARS = 0 OR IORIG = 0 THEN NOT THRU LFRAME SUBROUTINE SO
C        TNEWV UNDEFINED.  EIGENVECTORS OF T THEN UNCHANGED FROM ATINT.
      GO TO 30
   40 DO 50 I = 1,3
      DO 50 J = 1,3
      TNEWV(I,J) = VT(I,J)
   50 CONTINUE
   30 CALL TRAMA(TNEWV,TTNEWV)
      CALL DOUBLE(TTNEWV,TCIC,ATC)
      CALL DOUBLE(VLT,TCIC,ALC)
      DO 10 I = 1,3
      DO 10 J = 1,3
      COARG(1) = ATCIC(I,J)/CD(J)
      COARG(2) =   ALC(I,J)/CD(J)
      COARG(3) =   ATC(I,J)/CD(J)
      COARG(4) =   VLT(I,J)
      COARG(5)= TTNEWV(I,J)
      DO 20 K = 1,5
      IF(COARG(K).GT.1.0)  COARG(K) = 1.0
      IF(COARG(K).LT.-1.0)  COARG(K) = -1.0
   20 CONTINUE
      ATCIC(I,J) = ACOS(COARG(1))/PIDIV
      ALC(I,J)   = ACOS(COARG(2))/PIDIV
      ATC(I,J)   = ACOS(COARG(3))/PIDIV
      ALM(I,J)   = ACOS(COARG(4))/PIDIV
      ATM(I,J)   = ACOS(COARG(5))/PIDIV
   10 CONTINUE
      if(iexu.eq.1) return
C     PRINT RESULTS OF ANGLES
      CALL OUTH6
      IF(IBYP.EQ.0) CALL OTHR15
      CALL OUTR8
      CALL OTHR20
      RETURN
      END
      SUBROUTINE ARRVE(V,I,VH)
C
C     BUILDS VECTOR INTO AN ARRAY
      DIMENSION V(150,3), VH(3)
      DO 10 K = 1,3
      V(I,K) = VH(K)
   10 CONTINUE
      RETURN
      END
      SUBROUTINE ATINT(NCOR)
C         CALCULATE L, T, AND S IN INERTIAL FRAME AND, IF (IFU.GT.0),
C        "INTERPRETATION" OF VIBRATION TENSORS OF THE INDIVIDUAL ATOMS
C ***   OCT '92: when IBYP.NE.0, calcs here done in CARTES XTAL SYSTEM
      COMMON/AIDPAR/AX(150,3),AUOBS(150,6),AUCALC(150,6),WU(150,6),
     1  WU1(150,6)
      COMMON//AIDX(3000)
      COMMON/ATPAR/X(150,3),WT(150),MULT(150),UOBS(150,6),SIGU(150,6),
     1  UCALC(150,6),NUORB(150),SIGB(150,6)
      COMMON /CONT1/ISET,NO,NMULT,NA,ICOUNT,NINPAR,NPARS,NINOBS,NANG,NTO
     1T,NPULT,NA1,IFU,IB,NONRIG,NS,ISIG,ISYM,ICORL,IFU1,N8,
     2 IEIG, IMAT, IOUT, IRECAL, IFREQ
      COMMON/IAID1/ IAIDX1(1000)
      COMMON/INOUTN/ NPAGE, KOUTP,  DIS, IAW
      COMMON/INOUTC/ NAME1, ATNAME(150),TISET(80),TITLE(80),ITBL(29),
     1 NAME2
      common/new/isigx,ETA, TK,I11, isigu,nafa(7),NONSY(7),AXMOM(7),
     1  NRBP(150),NCPD,NDAT,NESD, IBYP, IEXU, inegl
      COMMON/TMCSIS/TCIC(3,3),TCIU(3,3),TCINVC(3,3),TCINVU(3,3),SCG(3),
     1 OMIN(3,3), TROI(3,3), oma(3,3)
C
      real mult
      DIMENSION AOL(3,3),AOT(3,3),AOC(3,3),P(80),PL(6),PT(6),AHS(3,3)
      DIMENSION VL(3,3), VT(3,3), AHL(3,3), AHT(3,3),TTROI(3,3),UH(3,3)
      DIMENSION AUO(3,3),AUC(3,3),VUO(3,3),VUC(3,3),SIGP(80)
      EQUIVALENCE(AUO(1,1),AIDX(2661)),(AUC(1,1),AIDX(2671))
      EQUIVALENCE(AHL(1,1),AIDX(2601)),(AHT(1,1),AIDX(2611))
      EQUIVALENCE(VL(1,1),AIDX(2641)),(VT(1,1),AIDX(2651))
      EQUIVALENCE (VUO(1,1),AIDX(2681)),(P(1),AIDX(801))
      EQUIVALENCE(VUC(1,1),AIDX(2691)),(PT(1),AIDX(2631))
      EQUIVALENCE (PL(1),AIDX(2621)),  (UH(1,1),AIDX(2490))
      EQUIVALENCE(AOC(1,1),AIDX(2701))
      EQUIVALENCE(AOL(1,1),AIDX(2711)),(AHS(1,1),AIDX(2781))
      EQUIVALENCE(AOT(1,1),AIDX(2721)),(SIGP(1),AIDX(881))
      CHARACTER*4 NAME1, ATNAME, TISET*1,TITLE*1, ITBL*3, NAME2*5
    1 FORMAT(1H ,48H *  E.S.D.'S NOT TRANSFORMED TO INERTIAL SYSTEM. ,/)
C
      DO 100  I = 1,6
      PL(I) = P(I)
      PT(I) = P(I+6)
  100 CONTINUE
C ***  when bypassing inertial system, have "interp" in Cartes Xtal Sys
C ***     because have set TROI and TTROI to unit matrices, so what is
C ***     thought to be transforming to inertial is just an identity
      CALL TRAMA(TROI,TTROI)
C          CONVERT ORIGINAL L,T,S TO INERTIAL SYSTEM, GIVING AHL,AHT,AHS
      CALL VMLT(PL,UH)
      CALL TRIPLE(TTROI,UH,TROI,AHL)
      CALL VMLT(PT,UH)
      CALL TRIPLE(TTROI,UH,TROI,AHT)
      IF(NPARS.EQ.0) GO TO 120
      M = 12
      DO 110 I = 1,3
      DO 110 K = 1,3
      M = M + 1
      UH(I,K) = P(M)
  110 CONTINUE
      CALL TRIPLE(TTROI,UH,TROI,AHS)
      M = 12
      DO 115 I = 1,3
      DO 115 J = 1,3
      M = M + 1
      P(M) = AHS(I,J)
  115 CONTINUE
  120 CALL MVLT(AHL,PL)
      CALL MVLT(AHT,PT)
      DO 125 I = 1,6
      K = I + 6
      P(I) = PL(I)
      P(K) = PT(I)
  125 CONTINUE
C         GET EIGENVALUES AND EIGENVECTORS OF L AND T IN AHL,VL AND AHT,
C         VT.  THE VECTORS, IN COLUMNS, ARE RELATIVE TO INERTIAL AXES.
      CALL EIGEN(AHL,VL,3)
      CALL EIGEN(AHT,VT,3)
      if(IBYP.NE.0) go to 131
      CALL OUTH6
      CALL OTHR1
      PRINT 1
      KOUTP = 1
      CALL OUTR1
      CALL OTHR2
  130 IF(IFREQ.LT.0) CALL NFREQ(NCOR)
  131 IF (IFU.EQ.0)  RETURN
      EPS = 0.1
      PIDIV = 3.14159265359/180.
      CALL OUTH6
      CALL OTHR9
      DO 10 I = 1,NTOT
      IF(WT(I).EQ.800.0.OR.UOBS(I,2).EQ.0.0) GO TO 10
C   SKIP DUMMY ATOMS WITH WEIGHT 800. AND ISOTROPIC ATOMS
      IM = MOD(I,2)
      CALL VEMA(AUOBS,AUO,I)
      CALL VEMA(AUCALC,AUC,I)
      CALL EIGEN(AUO,VUO,3)
      CALL EIGEN(AUC,VUC,3)
      DO 20 J = 1,3
      DO 20 J1= 1,3
      AOC(J,J1) = 0.
      AOL(J,J1) = 0.
      AOT(J,J1) = 0.
      DO 20 J2 = 1,3
      AOC(J,J1) = AOC(J,J1) + VUO(J2,J)*VUC(J2,J1)
      AOL(J,J1) = AOL(J,J1) + VUO(J2,J)*VL(J2,J1)
      AOT(J,J1) = AOT(J,J1) + VUO(J2,J)*VT(J2,J1)
   20 CONTINUE
      DO 24 J=1,3
      DO 24 J1=1,3
      IF(AOC(J,J1).GT.1.) GO TO 31
      IF(AOC(J,J1).LT.-1.) AOC(J,J1)=-1.
   21 IF(AOL(J,J1).GT.1.) GO TO 33
      IF(AOL(J,J1).LT.-1.) AOL(J,J1)=-1.
   22 IF(AOT(J,J1).GT.1.) GO TO 35
      IF(AOT(J,J1).LT.-1.) AOT(J,J1)=-1.
      GO TO 24
   31 AOC(J,J1)=1.
      GO TO 21
   33 AOL(J,J1)=1.
      GO TO 22
   35 AOT(J,J1)=1.
   24 CONTINUE
   23 DO 30 J = 1,3
      DO 30 J1= 1,3
      AOC(J,J1) = ACOS(AOC(J,J1))/PIDIV
      AOL(J,J1) = ACOS(AOL(J,J1))/PIDIV
      AOT(J,J1) = ACOS(AOT(J,J1))/PIDIV
   30 CONTINUE
      IAIDX1(1) = I
      CALL OUTR5
      DO 45 K = 1,2
      K1 = K+1
      DO 45 KI = K1,3
      EIDIV =  ABS(AUO(K,K) - AUO(KI,KI))/AUO(K,K)
      IF(EIDIV.LT.EPS)  GO TO 55
      EIDIV =  ABS(AUC(K,K) - AUC(KI,KI))/AUC(K,K)
      IF(EIDIV.LT.EPS)  GO TO 55
   45 CONTINUE
      GO TO 50
   55 CALL OTHR10
C     PRINT  TWO EIGENVALUES DIFFER LESS THAN 10 PER CENT,
C     ANGULAR RELATIONSHIP BETWEEN UOBS AND UCALC IS INACCURATE
   50 IF(IM.EQ.0)  GO TO 40
      GO TO 10
   40 IF(I.GE.NTOT)  RETURN
      CALL OUTH6
      CALL OTHR9
   10 CONTINUE
      RETURN
      END
      SUBROUTINE CALCUS
C
C     CALCULATE U'S AND SIGMAS IN CARTESIAN CRYSTAL SYSTEM
C ***   ADDED GOODNESS OF FIT ("GOF") 7.X.91
      COMMON/AIDPAR/AX(150,3),AUOBS(150,6),AUCALC(150,6),WU(150,6),
     1  WU1(150,6)
      COMMON/ATPAR/X(150,3),WT(150),MULT(150),UOBS(150,6),SIGU(150,6),UC
     1ALC(150,6),NUORB(150),SIGB(150,6)
      COMMON//AIDX(3000)
      COMMON/AMAT/AN(80,80)
      COMMON/AXESN/ISPAX(15),LT(5,15),LAT(5,15)
      COMMON/AXESC/LBAT(5,15)
      CHARACTER*4 LBAT
      COMMON /CONT1/ISET,NO,NMULT,NA,ICOUNT,NINPAR,NPARS,NINOBS,NANG,NTO
     1T,NPULT,NA1,IFU,IB,NONRIG,NS,ISIG,ISYM,ICORL,IFU1,N8,
     2 IEIG,IMAT, IOUT,IRECAL, IFREQ
      COMMON/CONT2/NP1,NNP1,IORIG,IWU,INOPAR
      COMMON/CONT3/ISOLV,NTOTS,CONSLV,SUMW,RWUDI,RMS,RMU,gof,sumsig,
     1  iscm,msd8
      COMMON/IAID1/ IAIDX1(1000)
      COMMON/INOUTC/ NAME1, ATNAME(150),TISET(80),TITLE(80),ITBL(29),
     1 NAME2
      common/new/isigx,ETA, TK,I11, isigu,nafa(7),NONSY(7),AXMOM(7),
     1  NRBP(150),NCPD,NDAT,NESD, IBYP, IEXU, inegl
      DIMENSION SIGP(80),AO(80),P(80),KAN(80)
      EQUIVALENCE (P(1),AIDX(801)),(SIGP(1),AIDX(881))
      EQUIVALENCE (AO(1),AIDX(1041)) , (KAN(1),AIDX(961))
      EQUIVALENCE (RWU,AIDX(2897))
      DOUBLE PRECISION  AN
      CHARACTER*4 NAME1,ATNAME,TISET*1,TITLE*1, ITBL*3, NAME2*5
C
      real mult
      IF(NONRIG.EQ.0) GO TO 110
      DO 100 I = 1,NONRIG
      DO 100 J = 1,5
      LAT(J,I) = LT(J,I)
  100 CONTINUE
C          THAT RESTORES ORIGINAL ATOM-NUMBERS FOR DEFINING ARG AXES
      CALL DERNOP
      call local(1)
  110 NHP1 = NP1 + 1
      sdu = 0.
      sdg = 0.
      SUM = 0.
      SUMOB = 0.
      SUMDI = 0.
      SUMOBDI = 0.
      WSUM = 0.
      DO 10 K = 1,NTOT
      CALL DERIVP(K)
      IF(NRBP(K).EQ.0)  GO TO 15
      CALL DERNP(K)
   15 DO 10 K1 = 1,6
      AUCALC(K,K1) = 0.
      IF(UOBS(K,2).EQ.0.0) GO TO 10
C ***    SKIP ISOTROPIC ATOMS
      CALL INTSET(K1,I,L)
      CALL DERIV(I,L)
      IF(NONRIG.EQ.0)  GO TO 20
      IF(NRBP(K).EQ.0)  GO TO 25
      CALL DERNON(K,I,L)
      GO TO 20
   25 DO 26 I = NHP1,NNP1
      AO(I) = 0.
   26 CONTINUE
   20 DO 30 J = 1,NNP1
      AUCALC(K,K1) = AUCALC(K,K1) + AO(J)*P(J)
   30 CONTINUE
      IF(WT(K).EQ.800.0.OR.WT(K).EQ.999.9.OR.WT(K).LT.0.0) GO TO 10
C  ATOMS WITH THESE WEIGHTS NOT TO BE INCLUDED IN CALCULATION OF
C    AGREEMENT MEASURES
      IF(K.GT.NA)  GO TO 10
      DELTU = (AUOBS(K,K1) - AUCALC(K,K1))*WU(K,K1)
      SUM = SUM + (DELTU*DELTU)
      SUMOB = SUMOB +    (AUOBS(K,K1)*WU(K,K1))**2
      WSUM = WSUM+WU(K,K1)*WU(K,K1)
      du = AUOBS(K,K1) - AUCALC(K,K1)
      sdu = sdu + du*du
      if(sigu(k,k1).eq.0.) go to 11
      sdg = sdg + (du/sigu(k,k1))**2
   11 IF(K1.GT.3) GO TO 10
      SUMDI = SUMDI + DELTU*DELTU
      SUMOBDI = SUMOBDI + (AUOBS(K,K1)*WU(K,K1))**2
   10 CONTINUE
      IF(NONRIG.EQ.0)  GO TO 35
      NINPAR = NINPAR + (NNP1 - NP1)
      CALL OUTP18
C     PRINT ADJUSTED NUMBER OF INDEPENDENT PARAMETERS
   35 IF(NINOBS.GT.NINPAR) GO TO 36
      NINOBS = NINPAR + 1
      PRINT 901
  901 FORMAT(' ','NINOBS EQUAL TO OR LESS THAN NINPAR.  ARBITRARILY SET
     1(NINOBS - NINPAR) = 1, TO PERMIT CONTINUING CALC.')
   36 SIG = (NMULT*SUM)/(NINOBS-NINPAR)
C ***  NMULT INSERTED IN PRECEDING LINE, 3.VI.84, BECAUSE SUM IS TAKEN
C ***    ONLY OVER UNIQUE ATOMS, WHILE MATRIX IS SUMMED (IN "SOLVE")
C ***    OVER ALL ATOMS (INCLUDING THOSE GENERATED BY SYMMETRY). IF
C ***    NMULT OMITTED, ESD'S ARE TOO SMALL BY SQUARE ROOT OF NMULT
C ***    WHEN CALCULATED FROM AN(I,I) IN LINE 8070 BELOW.  AN(I,I) IS
C ***    AT THIS POINT THE DIAGONAL ELEMENT OF THE INVERSE MATRIX
      IF(SUMOB.NE.0.) RWU = SQRT(SUM/SUMOB)
      IF(WSUM.NE.0.) RMU = SQRT(SUM/WSUM)
      IF(SUMOBDI.NE.0.) RWUDI = SQRT(SUMDI/SUMOBDI)
   45 DO 40 I = 1,NNP1
      SIGP(I) = SQRT(ABS(AN(I,I))*SIG)
   40 CONTINUE
      IF(IMAT.LT.100) GO TO 60
      PRINT 65
      PRINT 70, (J, SIGP(J), J = 1,NNP1)
   65 FORMAT(' ','ESDS OF THE PARAMETERS, IN ORDER (PRINTED BY SUBROUTIN
     1E CALCUS WHEN IMAT.GE.100)'/)
   70 FORMAT(1X,I5,5X,F15.8)
C     RMS OF THE DELTA U'S
C ***  6*(NA-N8) in next line changed to NINOBS, 10.X.91
   60 IF(WSUM.NE.0) RMS = SQRT(SIG*FLOAT(ninobs)/(NMULT*WSUM))
      if(isig.ne.0) gof = sqrt(sdg/(ninobs-ninpar))
      RETURN
      END
      SUBROUTINE CELLDI
C
C     CELLDI CALCULATES THE FULL SET OF THE REAL AND RECIPROCAL
C     CELLDIMENSIONS
C
      COMMON//AIDX(3000)
      COMMON/CELLP/CD(12),RCD(12),VOL,VST,G(3,3)
      COMMON /CONT1/ISET,NO,NMULT,NA,ICOUNT,NINPAR,NPARS,NINOBS,NANG,NTO
     1T,NPULT,NA1,IFU,IB,NONRIG,NS,ISIG,ISYM,ICORL,IFU1,N8,
     2 IEIG,IMAT, IOUT,IRECAL, IFREQ
      DIMENSION AH(3,3),DUM(3), RA(12), AHCD(12), GH(3,3)
      EQUIVALENCE (GH(1,1),AIDX(2416))
      EQUIVALENCE (AH(1,1),AIDX(801)),(DUM(1),AIDX(2401))
      DIMENSION GST(3,3)
      EQUIVALENCE (GST(1,1),AIDX(2891))
      EQUIVALENCE (RA(1),AIDX(1)), (AHCD(1),AIDX(2404))
C
C     CD(1) = A, CD(2) = B, CD(3) = C, CD(4) = ALPHA, CD(5) = BETA,
C     CD(6) = GAMMA, CD(7) = COS(ALPHA), CD(8) = COS(BETA),
C     CD(9) = COS(GAMMA), CD(10) = SIN(ALPHA), CD(11) = SIN(BETA)
C     CD(12) = SIN(GAMMA)
C     RCD(I)   ANALOGOUS FOR RECIPROCAL CELL DIMENSIONS
C
      RAD =  180./ 3.14159265359
      IF(CD(1).LT.1.)  GO TO 100
      IR = 1
      IF(CD(4).GT.1.)  GO TO 110
C     INPUT   REAL CELL WITH COSINES OF ANGLES
      DO 105 I = 4,6
      CD(I+3) = CD(I)
      CD(I) = ACOS(CD(I+3))
      CD(I+6) = SIN(CD(I))
  105 CD(I) = CD(I)*RAD
      GO TO 145
C     INPUT  REAL CELL WITH ANGLES
  110 DO 120 I = 4,6
      IF(CD(I).EQ.90.) GO TO 115
      IF(CD(I).EQ.120.) GO TO 117
      ANG = CD(I)/RAD
      CD(I+3) = COS(ANG)
      CD(I+6) = SIN(ANG)
      GO TO 120
  115 CD(I+3) = 0.
      CD(I+6) = 1.
      GO TO 120
  117 CD(I+3) = -.5
      CD(I+6)= 0.5*SQRT(3.)
  120 CONTINUE
      GO TO 145
  100 IR = 0
      DO 130 I = 1,3
  130 RCD(I) = CD(I)
      IF(CD(4).GT.1.)  GO TO 140
C     INPUT  RECIPROCAL CELL WITH COSINES OF ANGLES
      DO 135 I = 4,6
      RCD(I+3) = CD(I)
      RCD(I) = ACOS(RCD(I+3))
      RCD(I+6) = SIN(RCD(I))
  135 RCD(I) = RCD(I)*RAD
      GO TO 145
C     INPUT  RECIPROCAL CELL WITH ANGLES
  140 DO 142 I = 4,6
      RCD(I) = CD(I)
      IF(RCD(I).EQ.90) GO TO 143
      IF(RCD(I).EQ.60.) GO TO 144
      ANG = RCD(I)/RAD
      RCD(I+3) = COS(ANG)
      RCD(I+6) = SIN(ANG)
      GO TO 142
  143 RCD(I+3) = 0.
      RCD(I+6) = 1.
      GO TO 142
  144 RCD(I+3) = .5
      RCD(I+6) = .5*SQRT(3.)
  142 CONTINUE
  145 IF(IR.EQ.1)  GO TO 150
C     IR = 0, INPUT RECIPROCAL CELL
      DO 146 I = 1,12
  146 AHCD(I) = RCD(I)
  148 CALL GIK(GH,AHCD)
      DO 147 I = 1,3
      DO 147 K = 1,3
  147 AH(I,K) = GH(I,K)
      CALL MATINV(AH,3,3,0,DUM,DET)
      VH = SQRT(DET)
      DO 160 I = 1,3
      RA(I) = SQRT(AH(I,I))
  160 CONTINUE
      RA(7) = AH(2,3)/(RA(2)*RA(3))
      RA(8) = AH(1,3)/(RA(1)*RA(3))
      RA(9) = AH(1,2)/(RA(1)*RA(2))
      DO 149 I = 1,3
      RA(I+3) = ACOS(RA(I+6))
      RA(I+9) = SIN(RA(I+3))
      RA(I+3) = RA(I+3) * RAD
  149 CONTINUE
      IF(IR.EQ.1)  GO TO 190
      DO 180 I = 1,12
  180 CD(I) = RA(I)
      DO 182 I = 1,3
      DO 182 K = 1,3
      G(I,K) = AH(I,K)
      GST(I,K) = GH(I,K)
  182 CONTINUE
      VST = VH
      VOL = 1./VST
      GO TO 200
C     IR = 1, INPUT REAL CELL
  150 DO 152 I = 1,12
  152 AHCD(I) = CD(I)
      GO TO 148
  190 DO 192 I = 1,12
  192 RCD(I) = RA(I)
      DO 194 I = 1,3
      DO 194 K = 1,3
      G(I,K) = GH(I,K)
      GST(I,K) = AH(I,K)
  194 CONTINUE
      VOL = VH
      VST = 1./VOL
  200 EPS = 0.0005
      DO 205 I = 4,6
      ACD = ABS(CD(I) - 90.)
      IF(ACD.GT.EPS)  GO TO 210
  205 CONTINUE
      NANG = 0
C     NANG = 0, ALPHA=BETA=GAMMA=90 DEG.  ORTHOG.SYSTEM
      RETURN
  210 NANG = 1
      RETURN
      END
      SUBROUTINE CNTPAR
C
C     CALLED BY NPAR
C     COUNT NUMBER OF INDEPENDENT OBSERVATIONS AND PARAMETERS
C     NOW USED ONLY FOR POINT GROUPS CORRESPONDING TO MONOCLINIC AND
C         ORTHORHOMBIC SPACE GROUPS (NUMBERS 3, 6, 10, 16, 25, 47)
C
      COMMON /CONT1/ISET,NO,NMULT,NA,ICOUNT,NINPAR,NPARS,NINOBS,NANG,NTO
     1T,NPULT,NA1,IFU,IB,NONRIG,NS,ISIG,ISYM,ICORL,IFU1,N8,
     2 IEIG, IMAT,IOUT, IRECAL, IFREQ
      COMMON/IAID1/IAIDX1(1000)
      COMMON/IPAR/NP(80)
      DIMENSION NNP(9)
      EQUIVALENCE (NNP(1),IAIDX1(481))
C
      K = 0
      DO 100 I = 1,6
      IF(NP(I).EQ.0)  GO TO 100
      K = K + 1
      NNP(K) = NP(I)
  100 CONTINUE
      NPULT = K
      N = K - 1
      DO 110 I = 1,N
      NHP = IABS(NNP(I))
      IP1 = I + 1
      DO 105 K1 = IP1,K
      NKP = IABS(NNP(K1))
      IF(NHP.EQ.NKP)  NPULT = NPULT - 1
  105 CONTINUE
  110 CONTINUE
  115 NPARS = 0
      K = 0
      IF(NP(21).NE.0)  GO TO 120
C     COMPENSATE FOR SKIPPING ZERO'S IN THE DIAGONAL
      NPARS = NPARS + 1
  120 DO 130 I = 1,9
      IF(NP(I+12).EQ.0)  GO TO 130
      K = K + 1
      NNP(K) = NP(I+12)
  130 CONTINUE
      N = K - 1
      NPARS = NPARS + N
      IF(NPARS.EQ.0)  GO TO 145
      DO 140 I = 1,N
      NHP = IABS(NNP(I))
      IP1 = I + 1
      DO 150 K1 = IP1,K
      NKP = IABS(NNP(K1))
      IF(NHP.EQ.NKP)  NPARS = NPARS - 1
  150 CONTINUE
  140 CONTINUE
  145 NINPAR = NPULT * 2 + NPARS
      RETURN
      END
      SUBROUTINE CONVER
C
C     CONVERSION OF B INPUT TO U'S OR 'TYPE 4' U'S TO STANDARD U'S
C        (ORTEP 'TYPE 8' IS STANDARD)
C
      COMMON/ATPAR/X(150,3),WT(150),MULT(150),UOBS(150,6),SIGU(150,6),UC
     1ALC(150,6),NUORB(150),SIGB(150,6)
      COMMON//AIDX(3000)
      COMMON/CELLP/CD(12),RCD(12),VOL,VST,G(3,3)
      COMMON /CONT1/ISET,NO,NMULT,NA,ICOUNT,NINPAR,NPARS,NINOBS,NANG,NTO
     1T,NPULT,NA1,IFU,IB,NONRIG,NS,ISIG,ISYM,ICORL,IFU1,N8,
     2 IEIG,IMAT, IOUT,IRECAL, IFREQ
      DIMENSION B11(150),B22(150),B33(150),B12(150),B13(150),B23(150)
      EQUIVALENCE (B11(1),AIDX(1)),(B22(1),AIDX(201))
      EQUIVALENCE (B33(1),AIDX(401)),(B12(1),AIDX(601))
      EQUIVALENCE (B13(1),AIDX(801)),(B23(1),AIDX(1001))
      real mult
C
      TWPISQ = 19.7392088
      IF(IB.EQ.4) GO TO 30
      DO 10 I = 1,NTOT
      UOBS(I,1) = B11(I)*1./(TWPISQ*RCD(1)*RCD(1))
      UOBS(I,2) = B22(I)*1./(TWPISQ*RCD(2)*RCD(2))
      UOBS(I,3) = B33(I)*1./(TWPISQ*RCD(3)*RCD(3))
      UOBS(I,4) = B12(I)*0.5/(TWPISQ*RCD(1)*RCD(2))
      UOBS(I,5) = B13(I)*0.5/(TWPISQ*RCD(1)*RCD(3))
      UOBS(I,6) = B23(I)*0.5/(TWPISQ*RCD(2)*RCD(3))
   10 CONTINUE
      IF(IB.NE.0) RETURN
C          IB.EQ.0 IMPLIES EXPLICIT FACTOR OF 2 IN DEFINITION OF THE
C         OFF-DIAGONAL ELEMENTS OF B
      DO 20 I = 1,NTOT
      UOBS(I,4) = 2.0*UOBS(I,4)
      UOBS(I,5) = 2.0*UOBS(I,5)
      UOBS(I,6) = 2.0*UOBS(I,6)
   20 CONTINUE
      RETURN
   30 FAC = 1.0/(4.0*TWPISQ)
      DO 40 I = 1,NTOT
      DO 40 J = 1,6
      UOBS(I,J) = FAC*UOBS(I,J)
   40 CONTINUE
      RETURN
      END
      SUBROUTINE CORMAT(NS)
C
C     CALCULATE CORRELATION MATRIX
C
      COMMON//AIDX(3000)
      COMMON/AMAT/AN(80,80)
      COMMON/CONT2/NP1,NNP1,IORIG,IWU,INOPAR
      common/new/isigx,ETA, TK,I11, isigu,nafa(7),NONSY(7),AXMOM(7),
     1  NRBP(150),NCPD,NDAT,NESD, IBYP, IEXU, inegl
      DIMENSION  DIAG(80)
      EQUIVALENCE (DIAG(1),AIDX(1141))
      DOUBLE PRECISION  AN
C
      DO 10 I = 1,NNP1
      DIAG(I) = SQRT(ABS(AN(I,I)))
   10 CONTINUE
      DO 20 I = 1,NNP1
      DO 20 J = 1,NNP1
      IF (DIAG(I).EQ.0.0) GO TO 30
      IF (DIAG(J).EQ.0.0) GO TO 30
C         IF FOR THE ITH  PARAMETER AN(I,I) HAS BEEN SET TO 0.0 BY SOLVE
C             BECAUSE THIS PARAMETER IS IDENTICALLY ZERO, SET ALL ITS
C             CORRELATION COEFFICIENTS TO ZERO.
      AN(I,J) = AN(I,J)/(DIAG(I)*DIAG(J))
      GO TO 20
   30 AN(I,J) = 0.0
   20 CONTINUE
C          IF(NS.EQ.(-2).OR.NS.EQ.(-4)) RETURN
      CALL OUTH6
      CALL OTHR11
      CALL OUTR6
      RETURN
      END
      SUBROUTINE DERIV(I,L)
C
C     CALCULATES DERIVATIVES
C
      COMMON//AIDX(3000)
      COMMON /CONT1/ISET,NO,NMULT,NA,ICOUNT,NINPAR,NPARS,NINOBS,NANG,NTO
     1T,NPULT,NA1,IFU,IB,NONRIG,NS,ISIG,ISYM,ICORL,IFU1,N8,
     2 IEIG,IMAT, IOUT,IRECAL, IFREQ
      COMMON/SYM/SYMOP(23,3,3),TMAT(3,3),RTMAT(3,3),EPSIJK(3,3,3),
     1 SYML(3)
      DIMENSION R(3,3), GILJM(3,3), A(3,3), B(3,3), AO(80)
      EQUIVALENCE(R(1,1),AIDX(2901)),(A(1,1),AIDX(2911))
      EQUIVALENCE(B(1,1),AIDX(2921)),(GILJM(1,1),AIDX(2931))
      EQUIVALENCE (AO(1),AIDX(1041))
C
      J1 = 0
      DO 30 J = 1,3
      DO 30 M = 1,3
      GILJM(J,M) = R(I,J)*R(L,M)
   30 CONTINUE
      DO 40 J = 1,3
      DO 40 M = J,3
      IF(J.EQ.M)  GO TO 45
      J1 = J1 + 1
      AO(J1) = GILJM(J,M) + GILJM(M,J)
      GO TO 40
   45 J1 = J1 + 1
      AO(J1) = GILJM(J,M)
   40 CONTINUE
C     U(N,NU) = U(I,L) OF ATOM N
C     AO(1) TO AO(6)  CONTAIN dU(N,NU)/dL(1,1) TO dU(N,NU)/dL(3,3)
C     AO(7) TO AO(12) CONTAIN dU(N,NU)/dT(1,1) TO dU(N,NU)/dT(3,3)
C     AO(13)TO AO(21) CONTAIN dU(N,NU)/dS(1,1) TO dU(N,NU)/dS(3,3)
C     THE PARAMETERS ARE IN SEQUENCE
C     L11,L12,L13,L22,L23,L33,T11,T12,T13,T22,T23,T33,S11,S12,S13,S21,
C     S22,S23,S31,S32,S33
      DO 50 J = 1,3
      DO 50 M = J,3
      J1 = J1 + 1
      AO(J1) = SYMOP(1,I,J)*SYMOP(1,L,M)
   50 CONTINUE
      IF(NPARS.EQ.0)  RETURN
      DO 70 J = 1,3
      DO 70 M = 1,3
C   R(I,J) COME FROM SUBROUTINE DERIVP
      A(J,M) = R(I,J)*SYMOP(1,L,M)
      B(M,J) = R(L,M)*SYMOP(1,I,J)
   70 CONTINUE
      DO 80 J = 1,3
      DO 80 M = 1,3
      J1 = J1 + 1
      AO(J1) = A(J,M) + B(J,M)
   80 CONTINUE
      RETURN
      END
      SUBROUTINE DERIVP(N)
C
C     CALCULATE R MATRIX
C
      COMMON/AIDPAR/AX(150,3),AUOBS(150,6),AUCALC(150,6),WU(150,6),
     1  WU1(150,6)
      COMMON//AIDX(3000)
      COMMON/CONT2/NP1,NNP1,IORIG,IWU,INOPAR
      COMMON/SYM/SYMOP(23,3,3),TMAT(3,3),RTMAT(3,3),EPSIJK(3,3,3),
     1 SYML(3)
      DIMENSION R(3,3),AXX(150,3)
      EQUIVALENCE(R(1,1),AIDX(2901))
      EQUIVALENCE(AXX(1,1),AIDX(1))
C
      DO 10 IH = 1,3
      DO 10 J  = 1,3
      R(IH,J) = 0.
      DO 12 K = 1,3
      R(IH,J) = R(IH,J) + EPSIJK(IH,J,K) * AX(N,K)
   12 CONTINUE
   10 CONTINUE
      RETURN
      END
C
      subroutine dernon(n,i,l)
C ***  modified version (17/18.II.97) to solve in CCS
C  CALLED BY SOLVE OR CALCUS WHENEVER ATOM N IS AN "AFFECTED ATOM" OF
C            SOME ATTACHED RIGID GROUP (ARG; FORMERLY "NON-RIGID GROUP")
C     CALCULATE DERIVATIVES FOR ARG PARAMETERS
C
      COMMON/AIDPAR/AX(150,3),AUOBS(150,6),AUCALC(150,6),WU(150,6),
     1  WU1(150,6)
      COMMON//AIDX(3000)
      COMMON/CONT1/ISET,NO,NMULT,NA,ICOUNT,NINPAR,NPARS,NINOBS,NANG,NTOT
     1,NPULT,NA1,IFU,IB,NONRIG,NS,ISIG,ISYM,ICORL,IFU1,N8,
     2 IEIG,IMAT, IOUT, IRECAL, IFREQ
      COMMON/CONT2/NP1,NNP1,IORIG,IWU,INOPAR
      COMMON/IAID1/ IAIDX1(1000)
      COMMON/INOUTN/ NPAGE, KOUTP,  DIS, IAW
      COMMON/INOUTC/ NAME1, ATNAME(150),TISET(80),TITLE(80),ITBL(29),
     1 NAME2
      COMMON/LOCC/ATNX(7,2)
      common/locc_/BLLARG(7)
      COMMON/LOC/ VAF(7,3), PVEC(7,3), V5(7,3), VEC1(7,3)
      common/new/isigx,ETA, TK,I11, isigu,nafa(7),NONSY(7),AXMOM(7),
     1  NRBP(150),NCPD,NDAT,NESD, IBYP, IEXU, inegl
      DIMENSION AO(80),IZ(5),IPAIR(7,7) 
      EQUIVALENCE (IZ(1),IAIDX1(801)),(IPAIR(1,1),AIDX(1701))
      EQUIVALENCE (AO(1),AIDX(1041)), (IAIDX1(1000),IGN)
      CHARACTER*4 ATNX,NAME1, ATNAME,TISET*1, TITLE*1,ITBL*3, NAME2*5
C
      NHP1 = NP1 + 1
C ***   NP1 = 12 (IF PT GROUP IS CENTROSYMMETRIC) OR 21
      J1 = 0
      NN = NRBP(N)
      DO 5 J = 1,5
      IH = NN/16
      IZ(J) = NN - 16*IH
      IF(IZ(J).EQ.0)  GO TO 10
      NN = IH
      J1 = J1 + 1
    5 CONTINUE
C ***   DERNON NOT EVEN CALLED UNLESS ATOM IS IN AT LEAST ONE N-R GROUP
C ***  J1 = NO OF NON RIGID GROUPS THIS ATOM IS IN
C ***  IZ(I) [FOR I = 1,J1] ARE SERIAL NOS OF N-R GROUPS THIS ATOM IS IN
C ***   NNP1 = TOTAL NUMBER OF PARAMETERS (SET IN SOLVE)
C ***
C ***  UNIT VECTORS FOR LOCAL AXIAL SYSTEM FOR EACH GROUP, I, WILL BE:
C ***     VEC1(I,J)   VECTOR PARALLEL TO LIBRATION AXIS
C ***     VAF(I,J)   VECTOR PARALLEL TO MOTION OF 1ST AFFECTED ATOM
C ***     PVEC(I,J)   UNIT VECTOR NORMAL TO FIRST TWO
C ***   VEC1 COMES FROM SUBR DERNOP, THE OTHER TWO FROM SUBR LOCAL
   10 DO 15 I1 = NHP1,NNP1
      AO(I1) = 0.
   15 CONTINUE
      DO 20 K = 1,J1
C   IGN SET = M BY DERNP IF ATOM N IN NR GROUP M LIES ON AXIS OF
C     THIS GROUP ALTHOUGH SAID TO BE AFFECTED BY THE MOTION
      M = IZ(K)
C ***  SKIP ATOM IF IT LIES ON AXIS OF GROUP (NOT AFFECTED BY MOTION)
      IF(IGN.EQ.M) GO TO 20
C *** If icorl.lt.0 indices go by m EFM 10/27/98
      if(icorl.lt.0) goto 19
      m1 = 1 + 7*(m-1)
C ***  m1 will now be 1, 8, 15, ..., so NP1 + M1 will be (eg) 22,29,36,..
C ***   the next line takes care of the torsional motion about the ARG
C ***   axis for each ARG in which this atom lies
      AO(NP1+M1) = V5(M,I)*V5(M,L)
      goto 20
   19 AO(NP1+M) = V5(M,I)*V5(M,L)
   20 CONTINUE
      IF(ICORL.LT.0.OR.(NAFA(M).LT.3.AND.NONSY(M).NE.0)) GO TO 76
C *** CALCULATE CORRELATION OF PHI AND OVERALL MOTION
C ***     (UNLESS ICORL.LT.0 OR ONLY ONE ATOM IN THE ARG, NOT ON A SYM ELEM)
      NNP2 = NP1 + NONRIG
      DO 75 MM = 1,J1
      M = IZ(MM)
C ***  M = SERIAL NUMBER OF ARG
      K = NP1 + 7*(M-1) + 2
C ***  THUS, in general case, with NP1 = 21, K = 23 when M = 1 (atom is in
C ***     first ARG), 30 when M = 2, 37 when M = 3, ....
C ***    FOR EACH GROUP, the next three parameters are correln of PHI and
C ***      LAMBDA along the three CCS axes (in order), and the last 
C ***      three are for PHI and TRANSL along the three CCS axes
C ***  K IS TALLY FOR PARAMETER NUMBER
C ***  J1 IS NO OF ARGS THE ATOM N IS IN
C ***  V5 COMES FROM SUBROUTINE DERNP, VIA COMMON/LOC/
      GO TO (30,40,50), I
   30 IF(I.NE.L) GO TO 34
C ***    THIS BRANCH FOR I = L = 1, THAT IS FOR U11 TERMS
      AO(K+1) = 2.0*AX(N,3)*V5(M,1) 
      AO(K+2) = - 2.0*AX(N,2)*V5(M,1)
      AO(K+3) = 2.0*V5(M,1)
      GO TO 75
   34 IF(L.EQ.3) GO TO 37
C ***   I = 1, L = 2
      ao(k) = -ax(n,3)*v5(m,1)
      AO(K+1) = AX(N,3)*V5(M,2)
      AO(K+2) =  AX(N,1)*V5(M,1) - AX(N,2)*V5(M,2)
      AO(K+3) =  V5(M,2) 
      AO(K+4) =  V5(M,1)
      GO TO 75
   37 ao(k) = AX(N,2)*V5(M,1) 
C ***  I = 1, L = 3
      AO(K+1) = AX(N,3)*V5(M,3) - AX(N,1)*V5(M,1)
      AO(K+2) = - AX(N,2)*V5(M,3) 
      AO(K+3) =  V5(M,3) 
      AO(K+5) =  V5(M,1)
      GO TO 75
   40 IF(L.EQ.3) GO TO 45
C ***   I = 2, L = 2
      ao(k) = -2.0*AX(N,3)*V5(M,2)
      AO(K+2) = 2.0*AX(N,1)*V5(M,2)
      AO(K+4) =  2.0*V5(M,2)
      GO TO 75
   45 ao(k) = AX(N,2)*V5(M,2) - AX(N,3)*V5(M,3)
C ***   I = 2, L = 3
      AO(K+1) =  - AX(N,1)*V5(M,2) 
      AO(K+2) =  AX(N,1)*V5(M,3)
      AO(K+4) =   V5(M,3) 
      AO(K+5) =   V5(M,2)
      GO TO 75
   50 ao(k) = 2.0*AX(N,2)*V5(M,3) 
C ***   I = 3, L = 3
      AO(K+1) =  -2.0*AX(N,1)*V5(M,3)
      AO(K+5) =  2.0*V5(M,3)
   75 CONTINUE
   76 CONTINUE
      IF(J1.LE.1.OR.ICORL.GE.0) RETURN
C ***  INTERGROUP CORRELN INDETERMINATE WITH OVERALL/INTERNAL CORRELN
C *** FOLLOWING IS FOR CORRELATIONS OF PHI FOR DIFFERENT NR GROUPS IN
C ***   WHICH ATOM N IS INCLUDED.  J1 = 2 OR 3 (MAX IS 3)
C ***  IPAIR CREATED IN "SOLVE"
      M2 = 0
C ***   M2 IS AN INDICATOR OF WHERE ONE IS IN THIS LOOP
      M = IZ(1)
      MM = IZ(2)
   85 KK = IPAIR(M,MM)
      IF(KK.NE.0) GO TO 90
      PRINT 200, ATNAME(N), N, M, MM
  200 FORMAT(' ','ERROR.  ATOM ',A4,' (NO.',I4,') SAID TO BE IN GROUPS',
     1 I3,' AND',I3,' BUT SOME ERROR IN SETTING UP IPAIR(I,J)')
      STOP
   90 AO(KK) = V5(M,I)*V5(MM,L) + V5(MM,I)*V5(M,L)
      IF(J1.EQ.2) RETURN
C ***  J1 = 3; THREE GROUPS COMMON TO ATOM N
      IF(M2.GE.1) GO TO 100
C ***  THIS PASS GIVES CROSS-TERMS BETW 1ST, 3RD GROUPS COMMON TO ATOM N
      M2 = M2 + 1
      MM = IZ(3)
      GO TO 85
  100 IF(M2.EQ.2) RETURN
      M = IZ(2)
C ***  THIS PASS GIVES CROSS-TERMS BETW 2ND, 3RD GROUPS COMMON TO ATOM N
      M2 = M2 + 1
      GO TO 85
      END
C
      SUBROUTINE DERNOP
C
C     CALLED BY SOLVE WHENEVER ARGs ARE PRESENT
C         ALSO CALLED BY CALCUS
C     CALCULATE LIBRATION AXIS FOR EACH ARG, VECTORS VEC1(I,K)
C
      COMMON/AIDPAR/AX(150,3),AUOBS(150,6),AUCALC(150,6),WU(150,6),
     1  WU1(150,6)
      COMMON//AIDX(3000)
      COMMON/AXESN/ISPAX(15),LT(5,15),LAT(5,15)
      COMMON/AXESC/LBAT(5,15)
      CHARACTER*4 LBAT, ATNX
      COMMON /CONT1/ISET,NO,NMULT,NA,ICOUNT,NINPAR,NPARS,NINOBS,NANG,NTO
     1T,NPULT,NA1,IFU,IB,NONRIG,NS,ISIG,ISYM,ICORL,IFU1,N8,
     2 IEIG,IMAT, IOUT,IRECAL, IFREQ
      COMMON/CONT2/NP1,NNP1,IORIG,IWU,INOPAR
      COMMON/IAID1/ IAIDX1(1000)
      COMMON/LOC/ VAF(7,3), PVEC(7,3), V5(7,3), VEC1(7,3)
      COMMON/LOCC/ ATNX(7,2)
      common/locc_/BLLARG(7)
      DIMENSION DEL1(3)
      EQUIVALENCE  (DEL1(1),AIDX(776))
C
      DO 10 I = 1,NONRIG
      XL2 = 0.
      I1 = LAT(1,I)
      I2 = LAT(2,I)
      DO 20 K = 1,3
      DEL1(K) = AX(I2,K) - AX(I1,K)
      XL2 = XL2 + DEL1(K)*DEL1(K)
   20 CONTINUE
   40 XL2 = SQRT(XL2)
      DO 30 K = 1,3
      VEC1(I,K) = DEL1(K)/XL2
   30 CONTINUE
      IF(ISPAX(I).EQ.0) GO TO 10
C *** ISPAX(I) SET = 1 BY RDIN4 WHEN DEFINING N-R AXES BY 4 INPUT ATOMS
C ***   FOLLOWING PATCH IS TO GENERATE NR AXIS FROM VECTOR PRODUCT OF
C ***    TWO VECTORS DEFINED BY 4 INPUT ATOMS, WITH A 5TH ATOM NAME
C ***    USED TO LOCATE THE AXIS. 5TH ATOM REPLACES USUAL LBAT(2,I) IN
C ***    DERNP.
      I3 = LAT(3,I)
      I4 = LAT(4,I)
      DO 50 K = 1,3
      DEL1(K) = AX(I4,K) - AX(I3,K)
   50 CONTINUE
      V1 = VEC1(I,2)*DEL1(3) - VEC1(I,3)*DEL1(2)
      V2 = VEC1(I,3)*DEL1(1) - VEC1(I,1)*DEL1(3)
      V3 = VEC1(I,1)*DEL1(2) - VEC1(I,2)*DEL1(1)
      V4 = SQRT(V1*V1 + V2*V2 + V3*V3)
      IF(V4.NE.0) GO TO 55
      WRITE(*,60) (LAT(J,I),J=1,4),I
   60 FORMAT(' ','ATOM PAIRS ',A4,' - ',A4,' AND ',A4,' - ',A4,' DEFINE
     1PARALLEL VECTORS, SO NO ARG AXIS DEFINED FOR GROUP', I4)
      STOP
   55 VEC1(I,1) = V1/V4
      VEC1(I,2) = V2/V4
      VEC1(I,3) = V3/V4
   10 CONTINUE
      RETURN
      END
      SUBROUTINE DERNP(N)
C
C *** CALCULATE THE VECTOR PRODUCT OF TORSIONAL AXIS (VEC1) AND VECTOR
C ***   FROM POINT ON AXIS TO THIS ATOM (N) FOR EACH ARG ("attached
C ***   rigid group") (M) IT PARTICIPATES IN
C
      COMMON/AIDPAR/AX(150,3),AUOBS(150,6),AUCALC(150,6),WU(150,6),
     1  WU1(150,6)
      COMMON//AIDX(3000)
      COMMON/AXESN/ISPAX(15),LT(5,15),LAT(5,15)
      COMMON/AXESC/LBAT(5,15)
      CHARACTER*4 LBAT
      COMMON/CONT2/NP1,NNP1,IORIG,IWU,INOPAR
      COMMON/IAID1/ IAIDX1(1000)
      COMMON/INOUTN/ NPAGE, KOUTP,  DIS, IAW
      COMMON/INOUTC/ NAME1, ATNAME(150),TISET(80),TITLE(80),ITBL(29),
     1 NAME2
      COMMON/LOC/ VAF(7,3), PVEC(7,3), V5(7,3), VEC1(7,3)
      COMMON/LOCC/ ATNX(7,2)
      common/locc_/BLLARG(7)
      common/new/isigx,ETA, TK,I11, isigu,nafa(7),NONSY(7),AXMOM(7),
     1  NRBP(150),NCPD,NDAT,NESD, IBYP, IEXU, inegl
      DIMENSION IZ(5),DEL(3) 
      EQUIVALENCE(DEL(1),AIDX(751))
      EQUIVALENCE (IZ(1),IAIDX1(801)), (IAIDX1(1000),IGN)
      CHARACTER*4 ATNX,NAME1, ATNAME, TISET*1,TITLE*1,ITBL*3,NAME2*5
C
      J1 = 0
      IGN = 0
C   IGN USED TO SIGNAL THAT AN ATOM LYING ON ROTN AXIS OF THE ARG
C      SHOULD BE IGNORED (SEE AFTER 50 BELOW) (USED IN DERNON)
      NN = NRBP(N)
      DO 5 J = 1,5
      IH = NN/16
      IZ(J) = NN - 16*IH
      IF(IZ(J).EQ.0)  GO TO 10
      NN = IH
      J1 = J1 + 1
    5 CONTINUE
   10 DO 20 K = 1,J1
      M = IZ(K)
      XL2  = 0.
      IM = LAT(2,M)
      IF(ISPAX(M).NE.0) IM = LAT(5,M)
      DO 30 J = 1,3
      DEL(J) = AX(N,J) - AX(IM,J)
C ***  DEL(J) IS NOW VECTOR TO ATOM N (= ATOM K IN 'SOLVE') FROM 2ND
C ***        ATOM DEFINING THE TORSIONAL AXIS
   30 CONTINUE
C ***   V5(M,I) IS VECTOR PRODUCT OF AXIS VECTOR AND VECTOR FROM AXIS
C ***            TO THIS ATOM (N) FOR THIS GROUP (M)
      V5(M,1) = VEC1(M,2)*DEL(3) - VEC1(M,3)* DEL(2)
      V5(M,2) = VEC1(M,3)*DEL(1) - VEC1(M,1)* DEL(3)
      V5(M,3) = VEC1(M,1)*DEL(2) - VEC1(M,2)* DEL(1)
      SCV5 = 0.
      DO 50 J = 1,3
      SCV5 = SCV5 + V5(M,J)*V5(M,J)
   50 CONTINUE
      IF(SCV5.NE.0.0) GO TO 20
      WRITE(*,100) ATNAME(N),M
  100 FORMAT(' ','ATOM ',A4,' LIES ON AXIS FOR ARG NO.',
     1 I3,' AND IS IGNORED FOR THAT GROUP,'/5X,
     2 'BUT RESULTS SUSPECT.  REDO AFTER CORRECTION.  ',
     39X,'(ATOM NAMES MEANINGLESS FOR POSNS GENERATED BY SYM)',/)
      IGN = M
   20 CONTINUE
      RETURN
      END
C
      SUBROUTINE DISCOR
C **** EFM changes, 9/21/98, index kk
C **** KNT changes, 20.IV.91-7.V.91 re sym-equiv atoms and 
C ****    fixing so includes point group P1-bar ("IF" just after 120)
C ****    And 25.II.93 to bypass RBCOR when have RIDCOR, MINCOR, UNCOR
      COMMON//AIDX(3000)
      COMMON/AIDPAR/AX(150,3),AUOBS(150,6),AUCALC(150,6),WU(150,6),
     1  WU1(150,6)
      COMMON/AMPCLN/NVIB,ICSVIB,NVAT1(40),NVAT2(40),
     1 NCSVIB(10), DCOS(10,3)
      COMMON/AMPCLC/VBAT1(40),VBAT2(40),CSATNM(10,12)
      CHARACTER*4 CSATNM,VBAT1,VBAT2
      COMMON/ATPAR/X(150,3),WT(150),MULT(150),UOBS(150,6),SIGU(150,6),UC
     1ALC(150,6),NUORB(150),SIGB(150,6)
      COMMON/AXESN/ISPAX(15),LT(5,15),LAT(5,15)
      COMMON/AXESC/LBAT(5,15)
      CHARACTER*4 LBAT
      COMMON/NONAM/ NONAME(7,40)
      CHARACTER*4 NONAME
      COMMON/CELLP/CD(12),RCD(12),VOL,VST,G(3,3)
      COMMON /CONT1/ISET,NO,NMULT,NA,ICOUNT,NINPAR,NPARS,NINOBS,NANG,NTO
     1T,NPULT,NA1,IFU,IB,NONRIG,NS,ISIG,ISYM,ICORL,IFU1,N8,
     2 IEIG, IMAT, IOUT, IRECAL, IFREQ
      COMMON/CONT2/NP1,NNP1,IORIG,IWU,INOPAR
      COMMON/CONT3/ISOLV,NTOTS,CONSLV,SUMW,RWUDI,RMS,RMU,gof,sumsig,
     1  iscm,msd8
      COMMON/CORDIN/ IRIDE, IMIN, IUNC,IHAT(150), NUNC(20),TUNC(20,3),
     1   TOR(3,3), XCG(3),IHPR
      COMMON/CORDIC/ RIDA(20), RIDB(20), AMIN1(20), AMIN2(20),
     1   UNC1(20), UNC2(20)
      COMMON/IAID1/IAIDX1(1000)
      COMMON/INOUTN/ NPAGE, KOUTP,  DIS, IATWT
      COMMON/INOUTC/ NAME1, ATNAME(150),TISET(80),TITLE(80),ITBL(29),
     1 NAME2
      COMMON/LOC/ VAF(7,3), PVEC(7,3), V5(7,3), VEC1(7,3)
      COMMON/LOCC/ ATNX(7,2)
      common/locc_/BLLARG(7)
      common/new/isigx,ETA, TK,I11, isigu,nafa(7),NONSY(7),AXMOM(7),
     1  NRBP(150),NCPD,NDAT,NESD, IBYP, IEXU, inegl
      COMMON/SYM/SYMOP(23,3,3),TMAT(3,3),RTMAT(3,3),EPSIJK(3,3,3),
     1 SYML(3)
      COMMON/TMCSIS/TCIC(3,3),TCIU(3,3),TCINVC(3,3),TCINVU(3,3),SCG(3),
     1 OMIN(3,3), TROI(3,3), oma(3,3) 
      DIMENSION NNM(12),AUO(3,3),
     1 AHL(3,3), WTT(150), VCOS(3), XX(3),XXA(3), IZ1(5), IZ2(5), IGR(5)
      DIMENSION   AL(3,3),W(3,3),DEL(3),AAX(3),AXX(150,3)
      DIMENSION P(80),NAT(15,150), MAT(40), VC(3), SIGP(80)
      DIMENSION PL(6)
      DIMENSION TRCU(150),X1(3),X2(3), ASY(6), ISY(6),STR(3), PHICOR(3)
      EQUIVALENCE (AHL(1,1),AIDX(2601)), (PL(1), AIDX(2621))
      EQUIVALENCE  (P(1),AIDX(801)) 
      EQUIVALENCE (SIGP(1), AIDX(881)), (WTT(1), AIDX(451))
      EQUIVALENCE (AXX(1,1), AIDX(1)), (AAX(1), AIDX(2685))
      CHARACTER*4 XNM, ATNX, AN1,AN2, COD
      CHARACTER*4 NAME1, ATNAME, TISET*1,TITLE*1, ITBL*3, NAME2*5
      CHARACTER*4 RIDA,RIDB,AMIN1, AMIN2,UNC1,UNC2
      CHARACTER*1 ASY,STR
      CHARACTER*10 XYZ, XYZ1,XYZ2
      REAL MULT, MINCOR
      DATA  XYZ1/' X,  Y,  Z'/
      DATA XYZ2/'-X, -Y, -Z'/
C
 9000 FORMAT(/9x,'Not ALL of the following corrections are applied 
     * at once.  If an atom pair has been designated for RIDING or MINI
     *MUM'/8x,'or UNCORRELATED motion, no RIGID-BODY or ARG correction
     * is added in, although it may be LISTED.'/
     * T99,'CORRN FOR INTERNAL',T122,'KEYCORD'/
     1 T56,'RIGID',T99,'MOTION FOR EACH ARG',/T3,
     2 'UNIQUE', T25,'UNCORR',T36,'CORRD',T45,'SUM OF',T56,
     3 'BODY',T65,'ANHARM',T79,'B&L',T93,30('-')/T3,'ATOM 1',T13,
     4 'ATOM 2', T26,'DIST',T36,'DIST',T45,'CORRNS',T56,
     5 'CORRN',T65,'CORRN',T78,'CORRN',T90,3(3X,'GP CORRN')/)
 9001 FORMAT(1X, 4(A4,1X,I2,2X,A4,1X,I2,2X,F5.3,6X))
 9002 FORMAT(//,' ','CORRECTIONS TO UNIQUE DISTANCES SMALLER THAN ',
     1 F5.2, ' (IF FIRST ATOM LISTED LIES ON A SYMMETRY ELEMENT, SOME',/
     2 5X,'NON-UNIQUE DISTANCES MAY BE INCLUDED ALSO). ',
     3'SOME OTHER SPECIFIC DISTANCES MAY BE INCLUDED IF'
     4/5X,'CORRESPONDING ATOM PAIRS WERE SPECIFICALLY INPUT.')
 9003 FORMAT(' ')
 9010 FORMAT( 3X,'DISTANCES ARE IN ANGSTROMS.  IN COLUMN 8, "B&L" MEANS
     1 CORRECTION ACCORDING TO BUSING & LEVY (1964) ACTA 17, 142, WITH'/
     2 5X,'"RID" MEANING RIDING CORRECTION, "UNC" MEANING CORRECTION FOR
     3 INDEPENDENT OR UNCORRELATED MOTION, AND "MIN" MEANING MINIMUM'/
     4 5X,'"THERMAL MOTION" CORRECTION.  ONLY ONE OF THESE CORRECTIONS W
     5ILL BE INCLUDED FOR A SPECIFIED PAIR OF ATOMS IN A GIVEN RUN;'/
     6 5X,'IF MORE THAN ONE IS SPECIFIED, ONLY THE FIRST REQUESTED WILL
     6 BE ADDED IN.'/10X,'******* IF ANY OF THESE IS PRESENT, IT HAS
     * PRIORITY OVER ANY RIGID-BODY OR ARG-TORSION MOTIONAL CORRECTION.
     * *******'/ 7X,'A * NEXT TO
     7 THE COLUMN FOR A CORRECTION FOR INTERNAL TORSION INDICATES THAT
     8 THE CORRESPONDING AMPLITUDE '/8X,'WAS ZERO OR NEGATIVE.'//3X,
     8'ADDITION OF THE SEPARATE CORRECTIONS TO GET AN OVERALL CORRECTION
     8 (AS HERE) IMPLIES UNCORRELATED MOTION.  THIS MAY NOT BE VALID,'/
     95X,'BUT IS THE SIMPLEST ASSUMPTION. INTERPRET RESULTS CAUTIOUSLY!'
     9/3X,'REMEMBER TOO THAT APPLICATION OF ANY MODEL ALWAYS INVOLVES AS
     9SUMPTIONS, EVEN THOUGH THEY MAY BE IMPLICIT OR UNSTATED.'/)
 9015 FORMAT(' ','CAUTION: IF THE ANHARMONIC CORRECTION FOR BOND TO H OR
     1 D IS POSITIVE, DATA ARE SUSPECT.  IT SHOULD NORMALLY BE AROUND'/
     2 10X,'-0.015 TO -0.02 ANGSTROM.  SEE COMMENTS IN INSTRUCTIONS')
 9020 FORMAT(3X,A4,6X,A4,',',I2,3X,F7.4,4X,F6.3,3(3X,F7.4),5X,F7.4,1X,
     1 A3, 5X, I1,1X,F6.4,A1, 2(2X,I1,1X,F6.4,A1))
 9025 FORMAT(10X,'(FOR THIS INDEPENDENT-MOTION CORRECTION, ATOM 2 AT ',
     1 A10,', WITH TRANSLATIONS ',2(F5.2,', '),F5.2,')')
C  WHEN IMPLEMENTING THE 3-LETTER CODE, USE COD, DECLARED AS CHARACTER*4
C   AND ONE OF FOUR:  COD = 'RID', COD = 'MIN', COD = 'UNC', COD = '   '
C
      DO 5 I = 1,NTOTS
C ***  KNT changed NTOT to NTOTS in preceding statement, 20.IV.91
      TRCU(I) = AUOBS(I,1) + AUOBS(I,2) + AUOBS(I,3)
    5 CONTINUE
C ***  FIRST CALCULATE POSITIONS CORRECTED FOR RIGID-BODY MOTION
C *** AHL(I,I): eigenvalues of L, Cartesian crystal system from EIGVLT
      TRAL = 0.
      CALL VMLT(PL,AL)
      DO 15 I = 1,3
      TRAL = TRAL + AL(I,I)
   15 CONTINUE
      DO 20 I = 1,3
      DO 20 J = 1,3
      W(I,J) = 0.5*(SYMOP(1,I,J)*TRAL - AL(I,J))
   20 CONTINUE
      DO 50 K = 1,NTOTS
      DO 40 I = 1,3
      DEL(I) = 0.
      AAX(I) = AX(K,I)
      DO 30 J = 1,3
      DEL(I) = DEL(I) + W(I,J)*AX(K,J)
   30 CONTINUE
      AAX(I) = AAX(I) + DEL(I)
   40 CONTINUE
C          BACK-CORRECT FOR ORIGIN SHIFT OF AX(K,J) TO CENTER OF MASS
      DO 45 I = 1,3
      AXX(K,I) = SCG(I)
      DO 45 J = 1,3
      AXX(K,I) = AXX(K,I) + TCINVC(I,J)*AAX(J)
   45 CONTINUE
C ***  AXX(J,K) are now crystal coords for all atoms, corrd for r.-b. motion
   50 CONTINUE
  100 IF(IEXU.EQ.0.AND.(NS.GE.(-1).OR.NS.EQ.(-3))) CALL OUTH6
  102 IF(IEXU.EQ.0) THEN
         WRITE(*,9002) DIS
         WRITE(*,9010)
      ENDIF
C ***    FOLLOWING STATEMENT PRINTED ONLY WHEN ANISO H,D PRESENT (IHPR.NE.0)
      IF(IHPR.NE.0.AND.IEXU.EQ.0) WRITE(*,9015)
      WRITE(*,9000)
C
      NT = 0
C ***   NT IS LINE-TALLY FOR PAGINATION
      DO 1501 J = 1,NTOT
      IF(WTT(J).EQ.800.) GO TO 1501
C ***  J WILL BE TALLY FOR FIRST ATOM (UNIQUE ONES ONLY)
      JJ = J + 1
      JJ1 = NTOTS
      DO 1500 M = JJ,JJ1
C  M IS TALLY FOR SECOND ATOM
      IF(WTT(M).EQ.800.) GO TO 1500
      D = SQRT((AX(J,1) - AX(M,1))**2 +(AX(J,2) - AX(M,2))**2
     1   + (AX(J,3) - AX(M,3))**2)
      IF(D.EQ.0.0) GO TO 1500
      IF(D.GE.DIS.AND.IUNC.EQ.0) GO TO 1500
C ***  CLEAR VARIOUS ITEMS BEFORE CHECK FOR EACH PAIR OF ATOMS
      COR = 0.
      IR = 0
      CORBL = 0.
      RBCOR = 0.
      ANHCOR = 0.
      RIDCOR = 0.
      MINCOR = 0.
      UNCOR = 0.
      COD = '    '
      DO 105 I = 1,6
      ISY(I) = 0
      ASY(I) = ' '
      IF(I.GT.5) GO TO 105
      IZ1(I) = 0
      IZ2(I) = 0
      IGR(I) = 0
      IF(I.GT.3) GO TO 105
      PHICOR(I) = 0.
      STR(I) = ' '
  105 CONTINUE
      IF(M.GT.NTOT) GO TO 110
      NM = 1
      IM = M
      GO TO 120
C *** NEXT 2 LINES NEEDED ONLY WHEN SEARCH BEYOND FIRST NTOT ATOMS
  110 NM = (M - NTOT - 1)/NA + 2
      IM = M - NTOT - NA*(NM-2)
  120 AN1 = ATNAME(J)
      AN2 = ATNAME(IM)
      NP2 = NM
C ***  next line added 1.XI.91
      if(iunc.eq.0) go to 180
C ***   Omit calc if distance too large, and if beyond asym unit and 
C ***           IM.LT.J  (atom B ahead of atom A in orig list -- this
C ***           would just give duplicate calcs  (7.V.91)
      IF(D.LT.DIS.AND.(NM.EQ.1.OR.(NM.GT.1.AND.IM.GE.J))) GO TO 180
C ***  CHECK WHETHER WANT SPECIAL CALC FOR SOME DISTANCE EXCEEDING DIS
C ***  NOW CHECK TO SEE IF ATOM NAMES MATCH THOSE OF PAIRS FOR CORRN FOR
C ***       UNCORRELATED (INDEPENDENT) MOTION
      DO 130  N = 1,IUNC
      IF(AN1.NE.UNC1(N).OR.AN2.NE.UNC2(N)) GO TO 130
C ***   IF PREV CONDN FAILS, HAVE MATCH OF ATOM NAMES FOR BOTH ATOMS
      NN = N
      GO TO 135
  130 CONTINUE
      GO TO 1500
C ***  WANT CORRECTION FOR UNCORRELATED MOTION OF DISTANCE BETWEEN SOME
C ***    PAIR OF ATOMS INPUT.  MUST GET POSITION PARAMETERS UNLESS ALL
C ***    TRANSLATIONS ARE ZERO
  135 DO 140  I = 1,3
      IF(TUNC(NN,I).EQ.0.) GO TO 140
C ***  SOME TRANSLATIONAL COMPONENT NON-ZERO. MUST CALC POSN PARAMS
      GO TO 145
  140 CONTINUE
      GO TO 180
  145 DO 150 I = 1,3
C ***  Change M to IM in next two lines (May '91) so if beyond asym
C ***    unit generally, it will still look at orig posn for this corrn
      IF(NUNC(NN).LT.0)  X(IM,I) = - X(IM,I)
      XX(I) = X(IM,I) + TUNC(NN,I)
  150 CONTINUE
C ***  XX(I) ARE NOW THE CRYSTAL POSN PARAMS, CORRD FOR TRANSLATION
C ***  NOW MUST CONVERT THESE TO THE CRYSTAL CARTESIAN SYSTEM
C ***     AND HAVE THEM REL TO C OF MASS, SINCE OTHER AX(I,J) ARE
C ***  WANT TO GET POSITIONS FOR SECOND ATOM (IF TRANSLATION INVOLVED)
C ***     IN CRYSTAL CARTESIAN SYSTEM SO CAN USE AUOBS (ALSO IN THAT
C ***     SYSTEM) EASILY.  AUOBS INDEPENDENT OF TRANSLATIONAL SYM,
C ***     ALTHOUGH IT WILL VARY WITH ROTATION OR REFLECTION
      CALL MATVEC(TOR,XX,XXA)
      DO 160 I = 1,3
      XXA(I) = XXA(I) - XCG(I)
C ***   XCG(I) ARE COORDS OF C OF M IN CARTESIAN CRYST SYST (FROM INERT)
C ***    XXA(I) ARE NOW CARTES CRYST COORDS OF ATOM M REL TO C OF MASS
  160 CONTINUE
C ***  NOW CALCULATE DISTANCE BETWEEN ATOMS J AND M & DIR COS OF 'BOND'
      D = SQRT((AX(J,1) - XXA(1))**2 + (AX(J,2) - XXA(2))**2 +
     1   (AX(J,3) - XXA(3))**2)
      DO 165 I = 1,3
      VCOS(I) = (AX(J,I) - XXA(I))/D
  165 CONTINUE
C ***  CALCULATIONS JUST DONE INVOLVE AN ATOM PAIR WITH INDEPENDENT
C ***    (UNCORRELATED) MOTION.  NO RIGID-BODY OR INTERNAL MOTION CALCS
C ***    TO BE DONE FOR THIS PAIR
      GO TO 500
C ***  THIS BRANCH FOR DISTANCES SMALLER THAN 'DIS'
  180 DO 185  I = 1,3
C ***   GET DIRECTION COSINES OF THE 'BOND VECTOR'; CALL THEM VCOS(I)
      VCOS(I) = (AX(J,I) - AX(M,I))/D
  185 CONTINUE
C ***  NOW CALCULATE DISTANCE CORRD FOR RIGID-BODY MOTION
      DO 190 N = 1,3
C ***   AXX are defined for ALL atoms; do not want IM here
      DEL(N) = AXX(J,N) - AXX(M,N)
  190 CONTINUE
      DDIS = 0.
      DO 195 N = 1,3
      DO 195 L = 1,3
      DDIS = DDIS + G(N,L)*DEL(N)*DEL(L)
  195 CONTINUE
      DIST = SQRT(DDIS)
      RBCOR = DIST - D
C ***   RBCOR = CORRN FOR RIGID-BODY MOTION; before Feb '93, added in at
C ***     this point, but now moved later; not done if riding, min, uncorrel
  200 CONTINUE
C ***  TEST TO SEE IF ANHARMONIC CORRN WANTED (X-H BONDS ONLY)
C ***     BUT SKIP ANY ISOTROPIC ATOMS (UOBS(J,2) = 0.0 )
C ***     IF WANT NO ANHARM, WANT NO RIDING EITHER
      IF(UOBS(J,2).EQ.0.0.OR.UOBS(M,2).EQ.0.0) GO TO 320
      IF(IHAT(J).EQ.0.AND.IHAT(M).EQ.0) GO TO 320
C ***  ONLY IF ONE OF THE TWO ATOMS IS H (OR D) (IHAT.NE.0)
C ***  BUT DO NOT WANT IT FOR SHORT NON-BONDED H...H, D...D, H...D
C ***       I.E., ONE OF THE TWO ATOMS MUST BE OTHER THAN H OR D
      IF(IHAT(J).NE.0.AND.IHAT(M).NE.0) GO TO 320
C ***  NOW CALCULATE ANHARMONIC CORRECTION FOR H-X OR D-X BOND
      CALL VEMA(AUOBS,AUO,J)
      CALL VMAV(AUO,VCOS,SVOJ)
      CALL VEMA(AUOBS,AUO,M)
      CALL VMAV(AUO,VCOS,SVOM)
      ANHCOR = -3.0*(SVOJ - SVOM)
C ***  NOW CHECK TO SEE WHICH ATOM IS H OR D; IF IT IS J, THEN SIGN OF
C ***     ANHCOR IS CORRECT; IF IT IS M, REVERSE SIGN
      IF(IHAT(M).NE.0) ANHCOR = -ANHCOR
      COR = COR + ANHCOR
  300 CONTINUE
C ***  FOLLOWING SECTION IS FOR RIDING CORRECTION, AUTOMATIC FOR H OR D
C ***     BONDED TO A HEAVIER ATOM. USUALLY THE H OR D IS ATOM M (2ND
C ***     ATOM.  IF NOT, THEN IHAT(J) IS NON-ZERO (BOTH CAN'T BE)
      RIDCOR = 0.5*(TRCU(M) - SVOM - (TRCU(J) - SVOJ))/D
      IF(IHAT(J).NE.0) RIDCOR = - RIDCOR
C ***  CORRN NOT ADDED IN UNTIL SURE ATOM PAIR IS NOT IN AN A.R.G.
      CORBL = RIDCOR
C ***    BUT DO NOT CALC (OR LABEL) WHEN ATOM IS ISOTROPIC
      COD = 'RID'
C ***  ONCE HAVE (ANHARMONIC AND) RIDING CORRN FOR X-H OR X-D BOND,
C ***    NO OTHER B&L CORRECTION WANTED, SO SKIP TO 600
      GO TO 600
  320 CONTINUE
C ***   THIS PATH FOR RIDING CORRECTIONS FOR ATOM PAIRS SPECIFIED ON
C ***       INPUT
      IF(IRIDE.EQ.0) GO TO 400
      DO 330 I = 1, IRIDE
      IF(RIDA(I).EQ.ATNAME(J).AND.RIDB(I).EQ.ATNAME(M)) GO TO 335
      IF(RIDA(I).EQ.ATNAME(M).AND.RIDB(I).EQ.ATNAME(J)) GO TO 340
  330 CONTINUE
C ***  NO MATCH OF CURRENT ATOM NAMES WITH ANY INPUT PAIR OF ATOMS FOR
C ***      RIDING CORRECTION
      GO TO 400
  335 JK = J
      MK = IM
      GO TO 345
C ***   THE RIDING ATOM, RIDA ON INPUT, IS JK FOR THE CORRECTION BELOW
  340 JK = IM
      MK = J
  345 CALL VEMA(AUOBS,AUO,JK)
      CALL VMAV(AUO,VCOS,SVO1)
      CALL VEMA(AUOBS,AUO,MK)
      CALL VMAV(AUO,VCOS,SVO2)
      RIDCOR = 0.5*(TRCU(JK) - SVO1 - (TRCU(MK) - SVO2))/D
C ***  SET MARKER TO INDICATE THAT A RIDING CORRN HAS BEEN CALCULATED
      ISY(1) = 1
  400 CONTINUE
C ***   NOW BEGIN MINIMUM THERMAL MOTION CORRECTIONS
      IF(IMIN.EQ.0) GO TO 500
      DO 430 I = 1, IMIN
      IF(AMIN1(I).EQ.ATNAME(J).AND.AMIN2(I).EQ.ATNAME(IM)) GO TO 445
      IF(AMIN1(I).EQ.ATNAME(IM).AND.AMIN2(I).EQ.ATNAME(J)) GO TO 445
  430 CONTINUE
C ***  NO MATCH OF CURRENT ATOM NAMES WITH ANY INPUT PAIR OF ATOMS FOR
C ***      MINIMUM 'THERMAL MOTION' CORRECTION
      GO TO 500
  445 CALL VEMA(AUOBS,AUO,J)
      CALL VMAV(AUO,VCOS,SVOJ)
      CALL VEMA(AUOBS,AUO,IM)
      CALL VMAV(AUO,VCOS,SVOM)
      MINCOR = 0.5*(TRCU(J) - SVOJ + TRCU(IM) - SVOM -
     1     2.0*SQRT((TRCU(J) - SVOJ)*(TRCU(IM) - SVOM)))/D
C ***  SET MARKER TO INDICATE THAT MINIMUM CORRN HAS BEEN CALCULATED
      ISY(2) = 1
  500 CONTINUE
C ***   NOW BEGIN CORRECTIONS FOR UNCORRELATED (INDEPENDENT) MOTION
      IF(IUNC.EQ.0) GO TO 600
      DO 530 I = 1, IUNC
      IF(UNC1(I).EQ.ATNAME(J).AND.UNC2(I).EQ.ATNAME(IM)) GO TO 545
      IF(UNC1(I).EQ.ATNAME(IM).AND.UNC2(I).EQ.ATNAME(J)) GO TO 545
  530 CONTINUE
C ***  NO MATCH OF CURRENT ATOM NAMES WITH ANY INPUT PAIR OF ATOMS FOR
C ***      CORRECTION FOR UNCORRELATED MOTION
      GO TO 600
  545 CALL VEMA(AUOBS,AUO,J)
      CALL VMAV(AUO,VCOS,SVOJ)
      CALL VEMA(AUOBS,AUO,IM)
      CALL VMAV(AUO,VCOS,SVOM)
      UNCOR = 0.5*(TRCU(J) - SVOJ + TRCU(IM) - SVOM)/D
C ***  SET MARKER TO INDICATE THAT CORRN FOR INDEP MOTION HAS BEEN CALCD
      ISY(3) = 1
  600 CONTINUE
      IF(NONRIG.EQ.0) GO TO 800
C ***   NOW BEGIN THE CORRECTIONS FOR TORSIONAL MOTION
C ***   ASSUMPTION IS MADE THAT THE VALUE FOUND FOR (PHI SQUARED +
C ***      2.0*PHI-LAMBDA PARALLEL) IS JUST PHI SQUARED, THAT IS, THAT
C ***      CORRELATION WITH OVERALL PARALLEL MOTION IS ZERO.  THIS IS
C ***      CLEARLY NOT GENERALLY WARRANTED, BUT WHEN THE MOTION IS LARGE
C ***      IT MAY NOT BE A BAD APPROXIMATION, AND WHEN THE MOTION IS
C ***      SMALL, THE CORRECTIONS ARE SMALL -- COMPARABLE, INDEED, TO
C ***      THEIR OWN ESTIMATED PRECISION, SO THE ERROR MADE IS SCARCELY
C ***      SIGNIFICANT.
      IF(J.GT.NA.OR.M.GT.NA) GO TO 800
C ***  ONLY HAVE CORRNS FOR TORSIONAL MOTION FOR ATOMS INCLUDED IN THE
C ***    'THERMAL MOTION ANALYSIS', I.E., THE FIRST NA UNIQUE ATOMS
      IF(NRBP(J).EQ.0.AND.NRBP(M).EQ.0) GO TO 800
C *** AT LEAST ONE OF THE ATOMS MUST BE AN AFFECTED ATOM OF SOME ARG,
C ***    OR NO CORRECTION TO BE MADE
      J1 = 0
      J2 = 0
      NJ = NRBP(J)
      DO 610 I = 1,5
      IH = NJ/16
      IZ1(I) = NJ - 16*IH
      IF(IZ1(I).EQ.0) GO TO 620
      NJ = IH
      J1 = J1 + 1
  610 CONTINUE
  620 NM = NRBP(M)
      DO 630 I = 1,5
      IH = NM/16
      IZ2(I) = NM - 16*IH
      IF(IZ2(I).EQ.0) GO TO 632
      NM = IH
      J2 = J2 + 1
  630 CONTINUE
C *** IS EITHER ATOM THE 2ND AXIS-DEFINING ATOM OF SOME ARG?
  632 DO 638 I = 1,NONRIG
      LLL = LT(2,I)
      IF(ISPAX(I).NE.0) LLL = LT(5,I)
      IF(J.NE.LLL) GO TO 635
      J1= J1 + 1
      IZ1(J1) = I
  635 IF(M.NE.LLL) GO TO 638
      J2 = J2 + 1
      IZ2(J2) = I
  638 CONTINUE
C ***  CORRN ONLY IF EACH ATOM IS IN AN ARG (OR IS 2ND AXIS-DEF ATOM)
C ***  UNLESS J1.GT.0, J IS NOT; UNLESS J2.GT.0, M IS NOT
      IF(J1.EQ.0.OR.J2.EQ.0) GO TO 800
C ***  NOW HAVE THE NUMBER OF ARG'S THAT ATOM J IS IN (J1) AND THAT
C ***      ATOM M IS IN (J2), AND THE SERIAL NOS OF THESE GROUPS
C ***      AS IZ1(K), K = 1,J1 AND  IZ2(L), L = 1,J2
C ***      [2ND AXIS-DEFINING ATOM INCLUDED HERE FOR EACH ARG]
C ***  IF, AND ONLY IF, THE TWO ATOMS ARE IN THE SAME ARG, WANT TO
C ***      CALCULATE THE CORRECTION TO J-M DIST FOR MOTION OF THAT ARG
  640 IR = 0
      DO 650 K = 1,J1
      DO 650 L = 1,J2
      IF(IZ1(K).NE.IZ2(L)) GO TO 650
C ***  ATOMS ARE IN SAME GROUP; SAVE THAT GROUP NUMBER AS IGR(I)
      IR = IR + 1
      IGR(IR) = IZ1(K)
  650 CONTINUE
C ***  IGR GIVEN DIMENSION OF 5 FOR SAFETY, BUT PROGRAM ONLY DOES
C ***     CALCS FOR UP TO THREE GROUPS WITH ATOMS IN COMMON (ONLY
C ***     PROVISION FOR THAT MANY IN DERNON), SO ANY GIVEN PAIR CANNOT
C ***     BE IN MORE THAN 3 DIFFERENT GROUPS
      IF(IR.EQ.0) GO TO 900
C ***  IF IR = 0, THERE WERE NO GROUPS WITH THESE TWO ATOMS; IR IS THE
C ***     NUMBER OF GROUPS CONTAINING THESE TWO ATOMS
      DO 700 II =1,IR
      N = IGR(II)
C ***   N IS NOW THE SERIAL NUMBER OF THE GROUP CONTAINING THESE ATOMS
C Index KK changed by EFM 9-21-98 because libration amplitudes about 
C ARG axes are in P(NP1+1), P(NP1+8) etc. if icorl.eq.0
      if(icorl.lt.0) goto 651
      KK= NP1 + 7*(N-1) + 1
      goto 652
  651 KK = N + NP1
  652 IF(P(KK).GT.0) GO TO 660
C ***  IF PHI-SQ + 2 PHI-LAMBDA PARALLEL 0 OR NEG, SKIP CALC FOR GROUP
C ***      AND MARK THE PLACE WHERE CORRECTION WOULD NORMALLY BE LISTED
      STR(II) = '*'
      GO TO 700
  660 VC(1) = VEC1(N,2)*VCOS(3) - VEC1(N,3)*VCOS(2)
      VC(2) = VEC1(N,3)*VCOS(1) - VEC1(N,1)*VCOS(3)
      VC(3) = VEC1(N,1)*VCOS(2) - VEC1(N,2)*VCOS(1)
      SVC = 0.0
      DO 670 IJ = 1,3
      SVC = SVC + VC(IJ)*VC(IJ)
  670 CONTINUE
C ***  SVC IS SQUARE OF SINE OF ANGLE BETWEEN VECTOR FROM ATOM J TO ATOM
C ***     M AND THE AXIS OF THE ATTACHED RIGID GROUP (ARG)
C ***  D IS THE DISTANCE BETWEEN ATOMS J AND M (CALCULATED EARLIER)
      PHICOR(II) = 0.5*D*SVC*P(KK)
  700 CONTINUE
  800 CONTINUE
      IF(IHAT(J).NE.0.OR.IHAT(M).NE.0) GO TO 900
C ***  IF EITHER ATOM IS H, HAVE ALREADY CALCD RIDING CORRECTION, AND
C ***     ONLY ONE KIND OF BUSING-LEVY CORRECTION APPROP FOR GIVEN ATOM
C ***  NOW SUM CORRECTIONS (INCLUDING ONLY ONE B&L TYPE) AND SET
C ***    ANY NEEDED INDICATORS FOR PRINTING LINE.  HAVE ALREADY SUMMED
C ***      RBCOR, AND, FOR H OR D, ANHCOR
C ***     FIND OUT WHICH B&L CORRN CALCD; ADD IN FIRST ONE IN SEQ
      if(isy(1).eq.0.and.isy(2).eq.0.and.isy(3).eq.0) then
         COR = COR + RBCOR
C ***      NO RBCOR IF HAVE RIDING, MIN, OR UNCORREL (INDEP) MOTION
         GO TO 900
         ENDIF
      IF(ISY(1).EQ.0) GO TO 820
C ***  ISY(1) NON-ZERO MEANS RIDING CORRN CALCULATED FOR INPUT PAIR
      COD = 'RID'
      CORBL = RIDCOR
      IF(IR.NE.0) THEN
       COD = '*TO'
      ELSE
       COR = COR + RIDCOR
      ENDIF
      GO TO 900
  820 IF(ISY(2).EQ.0) GO TO 840
C ***  ISY(2) NON-ZERO MEANS MINIMUM CORRECTION CALCULATED
      COD = 'MIN'
      CORBL = MINCOR
      COR = COR + MINCOR
      IF(ISY(1).NE.0) ASY(2) = '*'
C ***  PRECEDING SETS AN INDICATOR IN CASE HAVE ROOM TO PRINT THE
C ***     MIN CORRN EVEN IF DO NOT INCLUDE IT IN SUM OF CORRNS BECAUSE
C ***     RIDING CORRN HAS BEEN INCLUDED
C *** AT PRESENT (23.X.85) THERE IS NO PROVISION FOR PRINTING ALL OF
C ***   CORRECTIONS CALCULATED; NOTE THAT IF WANT TO DO THAT, MUST
C ***   ALTER VARIOUS LINES HERE (INCLUDING   CORBL = ... ) SO THAT
C ***   ONLY THE ONE DESIRED CORRECTION IS ADDED IN
      GO TO 900
  840 IF(ISY(3).EQ.0) GO TO 900
C ***  ISY(3) NON-ZERO MEANS CORRN FOR UNCORRELATED MOTION CALCD
      COD = 'UNC'
      CORBL = UNCOR
      IF(ISY(1).NE.0.OR.ISY(2).NE.0) ASY(3) = '*'
C ***  PRECEDING SETS AN INDICATOR IN CASE HAVE ROOM TO PRINT THE
C ***     UNC CORRN EVEN IF DO NOT INCLUDE IT IN SUM OF CORRNS BECAUSE
C ***     RIDING OR MINIMUM CORRN HAS BEEN INCLUDED
      COR = COR + UNCOR
  900 CONTINUE
      IF(IHAT(J).NE.0.AND.IHAT(M).NE.0) GO TO 915
      IF(IHAT(J).EQ.0.AND.IHAT(M).EQ.0) GO TO 915
C ***  IF EITHER ATOM IS H OR D (BUT NOT BOTH), AND PAIR IS IN AN ARG,
C ***     WANT RIDING CORRN (ALREADY CALCD ABOVE) but not PHICOR
C ***      (change 26.II.93)
      IF(IR.NE.0) GO TO 917
C ***   WHEN IR = 0, THIS PAIR OF ATOMS IS IN NO ARG
C ***      BUT NO RIDING CORRN WHEN THE H OR D IS ISOTROPIC
  910 COD = 'RID'
      IF(UOBS(J,2).EQ.0.0.OR.UOBS(M,2).EQ.0.)  COD = '    '
      IF(UOBS(J,2).NE.0.0.AND.UOBS(M,2).NE.0.) COR = COR + RIDCOR
      GO TO 1000
C *** IR = NUMBER OF GROUPS CONTAINING THIS PAIR OF ATOMS
C ***   IF IR = 0, NO CORRNS FOR TORSIONAL MOTION FOR THIS PAIR
  915 IF(IR.EQ.0) GO TO 1000
  917 if(COD.EQ.'RID') THEN
          COR = COR + RIDCOR
C ***    don't want PHICOR if already have RIDCOR
          GO TO 921
      ENDIF
      DO 920 II = 1,IR
      COR = COR + PHICOR(II)
  920 CONTINUE
  921 DCOR = D + COR
      WRITE(*,9020) AN1,AN2,NP2, D, DCOR,COR, RBCOR,ANHCOR, CORBL,COD,
     1  (IGR(II),PHICOR(II),STR(II), II = 1,IR)
      IF(IUNC.EQ.0.OR.ISY(3).EQ.0) GO TO 1300
      XYZ = XYZ1
C *** THE SERIAL NO OF THIS "UNC" PAIR HAS BEEN SAVED AS   NN
      IF(NUNC(NN).LT.0) XYZ = XYZ2
      WRITE(*,9025) XYZ, (TUNC(NN,II), II = 1,3)
      NT = NT + 1
      GO TO 1300
 1000 CONTINUE
      DCOR = D + COR
 1200 WRITE(*,9020) AN1,AN2,NP2, D, DCOR,COR, RBCOR,ANHCOR, CORBL,COD
      IF(IUNC.EQ.0.OR.ISY(3).EQ.0) GO TO 1300
      XYZ = XYZ1
      IF(NUNC(NN).LT.0) XYZ = XYZ2
      WRITE(*,9025) XYZ, (TUNC(NN,II), II = 1,3)
      NT = NT + 1
 1300 NT = NT + 1
      IF(NT.LT.48) GO TO 1500
      NT = 1
      CALL OUTH6
      WRITE(*,9000)
 1500 CONTINUE
 1501 CONTINUE
      RETURN
      END
C
      SUBROUTINE DIST(NTS)
C  CALCULATES DISTANCES AND PRINTS THOSE SMALLER THAN  DIS  FROM EACH
C    ATOM IN INPUT UNIT TO EACH OTHER ATOM AND TO ALL GENERATED BY
C    SYMMETRY (EXCEPT THOSE AT ZERO DISTANCE, WHEN ATOM IS ON A
C    SYMMETRY ELEMENT)
C
      COMMON// AIDX(3000)
      COMMON/AIDPAR/AX(150,3),AUOBS(150,6),AUCALC(150,6),WU(150,6),
     1  WU1(150,6)
      COMMON/ATPAR/X(150,3),WT(150),MULT(150),UOBS(150,6),SIGU(150,6),UC
     1ALC(150,6),NUORB(150),SIGB(150,6)
      COMMON/CONT1/ISET,NO, NMULT,NA,ICOUNT,NINPAR,NPARS,NINOBS,NANG,NTO
     1T,NPULT,NA1,IFU,IB,NONRIG,NS,ISIG,ISYM,ICORL,IFU1,N8,
     2 IEIG,IMAT,IOUT, IRECAL, IFREQ
      COMMON/INOUTN/NPAGE, KOUTP,  DIS, IAW
      COMMON/INOUTC/ NAME1, ATNAME(150),TISET(80),TITLE(80),ITBL(29),
     1 NAME2
      DIMENSION D(4),AN1(4),AN2(4),NP2(4),X1(3),X2(3),IT(150),I0(150),
     1  I1(150),NP1(4),NB(12,12)
      EQUIVALENCE  (AIDX(1251), IT(1))
      EQUIVALENCE (AIDX(1400),I0(1)), (AIDX(1551),I1(1))
      CHARACTER*4 AN1,AN2
      CHARACTER*4 NAME1, ATNAME, TISET*1,TITLE*1, ITBL*3, NAME2*5
      real mult
    1 FORMAT(1X, 4(A4,1X,I2,2X,A4,1X,I2,2X,F5.3,6X))
    2 FORMAT(' ','DISTANCES SMALLER THAN ', F5.2,
     1 ', FROM INPUT ATOMS TO ALL ATOMS, INCLUDING ANY GENERATED BY SYMM
     2ETRY     KEYDIST',/)
    3 FORMAT(' ')
    4 FORMAT(1X,'ATOM ',A4,', POSN ',I2,', HAS NO NEIGHBORS WITHIN',
     1 F5.2,' ANGSTROMS.')
    5 FORMAT(1X,'ATOM ',A4,', POSN ',I2,', HAS ONLY ONE NEIGHBOR WITHIN'
     1, F5.2,' ANGSTROMS.')
    6 FORMAT(1X,'UNIT',I3,' TO UNIT',I3)
    7 FORMAT(' ','PAIRS OF ASYMMETRIC UNITS WITH AT LEAST ONE INTER-UNIT
     1 INTERATOMIC DISTANCE SMALLER THAN ',F5.2,' ANGSTROMS:',/)
C
C   NTS IS NTOTS, THE TOTAL NUMBER OF ATOMS IN THE SYSTEM
C      (INCLUDING THOSE GENERATED BY SYMMETRY)
      DO 10 I = 1,NTS
      IT(I) = 0
      I0(I) = 0
      I1(I) = 0
   10 CONTINUE
      DO 15 I=1,12
      DO 15 J = 1,12
   15 NB(I,J) = 0
      CALL OUTH6
      WRITE(*,2) DIS
      K = 1
      J = 0
C  J IS TALLY FOR FIRST ATOM
   20 J = J + 1
        IF(J.GT.NTOT) GO TO 75
      M = J
   25 M = M + 1
C  M IS TALLY FOR SECOND ATOM, INCLUDING UNIQUE AND SYMMETRY-CREATED
      IF(M.GT.NTS) GO TO 20
      D(K) = SQRT((AX(J,1) - AX(M,1))**2 +(AX(J,2) - AX(M,2))**2
     1   + (AX(J,3) - AX(M,3))**2)
      IF(D(K).GE.DIS.OR.D(K).LT.0.0001) GO TO 25
      NJ = 1
      IJ = J
   35 IF(M.GT.NTOT) GO TO 40
      NM = 1
      IM = M
      GO TO 50
   40 NM = (M - NTOT - 1)/NA + 2
      IM = M - NTOT - NA*(NM-2)
   50 AN1(K) = ATNAME(IJ)
      NP1(K) = NJ
      AN2(K) = ATNAME(IM)
      NP2(K) = NM
      IT(J) = IT(J) + 1
      IT(M) = IT(M) + 1
      IF(NO.EQ.1.OR.NM.EQ.NJ.OR.NM.GT.12.OR.NJ.GT.12) GO TO 55
      NB(NM,NJ) = 1
      NB(NJ,NM) = 1
C   NB MARKS SHORT DISTANCES BETWEEN PAIRS OF ATOMS IN SYMMETRY
C     POSNS NM AND NJ FOR UP TO 12 SYM POSITIONS
   55 IF(K.LT.4) GO TO 90
      K = 1
      LL = 4
      GO TO 80
   75 LL = K - 1
   80 WRITE(*,1) (AN1(L),NP1(L),AN2(L),NP2(L),D(L),L=1,LL)
      IF(J.GE.NTOT) GO TO 200
      GO TO 25
   90 K = K + 1
      GO TO 25
  200 WRITE(*,3)
      N0 = 0
      N1 = 0
      DO 240 I = 1,NTOT
      IF(IT(I).EQ.0) GO TO 210
      GO TO 220
  210 N0 = N0 + 1
      I0(N0) = I
      GO TO 240
  220 IF(IT(I).EQ.1) GO TO 230
      GO TO 240
  230 N1 = N1 + 1
      I1(N1) = I
  240 CONTINUE
      IF(N0.EQ.0) GO TO 260
      DO 250 I = 1,N0
      N = 1
      K = I0(I)
  250 WRITE(*,4) ATNAME(K),N,DIS
  260 CONTINUE
      IF(N1.EQ.0) GO TO 280
      DO 270 I = 1,N1
      N = 1
      K = I1(I)
  270 WRITE(*,5) ATNAME(K),N,DIS
  280 CONTINUE
      IF(NO.EQ.1) GO TO 310
      WRITE(*,7) DIS
      K = NMULT
      IF(K.GT.12) K = 12
      DO 300 I = 1,K
      DO 300 J = 1,K
      IF(NB(I,J).EQ.1) WRITE(*,6) I,J
  300 CONTINUE
  310 CONTINUE
      RETURN
      END
      SUBROUTINE DOUBLE(A,B,C)
C     MULTIPLICATION OF TWO MATRICES OF DIMENSIONS (3,3)
      DIMENSION A(3,3),B(3,3),C(3,3)
      DO 1 I=1,3
      DO 1 J=1,3
      C(I,J)=0
      DO 1 K=1,3
    1 C(I,J)=C(I,J)+A(I,K)*B(K,J)
      RETURN
      END
      SUBROUTINE EIGEN(A,V1,N)
C
C *** IN THIS VERSION, THE DIMENSION (N) IS IN THE CALLING STATEMENT
C     THE SUBROUTINE CAN HANDLE A N,N MATRIX BY ADJUSTING THE DIMENSIONS
C     AND STATEMENT NUMBER 1
C
C     THE DIAGONAL ELEMENTS OF THE REPLACED MATRIX A CONTAIN THE
C     EIGENVALUES WHICH ARE IN SEQUENCE A(1,1) A(2,2) A(3,3)
C     THE COLUMN J OF THE MATRIX V1 CONTAINS THE EIGENVECTOR BELONGING
C     TO THE EIGENVALUE A(J,J)
C
      DIMENSION V1(N,N),A(N,N)
C   1 N = 3
C ***  N IS NOW DEFINED IN THE CALLING STATEMENT
      DO 120 I = 1,N
      DO 120 J = 1,N
      IF ((I-J).NE.0) GO TO 110
      V1(I,J) = 1.
      GO TO 120
  110 V1(I,J) = 0.
  120 CONTINUE
      DO 360  K = 1,50
      SS = 0.
      NM1 = N - 1
      DO 170 I = 1,NM1
      IP1 = I + 1
      DO 170 J = IP1,N
      SS = SS + (A(I,J)**2)
      IF (K.GT.3)  GO TO 160
      TRESH = 0.2 * SQRT (2.0*SS)/N
      GO TO 170
  160 TRESH = 0.0
  170 CONTINUE
      DO 350 I = 1,NM1
      IP1 = I + 1
      DO 350 J = IP1,N
      IF ((A(I,J)**2).EQ.0.)  GO TO 200
      IF ((A(I,I) + A(I,J)).NE.A(I,I))  GO TO 220
      IF ((A(J,J) + A(I,J)).NE.A(J,J)) GO TO 220
  200 A(I,J) = 0.
      IF(A(I,I).GE.A(J,J)) GO TO 220
      C = 0.
      S = 1.
      GO TO 300
  220 CONTINUE
      IF(ABS (A(I,J)).LE.TRESH) GO TO 350
      THETA = 0.5 * (A(J,J)-A(I,I))/A(I,J)
      IF(ABS (THETA).LT.1.) GO TO 260
      IF((0.1/THETA/THETA).NE.0.)  GO TO 260
      S = 0.5 * THETA
      C = 1.
      GO TO 300
  260 T = ABS (THETA) + SQRT (1. + THETA**2)
      IF(THETA.LE.0.) GO TO 280
      T = 1./T
      GO TO 290
  280 T = -1./T
  290 C = 1./SQRT (1.+T**2)
      S = T*C
  300 D = (C*C*A(I,I)) - (2.*S*C*A(I,J)) + (S*S*A(J,J))
      A(J,J) = (S*S*A(I,I)) + (2.*S*C*A(I,J)) + (C*C*A(J,J))
      A(I,I) = D
      A(I,J) = 0.
      IM1 = I - 1
      IF (IM1 - 1) 410,311,311
  311 DO 310 KI = 1,IM1
      D = (C*A(KI,I)) - (S*A(KI,J))
      A(KI,J) = (S*A(KI,I)) + (C*A(KI,J))
      A(KI,I) = D
  310 CONTINUE
  410 JM1 = J - 1
      IF (IP1 - JM1) 321,321,420
  321 DO 320 KI=IP1,JM1
      D = (C*A(I,KI)) - (S*A(KI,J))
      A(KI,J) = (S*A(I,KI)) + (C*A(KI,J))
      A(I,KI) = D
  320 CONTINUE
  420 JP1 = J + 1
      IF (JP1 - N) 331,331,430
  331 DO 330 KI = JP1,N
      D = (C*A(I,KI)) - (S*A(J,KI))
      A(J,KI) = (S*A(I,KI)) + (C*A(J,KI))
      A(I,KI) = D
  330 CONTINUE
  430 DO 340 KI = 1,N
      D = (C*V1(KI,I)) - (S*V1(KI,J))
      V1(KI,J) = (S*V1(KI,I)) + (C*V1(KI,J))
      V1(KI,I) = D
  340 CONTINUE
      A(I,J) = 0.
  350 CONTINUE
      IF(SS.EQ.0.) GO TO 370
  360 CONTINUE
  370 RETURN
      END
      SUBROUTINE EIGVLT
C     CALCULATES EIGENVECTORS AND EIGENVALUES OF L AND T IN ORTHOGONAL
C            SYSTEM
C     IF KOUTP = 1, INERTIAL FRAME,  IF KOUTP = 2, ORTH.CRYSTAL SYSTEM
C
      COMMON//AIDX(3000)
      COMMON/INOUTN/ NPAGE, KOUTP,  DIS, IAW
      COMMON/INOUTC/ NAME1, ATNAME(150),TISET(80),TITLE(80),ITBL(29),
     1 NAME2
C     EIGENVALUES OF L = AHL(I,I),EIGENVECTORS VL(J,I),J=1,3
C     EIGENVALUES OF T = AHT(I,I),EIGENVECTORS VT(J,I),J=1,3
      DIMENSION P(80),AHL(3,3),AHT(3,3),PL(6),PT(6),VL(3,3),VT(3,3)
      EQUIVALENCE(AHL(1,1),AIDX(2601)),(AHT(1,1),AIDX(2611))
      CHARACTER*4 NAME1, ATNAME, TISET*1,TITLE*1, ITBL*3, NAME2*5
      EQUIVALENCE(PL(1),AIDX(2621)),(PT(1),AIDX(2631))
      EQUIVALENCE(VL(1,1),AIDX(2641)),(VT(1,1),AIDX(2651))
      EQUIVALENCE (P(1),AIDX(801))
C
      DO 10 I = 1,6
      PL(I) = P(I)
      PT(I) = P(I+6)
   10 CONTINUE
      CALL VMLT(PL,AHL)
      CALL VMLT(PT,AHT)
      CALL EIGEN(AHL,VL,3)
      CALL EIGEN(AHT,VT,3)
      CALL OUTH6
      CALL OTHR2
      RETURN
      END

C
      SUBROUTINE FREDA(IMIN,IMAX)
C   HEREIN  KN = TALLY FOR NUMERIC FIELDS
C           KL = TALLY FOR LITERAL FIELDS (STARTING WITH A LETTER)
C           FN(I) = (FIXED PT) VALUE OF NUMERICAL FIELD I
C           FL(I,J) = JTH CHARACTER OF ITH LITERAL FIELD (AS AN INTEGER)
C           L (NUMERIC FIELDS) = 1 AFTER FIRST NON-BLANK CHARAC OF FIELD
C                   AFTER SECOND CHARACTER FOUND, L IS GT.1
C           L (LITERAL FIELDS) = TALLY FOR NUMBER OF CHARACTERS
      INTEGER  FL,COL
      COMMON /FR/  COL(80),FL(40,6),FN(40),NCHAR,KN,KL
      DIMENSION NUM(10),INUM(10)
      DATA  NUM/1,2,3,4,5,6,7,8,9,0/
      DATA INUM/1H1,1H2,1H3,1H4,1H5,1H6,1H7,1H8,1H9,1H0/
      DATA IBLANK,IPLUS,IMINUS,IPOINT/1H ,1H+,1H-,1H./
      nchar = 6
      KN=0
      KL=0
      I=IMIN-1
C
C**** START OF A NEW FIELD
C**** LOOK FOR A NON-BLANK COLUMN
C
  109 A=0.0
      IP=0
      NP=0
      L=0
      S=1.0
  110 I=I+1
      IF(I.GT.IMAX)  GO TO 108
  111 ICH=COL(I)
      IF(L.EQ.0  .AND.  ICH.EQ.IBLANK)  GO TO 110
C**** START OF A FIELD
      L=L+1
      DO 100 J=1,10
      IF(ICH.EQ.INUM(J)) GO TO 101
  100 CONTINUE
      IF(ICH.EQ.IPOINT)  GO TO 102
      IF(ICH.EQ.IPLUS)  GO TO 103
      IF(ICH.EQ.IMINUS)  GO TO 104
      IF(L.GT.1)  GO TO 105
      GO TO 150
C**** START OF A LITERAL FIELD BY A CHARACTER WHICH IS OTHER THAN 0-9+-.
C
C**** NUMERIC FIELD FOUND
C
  101 IF(J.EQ.10)  J=0
      IF(IP.EQ.1)  NP=NP+1
  106 A=10.0*A + J
      GO TO 110
  102 IP=1
      GO TO 110
  103 IF(L.GT.1)  GO TO 105
      S=1.0
      GO TO 110
  104 IF(L.GT.1)  GO TO 105
      S=-1.0
      GO TO 110
  108 IF(L.GT.0)  GO TO 105
      GO TO 120
C**** END OF NUMERIC FIELD
  105 A = S*A/10.0**NP
      KN=KN+1
      FN(KN)=A
      IF(ICH.EQ.IPLUS .OR. ICH.EQ.IMINUS)   I=I-1
      GO TO 109
C
C**** LITERAL FIELD
C
  150 KL=KL+1
  151 FL(KL,L) = ICH
      L=L+1
      IF(L.GT.NCHAR)  GO TO 109
      I=I+1
      IF(I.GT.IMAX)  GO TO 152
      ICH=COL(I)
      IF(ICH.EQ.IBLANK)  GO TO 152
      GO TO 151
C**** END OF LITERAL FIELD DEFINED BY BLANK
  152  DO 153 J=L,NCHAR
  153 FL(KL,J) = IBLANK
C    THIS SEEMS TO IMPLY MAX NO OF CHARACTERS OUTPUT IS 5 (SIXTH BLANK)
      GO TO 109
C
C**** FINISHED
C
  120 continue
      RETURN
      END
C
      SUBROUTINE GIK (A,B)
C
      DIMENSION A(3,3),B(12)
      DO 10 I=1,3
   10 A(I,I) = B(I) * B(I)
      A(1,2) = B(1) * B(2) * B(9)
      A(2,1) = A(1,2)
      A(1,3) = B(1) * B(3) * B(8)
      A(3,1) = A(1,3)
      A(2,3) = B(2) * B(3) * B(7)
      A(3,2) = A(2,3)
      RETURN
      END
C
      SUBROUTINE INERT
C ***  modified 11.III.97 for bypassing origin shifts
C     CALCULATE AXIAL SYSTEM OF INERTIA, DETERMINE TRANSFORMATION
C     MATRICES AND (WHEN ISOLV = 1, AFTER GETTING L,T,S IN CARTESIAN
C     CRYSTAL SYSTEM) TRANSFORM NTOTs ATOMS INTO THE INERTIAL SYSTEM.
C ***  Modified Oct 1992 to permit BYPASS of some parts when IBYP.NE.0
C *****Modified by EFM March 1991 to print coordinates for NTOTS (all) 
C *****atoms IN THE INERTIAL SYSTEM
C     MODIFIED JANUARY 1982 TO TRANSFORM ESD OF U'S CORRECTLY, OR AT
C       LEAST MORE CORRECTLY, USING THE PROPOSED ISOTROPIC COVARIANCE
C       TENSOR OF HIRSHFELD AND SHMUELI, ACTA CRYST A28, 649-652 ('72)
C
      COMMON/AIDPAR/AX(150,3),AUOBS(150,6),AUCALC(150,6),WU(150,6),
     1  WU1(150,6)
      COMMON/ATPAR/X(150,3),WT(150),MULT(150),UOBS(150,6),SIGU(150,6),UC
     1ALC(150,6),NUORB(150),SIGB(150,6)
      COMMON//AIDX(3000)
      COMMON /CONT1/ISET,NO,NMULT,NA,ICOUNT,NINPAR,NPARS,NINOBS,NANG,NTO
     1T,NPULT,NA1,IFU,IB,NONRIG,NS,ISIG,ISYM,ICORL,IFU1,N8,
     2  IEIG,IMAT, IOUT,IRECAL, IFREQ
      COMMON/CONT2/ NP1,NNP1,IORIG,IWU,INOPAR
      COMMON/CONT3/ISOLV,NTOTS,CONSLV,SUMW,RWUDI,RMS,RMU,gof,sumsig,
     1  iscm,msd8
      COMMON/CORDIN/ IRIDE,IMIN,IUNC, IHAT(150), NUNC(20), TUNC(20,3),
     1 TOR(3,3), XCG(3),IHPR
      common/inerta/axi(150,3),auobsi(150,6)
      COMMON/INOUTN/ NPAGE, KOUTP,  DIS, IAW
      COMMON/INOUTC/ NAME1, ATNAME(150),TISET(80),TITLE(80),ITBL(29),
     1 NAME2
      common/new/isigx,ETA, TK,I11, isigu,nafa(7),NONSY(7),AXMOM(7),
     1  NRBP(150),NCPD,NDAT,NESD, IBYP, IEXU, inegl
      COMMON/TMCSIS/TCIC(3,3),TCIU(3,3),TCINVC(3,3),TCINVU(3,3),SCG(3),
     1 OMIN(3,3), TROI(3,3), oma(3,3) 
C
      DIMENSION TORIN(3,3)
      DIMENSION AXX(150,3), AXWT(150)
      DIMENSION VH(3),AXH(3),AH(3),TTCIU(3,3)
      DIMENSION AUO(3,3),TOMA(3,3),TTROI(3,3)
      DIMENSION DUM(3),EIGV(3),UH(3,3),XICG(3),CGM(3,3)
C
      EQUIVALENCE (TORIN(1,1),AIDX(1968))
      EQUIVALENCE (TTCIU(1,1),AIDX(1948))
      EQUIVALENCE (AUO(1,1),AIDX(2046)),(VH(1),AIDX(2055))
      EQUIVALENCE (AXH(1),AIDX(2058))
      EQUIVALENCE (AXX(1,1),AIDX(1)),(AXWT(1),AIDX(601))
      EQUIVALENCE (TTROI(1,1),AIDX(1935))
      EQUIVALENCE (AH(1),AIDX(1945)), (DPL,AIDX(1913))
      EQUIVALENCE (DUM(1),AIDX(2401)),(EIGV(1),AIDX(798))
      EQUIVALENCE (CGM(1,1),AIDX(1903))
      EQUIVALENCE (UH(1,1),AIDX(1914)),(XICG(1),AIDX(1932))
      EQUIVALENCE (WDSQ,AIDX(1958)),(TOMA(1,1),AIDX(1959))
C
      REAL   MULT
      CHARACTER*4 NAME1,ATNAME,TISET*1,TITLE*1, ITBL*3, NAME2*5
C
      NAH = NA + NA1
      if(isolv.ne.0) go to 110
      DO 5 I = 1,3
      XCG(I) = 0.
      DO 5 J = 1,3
      CGM(I,J) = 0.
    5 CONTINUE
      SUMW = 0.
      DO 300 I = 1,3
      DO 300 J = 1,3
      TORIN(I,J) = TOR(I,J)
      OMIN(I,J) = OMA(I,J)
  300 CONTINUE
      CALL MATINV(TORIN,3,3,0,DUM,DET)
      CALL MATINV(OMIN,3,3,0,DUM,DET)
C     PRINT TRANSFORMATION MATRICES FROM CRYSTAL SYSTEM TO ORTHOGONAL
C     SYSTEM AND THEIR INVERSES
      IF(IEXU.EQ.1.OR.NS.LT.(-3).OR.NS.EQ.(-2)) GO TO 305
      CALL OUTH18
      CALL OUTH15
      CALL OUTP11
      CALL OUTH14
      CALL OUTP13
      CALL OUTP20
      CALL OUTH17
  305 DO 10 I = 1,ICOUNT
C *** ICOUNT = TOTAL NO ATOMS FOR INERTIAL SYSTEM, GENERATED IN SYMPOS
C ***    AXX  ARE, INITIALLY, THE CRYSTAL-SYSTEM POSNS OF THOSE ATOMS
      CALL VECH(AXX,I,VH)
      CALL MATVEC(TOR,VH,AXH)
      CALL ARRVE(AXX,I,AXH)
C ***    AXX  ARE, NOW, POSITIONS IN THE CARTESIAN CRYSTAL SYSTEM
      IF(AXWT(I).LT.0.)   AXWT(I) =(-1.)* AXWT(I)
C   AXWT(I) IS INPUT WT MULTIPLIED BY MULT (IN  SYMPOS)
C     BUT MULT(I) IS DEFINED ONLY FOR FIRST NTOT ATOMS, WHILE
C     AXWT(I) IS DEFINED FOR NAH TIMES NMULT ATOMS, WITH
C     NAH = NA + NA1 = NO. OF UNIQUE ATOMS FOR INERTIAL TENSOR
      II = I
  306 IF(II.LE.NAH) GO TO 307
      II = II - NAH
      GO TO 306
  307 W = AXWT(I)/MULT(II)
      IF(W.EQ.800.0) AXWT(I) = 0.0
C   ATOMS WITH WT 800.0 IGNORED IN CALCULATION OF INERTIA TENSOR
      SUMW = SUMW + AXWT(I)
      DO 15 K = 1,3
      AH(K) = AXWT(I)*AXX(I,K)
      XCG(K) = XCG(K) + AH(K)
C ***    XCG IS MOLECULAR CENTER OF GRAVITY IN CARTESIAN CRYSTAL SYSTEM
      DO 15 J = 1,3
      CGM(K,J) = CGM(K,J) + AH(K)*AXX(I,J)
   15 CONTINUE
   10 CONTINUE
      DO 20 I = 1,3
      XCG(I) = XCG(I)/SUMW
   20 CONTINUE
C ***  now bypass inertial tensor calculations when IBYP is not zero
C ***    but we do have c of molecule (equally weighted atoms), XCG, in
C ***    Cartesian Crystal System.  Using this makes T,S much nearer
C ***    their reduced values than if use arbitrary xtal origin.
      IF(IBYP.EQ.0) go to 14
      DO 12 I = 1,3
      J = I + 1
      IF(J.EQ.4) J = 1
      TROI(I,I) = 1.0
      TROI(I,J) = 0.0
      TROI(J,I) = TROI(I,J)
   12 CONTINUE
      GO TO 28
   14 DO 25 I = 1,3
      DO 25 K = 1,3
      CGM(I,K) = CGM(I,K) - SUMW*XCG(I)*XCG(K)
   25 CONTINUE
C     INERTIA SYSTEM WITH CENTER IN CENTER OF GRAVITY
      CALL EIGEN(CGM,TROI,3)
      WDSQ = CGM(3,3)/SUMW
   28 CALL TRAMA(TROI,TTROI)
      CALL MATVEC(TTROI,XCG,XICG)
      CALL DOUBLE(TTROI,TOR,TCIC)
C     TCIC = TRANSFORMATION MATRIX FOR COORDINATES FROM CRYSTAL TO
C       INERTIAL SYSTEM  (or, when IBYP.NE.0, to Cartes Crystal Sys)
C     TCIU = TRANSFORMATION MATRIX FOR UOBS FROM CRYSTAL TO INERTIAL SYS
C                  (or, when IBYP.NE.0, to Cartes Crystal Sys)
C     TCIU*UOBS*TTCIU
C     TTCIU = TRANSPOSE OF TCIU
      CALL DOUBLE(TTROI,OMA,TCIU)
      CALL TRAMA(OMA,TOMA)
      IF(NO.EQ.1) NTOTS = NTOT
      DO 200 K = 1,NTOTS
      CALL VEMA(UOBS,AUO,K)
      CALL TRIPLE(OMA,AUO,TOMA,UH)
      CALL MAVE(UH,AUOBS,K)
C      AUOBS ARE NOW U'S IN CARTESIAN CRYSTAL SYSTEM
      CALL VECH(X,K,VH)
      CALL MATVEC(TOR,VH,AH)
      DO 200 I = 1,3
      if(ibyp.ne.2) go to 199
C *** IF IBYP = 2, save CCS coords rel to initial origin as ax(k,i)
      ax(k,i) = ah(i)
      go to 200
  199 AX(K,I) = AH(I) - XCG(I)
C      AX(K,I) ARE NOW CARTESIAN CRYSTAL POSITIONS REL TO C OF MASS
C ***      unless bypassing inertial calcs.  IB IBYP = 2, they are rel to
C ***      initial origing; if IBYP.ne.0 and .ne.2, they are relative to 
C ***      the unweighted center of the molecule ("centroid"?)
  200 CONTINUE
      DO 35 K = 1,NTOT
      CALL VECH(X,K,VH)
      CALL MATVEC(TOR,VH,AH)
      DO 35 I = 1,3
      AXX(K,I) = AH(I)
C      AXX(K,I) ARE CARTESIAN COORDINATES OF ALL NTOT ATOMS RELATIVE TO
C        THE CRYSTAL ORIGIN, FOR OUTPUT AND CHECKING
   35 CONTINUE
      IF(I11.NE.0.AND.ISIG.LE.0) GO TO 120
      IF(I11.EQ.0.AND.ISIGU.LE.0) GO TO 120
C      IF (ISIG.EQ.0) NO SIGU'S INPUT.
C *** IF ISIG.LT.0 or ISIGU.LT.0,  INPUT SIGU'S ARE WORKING WEIGHTS AND
C      ARE NOT TRANSFORMED. IF IWU.EQ.1, SIGU USED ONLY TO GET AVE SIGMA.
      IF(IWU.EQ.1) GO TO 120
C     CONVERT INPUT SIGB TO WU1 FOR CALCULATION WEIGHTED RMS DELTA U IN
C      CRYSTAL SYSTEM (IN UCRYST)
      DO 392 I=1,NA
      DO 392 K=1,6
C ***   NEXT TWO LINES INSERTED 20.IV.87; ANY SIGB=0. NOW LEFT IN  MAIN
      WU1(I,K) = 0.
      IF(SIGB(I,K).EQ.0.) GO TO 392
      WU1(I,K) = SUMSIG/SIGB(I,K)
  392 CONTINUE
C      SUBROUTINE  SGTRAN   TRANSFORMS SIGMAS OF U'S.
C ***    PRINT H-S VARIANCE-CHECK TABLE IF NS NON-NEG
  400 IF(IEXU.EQ.0.AND.NS.GE.0) CALL OUTH6
      IF(IEXU.EQ.0.AND.NS.GE.0) CALL OUTH31
      MM = 1
      CALL SGTRAN(OMA,SIGB,SIGU,NTOTS,MM)
C      TRANSFORMED SIGB ARE NOW PRESENT AS SIGU FOR ABS(ISIG) ATOMS
C       AND, IF SOME SYMMETRY-GENERATED ATOMS AS WELL, FOR THOSE ALSO
  120 IF(IEXU.EQ.0.AND.(NS.EQ.(-3).OR.NS.GT.(-2))) CALL OUTH6
      DO 45 I = 1,3
      DO 45 K = 1,3
      TCINVC(I,K) = TCIC(I,K)
      TCINVU(I,K) = TCIU(I,K)
   45 CONTINUE
      CALL MATINV(TCINVC,3,3,0,DUM,DET)
      CALL MATINV(TCINVU,3,3,0,DUM,DET)
C     BACKTRANSFORMATION FROM INERTIAL TO CRYSTAL SYSTEM
C     COORDINATES  TCINVC*AX + SHIFT FOR CENTER OF GRAVITY
C     U'S  TCINVU*AUOBS*TTCNVU
      IF(IEXU.EQ.1.OR.NS.EQ.(-2).OR.NS.LT.(-3)) GO TO 220
      if(ibyp.ne.0) go to 450
      CALL OUTH12
      CALL OUTH15
C     PRINT TCIC
      CALL OUTP1
      CALL OUTH14
C     PRINT TCIU
      CALL OUTP2
      CALL OUTH16
      CALL OUTH15
C          PRINT TCINVC
      CALL OUTP8
      CALL OUTH14
C          PRINT TCINVU
      CALL OUTP9
      CALL OUTH17
  450 IF(IEXU.EQ.1.OR.NS.LT.0) GO TO 220
      CALL OUTH6
C     PRINT COORDINATES IN CARTESIAN CRYSTAL SYSTEM
      CALL OUTH19
      CALL OUTH32
      CALL OUTH20
      KOUTP = 3
      if(ibyp.eq.2) koutp = 6
      CALL OUTP15
  220 EIGV(1) = CGM(2,2) + CGM(3,3)
      EIGV(2) = CGM(1,1) + CGM(3,3)
      EIGV(3) = CGM(1,1) + CGM(2,2)
      CALL MATVEC(TCINVC,XICG,SCG)
      DPL = 0.
      DO 50 I = 1,3
      DPL = DPL + (TCIC(3,I)*SCG(I))
   50 CONTINUE
      CALL TRAMA(TCIU,TTCIU)
      NTOTI=NTOT
      IF(NTOT.NE.NTOTS)NTOTI=NTOTS
      DO 500  K = 1,NTOTI
      CALL VEMA(UOBS,AUO,K)
      CALL TRIPLE(TCIU,AUO,TTCIU,UH)
      CALL MAVE(UH,AUOBSI,K)
      CALL VECH(X,K,VH)
      CALL MATVEC(TCIC,VH,AH)
C     TO TAKE CARE OF THE SHIFT OF THE ORIGIN THE COMPONENTS OF THE
C       VECTOR TO THE CENTER OF GRAVITY HAVE TO BE SUBTRACTED
      CALL MATVEC(TCIC,SCG,XICG)
C     C. OF M. IS AT SCG IN CRYSTAL SYSTEM, AT XICG IN INERTIAL SYSTEM
      DO 500 I = 1,3
      AXI(K,I) = AH(I) - XICG(I)
  500 continue
      if(ibyp.ne.0) return
      IF(NS.EQ.(-2).OR.NS.LT.(-3)) return
      IF(NTOT.GT.15.OR.NS.EQ.(-1).OR.NS.EQ.(-3)) CALL OUTH6
C     PRINT EIGENVALUES AND EIGENVECTORS OF THE TENSOR OF INERTIA,
C     PRINT CENTER OF MASS REFERRED TO THE CRYSTAL SYSTEM AND
C     DISTANCE OF THE BEST PLANE
      CALL OUTP19
C *****EFM PRINT ALL coordinates in inertial system here
      if(iexu.eq.1) return
      IF(NANG.NE.0.OR.NTOT.GT.15.OR.NS.GE.0)  CALL OUTH6
      CALL OUTH10
C     PRINT COORDINATES AND DISPLACEMENT PARAMETERS IN THE AXIAL
C     SYSTEM OF INERTIA
C ***** EFM changed 3/91 to print coordinates for symmetry-related
C ***** atoms also   
      KOUTP = 2
      IF(NTOT.NE.NTOTS)KOUTP=5
      CALL OUTP15
      return
C ***  redocalc of inertial U's and call them AUOBS, AUCALC, because
C ***    program used to look for them at this stage by that name
C ***    and I'm not prepared 3.X.91 to search for all the places 
  110 CALL TRAMA(TCIU,TTCIU)
C ***   note that if IBYP.NE.0 these calcs are all made in CARTES XTAL SYS
      NTOTI=NTOT
      IF(NTOT.NE.NTOTS)NTOTI=NTOTS
      DO 40  K = 1,NTOTI
      CALL VEMA(UOBS,AUO,K)
      CALL TRIPLE(TCIU,AUO,TTCIU,UH)
      CALL MAVE(UH,AUOBS,K)
      CALL VEMA(UCALC,AUO,K)
      CALL TRIPLE(TCIU,AUO,TTCIU,UH)
      CALL MAVE(UH,AUCALC,K)
   40 CONTINUE
      RETURN
      END
C
      SUBROUTINE INTERP(NIN)
C *** Adapted from PLUTOCAM by KNT for THMA14 
C INTERPRET CONTROL RECORDS 
      INTEGER FL,COL,TITL
      COMMON /FR/  COL(80),FL(40,6),FN(40),NCHAR,KN,KL
      COMMON/AMPCLN/NVIB,ICSVIB,NVAT1(40),NVAT2(40),
     1 NCSVIB(10), DCOS(10,3)
      COMMON/CELLP/CD(12),RCD(12),VOL,VST,GST(3,3)
      COMMON /CONT1/ISET,NO,NMULT,NA,ICOUNT,NINPAR,NPARS,NINOBS,NANG,NTO
     1T,NPULT,NA1,IFU,IB,NONRIG,NS,ISIG,ISYM,ICORL,IFU1,N8,IEIG,IMAT,
     2 IOUT, IRECAL, IFREQ
      COMMON/CONT2/NP1,NNP1,IORIG,IWU,INOPAR
      COMMON/CONT3/ISOLV,NTOTS,CONSLV,SUMW,RWUDI,RMS,RMU,gof,sumsig,
     1  iscm,msd8
      COMMON/CORDIN/ IRIDE,IMIN,IUNC, IHAT(150), NUNC(20), TUNC(20,3),
     1 TOR(3,3), XCG(3),IHPR
      COMMON/FORM/IFMX,IFMB,ILIST
      COMMON/INOUTN/ NPAGE, KOUTP,  DIS, IATWT
      COMMON/INOUTC/ NAME1, ATNAME(150),TISET(80),TITLE(80),ITBL(29),
     1 NAME2
      common/new/isigx,ETA, TK,I11, isigu,nafa(7),NONSY(7),AXMOM(7),
     1  NRBP(150),NCPD,NDAT,NESD, IBYP, IEXU, inegl
      COMMON/SYM/SYMOP(23,3,3),TMAT(3,3),RTMAT(3,3),EPSIJK(3,3,3),
     1 SYML(3)
      CHARACTER*1  CH
      CHARACTER*4 NAME1, ATNAME, TITLE*1, TISET*1, ITBL*3, NAME2*5
C ***
      DIMENSION  NUMB(10), titl(76)
      DATA NUMB/1H1,1H2,1H3,1H4,1H5,1H6,1H7,1H8,1H9,1H0/
      DATA LA,LB,LC,LD,LE,LF,LG,LH,LI,LJ,LK,LL,LM,LN,LO,LP,LQ,LR,LS,
     1LT,LU,LV,LW,LX,LY,LZ/ 1HA,1HB,1HC,1HD,1HE,1HF,1HG,1HH,1HI,1HJ,1HK,
     2 1HL,1HM,1HN,1HO,1HP,1HQ,1HR,1HS,1HT,1HU,1HV,1HW,1HX,1HY,1HZ/
      DATA LBL,LSTAR,LCOMMA/1H ,1H*,1H,/
      DATA L0,L8,L9/1H0,1H8,1H9/
C *** FIRST TIME AROUND SET PARAMETERS TO DEFAULT VALUES
C
      IEXU = 0
C ***   IEXU NEW FEB '93, the "experienced user" switch
      ifmx = 1
      ilist = 0
      ifmb = 0
      eta = -0.25
      dis = 2.0
      NO = 1
      IB = 8
      NONRIG = 0
      NVIB = -1
      NS = -1
      NSS = -1
      IFOLL = 0
      isigu = 1
      ISYM = 0
      icorl = 0
      iwu = 0
      ifu = 0
      icsvib = 0
      TK = 296.0
      irecal = 0
      isigx = 0
      iride = 0
      IBYP = 0
      imin = 0
      iunc = 0
      ifreq = 0
      iatwt = 0
      CONSLV = 0.01
      iset = 1
      NLINES = 0
C     following line added per Charles Ross, 1/11/99
      do 50 i=1,3
      DO 50 J = 1,3
      TMAT(I,J) = 0.
      RTMAT(I,J) = 0.
   50 CONTINUE
      do 55 i = 1,80
      tiset(i) = ' '
   55 continue
      CONSLV = 0.01
      IMAT = 0
      IEIG = 0
      IOUT = 0
      ISCM = 0
      MSD8 = 0
C
C***** ALL DATA lines READ HERE
    1 READ(NIN,9001,END=1000)   COL
      NLINES=NLINES+1
 9001 FORMAT(80A1)
C      IF(NIN.EQ.5)PRINT 8003,COL
C 8003 FORMAT(' CONTROL CARD...',80A1)
      J1=COL(1)
      J2=COL(2)
      J3=COL(3)
      J4=COL(4)
C ***    SKIP ANY LINES WITH BLANKS IN COLUMNS 1,2,3,4
      IF(J1.EQ.LBL.AND.J2.EQ.LBL.AND.J3.EQ.LBL.AND.J4.EQ.LBL) GO TO 1
C     IF(J1.EQ.LT .AND. J2.EQ.LI .AND. J3.EQ.LT)  GO TO 201
      IF(J1.EQ.LC .AND. J2.EQ.LO. AND. J3.EQ.LM)  GO TO 1201
      IF(J1.EQ.LC .AND. J2.EQ.LE .AND. J3.EQ.LL)  GO TO 102
      IF(J1.EQ.LE .AND. J2.EQ.LN .AND. J3.EQ.LD)  GO TO 1400
C ***  FOR LINES OTHER THAN TITL, COMM, CELL, AND END, CALL FREDA(1,80)
      CALL  FREDA(1,80)
      IF(J1.EQ.LF .AND.J2.EQ.LR.AND.J3.EQ.LM.AND.J4.EQ.LX)  GO TO 202
      IF(J1.EQ.LF .AND.J2.EQ.LR.AND.J3.EQ.LM.AND.J4.EQ.LU)  GO TO 203
      IF(J1.EQ.LD .AND. J2.EQ.LI .AND. J3.EQ.LS)            GO TO 204
C      IF(J1.EQ.LN .AND.J2.EQ.LT.AND.J3.EQ.LO.AND.J4.EQ.LT) GO TO 205
      IF(J1.EQ.LN .AND.J2.EQ.LV.AND.J3.EQ.LI.AND.J4.EQ.LB)  GO TO 205
      IF(J1.EQ.LN .AND.J2.EQ.LP.AND.J3.EQ.LT.AND.J4.EQ.LG)  GO TO 206
      IF(J1.EQ.LI .AND.J2.EQ.LO.AND.J3.EQ.LR.AND.J4.EQ.LT)  GO TO 208
      IF(J1.EQ.LN .AND.J2.EQ.LA.AND.J3.EQ.LR.AND.J4.EQ.LG)  GO TO 209
      IF(J1.EQ.LS .AND.J2.EQ.LI.AND.J3.EQ.LG.AND.J4.EQ.LU)  GO TO 211
      IF(J1.EQ.LS .AND.J2.EQ.LI.AND.J3.EQ.LG.AND.J4.EQ.LX)  GO TO 212
      IF(J1.EQ.LI .AND.J2.EQ.LS.AND.J3.EQ.LE.AND.J4.EQ.LT)  GO TO 214
      IF(J1.EQ.LC .AND.J2.EQ.LO.AND.J3.EQ.LR.AND.J4.EQ.LL)  GO TO 215
      IF(J1.EQ.LT .AND.J2.EQ.LE.AND.J3.EQ.LM.AND.J4.EQ.LP)  GO TO 216
      IF(J1.EQ.LM .AND.J2.EQ.LS.AND.J3.EQ.LD.AND.J4.EQ.LA)  GO TO 217
      IF(J1.EQ.LR .AND.J2.EQ.LE.AND.J3.EQ.LC.AND.J4.EQ.LA)  GO TO 218
      IF(J1.EQ.LA .AND.J2.EQ.LT.AND.J3.EQ.LW.AND.J4.EQ.LT)  GO TO 219
      IF(J1.EQ.LR .AND.J2.EQ.LI.AND.J3.EQ.LD.AND.J4.EQ.LE)  GO TO 220
      IF(J1.EQ.LM .AND.J2.EQ.LI.AND.J3.EQ.LN.AND.J4.EQ.LC)  GO TO 221
      IF(J1.EQ.LU .AND.J2.EQ.LN.AND.J3.EQ.LC.AND.J4.EQ.LR)  GO TO 222
      IF(J1.EQ.LF .AND.J2.EQ.LR.AND.J3.EQ.LE.AND.J4.EQ.LQ)  GO TO 223
      IF(J1.EQ.LE .AND. J2.EQ.LT .AND. J3.EQ.LA) GO TO 224
      IF(J1.EQ.LU .AND.J2.EQ.LN.AND.J3.EQ.LW.AND.J4.EQ.LT)  GO TO 225
      IF(J1.EQ.LA .AND.J2.EQ.LT.AND.J3.EQ.LU.AND.J4.EQ.LC)  GO TO 226
      IF(J1.EQ.LS .AND.J2.EQ.LY.AND.J3.EQ.LM.AND.J4.EQ.LL)  GO TO 227
      IF(J1.EQ.LI.AND.J2.EQ.LC.AND.J3.EQ.LS.AND.J4.EQ.LV) GO TO 229
      IF(J1.EQ.LO.AND.J2.EQ.LU.AND.J3.EQ.LT.AND.J4.EQ.LP) GO TO 230
      IF(J1.EQ.LB.AND.J2.EQ.LY.AND.J3.EQ.LI.AND.J4.EQ.LN) GO TO 233
      IF(J1.EQ.LF.AND.J2.EQ.LO.AND.J3.EQ.LL.AND.J4.EQ.LL) GO TO 235
      IF(J1.EQ.LT.AND.J2.EQ.LM.AND.J3.EQ.LA.AND.J4.EQ.LT) GO TO 237
      IF(J1.EQ.LR.AND.J2.EQ.LT.AND.J3.EQ.LM.AND.J4.EQ.LA) GO TO 239
      IF(J1.EQ.LT.AND.J2.EQ.LI.AND.J3.EQ.LS.AND.J4.EQ.LE) GO TO 241
      IF(J1.EQ.LC.AND.J2.EQ.LO.AND.J3.EQ.LN.AND.J4.EQ.LS) GO TO 243
      IF(J1.EQ.LI.AND.J2.EQ.LM.AND.J3.EQ.LA.AND.J4.EQ.LT) GO TO 245
      IF(J1.EQ.LI.AND.J2.EQ.LE.AND.J3.EQ.LI.AND.J4.EQ.LG) GO TO 247
      IF(J1.EQ.LI.AND.J2.EQ.LO.AND.J3.EQ.LU.AND.J4.EQ.LT) GO TO 249
      IF(J1.EQ.LE.AND.J2.EQ.LX.AND.J3.EQ.LU.AND.J4.EQ.LS) GO TO 260
      IF(J1.EQ.LI.AND.J2.EQ.LS.AND.J3.EQ.LC.AND.J4.EQ.LM) GO TO 265
      IF(J1.EQ.LM.AND.J2.EQ.LS.AND.J3.EQ.LD.AND.J4.EQ.L8) GO TO 270
      PRINT 9100, COL
 9100 FORMAT(' *WARNING* UNRECOGNISED LINE'/' ',80A1)
      GO TO 1
C
C *** CELL CONSTANTS
  102 CALL  FREDA(5,80)
      DO 103 I = 1,6
      CD(I) = FN(I)
  103 CONTINUE
      GO TO 1
C ***  PRINT COMMENTS (ONLY AT START)
 1201 PRINT 1300, (COL(I), I=5,80)
 1300 FORMAT(' ',80A1)
      GO TO 1
  202 call freda(5,80)
      if(fl(1,1).eq.LF) ilist = 1
      if(fl(1,1).eq.LO.AND.FL(1,2).EQ.LM) ifmx = 0
      if(fl(1,1).eq.LT) ifmx = 2
      if(fl(1,1).eq.LO.and.FL(1,2).eq.LR) IFMX = -1
C ***  IFMX irrelevant for free format; 0 and -1 both OK for ORTEP x,y,z,
C ***    but at wt and multiplicity in different places then; DEFAULT is
C ***    SHELX (IFMX = 1)
      go to 1
  203 call freda(5,80)
      if(fl(1,1).eq.LO) ifmB = 0
      if(fl(1,1).eq.LT) ifmB = 1
C ***  IFMB irrelevant for free format and for SHELX; O corresponds to
C ***     6F9.6,I1, and  non-zero corresponds to 6F10.6,I1
C ***    but at wt and multiplicity in different places then; DEFAULT is
C ***    SHELX (IFMX = 1)
      GO TO 1
  204 DIS = FN(1)
      GO TO 1
C  205 NTOT = FN(1)
C      GO TO 1
  205 NVIB = FN(1)
      GO TO 1
  206 NO = FN(1)
      GO TO 1
  208 IB = FN(1)
      GO TO 1
  209 NONRIG = FN(1)
      GO TO 1
  211 CALL FREDA(5,80)
      IF(FL(1,1).EQ.LN) iSIGU = 0
      IF(FL(1,1).EQ.LW) ISIGU = -1
C ***  ISIGU MADE NEGATIVE IF 'WORKING WTS' FOR OBS EQNS INPUT AS 'ESD'
C *** ISIGU (new) NEEDED IN RD14A5;  in   COMMON/NEW/
      GO TO 1
  212 CALL FREDA(5,80)
      IF(FL(1,1).EQ.LY) ISIGX = 1
C ***   DEFAULT IS NO SIGS OF X,Y,Z (ISIGX = 0)
      go to 1
  214 call freda(5,80)
C ***  here for ISET; FIND X, Y, Z, XY, XYZ, OR SP
      IF(FL(1,1).EQ.LZ)  ISET = 1
      IF(FL(1,1).EQ.LY)  ISET = 3
      IF(FL(1,2).EQ.LY.AND.FL(1,3).EQ.LZ) ISET = 5
      IF(FL(1,2).EQ.LY.AND.FL(1,3).NE.LZ) ISET = 4
      IF(FL(1,1).EQ.LX.AND.FL(1,2).NE.LY) ISET = 2
C ***  FOR SPECIAL SETTINGS, OTHER THAN THE 5 STANDARD ONES, ISET = 6
      IF(FL(1,1).EQ.LS.AND.FL(1,2).EQ.LP) ISET = 6
C ***  default of ISET IS 1 (corresp to Z-AXIS UNIQUE)
      go to 1
  215 CALL FREDA(5,80)
      IF(FL(1,1).EQ.LN) ICORL = -1
      GO TO 1
  216 TK = FN(1)
      GO TO 1
  217 CALL FREDA(5,80)
      IF(FL(1,1).EQ.LN) NVIB = 0
  218 CALL FREDA(5,80)
      IF(FL(1,1).EQ.LY) IRECAL = 1
      GO TO 1
  219 CALL FREDA(5,80)
      IF(FL(1,1).EQ.LN) IATWT = 1
      GO TO 1
  220 CALL FREDA(5,80)
      IF(FL(1,1).EQ.LY) IRIDE = 1
      GO TO 1
  221 CALL FREDA(5,80)
      IF(FL(1,1).EQ.LY) IMIN = 1
      GO TO 1
  222 CALL FREDA(5,80)
      IF(FL(1,1).EQ.LY) IUNC = 1
      GO TO 1
  223 CALL FREDA(5,80)
      IF(FL(1,1).EQ.LI) IFREQ = 1
      IF(FL(1,1).EQ.LB) IFREQ = -1
      GO TO 1
  224 ETA = FN(1)
C ***   ETA USED TO BE IN AIDX(1201) UNTIL AFTER INERT (EQUIV).  NOW PUT
C ***      IN COMMON NEW
      GO TO 1
  225 CALL FREDA(5,80)
      IF(FL(1,1).EQ.LY) IWU = 1
      GO TO 1
  226 CALL FREDA(5,80)
      IF(FL(1,1).EQ.LY) IFU = 1
      GO TO 1
  227 DO 228 I = 1,3
      SYML(I) = FN(I)
  228 CONTINUE
      ISYM = 1
      GO TO 1
  229 icsvib = fn(1)
      go to 1
C ***  to 230 when control card reads OUTP; answer can be F(ull), S(hort)
C ***        meaning somewhat shortened, or V(ery short)
C ***    (DEFAULT is S).  
  230 call freda(5,80)
      if(fl(1,1).eq.LF) NSS = 0
      if(fl(1,1).eq.LV) nss = -2
C ***  NSS DEFAULT is -1 for "partially short" output; changed to 0 if
C ***    full output wanted; to -2 if very short output wanted
      IF(NSS.EQ.0) NS = 1
      IF(NSS.EQ.-1) NS = -3
      IF(NSS.EQ.-2) NS = -4
C ***  NSS is set by line FOLL (see 235 below) if that has been read first
      go to 1
  233 IBYP = fn(1)
      go to 1
  235 call freda(5,80)
C ***  here if another compound follows, with new cell dim, params, ...
      IF(FL(1,1).EQ.LY)  IFOLL = 1
      IF(FL(1,1).EQ.LY.AND.NSS.EQ.0) NS = 1
      IF(FL(1,1).EQ.LY.AND.NSS.EQ.-1) NS = -3
      IF(FL(1,1).EQ.LY.AND.NSS.EQ.-2) NS = -4
C ***  default of NS is -1 (corresp to somewhat short, no cpd follows)
      go to 1
  237 DO 238 I = 1,3
      DO 238 J = 1,3
      K = 3*(I-1) + J 
C ***   FOR I = 1, K = 1,2,3; FOR I = 2, K = 4,5,6; FOR I = 3, K = 7,8,9
      TMAT(I,J) = FN(K)
  238 CONTINUE
      GO TO 1
  239 DO 240 I = 1,3
      DO 240 J = 1,3
      K = 3*(I-1) + J 
      RTMAT(I,J) = FN(K)
  240 CONTINUE
      GO TO 1
C ***  TISET = TITLE FOR SPECIAL SETTING OF UNIQUE AXIS 
  241 DO 1200  I = 1,76
      J = I + 4
      TITL(I) = COL(J)
 1200 CONTINUE
C ***  TITL is not in character form, but TISET is in THMA
      DO 1305 I = 1,4
      TISET(I) = ' '
 1305 CONTINUE
      DO 1310 J = 1,76
      I = J + 4
      N = TITL(J)
C ***  For an IBM compiler, the following ENCODE statement probably needs
C ***   to be replaced.  Delete it and replace it by the line that precedes
C ***   it, after removing the C at left margin.
      write(ch,1202) N
C      ENCODE(1,1202,CH)   N
      TISET(I) = CH
C ***  For an IBM compiler, the following ENCODE statement probably needs
C ***   to be replaced.  Delete it and replace it by the line that precedes
C ***   it, after removing the C at left margin.
      write(TISET(I),1202) TITL(J)
C      encode(1,1202,TISET(I))   titl(J)
 1310 CONTINUE
 1202 format(A1)
  243 CONSLV = FN(1)
      GO TO 1
  245 IMAT = FN(1)
      GO TO 1
  247 IEIG = FN(1)
      GO TO 1
  249 IOUT = FN(1)
      GO TO 1
  260 IEXU = 1
      go to 1
  265 ISCM = FN(1)
      GO TO 1
  270 MSD8 = FN(1)
      go to 1
 1400 IF(IFOLL.EQ.0) NS = NSS
C *** IFOLL = 0 means no FOLL Y line has been found for this structure;
C ***   NS then equals NSS, which is default -1 if no OUTP line has been
C ***   included (or OUTP S has been); otherwise -2 if FOLL V, 0 if FOLL F
      RETURN
C
C*** END OF FILE ON (NIN)
C
 1000 IF(NIN.EQ.5) IEOF5=1
      IF(NLINES.EQ.0) GO TO 1030
      PRINT 9940,  NLINES
 9940 FORMAT('  ',i3,' lines of input')
      RETURN
C MESSAGE WHEN NO CONTROL LINES GIVEN
 1030 PRINT 9930
 9930 FORMAT(' *NOTE* NO CONTROL RECORDS FOUND ON UNIT 5 ')
      RETURN
      END
C
      SUBROUTINE INTSET(K1,I,L)
C
C     SET EQUIVALENT INDICES FOR U'S AND DERIVATIVES
C
      GO TO (1,2,3,4,5,6), K1
    1 I = 1
      L = 1
      GO TO 25
    2 I = 2
      L = 2
      GO TO 25
    3 I = 3
      L = 3
      GO TO 25
    4 I = 1
      L = 2
      GO TO 25
    5 I = 1
      L = 3
      GO TO 25
    6 I = 2
      L = 3
   25 CONTINUE
      RETURN
      END
      SUBROUTINE LFRAME
C
C     ROTATE S AND T TO L FRAME, CALCULATE SHIFT OF ORIGIN TO REDUCE
C     TRACE OF  T AND SYMMETRIZE  S,SEE SCHOMAKER AND TRUEBLOOD,
C     ACTA CRYST(1968) B24,63, EQUATIONS P.67
C
C *** if IBYP.ne.0, references to I frame here will be to Cartes Xtal Sys
C     VL = EIGENVECTORS OF L IN I FRAME
C     AHL(I,I) = EIGENVALUES L IN I FRAME
C     VLT = TRANSPOSE OF VL
C     PT = ORIG. T TENSOR IN I FRAME(VECTORIAL SEQUENCE)
C     AAHT(3,3)= ORIG. T TENSOR IN I FRAME
C     AHT = EIGENVALUES OF ORIGINAL T TENSOR IN I FRAME
C     VT = EIGENVECTORS OF ORIGINAL T TENSOR IN I FRAME
C     AHS(3,3) = ORIG. S TENSOR IN I FRAME
C     RO (3) = ORIGIN SHIFT IN I FRAME
C     TNEW = NEW T TENSOR IN I FRAME
C     TNEWE = EIGENVALUES OF NEW T IN I FRAME
C     TNEWV = EIGENVECTORS OF NEW T IN I FRAME
C     SNEW = NEW S TENSOR IN I FRAME      (SYMMETRICAL)
C     TROT = TRACE OF OLD T, TRNT = TRACE OF NEW T
C
C     ROL(3) = ORIGIN SHIFT IN L FRAME
C     SL = ORIG. S TENSOR IN L FRAME
C     TL = ORIG. T TENSOR IN L FRAME
C     TLE = EIGENVALUES OF TL, TTLEV= EIGENVECTORS OF TL
C     SO = NEW SYMMETRIC S TENSOR IN L FRAME
C     TO = NEW T TENSOR IN L FRAME, TRACE OF T REDUCED
C     TOE = EIGENVALUES OF TO, TOEV = EIGENVECTORS OF TO
C
      COMMON/AIDPAR/AX(150,3),AUOBS(150,6),AUCALC(150,6),WU(150,6),
     1  WU1(150,6)
      COMMON//AIDX(3000)
      COMMON /CONT1/ISET,NO,NMULT,NA,ICOUNT,NINPAR,NPARS,NINOBS,NANG,NTO
     1T,NPULT,NA1,IFU,IB,NONRIG,NS,ISIG,ISYM,ICORL,IFU1,N8,
     2  IEIG,IMAT, IOUT,IRECAL, IFREQ
      COMMON/CONT3/ISOLV,NTOTS,CONSLV,SUMW,RWUDI,RMS,RMU,gof,sumsig,
     1  iscm,msd8
      COMMON/INOUTN/ NPAGE, KOUTP, DIS, IAW
      COMMON/INOUTC/ NAME1, ATNAME(150),TISET(80),TITLE(80),ITBL(29),
     1 NAME2
      common/new/isigx,ETA, TK,I11, isigu,nafa(7),NONSY(7),AXMOM(7),
     1  NRBP(150),NCPD,NDAT,NESD, IBYP, IEXU, inegl
      COMMON/SYM/SYMOP(23,3,3),TMAT(3,3),RTMAT(3,3),EPSIJK(3,3,3),
     1 SYML(3)
      DIMENSION AAHT(3,3),AHS(3,3),AHL(3,3),VL(3,3),SL(3,3),TL(3,3)
      DIMENSION PT(6),ROL(3),RO(3),VLT(3,3),SO(3,3),TO(3,3),TNEW(3,3)
      DIMENSION TOE(3,3),TOEV(3,3),TLE(3,3),TLEV(3,3),TNEWE(3,3)
      DIMENSION TNEWV(3,3),AHT(3,3),VT(3,3),P(80)
      DIMENSION R(3,3),SNEW(3,3)
      DIMENSION AXX(150,3)
      EQUIVALENCE(AXX(1,1),AIDX(1))
      EQUIVALENCE (PT(1),AIDX(2631)),(VL(1,1),AIDX(2641))
      EQUIVALENCE (AHL(1,1),AIDX(2601)),(AHT(1,1),AIDX(2611))
      EQUIVALENCE (VT(1,1),AIDX(2651)), (P(1),AIDX(801))
      EQUIVALENCE(AAHT(1,1),AIDX(2771)),(AHS(1,1),AIDX(2781))
      EQUIVALENCE(SL(1,1),AIDX(2791)),(TL(1,1),AIDX(2801))
      EQUIVALENCE(ROL(1),AIDX(2811)),(RO(1),AIDX(2815))
      EQUIVALENCE(VLT(1,1),AIDX(2821)),(R(1,1),AIDX(761))
      EQUIVALENCE(SO(1,1),AIDX(2831)),(TO(1,1),AIDX(2841))
      EQUIVALENCE(TNEW(1,1),AIDX(2551)),(TOE(1,1),AIDX(2561))
      EQUIVALENCE (TOEV(1,1),AIDX(2571)),(TLE(1,1),AIDX(2581))
      EQUIVALENCE(TLEV(1,1),AIDX(2591)),(TNEWE(1,1),AIDX(601))
      EQUIVALENCE (TNEWV(1,1),AIDX(611)),(SNEW(1,1),AIDX(751))
      EQUIVALENCE (TROT,AIDX(695)),(TRNT,AIDX(696))
      CHARACTER*4 NAME1,ATNAME,TISET*1,TITLE*1,ITBL*3, NAME2*5
C
      CALL VMLT(PT,AAHT)
      CALL TRIPLE(VLT,AAHT,VL,TL)
      SL1 = SL(2,3) - SL(3,2)
      SL2 = SL(3,1) - SL(1,3)
      SL3 = SL(1,2)- SL(2,1)
      ROL(1) = SL1 /(AHL(2,2) + AHL(3,3))
      ROL(2) = SL2 /(AHL(1,1) + AHL(3,3))
      ROL(3) = SL3 /(AHL(1,1) + AHL(2,2))
      CALL MATVEC(VL,ROL,RO)
      DO 20 I = 1,3
      DO 20 J = 1,3
      R(I,J) = 0.
      DO 20 K = 1,3
      R(I,J) = R(I,J) + EPSIJK(I,J,K)*ROL(K)
   20 CONTINUE
C     CALCULATE NEW SYMMETRICAL S IN L FRAME
      DO 30 I = 1,3
      DO 30 J = 1,3
      SO(I,J) = R(J,I)*AHL(I,I) + SL(I,J)
   30 CONTINUE
C     CALCULATE NEW T IN L FRAME
      DO 40 I = 1,3
      DO 40 L = 1,3
      TO(I,L) = 0.
      DO 50 J = 1,3
      TO(I,L) = TO(I,L) + R(I,J)*R(L,J)*AHL(J,J)
      TO(I,L) = TO(I,L) + R(I,J)* SL(J,L) + R(L,J)*SL(J,I)
   50 CONTINUE
      TO(I,L) = TO(I,L) + TL(I,L)
   40 CONTINUE
      CALL TRIPLE(VL,TO,VLT,TNEW)
      CALL TRIPLE(VL,SO,VLT,SNEW)
      DO 60 I = 1,3
      DO 60 K = 1,3
      TOE(I,K) = TO(I,K)
      TLE(I,K) = TL(I,K)
      TNEWE(I,K) = TNEW(I,K)
   60 CONTINUE
      CALL EIGEN(TOE,TOEV,3)
      CALL EIGEN(TLE,TLEV,3)
      CALL EIGEN(TNEWE,TNEWV,3)
      TROT = 0.
      KOUTP = 1
      DO 70 I = 1,3
      TROT = TROT + AAHT(I,I)
   70 CONTINUE
      TRNT = TROT - ROL(1)*SL1 - ROL(2)*SL2 - ROL(3)*SL3
      IF(IEXU.EQ.1.OR.NS.LT.0) RETURN
      CALL OUTH6
      CALL OTHR12
      CALL OUTR7
C     PRINT ORIGIN SHIFT AND TENSORS IN L AND I FRAME
      RETURN
      END
C
      SUBROUTINE LIBCOR
C ***  27.I  CALLED NOW ONLY WHEN  NS.GE.0 OR IOUT.NE.0
C             OCTOBER 1985 -- CORRD DISTANCES NOW CALCD IN 'DISCOR';
C                    NOW ONLY CORRECTED PARAMETERS CALCD, OUTPUT HERE
C     CALCULATES LIBRATION CORRECTIONS BY SCHOMAKER-TRUEBLOOD EQ 21. NO
C       Q**2 TERMS (CRUICKSHANK) USED; IN EFFECT ASSUME Q**2 INFINITE
C       (PEAKS BROAD RELATIVE TO OSCILLATIONS). SEE ALSO ACTA 17,142.
      COMMON/AIDPAR/AX(150,3),AUOBS(150,6),AUCALC(150,6),WU(150,6),
     1  WU1(150,6)
      COMMON/ATPAR/X(150,3),WT(150),MULT(150),UOBS(150,6),SIGU(150,6),
     1  UCALC(150,6),NUORB(150),SIGB(150,6)
      COMMON//AIDX(3000)
      COMMON/CELLP/CD(12),RCD(12),VOL,VST,G(3,3)
      COMMON /CONT1/ISET,NO,NMULT,NA,ICOUNT,NINPAR,NPARS,NINOBS,NANG,NTO
     1T,NPULT,NA1,IFU,IB,NONRIG,NS,ISIG,ISYM,ICORL,IFU1,N8,
     2 IEIG, IMAT,IOUT,IRECAL, IFREQ
      common/inerta/axi(150,3),auobsi(150,6)
      COMMON/INOUTN/ NPAGE, KOUTP,  DISTA, IAW
C *** WHAT IS INPUT AS "DIS" IS HERE CALLED "DISTA"
      COMMON/INOUTC/ NAME1, ATNAME(150),TISET(80),TITLE(80),ITBL(29),
     1 NAME2
      common/new/isigx,ETA, TK,I11, isigu,nafa(7),NONSY(7),AXMOM(7),
     1  NRBP(150),NCPD,NDAT,NESD, IBYP, IEXU, inegl
      COMMON/SYM/SYMOP(23,3,3),TMAT(3,3),RTMAT(3,3),EPSIJK(3,3,3),
     1 SYML(3)
      COMMON/TMCSIS/TCIC(3,3),TCIU(3,3),TCINVC(3,3),TCINVU(3,3),SCG(3),
     1 OMIN(3,3), TROI(3,3), oma(3,3)
      DIMENSION AHL(3,3),DIS(4),AT1(4),AT2(4),WTT(150)
      DIMENSION PL(6),AL(3,3),W(3,3),DEL(3),AAX(3),AXX(150,3)
      EQUIVALENCE(AHL(1,1),AIDX(2601)),(WTT(1),AIDX(451))
      EQUIVALENCE (AXX(1,1),AIDX(1)),(AAX(1),AIDX(2685))
      EQUIVALENCE(W(1,1),AIDX(2671)),(DEL(1),AIDX(2681))
      EQUIVALENCE(PL(1),AIDX(2621)),(AL(1,1),AIDX(2661))
      CHARACTER*4  AT1,AT2
      CHARACTER*4 NAME1,ATNAME,TISET*1,TITLE*1, ITBL*3, NAME2*5
      real mult
C
  200 FORMAT(1X,4(A4,2X,A4,2X,F6.3,10X))
C
      DO 80 I = 1,3
      IF(AHL(I,I).EQ.0.)  RETURN
   80 CONTINUE
      TRAL = 0.
      CALL VMLT(PL,AL)
      DO 5 I = 1,3
      TRAL = TRAL + AL(I,I)
    5 CONTINUE
      DO 10 I = 1,3
      DO 10 J = 1,3
      W(I,J) = 0.5*(SYMOP(1,I,J)*TRAL - AL(I,J))
   10 CONTINUE
      DO 15 K = 1,NTOT
      DO 20 I = 1,3
      DEL(I) = 0.
      AAX(I) = AXi(K,I)
      DO 30 J = 1,3
      DEL(I) = DEL(I) + W(I,J)*AXi(K,J)
   30 CONTINUE
      AAX(I) = AAX(I) + DEL(I)
   20 CONTINUE
C          BACK-CORRECT FOR ORIGIN SHIFT OF AX(K,J) TO CENTER OF MASS
   60 DO 50 I = 1,3
      AXX(K,I) = SCG(I)
      DO 50 J = 1,3
      AXX(K,I) = AXX(K,I) + TCINVC(I,J)*AAX(J)
   50 CONTINUE
   15 CONTINUE
      IF(iexu.ne.0.or.NS.LT.0) GO TO 90  
C *** SUBROUTINE NOT EVEN CALLED WHEN NS NEG, unless IOUT is non-zero
      CALL OUTH6
      CALL OTHR21
      CALL OTHR14
C     PRINT ATOMIC COORDINATES BEFORE AND AFTER LIBRATION CORRECTION
      KOUTP = 4
      CALL OUTP15
   90 IF(IOUT.NE.0) CALL OUTR9
C     OUTPUT NEW COORDINATES ON UNIT 7
      RETURN
      END
      SUBROUTINE MATINV(A,N,NA,M,B,DETERM)
C
C     N = SIZE OF THE SQUARE MATRIX A AND VECTOR B
C        N MUST BE NO LARGER THAN NA, DIMENSION OF A AND B (LINE 14655)
C        NA, THE DIMENSION OF A AND B, IS DEFINED IN THE CALLING PROGRAM
C     M = 0  MATRIX INVERSION ONLY
C     M = 1 MATRIX INVERSION AND SOLUTION OF LINEAR EQUATION
C     B = RIGHT HAND SIDE OF SYSTEM OF LINEAR EQUATIONS
C   RESULTS:
C     A CONTAINS INVERTED MATRIX  A**-1
C     B CONTAINS SOLUTIONS
C     DETERM = DETERMINANT
C     IF DETERM = 0.0, IT MEANS THAT LARGEST AVAILABLE ELEMENT BECAME
C        0.0 AND NO RELIABLE RESULTS OBTAINED
C
      COMMON//AIDX(3000)
      COMMON/IAID1/IAIDX1(1000)
C     MATINV USES FOR MAX. DIMENSIONS OF MATRIX
C     COMMON// AIDX(801-880,1301-1540)  AND /IAID1/IAIDX1(360 - 439)
C     DUM = B   IN AIDX(801 - 880)
      DIMENSION IPIVOT(80), INDEX(80,2), PIVOT(80)
      DIMENSION A(NA,NA),B(NA)
      EQUIVALENCE (IAIDX1(360),IPIVOT(1)),(AIDX(1381),INDEX(1,1))
      EQUIVALENCE (AIDX(1301),PIVOT(1))
C
C     INITIALIZATION
C
      DETERM=1.0
      DO 20 J=1,N
   20 IPIVOT(J)=0
      DO 550 I=1,N
C
C     SEARCH FOR PIVOT ELEMENT
      AMAX=0.0
      DO 105 J=1,N
      IF(IPIVOT(J).EQ.1)  GO TO 105
      DO 100 K = 1,N
      IF(IPIVOT(K).EQ.1)  GO TO 100
      IF(IPIVOT(K).GT.1)  GO TO 740
      AH = ABS(AMAX) - ABS(A(J,K))
      IF(AH.GE.0.)  GO TO 100
      IROW = J
      ICOLUM=K
      AMAX=A(J,K)
  100 CONTINUE
  105 CONTINUE
       IF (AMAX)110,800,110
  110 IPIVOT(ICOLUM)=IPIVOT(ICOLUM)+1
C
C     INTERCHANGE ROWS TO PUT PIVOT ELEMENT ON DIAGONAL
C
      IF (IROW-ICOLUM) 140, 260, 140
  140 DETERM=-DETERM
      DO 200 L=1,N
      SWAP=A(IROW,L)
      A(IROW,L)=A(ICOLUM,L)
  200 A(ICOLUM,L)=SWAP
      IF (M.EQ.0)  GO TO 260
      SWAP=B(IROW)
      B(IROW) = B(ICOLUM)
      B(ICOLUM) = SWAP
  260 INDEX(I,1)=IROW
      INDEX(I,2)=ICOLUM
      PIVOT(I)=A(ICOLUM,ICOLUM)
      DETERM=DETERM*PIVOT(I)
C
C     DIVIDE PIVOT ROW BY PIVOT ELEMENT
C
      A(ICOLUM,ICOLUM)=1.0
      DO 350 L=1,N
  350 A(ICOLUM,L)=A(ICOLUM,L)/PIVOT(I)
      IF (M.NE.0)  B(ICOLUM) =B(ICOLUM)/PIVOT(I)
C
C     REDUCE NON-PIVOT ROWS
C
      DO 550 L1=1,N
      IF(L1-ICOLUM) 400, 550, 400
  400 T=A(L1,ICOLUM)
      A(L1,ICOLUM)=0.0
      DO 450 L=1,N
  450 A(L1,L)=A(L1,L)-A(ICOLUM,L)*T
      IF (M.NE.0)  B(L1) = B(L1) - B(ICOLUM)*T
  550 CONTINUE
C
C     INTERCHANGE COLUMNS
C
      DO 710 I=1,N
      L=N+1-I
      IF (INDEX(L,1)-INDEX(L,2)) 630, 710, 630
  630 JROW=INDEX(L,1)
      JCOLUM=INDEX(L,2)
      DO 705 K=1,N
      SWAP=A(K,JROW)
      A(K,JROW)=A(K,JCOLUM)
      A(K,JCOLUM)=SWAP
  705 CONTINUE
  710 CONTINUE
  740 RETURN
  800 DETERM=0.0
      RETURN
      END
      SUBROUTINE MATVEC(A,B,C)
C
C     MULTIPLICATION OF MATRIX(3,3) WITH VECTOR
      DIMENSION A(3,3),B(3),C(3)
      DO 1 I=1,3
      C(I)=0.
      DO 1 J=1,3
    1 C(I)=C(I)+A(I,J)*B(J)
      RETURN
      END
      SUBROUTINE MAVE(A,V,I)
C
C     CONVERTS (3,3) MATRIX INTO AN ARRAY OF VECTORS WITH 6 ELEMENTS
      DIMENSION A(3,3), V(150,6)
      DO 10 K = 1,3
      V(I,K) = A(K,K)
   10 CONTINUE
      V(I,4) = A(1,2)
      V(I,5) = A(1,3)
      V(I,6) = A(2,3)
      RETURN
      END
C
      SUBROUTINE MVLT(A,V)
C     CONVERTS L AND T ARRAYS INTO VECTORS
C     SEQUENCE OF L AND T VECTORS L11,L12,L13,L22,L23,L33....
C
      DIMENSION A(3,3), V(6)
      L = 0
      DO 10 K = 1,3
      DO 10 J = K,3
      L = L + 1
      V(L) = A(K,J)
   10 CONTINUE
      RETURN
      END
 
      SUBROUTINE NPAR
C
C     PRINT SYMMETRY OPERATIONS AND, FOR TRICLINIC, MONOCLINIC, AND
C     ORTHORHOMBIC POINT GROUPS, DETERMINE THE NUMBER OF INDEPENDENT
C     PARAMETERS AND SET UP LIST OF CONSTRAINTS FOR PARAMETERS.  FOR THE
C     HIGHER-SYMMETRY POINT GROUPS, THIS IS DONE IN SYMET NOW.
C
      COMMON/ATPAR/X(150,3),WT(150),MULT(150),UOBS(150,6),SIGU(150,6),UC
     1ALC(150,6),NUORB(150),SIGB(150,6)
      COMMON//AIDX(3000)
      COMMON /CONT1/ISET,NO,NMULT,NA,ICOUNT,NINPAR,NPARS,NINOBS,NANG,NTO
     1T,NPULT,NA1,IFU,IB,NONRIG,NS,ISIG,ISYM,ICORL,IFU1,N8,
     2 IEIG,IMAT, IOUT,IRECAL, IFREQ
      COMMON/CONT3/ISOLV,NTOTS,CONSLV,SUMW,RWUDI,RMS,RMU,gof,sumsig,
     1  iscm,msd8
      COMMON/IAID1/IAIDX1(1000)
      COMMON/INOUTN/ NPAGE, KOUTP,  DIS, IAW
      COMMON/INOUTC/ NAME1, ATNAME(150),TISET(80),TITLE(80),ITBL(29),
     1 NAME2
      COMMON/IPAR/ NP(80)
      DIMENSION AIDS(48,3,3),DET(48),SMA(3,3),TMA(3,3),TNEW(3,3)
      DIMENSION SNEW(3,3),AH(9),NNP(9)
      EQUIVALENCE (AIDS(1,1,1),AIDX(2001)),(DET(1),AIDX(2501))
      EQUIVALENCE (SMA(1,1),AIDX(2951)),(TMA(1,1),AIDX(2961))
      EQUIVALENCE (TNEW(1,1),AIDX(2971)),(SNEW(1,1),AIDX(2980))
      EQUIVALENCE (AH(1),AIDX(2991))
      EQUIVALENCE (NNP(1),IAIDX1(481))
      CHARACTER*4 NAME1,ATNAME,TISET*1,TITLE*1, ITBL*3, NAME2*5
      real mult
C
      EPS = 0.00001
      IF (NO.GE.75) GO TO 615
C          FOR GROUPS WITH MORE THAN 2-FOLD SYMMETRY ELEMENTS, THE
C         CONSTRAINTS ARE SET AND THE PARAMETERS COUNTED IN SYMET NOW.
      DO 100 I=1,21
  100 NP(I) = I
    1 DO 10 I=1,3
      SI = FLOAT(I)*10.
      DO 10 J=1,3
   10 SMA(I,J) = SI + FLOAT(J)
      DO 20 I=1,3
      SI = FLOAT(I)*10
      DO 20 J=I,3
      TMA(J,I) = SI + FLOAT(J)
   20 TMA(I,J) = TMA(J,I)
      DO 25 I=1,3
      DO 25 J=1,3
      TNEW(I,J) = 0.
      SNEW(I,J) = 0.
   25 CONTINUE
      DO 30 NSY = 1,NMULT
      DO 130 I = 1,3
      DO 130 J = I,3
      SUMT = 0.
      DO 40 K=1,3
      DO 40 L=1,3
      SSYM = AIDS(NSY,I,K)*AIDS(NSY,J,L)
   40 SUMT = SUMT + SSYM*TMA(K,L)
      TNEW(I,J) = TNEW(I,J) + SUMT
  130 TNEW(J,I) = TNEW(I,J)
      DO 135 I = 1,3
      DO 135 J = 1,3
      SUMS = 0.
      DO 45 K=1,3
      DO 45 L=1,3
      SSYM = AIDS(NSY,I,K)*AIDS(NSY,J,L)
   45 SUMS = SUMS + SSYM*DET(NSY)*SMA(K,L)
  135 SNEW(I,J) = SNEW(I,J) + SUMS
   30 CONTINUE
      DO 50 I=1,3
      DO 50 J=1,3
      TMA(I,J)  = TNEW(I,J)/NMULT
   50 SMA(I,J)  = SNEW(I,J)/NMULT
      NPULT = 0
      NPARS = 0
      DO 210 I = 1,3
      DO 210 K=I,3
      IF (TMA(I,K).EQ.0.)  GO TO 210
      NPULT = NPULT + 1
  210 CONTINUE
      DO 220 I = 1,3
      DO 220 K = 1,3
      IF (SMA(I,K).EQ.0.)  GO TO 220
      NPARS = NPARS + 1
  220 CONTINUE
      IF (NPARS.GT.4)  NPARS = NPARS - 1
C     POINT GROUP SYMMETRIES C1 AND C2  AMBIGUITY IN DIAGONAL OF S
C     REDUCTION OF NUMBER OF INDEPENDENT PARAMETERS
      IF(NO.EQ.1) GO TO 200
      IF(NO.NE.2) GO TO 300
  200 NINPAR = 2*NPULT + NPARS
      IF(NO.EQ.2) GO TO 620
      IF(NO.EQ.1) GO TO 620
C        FOLLOWING SECTION (DOWN TO 615) IS NOW USED ONLY FOR POINT-
C         GROUP SYMMETRIES CORRESPONDING TO MONOCLINIC AND ORTHO-
C         RHOMBIC SPACE GROUPS, ALTHOUGH LOGIC REMAINS THAT OF THE
C         EARLIER VERSION (SOME NOT NOW NEEDED FOR USUAL SETTINGS OF
C         THE PRINCIPAL AXIS).
  300 I2 = 6
      DO 310 I = 1,3
  310 AH(I) = TMA(1,I)
      DO 320 I = 4,5
  320 AH(I) = TMA(2,I-2)
      AH(6) = TMA(3,3)
  325 DO 330 I = 1,I2
  330 NNP(I) = I
      DO 345 J = 1,I2
      I1 = J + 1
      AAH = ABS(AH(J))
      IF(AAH.LE.EPS)  GO TO 340
      SAH = AH(J)
      NSAH = NNP(J)
      GO TO 335
  340 NNP(J) = 0
  345 CONTINUE
  335 IF(J.GE.I2)  GO TO 350
  360 IKH = 1
      DO 355 I = I1,I2
      AAH = ABS(AH(I))
      IF(AAH.LE.EPS)  GO TO 380
      AAH = ABS(AH(I)-SAH)
      IF(AAH.LE.EPS)  GO TO 390
      AAH = ABS(AH(I)+SAH)
      IF(AAH.GT.EPS)  GO TO 355
      IKH = - 1
  390 IF(ISET.EQ.3)  GO TO 370
      IF(ISET.GT.3)  GO TO 365
  395 NNP(I) = IKH * NSAH
      GO TO 355
  370 IF(NO.GE.195)  GO TO 395
      IF(I2.EQ. 6)  GO TO 410
      IF(I .EQ. 5)  GO TO 355
      IT = I1 - 1
      IF(IT.EQ. 5)  GO TO 355
      GO TO 395
  410 IF(I.EQ.4)  GO TO 355
      GO TO 395
  365 IF(I2.EQ.9)  GO TO 375
      IT = I1 - 1
      IF(IT.EQ.1)  GO TO 366
      IF(IT.EQ.4)  GO TO 366
C     TEST FOR DIAGONAL ELEMENTS
      IF(I .EQ.4)  GO TO 355
      IF(I .EQ.6)  GO TO 355
      GO TO 395
  366 IF(I .EQ.4)  GO TO 395
      IF(I .EQ.6)  GO TO 395
      GO TO 355
  375 IT = I1 - 1
C     TEST FOR DIAGONAL ELEMENTS
      IF(IT.EQ.1)  GO TO 376
      IF(IT.EQ.5)  GO TO 376
      IF(I .EQ.5)  GO TO 355
      IF(I .EQ.9)  GO TO 355
      GO TO 395
  376 IF(I .EQ.5)  GO TO 395
      IF(I .EQ.9)  GO TO 395
      GO TO 355
  380 NNP(I) = 0
  355 CONTINUE
      SAH = AH(I1)
      NSAH = NNP(I1)
      I1 = I1 + 1
      IF(I1.NE.I2)  GO TO 360
  350 IF(I2.EQ.9)  GO TO 470
      DO 450 I = 1,I2
      IC = 0
      NP(I) = NNP(I)
      IF(NNP(I).EQ.0)  GO TO 460
      NHP = IABS(NNP(I)) + 6
      NP(I+6) = ISIGN(NHP,NNP(I))
      GO TO 450
  460 NP(I+6) = 0
  450 CONTINUE
      GO TO 500
  470 DO 480 I = 1,I2
      IC = 1
      IF(NNP(I).EQ.0)  GO TO 490
      NHP = IABS(NNP(I)) + 12
      NP(I+12) = ISIGN(NHP,NNP(I))
      GO TO 480
  490 NP(I+12) = 0
  480 CONTINUE
      CALL CNTPAR
      GO TO 620
  500 I2 = 9
      DO 590 I = 1,3
  590 AH(I) = SMA(1,I)
      DO 600 I = 1,3
  600 AH(I + 3) = SMA(2,I)
      DO 610 I = 1,3
  610 AH(I + 6) = SMA(3,I)
      GO TO 325
  615 NINPAR = 2*NPULT + NPARS
C     PRINT NAME1,NAME2,NA, NINOBS, NINPAR
  620 CALL OUTP3
      CALL ORTHO
      CALL INERT
      RETURN
      END
C
      SUBROUTINE NRBPAR
C
C     PRODUCE LIST INDICATING IN WHICH ARGs EACH ATOM PARTICIPATES,
C     	in NRBP(150)  
C
      COMMON/AXESN/ISPAX(15),LT(5,15),LAT(5,15)
      COMMON/AXESC/LBAT(5,15)
      CHARACTER*4 LBAT
      COMMON /CONT1/ISET,NO,NMULT,NA,ICOUNT,NINPAR,NPARS,NINOBS,NANG,NTO
     1T,NPULT,NA1,IFU,IB,NONRIG,NS,ISIG,ISYM,ICORL,IFU1,N8,
     2 IEIG,IMAT, IOUT,IRECAL, IFREQ
      COMMON/IAID1/ IAIDX1(1000)
      COMMON/INOUTN/ NPAGE, KOUTP,  DIS, IAW
      COMMON/INOUTC/ NAME1, ATNAME(150),TISET(80),TITLE(80),ITBL(29),
     1 NAME2
      common/new/isigx,ETA, TK,I11, isigu,nafa(7),NONSY(7),AXMOM(7),
     1  NRBP(150),NCPD,NDAT,NESD, IBYP, IEXU, inegl
      COMMON/NONAM/ NONAME(7,40)
      CHARACTER*4 NONAME
      DIMENSION NM(40)
      CHARACTER*4 NAME1,ATNAME,TISET*1,TITLE*1, ITBL*3, NAME2*5
C
      NNM = 0
      MST = 16
      DO 5 I = 1,NTOT
      NRBP(I) = 0
    5 CONTINUE
C       TEST FOR MATCH OF ATOM NAMES OF AFFECTED ATOMS;
      DO 7 I = 1,NONRIG
      NAFAI = NAFA(I)
      DO 4 J = 1,NAFAI
    4 NM(J) = 0
      DO 6 L = 1,NTOT
      DO 6 K = 1,NAFAI
      IF(NONAME(I,K).EQ.ATNAME(L)) NM(K) = 1
    6 CONTINUE
      DO 11 J = 1,NAFAI
      IF(NM(J).EQ.0) WRITE(*,110) J,I
      IF(NM(J).EQ.0) NNM = 1
   11 CONTINUE
    7 CONTINUE
      DO 8 I = 1,NONRIG
      DO 8 J = 1,5
      LAT(J,I) = 0
    8 CONTINUE
      DO 10 L = 1,NTOT
      DO 10 I = 1,NONRIG
      NAFAI = NAFA(I)
      DO 10 K = 1,NAFAI
      IF(ATNAME(L).NE.NONAME(I,K)) GO TO 10
      NRBP(L) = NRBP(L)*MST + I
   10 CONTINUE
      DO 20 I = 1,NONRIG
      LIM = 2
      IF(ISPAX(I).NE.0) LIM = 5
      DO 15 K = 1,NTOT
      DO 15 L = 1,LIM
   15 IF(LBAT(L,I).EQ.ATNAME(K)) LAT(L,I) = K
      DO 17 L = 1,LIM
   17 LT(L,I) = LAT(L,I)
   20 CONTINUE
      DO 25 I = 1,NONRIG
      LIM = 2
      IF(ISPAX(I).NE.0) LIM = 5
      DO 25 L = 1,LIM
      IF(LAT(L,I).EQ.0) GO TO 40
   25 CONTINUE
C      WHEN NNM.NE.0, NAMES OF AFFECTED ATOMS DON'T MATCH INPUT ATOMS
      IF(NNM.NE.0) STOP
      GO TO 50
   40  WRITE(*,100)
      STOP
  100 FORMAT(' ','ATOM NAMES FOR DEFINING ARG AXES DO NOT MATCH IN
     1PUT ATOM NAMES.  CALCULATION TERMINATED.')
  110 FORMAT(' ','ATOM NAME FOR AFFECTED ATOM',I3,' OF ARG',
     1 I3, ' DOES NOT MATCH NAME OF ANY INPUT ATOM.',/6X,
     2 'CALCULATION TERMINATED.')
   50 DO 30 I = 1,NTOT
      IF(NRBP(I).GT.1383)  CALL OUTH27
   30 CONTINUE
      RETURN
      END
      SUBROUTINE NFREQ(NCOR)
C  Latest modification by EFM 9/10/98 in index kk below
C  LATEST MODIFICATION, OCTOBER 1985
C  MODIFIED APRIL 1984 FOR NORMAL-MODE CALCULATION FOR OVERALL MOLECULAR
C    MOTION (NCOR = 1)
C  FORMERLY USED FOR CALCULATING CORRECTIONS TO BOND DISTANCES AFFECTED
C    BY MOTION OF ATTACHED RIGID GROUPS; THIS NOW DONE IN DISCOR (OCT85)
C     STILL USED FOR CALCULATION OF HARMONIC FREQUENCIES AND FORCE
C    CONSTANTS FOR BOTH INTERNAL ('NON-RIGID') AND OVERALL MOTION
C  CLASSICAL FREQUENCY USED AS FIRST APPROX TO QM FREQ, AND ITERATION
C    CONTINUED UNTIL RATIO OF FREQUENCIES IN TWO SUCCESSIVE CYCLES
C    IS BETWEEN 0.999 AND 1.001, I.E., SAME WITHIN 0.1 PERCENT.
C    IF NO. OF CYCLES REQUIRED EXCEEDS 20, IT STOPS AT 20.
C    ITERATION RECIPE DEPENDS ON VALUE OF ARG OF TANH.  SEE BETWEEN
C      145 AND 148.
C    NOTE THAT THE MOMENT OF INERTIA IS USED IN CALCULATING THE FRE-
C      QUENCY AND FOR X-RAY STRUCTURES, WITH H-ATOMS OMITTED, THE
C      MOMENT OF INERTIA WILL BE LOW (E.G., FOR A METHYL GROUP,
C      REPRESENTED BY A C RATHER THAN A CH3.  THE DIFFERENCE IS OF
C      THE ORDER OF 20 TO 25 % FOR A METHYL (OR T-BUTYL), WHICH CAN
C      MAKE THEN A DIFFERENCE OF AROUND 10 % IN THE FREQUENCY.  THE
C      FORCE CONSTANT AND THE BARRIER CALCULATIONS WILL NOT BE AF-
C      FECTED, IN THE CLASSICAL APPROXIMATION (WHICH IS VALID FOR
C      MOST GROUPS WITH AT WTS OF 15 OR MORE UNLESS THE TEMPERATURE
C      IS VERY LOW), BECAUSE THE MOMENT OF INERTIA THEN CANCELS OUT.
C      (CLASSICALLY, THE FORCE CONSTANT IS JUST KT/(MEAN SQ AMP).)
C
C  NCOR = 0, CALCS FOR INTERNAL MOTION (CALLED ONLY IF NONRIG.NE.0)
C  NCOR = 1, CALCS FOR OVERALL MOTION
C
      COMMON// AIDX(3000)
      COMMON/AIDPAR/AX(150,3),AUOBS(150,6),AUCALC(150,6),WU(150,6),
     1  WU1(150,6)
      COMMON/AXESN/ISPAX(15),LT(5,15),LAT(5,15)
      COMMON/AXESC/LBAT(5,15)
      CHARACTER*4 LBAT
      COMMON/CONT1/ISET,NO,NMULT,NA,ICOUNT,NINPAR,NPARS,NINOBS,NANG,
     1  NTOT,NPULT,NA1,IFU,IB,NONRIG,NS,ISIG,ISYM,ICORL,IFU1,N8,
     2 IEIG,IMAT, IOUT,IRECAL, IFREQ
      COMMON/CONT2/NP1,NNP1,IORIG,IWU,INOPAR
      COMMON/CONT3/ISOLV,NTOTS,CONSLV,SUMW,RWUDI,RMS,RMU,gof,sumsig,
     1  iscm,msd8
      COMMON/IAID1/ IAIDX1(1000)
      COMMON/INOUTN/ NPAGE, KOUTP,  DIS, IAW
      COMMON/INOUTC/ NAME1, ATNAME(150),TISET(80),TITLE(80),ITBL(29),
     1 NAME2
      COMMON/LOC/ VAF(7,3), PVEC(7,3),V5(7,3), VEC1(7,3)
      COMMON/LOCC/ ATNX(7,2)
      common/locc_/BLLARG(7)
      common/new/isigx,ETA, TK,I11, isigu,nafa(7),NONSY(7),AXMOM(7),
     1  NRBP(150),NCPD,NDAT,NESD, IBYP, IEXU, inegl
C
      DIMENSION P(80),SIGP(80),NAT(15,150),WTT(150)
      DIMENSION MAT(40),IZ(5),DEL(3),VEC(3),VC(3),SG(15)
      DIMENSION AMP(15),AMOM(15),FRCL(15),FRQ2(15),IGR(15),NCY(15)
      DIMENSION  FRU(15),FUJ(15),CORD(40),B2(15),FDEGJ(15) 
      DIMENSION  EIGI(3),PL(6),AP(3),B3(15),B6(15)
      DIMENSION AHL(3,3),SQMI(3),KGO(3,3),BB(6,6),VB(6,6),AHT(3,3)
C
      EQUIVALENCE (EIGI(1),AIDX(798)), (PL(1),AIDX(2621))
C ***  EIGI(J) ARE PRINCIPAL MOMENTS OF INERTIA OF MOL (SEE SUBR INERT)
      EQUIVALENCE  (P(1),AIDX(801))
      EQUIVALENCE (SIGP(1), AIDX(881)), (WTT(1), AIDX(451))
      EQUIVALENCE (AHL(1,1),AIDX(2601)),(AHT(1,1),AIDX(2611))
C ***  WHEN NFREQ CALLED FROM ATINT, AHL AND AHT ARE EIGENVALUES L,T
C
      CHARACTER*4 ATNX, NAME1,ATNAME,TISET*1,TITLE*1,ITBL*3,NAME2*5
C
  900 FORMAT(' ',I4,' ATOMS INPUT IN NR GROUP',I4,' BUT ONLY',
     1 ' FOUND NOW')
  901 FORMAT(' ')
  902 FORMAT(2X,I2,T14,A4,T22,A4,T31,F6.3,T38,F5.3,T48,F6.3)
  904 FORMAT(' ','ATOM ',A4,' OF ARG ',I2,' IS AT SAME POSIT
     1ION AS ATOM ',A4,' USED TO DEFINE AXIS OF THE GROUP',/4X,
     2 'THIS ATOM SKIPPED IN THE CALCULATIONS.')
  905 FORMAT(' ','TEMPERATURE INPUT AS ZERO. CHANGED TO 296 K HERE')
  906 FORMAT(' ','CONVERGENCE TOOK MORE THAN 20 ITERATIONS FOR GROUP',
     1 I3,'.  STOPPED ITERATING AFTER 20 CYCLES')
  907 FORMAT(' ',T12,'MEAN SQUARE',T27,'CORRD MOMENT',T70,'Q.M.',T82,
     1 'FORCE CONSTANT',T102,'COSINE FUNCTION',/T12,'AMPL    ESD',T28,
     2 'OF INERTIA',T42,'(CLASSICAL)',T68,'FREQUENCY',T84,
     X 'JOULE/MOL',T101,'BARRIER  (KJ/MOL)',/T2,'AXIS',
     3 T11,'(DEGREES SQ)',T26,'(AT WT, ANGST)',T42,'(FREQUENCY)',T57,
     4 '(ITER)',T67,'(RECIPR CM)',T82,'PER SQ. DEGREE',T101,
     5  'N=2    N=3    N=6',/)
  908 FORMAT(2X,I2,T10,F6.1,T16,'(',T17,F6.1,T23,')',T28,F7.1,T44,F6.1,
     1 T56,I5,T66,F6.1,T72,'(',T73,F5.1,T78,')',T81,F7.1,T88,'(',
     2 T89,F6.1,T95,')',T98,2F7.1,T112,F7.2)
  909 FORMAT(//,1X,'HARMONIC FREQUENCIES AND FORCE CONSTANTS FOR INTERNA
     1L MOTION.  GROUPS WITH NEGATIVE MEAN SQUARE AMPLITUDE SKIPPED',/
     2 100x,'KEYFREQ')
  910 FORMAT(' ','HARMONIC FREQUENCIES AND FORCE CONSTANTS FOR OVERALL M
     1OLECULAR LIBRATION',/)
  911 FORMAT(2X,I2,T10,F6.1,T27,F8.1,T44,F6.1,T58,I3,T68,F6.1,T83,
     1  F8.1)
  912 FORMAT(/,9X,'NO FREQUENCY CALCULATIONS DONE FOR ARGs
     1 THAT LIE ON SYMMETRY ELEMENTS, UNLESS AXMOM(I) INPUT.'/10x,'IF
     2 THE SYMMETRY IS HIGHER THAN P1 OR P1-BAR (NO.GE.3) AND IF NONSY 
     3 INPUT AS ZERO FOR ANY ARG,'/10X,'PROGRAM ASSUMES THAT THAT ARG 
     4 LIES ON A SYMMETRY ELEMENT',/)
  913 FORMAT(' ',5X,'(UNCERTAINTY IN Q.M. FREQUENCY ESTIMATED BY REDOING
     1 CALCULATION FOR SUM OF MEAN SQ AMPLITUDE AND ITS ESD)')
  914 FORMAT(' ','FREQUENCY VALUES CALCULATED HERE SHOULD BE TAKEN "CUM
     1 GRANO SALIS"'/)
  990 FORMAT(' ','VECTOR LENGTH ZERO BETWEEN ',A4,' AND ',A4,
     1 ' IN ARG',I3,'. CALCULATION TERMINATED.')
  991 FORMAT(' ','MOMENT OF INERTIA NOT CORRECTED FOR THESE CALCULATIONS
     1 ')
  992 FORMAT(' ','NO FREQUENCY CALCS FOR GROUP',I2,' BECAUSE MOMENT OF I
     1NERTIA IS ZERO.  ARE ATOMIC WTS OK FOR ATOMS IN THIS GROUP?')
C
      C1 = 3282.81
C   C1 IS (180/PI) SQUARED
      C2 = 4.8405
C   C2 IS (10 TO 8TH)*SQRT(R)/(2*PI*C), WITH R IN ERGS/MOL-K,
C     AND C IN CM/SEC
      C3 = 16.86
C   C3 IS ((PLANCK'S CONSTANT)*(N AVOG)*(10 TO 16TH))/(8*PISQ*C)
      C4 = 0.7194
C   C4 IS ((PLANCK'S CONSTANT)*C)/(2*(BOLTZMANN'S CONSTANT))
      C5 = 0.3548
C   C5 IS 4*PISQ*(C SQ)*(10 TO -23RD), FOR GETTING FORCE CONSTANTS
C     IN JOULE/(MOL RADSQ) FROM FREQ IN RECIP CM
C   C6 IS CONVERSION FACTOR FOR NO. OF CALORIES TO NO. OF JOULES
      C6 = 4.184
      NR = NONRIG
      IF(NCOR.EQ.0) GO TO 10
      IF(NCOR.EQ.1) GO TO 500
      RETURN
   10 DO 12 I = 1,15
      DO 12 J = 1,150
      NAT(I,J) = 0
   12 CONTINUE
      DO 40 K = 1,NA
      IF(NRBP(K).EQ.0) GO TO 40
      J1 = 0
      N = NRBP(K)
      DO 15 J = 1,5
      IH = N/16
      IZ(J) = N - 16*IH
      IF(IZ(J).EQ.0) GO TO 20
      N = IH
      J1 = J1 + 1
   15 CONTINUE
C  J1 IS THE NUMBER OF N.R. GROUPS ATOM K IS IN
C  NRBP(K) IS BUILT UP CODE NUMBER TELLING WHICH NR GROUPS K IS IN
C  IZ(J), WITH J.NE.0, ARE SERIAL NOS OF NR GROUPS ATOM K IS IN,
C    WITH J VARYING FROM 1 TO J1 FOR THAT ATOM
   20 DO 30 I = 1,NR
      DO 30 J = 1,J1
      IF(I.EQ.IZ(J)) NAT(I,K) = 1
   30 CONTINUE
   40 CONTINUE
C   NOW NAT(I,K) CONTAINS 1 FOR EVERY NR GROUP I THAT CONTAINS
C    ATOM K.  NOW DO CALCULATION FOR EACH NR GROUP IN TURN
      DO 200 I = 1,NR
C     WRITE(*,901)
C Index KK changed by EFM 9-10-98 because libration amplitudes about 
C ARG axes are in P(NP1+1), P(NP1+8) etc. if icorl.eq.0
      if(icorl.lt.0) goto 41
      KK= NP1 + 7*(I-1) + 1
      goto 42
   41 KK = I + NP1 
   42 IF(P(KK).LE.0.0) GO TO 200
C  NO CALCULATIONS WHEN LIBR AMPL FOR NON-RIG GROUP IS NEG OR ZERO
      AMOM(I) = 0.0
      N = NAFA(I)
      M = 0
      DO 50 J = 1,NA
      IF(NAT(I,J).EQ.0) GO TO 50
      M = M + 1
      MAT(M) = J
C  MAT(M) STORES ATOM NUMBERS OF THE ATOMS IN RIGID GROUP I
C   M TALLIES THE NUMBER OF (UNIQUE) ATOMS IN THE GROUP
   50 CONTINUE
      IF(M.NE.N) WRITE(*,900) N,I,M
      NN = M + 1
      MAT(NN) = LT(2,I)
      IF(ISPAX(I).NE.0) MAT(NN) = LT(5,I)
C  INCLUDE SECOND ATOM DEFINING AXIS IN LIST FOR DISTANCES
      DO 100 J = 1,N
      KL = J + 1
      DO 100 K = KL,NN
      L = MAT(J)
      LN = MAT(K)
      XL = 0.0
      DO 60 II = 1,3
      DEL(II) = AX(L,II) - AX(LN,II)
      XL = XL + DEL(II)*DEL(II)
   60 CONTINUE
      XL = SQRT(XL)
      IF(XL.NE.0.0) GO TO 62
C  VECTOR OF LENGTH 0.0 BETWEEN TWO ATOMS IN ARG
      WRITE(*,990) ATNAME(L),ATNAME(LN),I
      CALL EXIT
   62 DO 65 II = 1,3
      VEC(II) = DEL(II)/XL
   65 CONTINUE
      VC(1) = VEC1(I,2)*VEC(3) - VEC1(I,3)*VEC(2)
      VC(2) = VEC1(I,3)*VEC(1) - VEC1(I,1)*VEC(3)
      VC(3) = VEC1(I,1)*VEC(2) - VEC1(I,2)*VEC(1)
      SVC = 0.0
      DO 70 II = 1,3
      SVC = SVC + VC(II)*VC(II)
   70 CONTINUE
C   SVC IS SQUARE OF SINE OF ANGLE BETWEEN VECTOR FROM ATOM L
C    TO ATOM LN AND THE AXIS OF THE ARG
      COR = 0.5*XL*SVC*P(KK)
      XLC = XL + COR
      IF(K.EQ.NN)  CORD(J) = XLC
C  SAVE CORRD DIST TO LAST ATOM (ATOM ON AXIS) FOR USE IN CALC
C     CORRECTED MOMENT OF INERTIA FOR THIS GROUP LATER
  100 CONTINUE
C   FOLLOWING IS FOR CALCULATING FREQUENCY AND FORCE CONSTANTS.  SKIP IF
C      NR GROUP LIES ON SYM ELEMENT BECAUSE OF DIFFICULTY IN GETTING
C      MOMENT OF INERTIA FOR SUCH NR GROUPS, UNLESS MOM OF INERTIA INPUT
      IF(NO.GT.2.AND.NONSY(I).EQ.0.AND.AXMOM(I).EQ.0) GO TO 200
C   N IS THE NUMBER OF AFFECTED ATOMS IN EACH GROUP (NAFA(I))
  110 DO 140 J = 1,N
      L = MAT(J)
      LN = LT(2,I)
      XL = 0.0
      DO 115 II = 1,3
      DEL(II) = AX(L,II) - AX(LN,II)
      XL = XL + DEL(II)*DEL(II)
  115 CONTINUE
      XL = SQRT(XL)
      IF(XL.NE.0.0) GO TO 120
      WRITE(*,904) ATNAME(L),I,ATNAME(LN)
      GO TO 140
  120 DO 125 II = 1,3
      VEC(II) = DEL(II)/XL
  125 CONTINUE
      VC(1) = VEC(2)*VEC1(I,3) - VEC(3)*VEC1(I,2)
      VC(2) = VEC(3)*VEC1(I,1) - VEC(1)*VEC1(I,3)
      VC(3) = VEC(1)*VEC1(I,2) - VEC(2)*VEC1(I,1)
      SVC = 0.0
      DO 130 II = 1,3
      SVC = SVC + VC(II)*VC(II)
  130 CONTINUE
      SVC = SQRT(SVC)
C  NOW SVC = SINE OF ANGLE FROM AXIS TO THE VECTOR FROM THE SECOND
C       ATOM DEFINING THE AXIS TO ATOM L
C    CORD(J) = DISTANCE FROM SECOND ATOM DEFINING AXIS TO ATOM L
C    DDIS = CORRD DISTANCE OF ATOM L FROM THE AXIS
      DDIS = CORD(J)*SVC
      AMOM(I) = AMOM(I) + WTT(L)*DDIS*DDIS
C  AMOM(I) WILL BE THE MOMENT OF INERTIA IN AT WT UNITS & SQ ANGSTR
C      (INCLUDING CORRD DISTANCES, SIGNIFICANT FOR LARGE AMPLITUDES)
  140 CONTINUE
      IF(NO.GT.2.AND.AXMOM(I).NE.0) AMOM(I) = AXMOM(I)
C *** IF AMOM(I) = 0. (BECAUSE ATWTS ARE 0.0, E.G.), PRINT MESSAGE
C ***    AND SKIP THIS GROUP
      IF(AMOM(I).NE.0.) GO TO 141
      WRITE(6,992) I
      GO TO 200
  141 CON1 = C4/TK
      CON2 = C3/(AMOM(I)*P(KK))
      AMP(I) = C1*P(KK)
      SG(I) = C1*SIGP(KK)
C   THESE QUANTITIES ARE NOW IN DEGREES SQUARED
      FRCL(I) = C2*SQRT(TK/(AMOM(I)*P(KK)))
C   USE CLASSICAL FREQUENCY AS FIRST APPROX TO QM FREQ
      FRQ1 = FRCL(I)
      IF(TK.NE.0.0) GO TO 142
      WRITE(*,905)
      TK = 296.0
C  FRQ1 CANNOT BE 0.0 UNLESS TK INPUT AS ZERO, AND THUS TANH
C    CAN'T BE ZERO, SO CAN USE COTH = 1.0/TANH
  142 T1 = TANH(CON1*FRQ1)
      FRQ2(I) = CON2/T1
      NCY(I) = 1
      FRQ1 = FRQ2(I)
  145 T1 = TANH(CON1*FRQ1)
      FRQ2(I) = CON2/T1
      NCY(I) = NCY(I) + 1
      RAT = FRQ2(I)/FRQ1
      CONV = ABS(1.0 - RAT)
      IF(CONV.LT.0.001) GO TO 150
      IF(T1.LT.0.75) GO TO 148
C   FASTER CONVERGENCE BY AVERAGING WHEN T1 LESS THAN 0.75
      FRQ1 = FRQ2(I)
      IF(NCY(I).LT.20) GO TO 145
      WRITE(*,906) I
      GO TO 150
  148 FRQ1 = 0.5*(FRQ1 + FRQ2(I))
      IF(NCY(I).LT.20) GO TO 145
      WRITE(*,906) I
C  NOW ESTIMATE UNCERTAINTY IN THE FREQUENCY FROM SIGMA AMPL
  150 A2 = P(KK) + SIGP(KK)
      FCL = C2*SQRT(TK/(AMOM(I)*A2))
      F1 = FCL
      CON3 = C3/(AMOM(I)*A2)
      T2 = TANH(CON1*F1)
      FREQ = CON3/T2
      NCY2 = 1
      F1 = FREQ
  155 T2 = TANH(CON1*F1)
      FREQ = CON3/T2
      NCY2 = NCY2 + 1
      RAT = FREQ/F1
      CONV = ABS(1.0 - RAT)
      IF(CONV.LT.0.001) GO TO 160
      IF(T2.LT.0.75) GO TO 158
      F1 = FREQ
      IF(NCY2.LT.20) GO TO 155
      GO TO 160
  158 F1 = 0.5*(F1 + FREQ)
      IF(NCY2.LT.20) GO TO 155
  160 FRU(I) = ABS(FRQ2(I) - FREQ)
      FDEGJ(I) = (C5/C1)*AMOM(I)*FRQ2(I)*FRQ2(I)
      FOR2 =(C5/C1)*AMOM(I)*FREQ*FREQ
      FUJ(I) = ABS(FDEGJ(I) - FOR2)
      TEMP = C1*0.001*FDEGJ(I)
C  TEMP IS NOW F IN KJ PER SQ RADIAN PER MOL
      B2(I) = TEMP/2.0
      B3(I) = TEMP/4.5
      B6(I) = TEMP/18.0
C  B2,B3,B6 ARE CORRESPONDING BARRIERS FOR 2-FOLD, 3-FOLD AND
C     6-FOLD COSINE POTENTIALS
  200 CONTINUE
C ***  print no headings unless calculations made for at least one arg
      iall = 0
      do 205 i = 1,nr
      IF(NO.GT.2.AND.NONSY(I).EQ.0.AND.AXMOM(I).EQ.0.) GO TO 205
      iall = 1
  205 continue
      if(iall.eq.0) go to 220
      WRITE(*,909)
      WRITE(*,914)
      WRITE(*,907)
      DO 210 I = 1,NR
      KK = NP1 + I
      IF(P(KK).LE.0.0) GO TO 210
      IF(NO.GT.2.AND.NONSY(I).EQ.0.AND.AXMOM(I).EQ.0.) GO TO 210
C  NOTHING TO PRINT IF GROUP LIES ON SYM ELEMENT AND NO MOM OF INERTIA
C     WAS INPUT, OR IF MOM OF INERTIA IS ZERO
      IF(AMOM(I).EQ.0.0.AND.AXMOM(I).EQ.0.) GO TO 210
      WRITE(*,908,ERR=210)I,AMP(I),SG(I),AMOM(I),FRCL(I),NCY(I),FRQ2(I),
     1  FRU(I),FDEGJ(I),FUJ(I),B2(I),B3(I),B6(I)
  210 CONTINUE
      PRINT 913
  220 IF(NO.GT.2) PRINT 912
      RETURN
C  FOLLOWING IS FOR LIBRATIONAL FREQUENCIES FOR OVERALL MOTION
  499 WRITE(*,910)
      WRITE(*,914)
      WRITE(*,907)
      AP(1) = PL(1)
      AP(2) = PL(4)
      AP(3) = PL(6)
      DO 600 I = 1,3
      IF(AP(I).LE.0) GO TO 600
      AMP(I) = C1*AP(I)
      FRCL(I) = C2*SQRT(TK/(EIGI(I)*AP(I)))
      NCY(I) = 0
      FRQ1 = FRCL(I)
      IF(TK.NE.0.0) GO TO 510
      WRITE(*,905)
      TK = 296.0
  510 T1 = TANH(C4*FRQ1/TK)
      FRQ2(I) = C3/(EIGI(I)*AP(I)*T1)
      NCY(I) = NCY(I) + 1
      RAT = FRQ2(I)/FRQ1
      CONV = ABS(1.0 - RAT)
      IF(CONV.LT.0.001) GO TO 520
      IF(T1.LT.0.75) GO TO 515
      FRQ1 = FRQ2(I)
      IF(NCY(I).LT.20) GO TO 510
      GO TO 520
  515 FRQ1 = 0.5*(FRQ2(I) + FRQ1)
      IF(NCY(I).LT.20) GO TO 510
  520 FDEGJ(I) = (C5/C1)*EIGI(I)*FRQ2(I)*FRQ2(I)
      WRITE(*,911) I,AMP(I),EIGI(I),FRCL(I),NCY(I),FRQ2(I),FDEGJ(I)
  600 CONTINUE
      PRINT 991
  500 CALL OUTH6
      IF(NCOR.GT.1) GO TO 499
C ***  PRECEDING ONLY TO PROVIDE DUMMY PATH TO OLDER PART OF PROGRAM
      DO 700 I = 1,3
C ***  SQMI(J) SQ RTS OF PRINCIPAL MOMENTS OF INERTIA
  700 SQMI(I) = SQRT(EIGI(I))
C ***   SQM WILL BE SQRT OF MOL WT
      SQM = SQRT(SUMW)
      DO 710 I = 1,6
      DO 710 J = 1,6
  710 BB(I,J) = 0.
C ***  SET UP 6X6 MATRIX:      T    S-TRANSPOSE
C ***                          S    L
C ***    (NOTE THAT OUR DEFN OF S AS AVE OF (ROT-TRANSL) IS OPPOSITE TO
C ***      THAT OF WILLIS & PRYOR)
      BB(1,1) = P(7)*SUMW
      BB(1,2) = P(8)*SUMW
      BB(1,3) = P(9)*SUMW
      BB(2,2) = P(10)*SUMW
      BB(2,3) = P(11)*SUMW
      BB(3,3) = P(12)*SUMW
      BB(4,4) = P(1)*EIGI(1)
      BB(4,5) = P(2)*(SQMI(1)*SQMI(2))
      BB(4,6) = P(3)*(SQMI(1)*SQMI(3))
      BB(5,5) = P(4)*EIGI(2)
      BB(5,6) = P(5)*(SQMI(2)*SQMI(3))
      BB(6,6) = P(6)*EIGI(3)
      IF(NPARS.EQ.0) GO TO 720
C ***   WHEN NPARS = 0, THERE ARE NO INDEP COMPONENTS OF THE S TENSOR
      BB(1,4) = P(13)*(SQM*SQMI(1))
      BB(1,5) = P(16)*(SQM*SQMI(2))
      BB(1,6) = P(19)*(SQM*SQMI(3))
      BB(2,4) = P(14)*(SQM*SQMI(1))
      BB(2,5) = P(17)*(SQM*SQMI(2))
      BB(2,6) = P(20)*(SQM*SQMI(3))
      BB(3,4) = P(15)*(SQM*SQMI(1))
      BB(3,5) = P(18)*(SQM*SQMI(2))
      BB(3,6) = P(21)*(SQM*SQMI(3))
  720 ISKIP = 0
C ***  TEST FOR NEGATIVE DIAGONAL ELEMENTS IN BB(I,J); SKIP CALC IF ANY
      DO 780 I = 1,6
      IF(BB(I,I).LT.0.) GO TO 755
      GO TO 780
  755 GO TO (760,760,760,765,765,765) I
  760 WRITE(*,785) I, BB(I,I)
  785 FORMAT(' ','DIAGONAL ELEMENT',I2,' OF T IS NEGATIVE, ',F12.6,';
     1    NO NORMAL MODE CALCULATION')
      ISKIP = 1
      GO TO 780
  765 J = I-3
      WRITE(*,788) J, BB(I,I)
  788 FORMAT(' ','DIAGONAL ELEMENT',I2,' OF L IS NEGATIVE, ',F12.7,';
     1    NO NORMAL MODE CALCULATION')
      ISKIP = 1
  780 CONTINUE
      IF(ISKIP.NE.0) RETURN
      DO 725 I = 1,6
      K = I + 1
      DO 725 J = K,6
  725 BB(J,I) = BB(I,J)
C     WRITE(*,800) ((BB(I,J), I = 1,6), J = 1,6)
C ***  WRITE OUT EIGENVALUE MATRIX ON UNIT 9 FOR CHECKING
C     WRITE(9)  ((BB(I,J), I = 1,6), J = 1,6)
      CALL EIGEN(BB,VB,6)
C ***  EIGEN (WITH N = 6) CALCULATES EIGENVALUES, VECTORS FOR MATRIX BB
C ***    THE EIGENVALUES WILL BE BB(1,1), BB(2,2), ... WHEN RETURNED,
C ***    AND THE EIGENVECTOR FOR EIGENVALUE BB(I,I) WILL BE IN COLUMN I
C ***    OF THE MATRIX OF VECTORS, VB(J,I)
C ***  THE EIGENVALUES ARE FORCE CONSTANTS, AND TO THE EXTENT THAT THE
C ***    CLASSICAL APPROX IS VALID CAN BE CONVERTED TO FREQUENCIES IN
C ***    THE USUAL WAY
  800 FORMAT(' ', 'MATRIX FOR NORMAL MODE CALCULATION',/6(5X,6F20.10/))
C     WRITE(*,810) ((BB(I,J), I = 1,6), J = 1,6)
  810 FORMAT(' ', 'NORMAL MODE MATRIX',/6(5X,6F20.10,/))
C ***  EIGENVECTORS ARE ARRANGED IN COLS (COL I HAS VECTOR FOR MODE I)
      WRITE(*,820) (I, BB(I,I), (VB(J,I), J = 1,6 ), I = 1,6)
  820 FORMAT(' ','NORMAL MODES:             CALCULATED FROM MASS-WEIGHTE
     1D, I-WEIGHTED 6X6 MATRIX DERIVED FROM --->:',7X,'T   S-transpose'/
     217X,'NOTE: S HERE IS AVE OF (ROT*TRANSL); WILLIS & PRYOR [p. 178,
     3 eq. (6c)] USE              S   L   '/
     420X,'OPPOSITE CONVENTION, AVE OF (TRANSL*ROT), SO THEIR S(J,I) IS
     5 OUR S(I,J)'/17X,'T,L,S REFERRED TO INERTIAL AXES IN THIS CALCULAT
     6ION',40X,'KEYMODE'/11X,'UNITS OF EIGENVALUES ARE (AMU)*(ANGSTROM
     7 SQUARED)'//1X,'MODE',5X,'EIGENVALUE',20X,'EIGENVECTOR -->'/
     8  6(1X,I3,3X,F11.4,20X,6F12.5,/)/)
      DO 740 I = 1,6
      IF(BB(I,I).GT.0) GO TO 735
      FRCL(I) = 0.0
      GO TO 740
  915 FORMAT(' ',10X,  'IF EIGENVALUE WAS ZERO OR NEGATIVE, FREQUENCY PR
     1INTED AS 0.0')
  735 FRCL(I) = C2*SQRT(TK/BB(I,I))
  740 CONTINUE
      WRITE(*,914)
      WRITE(*,915)
      WRITE(*,830) (FRCL(I), I = 1,6)
  830 FORMAT(' ','NORMAL-MODE FREQUENCIES, ASSUMING THAT OBSERVED T,L,S
     1 REFLECT POTENTIAL FUNCTION AROUND THE MOLECULE'/10X,'UNITS ARE RE
     2CIPROCAL CM:', 6F12.1,/)
      RETURN
      END
C
      subroutine origts
C *** adapted 10/21.III.97 from version for RBM14c
C ***  Called whenever IBYP.eq.2, to calc effect of shift of origin (in 
C *** 	CCS) to XCG(3) (from INERT) on T and S (compared with the values
C ***   output by the program).
      common//aidx(3000)
      COMMON/CORDIN/ IRIDE,IMIN,IUNC, IHAT(150), NUNC(20), TUNC(20,3),
     1  TOR(3,3), nw(3),IHPR
C ***    XCG(3) here called nw(3)
      DIMENSION  P(80), ll(3,3), lt(3,3)
      DIMENSION  SN(3,3), TN(3,3), to(3,3), dt(3,3)
      REAL LT, LL, LLI, lpar(4), nw
      equivalence  (P(1), aidx(801))
C
  900 format('  After an origin shift in CCS by: ', 3f8.4,', then:'/)
  910 format('  Original S:',2x,3f8.4/2(15x,3f8.4/))
  920 format('  New S:',7x,3f8.4/2(15x,3f8.4/))
  930 format(/'  Original T:',2x,3f8.4/23x,2f8.4/31x,f8.4/)
  940 format('  New T:',7x,3f8.4/23x,2f8.4/31x,f8.4/)
  945 format('  Changes in  T:',1x,3f8.4/25x,2f8.4/33x,f8.4/)
C 
C ***    nw(3) are CCS coords of origin used in THMA14c calculation of
C ***       L, T, and S, rel to initial origin, so -nw(3) gets you back
C ***  Use LL(3,3) for L, LT(3,3) for current S, TT(3,3) for current T, 
      ll(1,1) = p(1)
      ll(2,2) = p(4)
      ll(3,3) = p(6)
      ll(1,2) = p(2)
      ll(2,1) = p(2)
      ll(1,3) = p(3)      
      ll(3,1) = p(3)
      ll(2,3) = p(5)
      ll(3,2) = p(5)
      to(1,1) = p(7)
      to(2,2) = p(10)
      to(3,3) = p(12)
      to(1,2) = p(8)
      to(2,1) = p(8)
      to(1,3) = p(9)      
      to(3,1) = p(9)
      to(2,3) = p(11)
      to(3,2) = p(11)
      lt(1,1) = p(13)
      lt(1,2) = p(14)
      lt(1,3) = p(15)
      lt(2,1) = p(16)
      lt(2,2) = p(17)
      lt(2,3) = p(18)
      lt(3,1) = p(19)
      lt(3,2) = p(20)
      lt(3,3) = p(21)
      do 30 i = 1,3
      sn(i,1) = lt(i,1) - ll(i,2)*nw(3) + ll(i,3)*nw(2)
      sn(i,2) = lt(i,2) - ll(i,3)*nw(1) + ll(i,1)*nw(3)
      sn(i,3) = lt(i,3) - ll(i,1)*nw(2) + ll(i,2)*nw(1)
   30 continue
      dt(1,1) = + 2.0*(lt(2,1)*nw(3) - lt(3,1)*nw(2)) -
     1  2.0*nw(2)*nw(3)*ll(2,3) + nw(3)*nw(3)*ll(2,2) 
     2 + nw(2)*nw(2)*ll(3,3)  
      dt(2,2) = + 2.0*(lt(3,2)*nw(1) - lt(1,2)*nw(3)) -
     1  2*nw(1)*nw(3)*ll(1,3) + nw(3)*nw(3)*ll(1,1) 
     2 + nw(1)*nw(1)*ll(3,3)  
      dt(3,3) = + 2.0*(lt(1,3)*nw(2) - lt(2,3)*nw(1)) -
     1  2*nw(2)*nw(1)*ll(1,2) + nw(1)*nw(1)*ll(2,2) 
     2 + nw(2)*nw(2)*ll(1,1)  
      dt(1,2) = + nw(3)*(lt(2,2) - lt(1,1)) + nw(1)*lt(3,1)
     1 - nw(2)*lt(3,2) - nw(2)*nw(1)*ll(3,3) - nw(3)*nw(3)*ll(1,2)
     2 + nw(1)*nw(3)*ll(2,3) + nw(2)*nw(3)*ll(1,3)
      dt(1,3) = + nw(2)*(lt(1,1) - lt(3,3)) + nw(3)*lt(2,3)
     1 - nw(1)*lt(2,1) - nw(1)*nw(3)*ll(2,2) - nw(2)*nw(2)*ll(1,3)
     2 + nw(1)*nw(2)*ll(2,3) + nw(2)*nw(3)*ll(1,2)
      dt(2,3) = + nw(1)*(lt(3,3) - lt(2,2)) + nw(2)*lt(1,2)
     1 - nw(3)*lt(1,3) - nw(2)*nw(3)*ll(1,1) - nw(1)*nw(1)*ll(2,3)
     2 + nw(1)*nw(2)*ll(1,3) + nw(1)*nw(3)*ll(1,2)
      do 40 i = 1,3
      do 40 l = 1,3
      tn(i,l) = to(i,l) + dt(i,l)
   40 continue
C ** print old T (930), old S (910), xcg (=nw) (900), new T (940), new S (920)
      write(6,930) ((to(i,j), j = i,3), i = 1,3)
      write(6,910) ((lt(i,j), j = 1,3), i = 1,3)
      write(6,900) (nw(k), k = 1,3)
      write(6,940) ((tn(i,j), j = i,3), i = 1,3)
      write(6,945) ((dt(i,j), j = i,3), i = 1,3)
      write(6,920) ((sn(i,j), j = 1,3), i = 1,3)
      return
      end
C
      SUBROUTINE ORTHO
C
C     SET UP MATRICES FOR TRANSFORMATION OF COORDINATES AND U'S TO A
C        CARTESIAN CRYSTAL SYSTEM WITH FIRST AXIS PARALLEL TO A,
C        2ND AXIS PARALLEL TO C*xA, AND THIRD PARALLEL TO C*.
C      CARTESIAN SYSTEM IS RIGHT-HANDED IF ORIGINAL AXES WERE.
C
C     TOR = TRANSFORMATION MATRIX FOR COORDINATES INTO ORTHOGONAL
C     CRYSTAL SYSTEM
C     OMA AND TOMA(TRANSPOSE OF OMA)  = TRANSFORMATION MATRICES
C     FOR U'S  TO ORTHOGONAL CRYSTAL SYSTEM
C
      COMMON//AIDX(3000)
      COMMON/CELLP/CD(12),RCD(12),VOL,VST,G(3,3)
      COMMON /CONT1/ISET,NO,NMULT,NA,ICOUNT,NINPAR,NPARS,NINOBS,NANG,NTO
     1T,NPULT,NA1,IFU,IB,NONRIG,NS,ISIG,ISYM,ICORL,IFU1,N8,
     2 IEIG,IMAT, IOUT,IRECAL, IFREQ
      COMMON/CORDIN/ IRIDE,IMIN,IUNC, IHAT(150), NUNC(20), TUNC(20,3),
     1  TOR(3,3), XCG(3),IHPR
      COMMON/TMCSIS/TCIC(3,3),TCIU(3,3),TCINVC(3,3),TCINVU(3,3),SCG(3),
     1 OMIN(3,3), TROI(3,3), oma(3,3)
      DIMENSION  D(3,3)
      EQUIVALENCE (D(1,1),AIDX(2028))
C
      TOR(1,1) = CD(1)
      TOR(1,2) = CD(2)*CD(9)
      TOR(1,3) = CD(3)*CD(8)
      TOR(2,1) = 0.
      TOR(2,2) = CD(2)*CD(12)
      TOR(2,3) = CD(3)*(CD(7)-CD(8)*CD(9))/CD(12)
      TOR(3,1) = 0.
      TOR(3,2) = 0.
      SQN = VOL/(CD(1)*CD(2)*CD(3))
      TOR(3,3) = CD(3)*SQN/CD(12)
      DO 10 I = 1,3
      D(I,I) = RCD(I)
      IK = I + 1
      IF(IK.GT.3)  GO TO 15
      DO 10 K = IK,3
      D(I,K) = 0.
      D(K,I) = 0.
   10 CONTINUE
   15 CALL DOUBLE(TOR,D,OMA)
      RETURN
      END
      SUBROUTINE OTHR
C
C     WRITES HEADINGS OF RESULTS OF ANALYSIS
C
      COMMON /CONT1/ISET,NO,NMULT,NA,ICOUNT,NINPAR,NPARS,NINOBS,NANG,NTO
     1T,NPULT,NA1,IFU,IB,NONRIG,NS,ISIG,ISYM,ICORL,IFU1,N8,
     2 IEIG,IMAT, IOUT,IRECAL, IFREQ
      COMMON/CONT2/NP1,NNP1,IORIG,IWU,INOPAR
      COMMON/INOUTN/ NPAGE, KOUTP,  DIS, IAW
      COMMON/INOUTC/ NAME1, ATNAME(150),TISET(80),TITLE(80),ITBL(29),
     1 NAME2
      common/new/isigx,ETA, TK,I11, isigu,nafa(7),NONSY(7),AXMOM(7),
     1  NRBP(150),NCPD,NDAT,NESD, IBYP, IEXU, inegl
      CHARACTER*4 NAME1,ATNAME,TISET*1,TITLE*1, ITBL*3, NAME2*5
C
    1 FORMAT(46H RIGID-BODY MOTION PARAMETERS (INERTIAL FRAME),/)
    2 FORMAT(55H EIGENVECTORS AND EIGENVALUES OF L AND T IN THE I-FRAME,
     1/)
    3 FORMAT(/,'  T-TENSOR', 5X,5HXI(1),5X,5HXI(2),5X,5HXI(3),10X,8HVALU
     1E(I),5X,'RMS (ANGST.)')
    4 FORMAT(9H L-TENSOR,5X,5HXI(1),5X,5HXI(2),5X,5HXI(3),10X,8HVALUE(I)
     1,5X,10HRMS (RAD.),12X,19HVALUE(I) (DEG. SQ.) ,6X,10HRMS (DEG.),/)
    5 FORMAT(' ','RIGID-BODY MOTION PARAMETERS (CARTESIAN CRYSTAL FRAME)
     1' /)
    6 FORMAT(' ',39HVIBRATION TENSORS IN THE INERTIAL FRAME,/,12X,3HU11,
     16X,3HU22,6X,3HU33,6X,3HU12,6X,3HU13,6X,3HU23,/)
    7 FORMAT(1H ,10X,3HU11,6X,3HU22,6X,3HU33,6X,3HU12,6X,3HU13,6X,3HU23,
     1/)
    8 FORMAT(' ',49HVIBRATION TENSORS IN THE CARTESIAN CRYSTAL SYSTEM ,/
     1,12X,3HU11,
     26X,3HU22,6X,3HU33,6X,3HU12,6X,3HU13,6X,3HU23,/)
    9 FORMAT(72H EIGENVECTORS AND EIGENVALUES OF L AND T IN THE CARTESIA
     1N CRYSTAL SYSTEM ,///)
   10 FORMAT(15H  S SYMMETRICAL,/)
   11 FORMAT(' ',38H TRACE OF T REDUCED BY SHIFT OF ORIGIN,/)
   12 FORMAT(' ',112HLISTING OF THE EIGENVALUES AND EIGENVECTORS OF THE
     1CALCULATED AND OBSERVED VIBRATION TENSORS OF INDIVIDUAL ATOMS,/)
   13 FORMAT(' ',44HTWO EIGENVALUES DIFFER LESS THAN 10 PER CENT,/,65H A
     1NGULAR RELATIONSHIP U OBSERVED/U CALCULATED NOT WELL DETERMINED,/)
   14 FORMAT(19H CORRELATION MATRIX)
   15 FORMAT(' ',19HROTATION TO L FRAME,/,42H SHIFT OF ORIGIN REQUIRED T
     1O SYMMETRIZE S ,/)
   16 FORMAT(' ',55HORIGIN SHIFT AND TENSORS REFERRED TO THE INERTIAL FR
     1AME,/)
   17 FORMAT(' ' /' CAUTION:  THESE "CORRECTED PARAMETERS" ARE VAL
     1ID ONLY FOR THE CALCULATION OF DISTANCES WITHIN THE RIGID GROUP.'
     2  /     ' THEY WILL GIVE SPECIOUS RESULTS IF USED IN THE CALCUL
     3ATION OF INTERMOLECULAR DISTANCES.'/' NOTE THAT THEY DO
     4 NOT INCLUDE ANY CORRECTION FOR THE EFFECTS OF ARG LIBRATIONS.'
     5//15X,3HOLD,34X,3HNEW/)
   18 FORMAT(' ',22H ANGULAR RELATIONSHIPS,/30H MOLECULAR AXES - CRYSTAL
     1 AXES,/)
   19 FORMAT(1H0,22H ANGULAR RELATIONSHIPS,/30H LIBRATION AXES - CRYSTAL
     1 AXES,/)
C Heading added, EFM 9/28/98
C   19 FORMAT(/,30H LIBRATION AXES - CRYSTAL AXES,/)
   20 FORMAT(/,32H TRANSLATION AXES - CRYSTAL AXES,/)
   21 FORMAT(/,32H LIBRATION AXES - MOLECULAR AXES,/)
   22 FORMAT(/,34H TRANSLATION AXES - MOLECULAR AXES,/)
   23 FORMAT(19X,4HA(1),4X,4HA(2),4X,4HA(3),/)
   24 FORMAT(' ',/,59H RELATIONSHIPS INVOLVE REDUCED TRANSLATION TENSOR
     1(IF ANY), ,/75H  THAT IS, T AFTER SYMMETRIZING S.  IF THIS NOT DON
     2E, THEN ORIGINAL T USED.     )
   25 FORMAT(' ',43H ATOMIC COORDINATES CORRECTED FOR LIBRATION)
   26 FORMAT(' ',  ' NON-INTERSECTING AXES DESCRIPTION',/)
   27 FORMAT(' ','DISPLACEMENTS OF LIBRATION AXES FROM ORIGIN OF INERTIA
     1L FRAME,IN ANGSTROMS. THIS IS FOR THE NON-INTERSECTING'       /
     21H ,'AXES ALTERNATIVE DESCRIPTION OF THE RIGID BODY MOTION. THE DI
     3SPLACEMENTS ARE MEASURED PARALLEL TO L-AXES.')
   28 FORMAT(' FIRST INDEX GIVES PRINCIPAL AXIS OF L, SECOND GIVES OTHER
     1 AXIS PARALLEL TO WHICH THE SHIFT IS MEASURED'//)
   29 FORMAT(1H ,'SCREW PITCHES (ANGSTROMS/RADIANS) ALONG THE SHIFTED LI
     1BRATION AXES',//)
   30 FORMAT(' ',  ' EFFECTIVE SCREW TRANSLATIONS (ANGSTROMS) ALONG THE
     1SHIFTED LIBRATION AXIS',/)
   31 FORMAT(' ','DISPLACEMENTS OF LIBRATION AXES FROM MOLECULAR CENTROI
     1D IN THE CARTESIAN CRYSTAL SYSTEM, IN ANGSTROMS.'/' THIS IS FOR
     2 THE NON-INTERSECTING AXES ALTERNATIVE DESCRIPTION OF THE RIGID
     3 BODY MOTION.'/' THE DISPLACEMENTS ARE MEASURED PARALLEL TO
     4 L-AXES.')
   32 FORMAT(17H (INERTIAL FRAME))
   33 FORMAT(' ',  'LIST OF PARAMETERS WITH NEGATIVE DIAGONAL ELEMENT IN
     1 INVERSE MATRIX, RESULTING IN',/13X,' UNRELIABLE RESULTS, WRONG E.
     2S.D. AND WRONG TERMS IN CORRELATION MATRIX',/)
   34 FORMAT(' ',39HVIBRATION TENSORS IN THE CRYSTAL SYSTEM,/,12X,3HU11,
     16X,3HU22,6X,3HU33,6X,3HU12,6X,3HU13,6X,3HU23,/)
   35 FORMAT(' ','ORIGIN SHIFT AND TENSORS REFERRED TO THE CARTESIAN C
     1RYSTAL SYSTEM AND MOLECULAR CENTROID.'/)
   36 format(' (CARTESIAN CRYSTAL SYSTEM)')
C
C
      ENTRY OTHR1
C     CALL FROM ATINT
      PRINT 1
      RETURN
C
      ENTRY OTHR2
C     CALL FROM EIGVLT (KOUTP = 2, CARTESIAN CRYSTAL FRAME) AND ATINT
C        (WHEN KOUTP = 1, INERTIAL FRAME)
      IF(KOUTP.EQ.2)  GO TO 100
      PRINT 2
      GO TO 110
  100 PRINT 9
  110 PRINT 4
      CALL OUTR3
      PRINT 3
      KOUTP = 3
      CALL OUTR3
      RETURN
C
      ENTRY OTHR3
C     CALL FROM MAIN
      PRINT 5
      RETURN
C
      ENTRY OTHR4
C     CALL FROM MAIN
      PRINT 6
      RETURN
C
      ENTRY OTHR5
C     CALL FROM MAIN
      PRINT 7
      RETURN
C
      ENTRY OTHR6
C     CALL FROM MAIN
      PRINT 8
      RETURN
C
      ENTRY OTHR7
C     CALL FROM OUTR1
      PRINT 10
      RETURN
C
      ENTRY OTHR8
C     CALL FROM MAIN
      PRINT 11
      RETURN
C
      ENTRY OTHR9
C     CALL FROM ATINT
      PRINT 12
      IF(IBYP.EQ.0) GO TO 90
      PRINT 36
      RETURN
   90 PRINT 32
      RETURN
C
      ENTRY OTHR10
C     CALL FROM ATINT
      PRINT 13
      RETURN
C
      ENTRY OTHR11
C     CALL FROM CORMAT
      PRINT 14
      RETURN
C
      ENTRY OTHR12
C     CALL FROM LFRAME
      PRINT 15
      RETURN
C
      ENTRY OTHR13
C     CALL FROM OUTR7
      IF(IBYP.EQ.0) PRINT 16
      IF(IBYP.NE.0) PRINT 35
      RETURN
C
      ENTRY OTHR 14
C     CALL FROM LIBCOR
      PRINT 17
      RETURN
C
      ENTRY OTHR15
C     CALL FROM ANGLES
      PRINT 18
      PRINT 23
      RETURN
C
      ENTRY OTHR16
C     CALL FROM OUTR8
      PRINT 19
      PRINT 23
      RETURN
C
      ENTRY OTHR17
C     CALL FROM OUTR8
      PRINT 20
      PRINT 23
      RETURN
C
      ENTRY OTHR18
C     CALL FROM OUTR8
      PRINT 21
      PRINT 23
      RETURN
C
      ENTRY OTHR19
C     CALL FROM OUTR8
      PRINT 22
      PRINT 23
      RETURN
C
      ENTRY OTHR20
C     CALL FROM ANGLES
      PRINT 24
      RETURN
C
      ENTRY OTHR21
C     CALL FROM LIBCOR
      PRINT 25
      RETURN
C
      ENTRY OTHR22
C     CALL FROM STAS
      PRINT 26
      IF(IBYP.EQ.0) PRINT 27
      IF(IBYP.NE.0) PRINT 31
      PRINT 28
      RETURN
C
      ENTRY OTHR23
C     CALL FROM OUTR10
      PRINT 29
      RETURN
C
      ENTRY OTHR24
C     CALL FROM OUTR10
      PRINT 30
      RETURN
C
      ENTRY OTHR25
C     CALL FROM OUTR12
      PRINT 33
      RETURN
      ENTRY OTHR26
C     CALL FROM MAIN
      PRINT 34
      RETURN
      END
      SUBROUTINE OUTH
C
C     WRITE HEADINGS
C
      COMMON /CONT1/ISET,NO,NMULT,NA,ICOUNT,NINPAR,NPARS,NINOBS,NANG,NTO
     1T,NPULT,NA1,IFU,IB,NONRIG,NS,ISIG,ISYM,ICORL,IFU1,N8,
     2 IEIG,IMAT, IOUT,IRECAL, IFREQ
      COMMON/IAID1/IAIDX1(1000)
      COMMON/INOUTN/ NPAGE, KOUTP,  DIS, IAW
      COMMON/INOUTC/ NAME1, ATNAME(150),TISET(80),TITLE(80),ITBL(29),
     1 NAME2
      common/new/isigx,ETA, TK,I11, isigu,nafa(7),NONSY(7),AXMOM(7),
     1  NRBP(150),NCPD,NDAT,NESD, IBYP, IEXU, inegl
      CHARACTER*4 NAME1,ATNAME,TISET*1,TITLE*1, ITBL*3, NAME2*5
C      INTEGER TITLE,       TISET
C
    1 FORMAT(' ',/)
    2 FORMAT(a)
    3 FORMAT(' ',7HINPUT  )
    4 FORMAT(' ',/,49H ATOMIC PARAMETERS IN THE AXIAL SYSTEM OF INERTIA)
    5 FORMAT(1H ,80a1,20X,4HPAGE,I4,//)
    6 FORMAT('  TRANSFORMATION MATRICES FROM THE CRYSTAL SYSTEM TO THE A
     1XIAL SYSTEM OF INERTIA'/)
    7 FORMAT(' ',12H COORDINATES,/)
    8 FORMAT(' ',18H VIBRATION TENSORS,/)
    9 FORMAT(1H ,80A1)
   10 FORMAT(' ',79H TRANSFORMATION MATRICES FROM THE AXIAL SYSTEM OF IN
     1ERTIA TO THE CRYSTAL SYSTEM,/)
   11 FORMAT(' ',29H MATRICES PREMULTIPLY VECTORS/' ',
     161H TENSORS TRANSFORMED BY (MATRIX)(TENSOR)(TRANSPOSE OF MATRIX) )
   13 FORMAT(34H NO INTERPRETATION OF SCREW MOTION)
   14 FORMAT('  THE ORTHOGONAL CRYSTAL SYSTEM IS DEFINED BY:'/8X,' XO
     1 PARALLEL TO A-AXIS, YO PARALLEL TO C*xA, ZO PARALLEL TO C*'/
     2 8X,' THE AXES XO,YO,ZO FORM A RIGHT-HANDED SYSTEM'//)
   15 FORMAT(' ',74H TRANSFORMATION MATRICES FROM CRYSTAL SYSTEM TO CART
     1ESIAN CRYSTAL SYSTEM   ,/)
   16 FORMAT(' ',49H ATOMIC PARAMETERS IN CARTESIAN CRYSTAL SYSTEM   ,/)
   20 FORMAT(26H ILLEGAL SPACEGROUP NUMBER)
   21 FORMAT(/,' ','INPUT',3X,'IF (ISIG.GT.0)  SIGMA(U),',5X,  'IF (ISIG
     1.LT.0)  WORKING WEIGHTS WU (except for atoms with weight 800.)'
     2 /,10H ATNAME(I),4X,9HSIGU11(I),1X,'SIGU22(I)',
     3 1X,9HSIGU33(I),1X,9HSIGU12(I),1X,9HSIGU13(I),1X,9HSIGU23(I),//)
   22 FORMAT(49H  SIGMA(U) AFTER TRANSFORMATION TO CARTESIAN AXES ,/
     1 2X,'POSN',2X,10H ATNAME(I),4X,9HSIGU11(I),1X,9HSIGU22(I),
     21X,9HSIGU33(I),1X,9HSIGU12(I),1X,9HSIGU13(I),1X,9HSIGU23(I),//)
   23 FORMAT(' ',' NUMBER OF PARAMETERS TOO LARGE (GT.80) OR POTENTIALLY
     1 SO (GT.78)',//)
   25 FORMAT('     LIST OF AFFECTED ATOMS:')
   26 FORMAT(' ','ALLOWED NUMBER OF ATTACHED RIGID GROUPS EXCEEDED.  THE
     1 MAX. PERMISSIBLE "NONRIG" IS 7, BUT HERE NONRIG = ',I3)
   27 FORMAT(' ',45H TOO MANY AFFECTED ATOMS, MAXIMUM ALLOWED  40,/)
   28 FORMAT(' ','  A GIVEN ATOM MAY ONLY PARTICIPATE IN 3 ATTACHED RIGI
     1D GROUP LIBRATIONS'/,17H CHECK YOUR LISTS,/)
   29 FORMAT(72H WORKING WEIGHTS OF U'S USED FOR SOLUTION OF SYSTEM OF L
     1INEAR EQUATIONS ,/,10H ATNAME(I),4X,7HWU11(I),3X,7HWU22(I),3X,7HWU
     233(I),3X,7HWU12(I),3X,7HWU13(I),3X,7HWU23(I),//)
   30 FORMAT(' ','NONRIG = 7.  UNLESS MOLECULAR POINT GROUP IS CENTROSYM
     1METRIC, OR SOME OF THE ARGS HAVE ONLY ONE ATOM,'/5X,'YOU MAY HAVE
     2TOO MANY PARAMETERS.  BEWARE!!!!'/10X,80('*'),/)
   38 FORMAT(45H TRANSFORMATION MATRICES FOR SPECIAL SETTING ,/,11H TMAT
     1(I,K) ,31X,12H RTMAT(I,K) ,//)
   40 FORMAT(18H INPUT   BETA(I,J),/,10H ATNAME(I),6X,6HB11(I),4X,6HB22(
     1I),4X,6HB33(I),4X,6HB12(I),4X,6HB13(I),4X,6HB23(I),3X,8HNUORB(I),/
     2/)
   42 FORMAT(' ',7HATOM(I),11X,14HCOORDINATES(I),12X,5HWT(I),3X,7HMULT(I
     1),33X,7HUOBS(I),/,12X,3HX/A,8X,3HY/B,8X,3HZ/C,29X,3HU11,8X,3HU22,8
     2X,3HU33,8X,3HU12,8X,3HU13,8X,3HU23,3X,5HNUORB,/)
   43 FORMAT(' ',7HATOM(I),5X,26HCOORDINATES(I) (ANGSTROMS), 6X,
     15HWT(I), 3X, 7HMULT(I)
     2 ,33X,7HUOBS(I),/,14X,1HX,10X,1HY,10X,1HZ,31X,3HU11,8X,3HU22,8X,3H
     3U33,8X,3HU12,8X,3HU13,8X,3HU23,/)
   44 FORMAT(' ',/' NO ANALYSIS OF THERMAL MOTION PARAMETERS DESIRED.')
   45 FORMAT(' ',/,23H TOO MANY ATOMS, NTOT =,I5,/' INPUT ERROR  OR',
     1' GENERATED FULL SET OF ATOMS EXCEEDS LIMIT OF 150')
   46 FORMAT(' ',15X,'(EXCEPT THAT HERE MULT(I) IS RECIPROCAL OF THAT IN
     1PUT AND B''S, IF ANY, CONVERTED TO U''S)'     )
   54 FORMAT(' THE FOLLOWING TABLE SUMMARIZES THE USE OF THE HIRSHFELD-S
     1HMUELI, A28, 649, RECIPE TO GET A VALUE OF S, THE ISOTROPIC'/3X,
     2'VARIANCE OF MEAN-SQUARE AMPLITUDE. THE VALUE OF ETA (THE CORRELAT
     3ION COEFFICIENT BETWEEN MUTUALLY PERPENDICULAR MEAN'/3X,'SQUARE AM
     4PS) USED IS THAT INPUT OR ASSUMED BY DEFAULT.  IF VARIANCE IS ISOT
     5ROPIC, AND THE VALUE OF ETA APPROPRIATE,'/ 3X,'THEN IDEALLY COLUMN
     6S 1,2,3 AND 5,6,7 SHOULD ALL BE THE SAME.  VARIATIONS INDICATE ANI
     7SOTROPY OF ESDS OR INAPPROPRIATE ETA'/ 6X,'THE OVERALL AVERAGE (CO
     8LUMN 9) IS USED AS AN ESTIMATE OF THE ISOTROPIC ESD (SQ RT OF S),
     9AND THEN S, A STANDARD ETA (= -0.25),'/3X,'AND THE INTERAXIAL ANGL
     *ES ARE USED TO ESTIMATE ISOTROPIC COVARIANCES, TO PERMIT TRANSFORM
     *ATION OF ESDs FROM ONE AXIAL SYSTEM'/3X,'TO ANOTHER.'//
     * 1X,'POSN',3X,'ATOM',10X,2(3(I1,10X),4X,I1,14X),I1,/)
   55 FORMAT(a,//)
   56 FORMAT(' ','THESE ARE FROM SUBROUTINE INERT AND ARE RELATIVE TO TH
     1E CRYSTAL ORIGIN')
C
      ENTRY OUTH1
C     CALL FROM MAIN AND OUTP14
      if(iexu.eq.0) PRINT 1
      PRINT 9, (TISET(I),I=1,80)
      RETURN
C
      ENTRY OUTH2
C     CALL FROM MAIN
   47 FORMAT(' ',/' PRINCIPAL AXIS IS ')
   48 FORMAT(1H+,18X,1HZ)
   49 FORMAT(1H+,18X,1HX)
   50 FORMAT(1H+,18X,1HY)
   51 FORMAT(1H+,18X,11HXY-DIAGONAL)
   52 FORMAT(1H+,18X,12HXYZ-DIAGONAL)
      PRINT 47
      GO TO (1000,1010,1020,1030,1040), ISET
 1000 PRINT 48
      RETURN
 1010 PRINT 49
      RETURN
 1020 PRINT 50
      RETURN
 1030 PRINT 51
      RETURN
 1040 PRINT 52
      RETURN
C
      ENTRY OUTH3
C     CALL FROM OUTP3
      if(iexu.eq.0) PRINT 1
      PRINT 13
      RETURN
C
      ENTRY OUTH5
C     CALL FROM SYMET
      PRINT 20
      RETURN
C
      ENTRY OUTH6
C     CALL FROM MAIN
      NPAGE = NPAGE + 1
C ***   ALTERED THIS (SEPT 1983) SO WHEN NS NEGATIVE (SHORTENED OUTPUT)
C ***     IT SKIPS 3 LINES BETWEEN "PAGES", NOT NECESSARILY GIVING A NEW
C ***     SHEET OF PAPER  (changed to 3 lines from 5, 25.II.93)

C ---- cljf-char12 replaces carriage control 1H1
      IF(NPAGE.NE.1.AND.NS.GE.0.AND.IEXU.EQ.0) PRINT 2,CHAR(12)
      IF(NPAGE.NE.1.AND.(NS.LT.0.OR.IEXU.EQ.1)) PRINT 55,CHAR(12)
      PRINT 5,  TITLE, NPAGE
      RETURN
C
      ENTRY OUTH7
C     CALL FROM OUTP14
      PRINT 38
      RETURN
C
      ENTRY OUTH8
C     CALL FROM MAIN
      if(iexu.eq.0) PRINT 3
      if(iexu.eq.0) PRINT 46
      PRINT 42
      RETURN
C
      ENTRY OUTH9
C     CALL FROM RDIN3
      PRINT 40
      RETURN
C
      ENTRY OUTH10
C     CALL FROM INERT
      PRINT 4
      PRINT 43
      RETURN
C
      ENTRY OUTH11
C     CALL FROM SORT
      PRINT 44
      RETURN
C
      ENTRY OUTH12
C     CALL FROM INERT
      PRINT 6
      RETURN
C
      ENTRY OUTH13
C     CALL FROM MAIN OR SYMET
      PRINT 45, NTOT
      RETURN
C
      ENTRY OUTH14
C     CALL FROM INERT AND OUTP20
      PRINT 8
      RETURN
C
      ENTRY OUTH15
C     CALL FROM INERT AND OUTP20
      PRINT 7
      RETURN
C
      ENTRY OUTH16
C     CALL FROM INERT
      if(iexu.eq.0) PRINT 1
      if(iexu.eq.0) PRINT 1
      PRINT 10
      RETURN
C
      ENTRY OUTH17
C     CALL FROM INERT
      if(iexu.eq.0) PRINT 1
      PRINT 11
      RETURN
C
      ENTRY OUTH18
C     CALL FROM INERT
      PRINT 14
      PRINT 15
      RETURN
C
      ENTRY OUTH19
C     CALL FROM INERT
      PRINT 16
      RETURN
C
      ENTRY OUTH20
C     CALL FROM INERT
      PRINT 43
      RETURN
C
      ENTRY OUTH21
C     CALL FROM MAIN
      NSIG = IABS(ISIG)
      if(iexu.eq.0) PRINT 21
      RETURN
C
      ENTRY OUTH22
C     CALL FROM MAIN
      PRINT 23
      RETURN
C
      ENTRY OUTH24
C     CALL FROM OUTP16
      PRINT 25
      RETURN
      ENTRY OUTH25
C     CALL FROM RDIN2
      PRINT 26, NONRIG
      CALL EXIT
      ENTRY OUTH26
C     CALL FROM RDIN4
      PRINT 27
      CALL EXIT
      ENTRY OUTH27
C     CALL FROM NRBPAR
      PRINT 28
      CALL EXIT
      ENTRY OUTH28
C     CALL FROM MAIN
      if(iexu.eq.0) PRINT 1
      PRINT 29
      RETURN
C
      ENTRY OUTH29
C     CALL FROM OUTP21
      PRINT 22
      RETURN
C
      ENTRY OUTH30
C     CALL FROM NRBPAR
      PRINT 53
   53 FORMAT(' ATOM NAME FOR NON RIGID GROUP OR LIBRATION AXES NOT FOUND
     1 IN LIST')
      RETURN
C
      ENTRY OUTH31
C     CALL FROM INERT
      PRINT 54, (I, I =  1,9)
      RETURN
C
      ENTRY OUTH32
C ***   CALL FROM MAIN and INERT
      PRINT 56
      RETURN
C
      ENTRY OUTH33
C ***   CALL FROM RDIN2
      PRINT 30
      RETURN
      END
C
      SUBROUTINE OUTP
C
      COMMON/AIDPAR/AX(150,3),AUOBS(150,6),AUCALC(150,6),WU(150,6),
     1  WU1(150,6)
      COMMON/ATPAR/X(150,3),WT(150),MULT(150),UOBS(150,6),SIGU(150,6),UC
     1ALC(150,6),NUORB(150),SIGB(150,6)
      COMMON//AIDX(3000)
      COMMON/AMPCLN/NVIB,ICSVIB,NVAT1(40),NVAT2(40),
     1 NCSVIB(10), DCOS(10,3)
      COMMON/AMPCLC/VBAT1(40),VBAT2(40),CSATNM(10,12)
      CHARACTER*4 CSATNM,VBAT1,VBAT2
      COMMON/AXESN/ISPAX(15),LT(5,15),LAT(5,15)
      COMMON/AXESC/LBAT(5,15)
      CHARACTER*4 LBAT
      COMMON/CELLP/CD(12),RCD(12),VOL,VST,G(3,3)
      COMMON /CONT1/ISET,NO,NMULT,NA,ICOUNT,NINPAR,NPARS,NINOBS,NANG,NTO
     1T,NPULT,NA1,IFU,IB,NONRIG,NS,ISIG,ISYM,ICORL,IFU1,N8,
     2  IEIG,IMAT, IOUT,IRECAL, IFREQ
      COMMON/CONT2/NP1,NNP1,IORIG,IWU,INOPAR
      COMMON/CONT3/ISOLV,NTOTS,CONSLV,SUMW,RWUDI,RMS,RMU,gof,sumsig,
     1  iscm,msd8
      COMMON/CORDIN/ IRIDE,IMIN,IUNC, IHAT(150),NUNC(20), TUNC(20,3),
     1 TOR(3,3),XCG(3),IHPR
      COMMON/FORM/ IFMX, IFMB, ILIST
C     COMMON/FORMC/ FMTX(18), FMTB(18)
      COMMON/IAID1/IAIDX1(1000)
      common/inerta/axi(150,3),auobsi(150,6)
      COMMON/INOUTN/ NPAGE, KOUTP,  DIS, IAW
      COMMON/INOUTC/ NAME1, ATNAME(150),TISET(80),TITLE(80),ITBL(29),
     1 NAME2
      COMMON/IPAR/ NP(80)
      common/new/isigx,ETA, TK,I11, isigu,nafa(7),NONSY(7),AXMOM(7),
     1  NRBP(150),NCPD,NDAT,NESD, IBYP, IEXU, inegl
      COMMON/SYM/SYMOP(23,3,3),TMAT(3,3),RTMAT(3,3),EPSIJK(3,3,3),
     1 SYML(3)
      COMMON/TMCSIS/TCIC(3,3),TCIU(3,3),TCINVC(3,3),TCINVU(3,3),SCG(3),
     1 OMIN(3,3), TROI(3,3), oma(3,3)
      COMMON/NONAM/ NONAME(7,40)
      CHARACTER*4 NONAME
      DIMENSION AIDS(48,3,3),IKM(3,3),IKX(3,3),KTBL(3)
      DIMENSION B11(150),B22(150),B33(150),B12(150),B13(150),B23(150)
      DIMENSION AXX(150,3) 
      DIMENSION EIGV(3), TTROI(3,3)
      DIMENSION  TORIN (3,3)
      EQUIVALENCE (EIGV(1),AIDX(798)), (DPL,AIDX(1913))
      EQUIVALENCE (TTROI(1,1),AIDX(1935)) , (TORIN(1,1),AIDX(1968))
      EQUIVALENCE (AIDS(1,1,1),AIDX(2001)) 
      EQUIVALENCE (AXX(1,1),AIDX(1)), (WDSQ,AIDX(1958))
      EQUIVALENCE (KTBL(1),ITBL(27))
      EQUIVALENCE (B11(1),AIDX(1)),(B22(1),AIDX(201))
      EQUIVALENCE (B33(1),AIDX(401)),(B12(1),AIDX(601))
      EQUIVALENCE (B13(1),AIDX(801)),(B23(1),AIDX(1001))
C
      CHARACTER*4 NAME1,ATNAME,TISET*1,TITLE*1, ITBL*3, NAME2*5
      CHARACTER*3 KTBL, IKM, IKX
      REAL   MULT
C
    1 FORMAT(' ',/)
    2 FORMAT(1H )
    7 format(/'  Total number of atoms input (NTOT) is ', i3)
   10 FORMAT(//'  FROM TOTAL NUMBER OF ATOMS NTOT =',I4,', (NA-N8) =',I4
     1,' WILL BE INCLUDED IN ANALYSIS'/4X,'(N8 = NUMBER WITH WEIGHT 800.
     *).',5X,I5,' OTHERS ALSO USED IN DETERMINATION OF INERTIAL SYSTEM'
     2 /1X,' ATOMS WITH WEIGHTS OTHER THAN 0, 800.0 OR 999.9 CONTRIBUTE
     3 TO THE DETERMINATION OF THE SYSTEM OF INERTIA   ',//)
   11 FORMAT(' '              , 53HNUMBER OF ATOMS DETERMINING THERMAL M
     1OTION PARAMETERS,6X,I5,/,35H NUMBER OF INDEPENDENT OBSERVATIONS,25
     2X,I5,/,44H NUMBER OF INDEPENDENT RIGID-BODY PARAMETERS,16X,I5)
   12 FORMAT(' ','MOLECULAR WT. = ',F6.1//' CENTER OF MASS REFERRED TO T
     1HE CRYSTAL AXES:',6X,'X =',F9.5,',  Y =',F9.5,',  Z =',F9.5/)
   13 FORMAT(' ',54HD OF THE BEST PLANE FROM ORIGIN OF CRYSTAL SYSTEM IS
     1    ,F10.3,1X,8HANGSTROM)
   15 FORMAT(' ',A4,9X,A6,7X,7HNMULT =,I5)
   16 FORMAT(37H SYMMETRY OPERATIONS FOR POINT GROUP ,4X,A4,8X,A6)
   17 FORMAT(3(1X,F10.5))
   18 FORMAT(2X,7A1,8X,7A1,8X,6A1)
   20 FORMAT(' ',67HNUMBER OF INDEPENDENT PARAMETERS ADJUSTED FOR NON-RI
     1GID BODY MODEL ,I5,//)
   21 FORMAT(' ',34HALL SYMMETRY ELEMENTS PASS THROUGH,5X,4HX = ,
     .F8.5,8H,   Y = ,F8.5,8H,   Z = ,F8.5/)
   22 FORMAT(//' PARAMETERS FOR SYMMETRY-EQUIVALENT ATOMS, INCLUDING ALL
     1 THOSE WHOSE Us WILL BE USED IN THE ANALYSIS OF MOTION, PLUS'/3X,
     2'THOSE OF WEIGHT 800.0.  OTHERS USED IN DETERMINATION OF THE INERT
     3IAL TENSOR HAVE BEEN REPRODUCED (BY SUBROUTINE SYMET),'/3X,
     4'BUT ARE NOT LISTED HERE.'/' POSITION'
     5,1X,4HATOM,9X,1HX,10X,1HY,10X,1HZ,13X,3HU11,8X,3HU22,8X,3HU33,8X,
     6 3HU12,8X,3HU13,8X,3HU23/)
   23 FORMAT(1H ,3X,I2,5X,A4,2X,3(1X,F10.5),4X,6(F10.5,1X))
   25 FORMAT(' IF(IWU=1) WORKING WEIGHTS WU(I,K)=1,', 28X,'IWU =',I5)
   26 FORMAT(1X,'NUMBER OF ATTACHED RIGID GROUPS =',I2)
   27 FORMAT(/3X,'LIBRATION AXIS',i2,'; NUMBER OF AFFECTED ATOMS = ',
     1 I2,';  LIBRATION AXIS IS DEFINED BY ',A4,' and ',A4)
   28 FORMAT(8X,10(A4,6X))
   29 FORMAT(/' ADDITIONAL INDEPENDENT ARG PARAMETERS TO BE INCLUDED
     1 IN ANALYSIS: ',i3/)
   30 FORMAT(4H A =,F9.5,1X,4H B =,F9.5,1X,4H C =,F9.5,8X,7HALPHA =,F9.3
     1,2X,6HBETA =,F9.3,2X,7HGAMMA =,F9.3)
   33 FORMAT(' ',36HEIGENVALUES OF THE TENSOR OF INERTIA,3(F10.2,2X),
     1  20x,'KEYINRT'//)
   34 FORMAT(14H CELL VOLUME  ,3X,F10.3,7X,25H RECIPROCAL CELL VOLUME  ,
     1F15.8,//)
   35 FORMAT(' ',4HVEC(,I1,1H),4X,3F9.5)
   36 FORMAT(' IB DENOTES TYPE OF ''THERMAL'' PARAMETER.',26X,'IB =',I5/
     1 ' IF(NONRIG.EQ.0),NO NONRIGID-BODY TREATMENT',19X,'NONRIG =',I5/
     2' IF(IFU.NE.0), DETAILED INFO. FOR EACH ATOM REQUESTED',12X,
     2  'IFU =',I5/
     31X,'VALUE OF NS CONTROLS AMOUNT OF OUTPUT AND WHETHER ANOTHER COMP
     *OUND FOLLOWS:'/5X,    'NS POSITIVE, FULL OUTPUT, ANOTHER COMPOUND
     *FOLLOWS;'/5X,'NS =  0, FULL OUTPUT, NO COMPOUND FOLLOWS;'/5X,'NS =
     * -1, SHORT OUTPUT, NO COMPOUND FOLLOWS;'/5X,'NS = -2, VERY SHORT O
     *UTPUT, NO COMPOUND FOLLOWS;'/5X,'NS = -3, SHORT OUTPUT, ANOTHER CO
     *MPOUND FOLLOWS;'/5X,'NS LESS THAN -3, VERY SHORT OUTPUT, ANOTHER C
     *OMPOUND FOLLOWS.'/66X,'NS =',I5/
     4' IF(ISIG.EQ.0), NO WEIGHTS FOR U(I,J) PROVIDED',18X,'ISIG =',I5/
     5' IF(ISYM.EQ.0), ORIGIN LIES ON ALL MOL. SYM. ELEMENTS',11X,'ISYM
     6 =',I5/' IF(ICORL.LT.0), IGNORE CORRELNS INTERNAL & OVERALL MOTION
     7',5X,'ICORL =',I5/)
   37 FORMAT(' TOTAL NUMBER OF ATOMS READ AS INPUT',28X,'NTOT =',I5/
     1' SPACE GROUP NUMBER CORRESP. TO POINT GROUP SYM. OF MOLECULE',6X,
     2'NO =',I5/' ORIENTATION OF PRINCIPAL-AXIS SETTING',26X,'ISET =',
     3 I5)
   38 FORMAT(1H ,37HEIGENVECTORS OF THE TENSOR OF INERTIA,/,17X,2HXO,7X,
     12HYO,7X,2HZO)
   39 FORMAT(3F10.5,10X,3F10.5)
   40 FORMAT(5H A* =,F9.6,7H,  B* =,F9.6,7H,  C* =,F9.6,1H,,7X,
     1  8HALPHA* =,F9.3,10H,  BETA* =,F9.3,11H,  GAMMA* =,F9.3)
   41 FORMAT(1H ,A4,7X,6F10.5)
   42 FORMAT(1H ,A4,7X,6F10.6,5X,I1)
   43 FORMAT(1H ,A4,2X,3(1X,F10.5),3X,F6.2,4X,F5.3,4X,6(F10.5,1X),2X,I1)
   44 FORMAT(1H ,A4,4X,3F10.6,5X,3F10.6)
   45 FORMAT(1H ,A4,2X,3(1X,F10.5),3X,F6.2,4X,F5.3,4X,6(F10.5,1X))
   46 FORMAT(' ',57H WEIGHTED SUM OF SQUARES OF DEVIATIONS FROM BEST PLA
     1NE =  ,F8.4,21H ANGSTROMS SQUARED    ,/1H ,43H   THIS IS (SUM (WT)
     2(DIST. SQ.))/(SUM WT).     )
   47 FORMAT(' ',113H THESE ARE RELATIVE TO ORTHOGONALIZED (CARTESIAN) C
     1RYSTAL SYSTEM. THE THIRD LINE IS THE NORMAL TO THE BEST PLANE. ,/)
   48 FORMAT(' ',42H MATRICES FOR THE INVERSE TRANSFORMATIONS  ,/)
   49 FORMAT(' ','IF(NVIB.NE.0) CALCULATE MEAN SQ. VIB. AMPS. ALONG INTE
     1RATOMIC LINES.',1X,'NVIB =',I5,   /,1H ,'IF(ICSVIB.NE.0) CALCULATE
     2 MSDA FOR SPECIFIED DIRECTIONS AND ATOMS.',1X,'ICSVIB =', I5)
   50 FORMAT(' ',' HIRSHFELD-SHMUELI CORRELATION COEFFICIENT BETWEEN MUT
     1UALLY PERPENDICULAR MEAN SQUARE AMPLITUDES, ETA, =', F8.3)
   51 FORMAT(' ','IFMX =',I5,'  (SPECIAL INPUT FORMAT FOR X,Y,Z)')
   52 FORMAT(' ','IFMB =',I5,'  (SPECIAL INPUT FORMAT FOR B OR U VALUES)
     1 ')
   53 FORMAT(9x,'NONSY entered as zero, which implies that this ARG lies
     1 on a symmetry element.  If it does not,'/15x,'re-run the job with
     2 a non-zero value of NONSY in order to get frequencies.'/20x,
     3 'All other results are independent of the value of NONSY',/)
   54 FORMAT(' ','AXIS OF INTERNAL MOTION FOR GROUP',I3,' DEFINED BY VEC
     1TOR PRODUCT OF VECTORS ',A4,'-',A4,' AND ',A4,'-',A4,', THROUGH AT
     2OM ',A4)
   55 FORMAT(' ','MOMENT OF INERTIA OF GROUP',I4,', LYING ON A SYMMETRY
     1ELEMENT, WAS INPUT AS ',F8.2,' (UNITS AT WT, SQUARE ANGSTROMS)')
   56 FORMAT(10X,'RELATIVE TO CARTESIAN CRYSTAL AXES:',6X,'AX =',F9.5,
     1 ',  AY =',F9.5,',  AZ =',F9.5)
   57 FORMAT(' ','ARG has only 1 or 2 atoms in a general position; too
     1 few U(i,j) to determine correlations of internal and overall
     2 motion'/5x, 
     3'BE SURE SINGLE-ATOM and TWO-ATOM GROUPS COME AFTER OTHERS IF 
     4 CALCULATING CORRELATIONS FOR ARGS CONTAINING MORE ATOMS'/)
   58 FORMAT(' ','ALL DISTANCES SMALLER THAN ',F5.2,' FROM ANY INPUT ATO
     1M TO ANY OTHER INPUT ATOM OR ANY ATOM GENERATED BY SYMMETRY'/3X,
     2'WILL BE LISTED IF NS IS NOT -2 OR -4.  CORRECTIONS TO DISTANCES S
     3MALLER THAN THIS BETWEEN INPUT ATOMS WILL BE LISTED WHATEVER NS.')
   59 format('  Inertial system bypassed and NO shift of origin made.')
   60 format(' Format for atomic position parameters is A4,23X,3F9.6,
     12F5.1, corresponding to ATOM name, x,y,z, At Wt, multiplicity.')
   61 format(' Format for atomic position parameters is A4,5x,5f9.6,
     1 corresponding to ATOM name, At Wt, multiplicity, x,y,z.')
   62 format(' Format for atomic position parameters is 3F8.5,14X,A4
     14X,2F5.1,
     2 corresponding to x,y,z, ATOM name, At Wt, multiplicity.')
   63 format(' Free format input for atomic parameters.  Order is:'/
     15x,'ATOM name, x,y,z, At Wt, Multiplicity and, for displacement pa
     1rameters, 11,22,33,12,13,23')
   64 format(' Format for displacement parameters is 6F10.6,I1, correspo
     1nding to  11,22,33,12,13,23 and no. of independent values.')
   65 format(' Maximum distance to be regarded as a bond: ',f5.2,'A')
   66 FORMAT(' No. of the point group of the species studied in this
     1 crystal: ',I3)
   67 FORMAT(' No. of attached rigid groups ("ARGs"): ',I2)
   68 FORMAT(' Output will be "very short"')
   69 FORMAT(' Full output will be provided.  BEWARE.  It can be very le
     1ngthy!')
   70 FORMAT(' More than one structure being analyzed in this run.')
   71 FORMAT(' ESDs of atomic positions interleaved with those of displa
     1cement parameters in the ESD file.')
   72 FORMAT(' Coordinates of point through which all symmetry elements
     1 pass: ', 2x,2(F9.5,','),F9.5)
   73 FORMAT(' Principal axis of the molecule or ion parallels [100]')
   74 FORMAT(' Principal axis of the molecule or ion parallels [010]')
   75 FORMAT(' Principal axis of the molecule or ion parallels [110]')
   76 FORMAT(' Principal axis of the molecule or ion parallels [111]')
   77 FORMAT(' Principal axis of the molecule or ion has a special
     1 orientation, specified by matrices that have been input.')
   78 FORMAT(' Correlations of internal and overall motion ignored.')
   79 FORMAT(' Temperature of data collection:  ', f6.1,' K')
   80 FORMAT(' No automatic calculation of differences of MSDA values
     1 for ALL pairs of atoms in the structure,'/10x,'but differences
     2 will be calculated for ',i2,' specified pairs of atoms.')
   81 FORMAT(' Further calculations to be done with the same atomic
     1 parameters (and esds, if any) but different control variables.')
   82 FORMAT(' Riding corrections to be made for ',i2,' pairs of atoms
     1 especially input, in addition to those for any H or D present.')
   83 FORMAT(' Minimum motion corrections to be made for ',i2,' pairs 
     1 of atoms especially input.')
   84 FORMAT(' Correction for uncorrelated motion to be made for ',i2,
     1' pairs of atoms especially input.')
   85 FORMAT(' Frequency, force constant, and barrier calculations to
     1 be done for internal motion only.')
   86 FORMAT(' Frequency, force constant, and barrier calculations to
     1 be done for both internal and overall motion.')
   87 FORMAT(' Detailed atom-by-atom comparisons of Uobs and Ucalc to
     1 be done in various axial systems.')
   88 FORMAT(' Value of ETA, the Hirshfeld-Shmueli correlation coeffi
     1cient between mutually perpendicular mean-square amplitudes,'/
     2 5x,'is: ', f6.3)
   89 FORMAT(' Libration-corrected coordinates output on UNIT 7.  Use
     1 these with EXTREME caution and forethought.')
   90 FORMAT(' Direction cosines to be input for MSDA calculations. Up
     1 to 12 atoms for each of ',I2,' directions.')
   91 FORMAT(' No atomic weights to be generated by the program.')
   92 FORMAT(' No calculation of differences of MSDA values
     1 for pairs of atoms in the structure.')
   93 FORMAT(' Inertial system being bypassed.  All atomic weights set
     1 = 10.0, unless input as 0.0, 800.0, or 999.9;'/10X,'No frequenc
     2y or barrier calculations will be done, regardless of FREQ.')
   94 FORMAT(' CONSLV, used in subroutine SOLVE, input as ',f12.8)
   95 format(' IMAT input as ',i4,';  matrix of normal equations to
     1 be output if IMAT.GE.100')
   96 FORMAT(' "Experienced User":  much of usual output omitted',/)
   97 FORMAT('   NTOT = ',i3,',   NO = ',i3,',   ISET = ',i1,',   IB =
     1 ',i2/3x,'NVIB = ',I3,'   NONRIG = ',i1,',   NS = ',i3,
     2',   ISIG = ',i3/3X,'ISYM = ',i2,',   ICORL = ',i3,'   IWU = ',
     3 I2,',   IFU = ',I3,',   ICSVIB = ',i3)
   98 format('  MSD8.NE.0. MSD differences for atom-pairs on UNIT 8.')
   99 format('  ISCM = ',i3,'; screened MSDA matrices output.')
C
      ENTRY OUTP1
C     CALL FROM INERT
      PRINT 17, ((TCIC(I,K),K=1,3),I=1,3)
      RETURN
C
      ENTRY OUTP2
C     CALL FROM INERT
      PRINT 17, ((TCIU(I,K),K=1,3),I=1,3)
      RETURN
C
      ENTRY OUTP3
C     CALL FROM NPAR
      CALL OUTH6
      PRINT 11,(NA-N8),NINOBS,NINPAR
      IF(NO.EQ.195)  GO TO 300
      IF(NO.EQ.207)  GO TO 300
C     POINT GROUPS O AND T HAVE ONLY 1 INDETERMINABLE PARAMETER FOR S
      IF(NPARS.NE.0)  RETURN
  300 CALL OUTH3
      RETURN
C
      ENTRY OUTP4
C     CALL FROM SYMPOS
      IF(NO.EQ.221) CALL OUTH6
      PRINT 1
      PRINT 21,(SYML(I),I=1,3)
      PRINT 16,NAME1,NAME2
      DO 210 J = 1,NMULT
      DO 200 I1 = 1,3
      KBL = 1
      DO 200 K1 = 1,3
      IF(AIDS(J,I1,K1)) 220,230,240
  220 IKM(I1,K1) = ITBL(25)
      IKX(I1,K1) = KTBL(K1)
      KBL = KBL + 1
      GO TO 200
  230 IKM(I1,K1) = ITBL(23)
      IKX(I1,K1) = ITBL(23)
      GO TO 200
  240 IKX(I1,K1) = KTBL(K1)
      GO TO (205,206), KBL
  205 IKM(I1,K1) = ITBL(23)
      KBL = KBL + 1
      GO TO 200
  206 IKM(I1,K1) = ITBL(24)
  200 CONTINUE
      PRINT 18,(IKM(1,K),IKX(1,K),K=1,3),ITBL(26),(IKM(2,K),IKX(2,K),K=1
     1,3),ITBL(26),(IKM(3,K),IKX(3,K),K=1,3)
  210 CONTINUE
      RETURN
C
      ENTRY OUTP5
C     CALL FROM SYMET
      PRINT 15, NAME1,NAME2,NMULT
      RETURN
C
      ENTRY OUTP6
C     CALL FROM SYMPOS
      PRINT 22
      M=1
      J=NTOT +1
      KI=0
      L=2
      DO 600 I=J,NTOTS
      KI=KI+1
      IM=MOD(M,50)
      IF(IM.NE.0) GO TO 610
      CALL OUTH6
      PRINT 22
  610 PRINT 23,L,ATNAME(KI),(X(I,K),K=1,3),(UOBS(I,K),K=1,6)
      M=M+1
      IF(KI.LT.NA) GO TO 600
      KI=0
      PRINT 2
      L=L+1
      M=M+1
  600 CONTINUE
      RETURN
C
      ENTRY OUTP8
C     CALL FROM INERT
      PRINT 17, ((TCINVC(I,K),K=1,3),I=1,3)
      RETURN
C
      ENTRY OUTP9
C     CALL FROM INERT
      PRINT 17, ((TCINVU(I,K),K=1,3),I=1,3)
      RETURN
C
      ENTRY OUTP10
C     CALL FROM MAIN
      PRINT 10, NTOT, (NA-N8), NA1
      RETURN
C
      ENTRY OUTP11
C     CALL FROM INERT
      PRINT 17, ((TOR(I,K),K=1,3),I=1,3)
      RETURN
C
      ENTRY OUTP12
C     CALL FROM MAIN
      PRINT 30, (CD(I),I=1,6)
      PRINT 34, VOL, VST
      IF(I11.EQ.0) RETURN
C ***   print the following (at this point) only for "OLD" input 
      IF(IFMX.NE.0) PRINT 51, IFMX
      IF(IFMB.NE.0) PRINT 52,IFMB
      PRINT 50, ETA
      IF(IEXU.EQ.0.AND.NS.NE.(-2).AND.NS.NE.(-4)) PRINT 58, DIS
      RETURN
C
      ENTRY OUTP13
C     CALL FROM INERT
      PRINT 17, ((OMA(I,K),K=1,3),I=1,3)
      RETURN
C
      ENTRY OUTP14
C     CALL FROM MAIN when I11.NE.0, i.e., when using "old" input
      if(IEXU.ne.0) go to 1420
      PRINT 37, NTOT,NO,ISET
      IF(ISET.GT.5)  GO TO 1400
 1405 PRINT 36, IB,NONRIG,IFU,NS,ISIG,ISYM,ICORL
      PRINT 25,IWU
      PRINT 49, NVIB,ICSVIB
      RETURN
 1400 CALL OUTH1
      CALL OUTH7
      DO 1410 I = 1,3
      PRINT 39,   (TMAT(I,K),K=1,3), (RTMAT(I,K),K=1,3)
 1410 CONTINUE
      PRINT 1
      PRINT 1
      GO TO 1405
 1420 print 97, NTOT, NO, ISET, IB, NVIB, NONRIG, NS, ISIG, ISYM,
     1 ICORL, IWU, IFU, ICSVIB
      RETURN
C
      ENTRY OUTP15
C     PRINT ATOMIC PARAMETERS
C ***** EFM wants ALL inertial system coordinates 3/91
C ***** get them from inert; when koutp = 5, SYMMETRY
C ***** RELATED COORDINATES ARE ALSO PRESENT
      ntoti = ntot
      if(koutp.eq.5)ntoti=ntots
      DO 1500 I = 1,NTOTi
      IM = MOD(I,50)
      IF(IM.EQ.0)  GO TO 1505
      IF(I.EQ.(NA+1))  PRINT 1
      IF(I.EQ.(NA+NA1+1))  PRINT 1
      GO TO (1511,1512,1513,1514,1512,1520), KOUTP
 1511 PRINT 43, ATNAME(I),(X(I,K),K=1,3),WT(I),MULT(I),(UOBS(I,K),K=1,6)
     1,NUORB(I)
      GO TO 1500
 1512 PRINT 45,ATNAME(I),(AXi(I,K),K=1,3),WT(I),MULT(I),(AUOBSi(I,K),
     1  K=1,6)
      GO TO 1500
 1513 PRINT 45, ATNAME(I),(AXX(I,K),K=1,3) ,WT(I),MULT(I),(AUOBS(I,K),
     1 K = 1,6)
      GO TO 1500
 1514 PRINT 44,ATNAME(I),(X(I,K),K=1,3),(AXX(I,K),K=1,3)
      GO TO 1500
 1505 CALL OUTH6
      GO TO (1516,1517,1518,1519), KOUTP
 1516 CALL OUTH8
      PRINT 43, ATNAME(I),(X(I,K),K=1,3),WT(I),MULT(I),(UOBS(I,K),K=1,6)
     1,NUORB(I)
      GO TO 1500
 1517 CALL OUTH10
      PRINT 45,ATNAME(I),(AXi(I,K),K=1,3),WT(I),MULT(I),(AUOBSi(I,K),
     1 k = 1,6)
      GO TO 1500
 1518 CALL OUTH20
      PRINT 45, ATNAME(I),(AXX(I,K),K=1,3) ,WT(I),MULT(I),(AUOBS(I,K),
     1 K = 1,6)
      GO TO 1500
 1519 CALL OTHR21
      PRINT 44,ATNAME(I),(X(I,K),K=1,3),(AXX(I,K),K=1,3)
      GO TO 1500
C 1520 CALL OUTH20
C *** changed by EFM 9/25/98 because heading was printed too often
 1520 PRINT 45, ATNAME(I),(AX(I,K),K=1,3) ,WT(I),MULT(I),(AUOBS(I,K),
     1 K = 1,6)
      GO TO 1500
 1500 CONTINUE
      RETURN
C
      ENTRY OUTP16
C     CALL FROM MAIN
      CALL OUTH6
      PRINT 26, NONRIG
      DO 1600 I = 1,NONRIG
      IM = MOD(I,9)
      IF(IM.EQ.0)  CALL OUTH6
      if(iexu.eq.0) PRINT 1
      PRINT 27, I,NAFA(I),LBAT(1,I),LBAT(2,I)
      IF(ISPAX(I).NE.0) GO TO 1610
      GO TO 1620
 1610 WRITE(*,54) I, (LBAT(J,I), J = 1,5)
 1620 IF(NO.GT.2.AND.NONSY(I).EQ.0.and.ifreq.ne.0) PRINT 53
      IF(NONSY(I).EQ.0.AND.AXMOM(I).NE.0.0) WRITE(*,55) I,AXMOM(I)
      CALL OUTH24
      PRINT 28,(NONAME(I,K), K=1,NAFA(I))
      IF(NAFA(I).LT.3.AND.ICORL.GE.0.AND.NONSY(I).NE.0) PRINT 57
 1600 CONTINUE
      PRINT 29, INOPAR
      RETURN
C
      ENTRY OUTP17
C     PRINT U'S,BETA'S AND SIGU'S
      NSIG = IABS(ISIG)
      DO 1700 I = 1,NTOT
      IM = MOD(I,50)
      IF(IM.EQ.0)  GO TO 1705
      GO TO (1711,1712,1713), KOUTP
 1711 PRINT 42, ATNAME(I),B11(I),B22(I),B33(I),B12(I),B13(I),B23(I),NUOR
     1B(I)
      GO TO 1700
 1712 PRINT 41, ATNAME(I), (SIGB(I,K),K=1,6)
      IF(I.EQ.NSIG) GO TO 1750
      GO TO 1700
 1713 PRINT 41,ATNAME(I),(WU(I,K),K=1,6)
      IF(I.EQ.(NA-N8)) GO TO 1750
C ***  CHANGED NSIG TO (NA-N8) 14.I.87 SO PRINT NO WORKING WTS FOR
C ***    ATOMS WITH WEIGHTS 800.
      GO TO 1700
 1705 CALL OUTH6
      GO TO (1716,1717,1718), KOUTP
 1716 CALL OUTH9
      PRINT 42, ATNAME(I),B11(I),B22(I),B33(I),B12(I),B13(I),B23(I),NUOR
     1B(I)
      GO TO 1700
 1717 CALL OUTH21
      PRINT 41, ATNAME(I), (SIGB(I,K),K=1,6)
      IF(I.EQ.NSIG) GO TO 1750
      GO TO 1700
 1718 CALL OUTH28
      PRINT 41,ATNAME(I),(WU(I,K),K=1,6)
      IF(I.EQ.(na-n8)) GO TO 1750
 1700 CONTINUE
 1750 CONTINUE
      RETURN
C
      ENTRY OUTP18
C     CALL FROM CALCUS
      PRINT 20,NINPAR
      RETURN
C
      ENTRY OUTP19
C     CALL FROM INERT
      PRINT 1
      PRINT 33, (EIGV(I),I=1,3)
      PRINT 38
      DO 1900 I = 1,3
      PRINT 35, I, (TTROI(I,K),K=1,3)
 1900 CONTINUE
      PRINT 47
      PRINT 46, WDSQ
      PRINT 12, SUMW, (SCG(I),I=1,3)
      PRINT 56, (XCG(I),I=1,3)
      PRINT 13, DPL
      RETURN
C
      ENTRY OUTP20
C     CALL FROM INERT
      PRINT 48
      CALL OUTH15
      PRINT 17, ((TORIN(I,K), K=1,3), I=1,3)
      CALL OUTH14
      PRINT 17, ((OMIN(I,K),K=1,3),I=1,3)
      RETURN
C
      ENTRY OUTP21
C     PRINT TRANSFORMED ESD'S.  CALL FROM MAIN
      NSIG = IABS(ISIG)
      M = 0
      J = 1
      KI = 0
      KEQ = NSIG
      L = 1
      K = NSIG
 2105 DO 2120 I = J,K
      KI = KI + 1
      IM = MOD(M,50)
      IF(IM.NE.0) GO TO 2110
      CALL OUTH6
      CALL OUTH29
 2110 PRINT 2130,L,ATNAME(KI), (SIGU(I,N), N=1,6)
 2130 FORMAT(2X,I3,6X,A4,6X,6F10.5)
      M = M + 1
      IF(KI.LT.KEQ) GO TO 2120
      KI = 0
      PRINT 2
      L = L + 1
      M = M + 1
 2120 CONTINUE
      IF(K.EQ.NTOTS) RETURN
      KEQ = NA
      J = NTOT + 1
      K = NTOTS
      GO TO 2105
C
      ENTRY OUTP22
C ***   first, print values of non-defaulted quantities
      print 7,NTOT
      IF(IEXU.EQ.1) PRINT 96
      if(ilist.ne.0) go to 2202
      if(ifmx.eq.1)  go to 2203
      if(ifmx.eq.0)  print 60
      if(ifmx.lt.0)  print 61
      if(ifmx.gt.1)  print 62
      go to 2203
 2202 print 63
 2203 if(ilist.eq.1.or.ifmx.eq.1.or.ifmb.eq.0) go to 2204
C ***  ifmb irrelevant for free-format or SHELX input
      print 64
 2204 if(dis.ne.2.0) print 65, dis      
      if(no.ne.1) print 66, NO
      if(nonrig.ne.0) print 67, nonrig
      if(tk.ne.296.) print 79, TK
      if(ns.eq.-1.or.ns.eq.-3) go to 2205
      if(ns.eq.-2.or.ns.le.-4) print 68
      if(ns.ge.0) print 69
 2205 if(ns.gt.0.or.ns.le.-3) print 70
      if(isigu.gt.0.and.isigx.ne.0) print 71
      if(isym.ne.0) print 72, (syml(i),i=1,3)
      if(iset.eq.1) go to 2206
      if(iset.eq.2) print 73
      if(iset.eq.3) print 74
      if(iset.eq.4) print 75
      if(iset.eq.5) print 76
      if(iset.le.5) go to 2206
      print 77
      CALL OUTH1
      CALL OUTH7
      DO 2207 I = 1,3
      PRINT 39, (TMAT(I,K),K=1,3), (RTMAT(I,K),K=1,3)
 2207 CONTINUE
      PRINT 1
 2206 if(icorl.lt.0.and.nonrig.gt.0) print 78
      if(nvib.gt.0) print 80, nvib
      if(nvib.eq.0) print 92
      if(msd8.ne.0) print 98
      if(iscm.ne.0) print 99, iscm
      if(irecal.ne.0) print 81
      if(iride.ne.0) print 82, iride
      if(imin.ne.0) print 83, imin
      if(iunc.ne.0) print 84, iunc
      if(ifreq.eq.0) go to 2210
      if(ifreq.gt.0) print 85
      if(ifreq.lt.0) print 86
 2210 if(ifu.ne.0) print 87
      if(iaw.ne.0) print 91
      if(ibyp.eq.2) print 59
      if(ibyp.ne.0.and.ibyp.ne.2) print 93
      if(eta.ne.-0.25) print 88, eta
      if(iout.ne.0) print 89
      if(icsvib.ne.0) print 90, icsvib
      IF(IMAT.NE.0) PRINT 95, IMAT
      IF(CONSLV.NE.0.01) PRINT 94, CONSLV
 2295 continue
      PRINT 1
      return
      END
C
      SUBROUTINE OUTR
C     OUTPUT OF RESULTS OF ANALYSIS
C   ADDED ENTRY OUTR14 AND COMMON/NOREIG/, SEPT 1985; NOT OPERATIVE YET
C
      COMMON/AIDPAR/AX(150,3),AUOBS(150,6),AUCALC(150,6),WU(150,6),
     1  WU1(150,6)
      COMMON/ATPAR/X(150,3),WT(150),MULT(150),UOBS(150,6),SIGU(150,6),UC
     1ALC(150,6),NUORB(150),SIGB(150,6)
      COMMON//AIDX(3000)
      COMMON/AMAT/AN(80,80)
      COMMON/AMPCLN/NVIB,ICSVIB,NVAT1(40),NVAT2(40),
     1 NCSVIB(10), DCOS(10,3)
      COMMON /CONT1/ISET,NO,NMULT,NA,ICOUNT,NINPAR,NPARS,NINOBS,NANG,NTO
     1T,NPULT,NA1,IFU,IB,NONRIG,NS,ISIG,ISYM,ICORL,IFU1,N8,
     2 IEIG,IMAT, IOUT,IRECAL, IFREQ
      COMMON/CONT2/NP1,NNP1,IORIG,IWU,INOPAR
      COMMON/CONT3/ISOLV,NTOTS,CONSLV,SUMW,RWUDI,RMS,RMU,gof,sumsig,
     1  iscm,msd8
      COMMON/IAID1/ IAIDX1(1000)
      COMMON/INOUTN/ NPAGE, KOUTP,  DIS, IAW
      COMMON/INOUTC/ NAME1, ATNAME(150),TISET(80),TITLE(80),ITBL(29),
     1 NAME2
      COMMON/LOC/ VAF(7,3), PVEC(7,3), V5(7,3), VEC1(7,3)
      COMMON/LOCC/ ATNX(7,2)
      common/locc_/BLLARG(7)
      common/new/isigx,ETA, TK,I11, isigu,nafa(7),NONSY(7),AXMOM(7),
     1  NRBP(150),NCPD,NDAT,NESD, IBYP, IEXU, inegl
C     COMMON/NOREIG/ IMAT, QV(80,80), VE(80,80)
C
      CHARACTER*4 ATNX,NAME1,ATNAME,TISET*1,TITLE*1,ITBL*3,NAME2*5
C
      DIMENSION KAN(80), DEL(6), UH(3,3), PLL(6), ALL(3,3), VLL(3)
      DIMENSION EFSCT(3),SCRP(3),RHO(3,3), PD(7)
      DIMENSION  AHL(3,3),AHT(3,3),VL(3,3),VT(3,3)
      DIMENSION AAHT(3,3),AHS(3,3),SL(3,3),TL(3,3),TNEWV(3,3)
      DIMENSION ROL(3),RO(3),SO(3,3),TO(3,3),TNEW(3,3),SNEW(3,3)
      DIMENSION TOE(3,3),TOEV(3,3),TLE(3,3),TLEV(3,3),TNEWE(3,3)
      DIMENSION SIGP(80),P(80),DP(3),DSP(3),SDP(3),SDSP(3)
      DIMENSION INDX(80),CORR(80)
      DIMENSION AOL(3,3),AOT(3,3),AOC(3,3)
      DIMENSION AUO(3,3),AUC(3,3),VUO(3,3),VUC(3,3)
      DIMENSION ATCIC(3,3),ALC(3,3),ATC(3,3),ALM(3,3),ATM(3,3)
      DIMENSION AXX(150,3),DELTU(6) 
      DIMENSION  IPAIR(7,7)
      EQUIVALENCE (UH(1,1),AIDX(2490))
      EQUIVALENCE (KAN(1),AIDX(961)),(DP(1),AIDX(1750))
      EQUIVALENCE (AHL(1,1),AIDX(2601)),(AHT(1,1),AIDX(2611))
      EQUIVALENCE (VL(1,1),AIDX(2641)),(VT(1,1),AIDX(2651))
      EQUIVALENCE (P(1),AIDX(801)),(DSP(1),AIDX(1753))
      EQUIVALENCE (INDX(1),AIDX(1541)), (CORR(1),AIDX(1621))
      EQUIVALENCE (SNEW(1,1),AIDX(751))
      EQUIVALENCE (SIGP(1),AIDX(881)), (IPAIR(1,1),AIDX(1701))
      EQUIVALENCE(EFSCT(1),AIDX(601)),(SCRP(1),AIDX(605))
      EQUIVALENCE(RHO(1,1),AIDX(2811)) 
      EQUIVALENCE(AUO(1,1),AIDX(2661)),(AUC(1,1),AIDX(2671))
      EQUIVALENCE(VUO(1,1),AIDX(2681)) 
      EQUIVALENCE(VUC(1,1),AIDX(2691))
      EQUIVALENCE(AOC(1,1),AIDX(2701))
      EQUIVALENCE(AOL(1,1),AIDX(2711))
      EQUIVALENCE(AOT(1,1),AIDX(2721))
      EQUIVALENCE(AAHT(1,1),AIDX(2771)),(AHS(1,1),AIDX(2781))
      EQUIVALENCE(SL(1,1),AIDX(2791)),(TL(1,1),AIDX(2801))
      EQUIVALENCE(ROL(1),AIDX(2811)),(RO(1),AIDX(2815))
      EQUIVALENCE(SO(1,1),AIDX(2831)),(TO(1,1),AIDX(2841))
      EQUIVALENCE(TNEW(1,1),AIDX(2551)),(TOE(1,1),AIDX(2561))
      EQUIVALENCE (TOEV(1,1),AIDX(2571)),(TLE(1,1),AIDX(2581))
      EQUIVALENCE(TLEV(1,1),AIDX(2591)),(TNEWE(1,1),AIDX(601))
      EQUIVALENCE(SUMSGU,AIDX(2486))
      EQUIVALENCE (TNEWV(1,1),AIDX(611))
      EQUIVALENCE (ATCIC(1,1),AIDX(621)),(ALC(1,1),AIDX(631))
      EQUIVALENCE (ATC(1,1),AIDX(641)),(ALM(1,1),AIDX(651))
      EQUIVALENCE (ATM(1,1),AIDX(661))
      EQUIVALENCE (TROT,AIDX(695)),(TRNT,AIDX(696))
      EQUIVALENCE (AXX(1,1),AIDX(1)),(DELTU(1),AIDX(2491))
      EQUIVALENCE (RWU,AIDX(2897))
      DOUBLE PRECISION  AN, SUM
      real mult
C ***  NEED FOLLOWING WHEN ACTIVATE    ENTRY  OUTR14
C     DOUBLE PRECISION QV,VE
C
      CHARACTER*1 STAR
      DATA  STAR/'*'/
    1 FORMAT(1H ,A4,4H =   , F9.5,5X,F7.5,10X,F9.3,5X,F7.3)
    2 FORMAT(' ','INTERNAL TORSIONAL AXIS',I3/5X,'FIRST LINE IS PHI-PHI
     1 PLUS 2*(PHI-LAMBDA PARALLEL)'/29X,G10.3,2X,
     2G9.3,8X,G10.3,2X,G9.3,4X,G10.3,2X,G8.2)
    3 FORMAT(5H VEC(,I1,1H),3X,3F10.5,7X,F10.5,5X,F8.4,2(17X,F6.2))
    4 FORMAT(1H ,A4,3X,6(F9.4),4X,8HOBSERVED)
    5 FORMAT(' ',/)
    6 FORMAT(1H ,7X,6(F9.4),4X,10HCALCULATED)
    7 FORMAT(' ','A SORT OF ESD OF WEIGHTED DELTA(U)',F10.4,/1X, 'SQRT(S
     1UM((WT(UOBS-UCALC))**2)/((NINOBS-NINPAR)*(AVE. of (WT**2)))'/
     22X,'NINOBS IS THE NUMBER OF INDEPENDENT OBSERVATIONS (U VALUES);
     3 NINPAR IS THE NUMBER OF INDEPENDENT PARAMETERS DETERMINED'/)
    8 FORMAT(1H ,A4,6X,6F10.4,3X,10HU OBSERVED/1H ,10X,6F10.4
     1,3X,12HU CALCULATED,/,1H ,10X,6F10.4,3X,12H DIFFERENCE  /)
    9 FORMAT(1H ,F10.4,5X,3F10.5,6X,F10.4,5X,3F10.5)
   10 FORMAT(' ',48H ANGULAR RELATIONSHIPS BETWEEN THE AXIAL SYSTEMS)
   11 FORMAT(' ',11X,6H UC(1),8H   UC(2),8H   UC(3),6X,8H    L(1),
     18H    L(2) ,8H    L(3),6X,8H    T(1),8H    T(2),8H    T(3)/)
   12 FORMAT(2X,3HUO(,I1,1H),3X,3F8.2,6X,3F8.2,6X,3F8.2/)
   13 FORMAT(' ',28HEIGENVALUES AND EIGENVECTORS,2X,61H(V1, V2, V3 ARE D
     1IRECTION COSINES RELATIVE TO INERTIAL AXES) ,/ ,4X,9HOBSERVED:,9X,
     22HV1,8X,2HV2,8X,2HV3,10X,11HCALCULATED:,8X,2HV1,8X,2HV2,8X,2HV3,/)
   14 FORMAT(' ',2HA(,I2,5H,J) =,28I4)
   15 FORMAT(1H ,3(4HROL(,I1,2H)=,F7.3,5X),13H  ANGSTROMS    )
   16 FORMAT(1X,3F10.5,10X,3F10.5)
   17 FORMAT(' ',6H OLD S,35X,5HNEW S,/)
   18 FORMAT(' ',6H OLD T,35X,5HNEW T,/)
   19 FORMAT(' ',29HEIGENVECTORS AND EIGENVALUES ,/)
   20 FORMAT(1H ,5X,5HOLD T,55X,5HNEW T,/)
   21 FORMAT(5H VEC(,I1,2H)=,3F10.5,2X,F10.5,5X,4HVEC(,I1,2H)=,3F10.5,2X
     1,F10.5)
   22 FORMAT(' ',15HTRACE OF OLD T ,F10.5,5X,15HTRACE OF NEW T ,F10.5,/)
   23  FORMAT(1H ,2HI(,I1,1H),12X,3(F7.2,1X))
   24 FORMAT(A4,23X,3F9.6)
   25 FORMAT(6H (RHO(,I1,8H),J=1,3),3(2X,F8.3),/)
   26 FORMAT(22H SCREWPITCH PARALLEL L,I1,2H  ,2X,F7.3,/)
   27 FORMAT(31H SCREWTRANSLATION PARALLEL TO L,I1,2H  ,2X,F7.3,/)
   28 FORMAT(1H ,7X,6(F9.4),4X,10HDIFFERENCE,/)
   29 FORMAT(39H MEAN STANDARD DEVIATION OF U OBSERVED ,F10.4,/,36H (VAL
     1UE CORRESPONDING TO THE R.M.S.),/)
   30 FORMAT('  NO SHIFT OF ORIGIN TO SYMMETRIZE THE S-TENSOR AND 
     1 MINIMIZE THE TRACE'/5x,'OF T WILL BE APPLIED.  NO ALTERNATIVE
     2 SYSTEMS OF INTERPRETATION CALCULATED.'/)
   31 FORMAT(40(1X,I2),//)
   32 FORMAT(' ',30X,'RADIANS SQUARED',14X,'DEGREES SQUARED',13X,'DEGREE
     *S',15X,'RADIAN-ANGSTROM'/
     11H ,31X,'VALUE',5X,'E.S.D.',11X,'VALUE',6X,'E.S.D.',7X,'RMS AMPL.'
     2,2X,'E.S.D.',10X,'VALUE',5X,'E.S.D.')
   33 FORMAT(' ',/,14X,19H ANGSTROMS SQUARED   )
   34 FORMAT(/,'  UNITS OF S ARE RADIAN-ANGSTROMS')
   35 FORMAT(' ',10X,'THE PARAMETER NUMBERS ARE:'/T15,'1   L11',T30,'7
     1   T11',T45,'13   S11 (IF PRESENT) OR PHI1 SQUARED'/T15,'2   L12',
     2 T30,'8   T12',T45,'14   S12 (OR SEE BELOW)'/
     3 T15,'3   L13',T30,'9   T13',T45,'15   S13',T60,'19   S31'/
     4 T15,'4   L22',T29,'10   T22',T45,'16   S21',T60,'20   S32'/
     5 T15,'5   L23',T29,'11   T23',T45,'17   S22',T60,'21   S33'/
     6 T15,'6   L33',T29,'12   T33',T45,'18   S23'//10X,'IF S IS ABSENT,
     7 PARAMETER NUMBERS FOR RIGID GROUPS START AT 13; WITH S, THEY STAR
     8T AT 22. '/12X,'If ICORL.GE.0, seven parameters for each ARG are
     8 given:  FIRST, <PHI squared> + 2<PHI Lambda-parallel>, then,'/
     912X,' in order, correlations of PHI with LAMBDA, the overall
     * rotation, about each of the three CCS axes, and then'/12x,'those
     * of PHI with overall TRANSL along each of the three CCS axes.'/)
   36 FORMAT(' ','DIRECTION COSINES OF LIBRATION AXES OF ATTACHED RIGID
     1 GROUPS (ARGS) IN CARTESIAN CRYSTAL SYSTEM'/5X,'AND VALUES OF L AN
     2D ITS RMS IN THAT DIRECTION'/' ','  GROUP',5X,3H V1,10x,3h V2,
     3 10X,3H V3,11X,'L/RAD SQ',4X,'L/DEG SQ',4X,'RMS L')
   37 FORMAT(1H ,3X,I2,3(5X,F8.5),7X,F8.5,3x,2(3X,F7.3))
   38 FORMAT(' ',10X,'ONLY CORRELATION COEFFICIENTS = 0.500 OR LARGER AR
     1E PRINTED; IF  IEXU  IS NON-ZERO, or NS = -2 OR -4,'/12X,'ONLY 
     2 VALUES = 0.900 OR LARGER ARE PRINTED.  EACH LINE BEGINS AT THE 
     3 LEFT WITH THE VALUE OF I'/12X,'AND EACH VALUE ON A LINE IS 
     4 PRECEDED BY THE CORRESPONDING VALUE OF J')
   39 FORMAT  (1H , A4, 4H  = ,F9.5, 8X,A1,13X,F9.3,8X,A1)
C  40 FORMAT(' ','ARG AXIS',I3/5X,'PHI-PHI',18X,G10.3,2X,
C    1G9.3,7X,G9.3,2X,G9.3,5X,'(NO RMS VALUE SINCE MEAN SQ AMPL IS NEG.
C    2OR ZERO)')
   41 FORMAT(73H  EIGENVECTORS AND EIGENVALUES OF REDUCED T, SCHOMAKER-T
     1RUEBLOOD EQ. (20)   /' ',50X,17HDIRECTION COSINES ,21X,6HT(I,I),
     2/9H  L-FRAME )
   42 FORMAT(' ',34X,4HVEC(,I1,3H) =,3F10.5,10X,F10.5/
     1 2(35X,4HVEC(,I1,3H) =,3F10.5,10X,F10.5/))
   43 FORMAT(16H  INERTIAL FRAME)
   44 FORMAT(25H  CARTESIAN CRYSTAL FRAME )
   45 FORMAT(/,'  WEIGHTED R FOR ALL U''S = ',F6.3,';  FOR DIAGONAL U''S
     1 ONLY, WEIGHTED R =',F6.3,20X,'KEYR'
     * /, ' [R HERE IS SQRT(SUM SQUARES WEIGHTED
     2 DELTA U DIVIDED BY SUM SQUARES WEIGHTED UOBS).]',/)
   46 FORMAT(' ',33HR.M.S. OF THE WEIGHTED DELTA(U) =,F10.4,/,43H (SQRT(
     1SUM(WT(UOBS-UCALC))**2/SUM(WT**2)))   )
   47 FORMAT(1H ,2HL(,I1,1H),12X,3(F7.2,1X))
   48 FORMAT(1H ,2HT(,I1,1H),12X,3(F7.2,1X))
   49 FORMAT(' ',12X,'RADIANS SQUARED',17X,'DEGREES SQUARED',20x,
     1  'KEYLTS'/12X,'VALUE',7X,'E.S.D.',14X,'VALUE',7X,'E.S.D.')
   50 FORMAT('   OVERALL MEAN SQUARE AMPLITUDE ABOUT AXIS OF EACH ARG,',
     1 ' IN DEGREES SQUARED' /10X,'This is the sum of L about the ARG ax
     2is and phi-squared plus 2<phi-lambda parallel>.'/)
   51 FORMAT(' ',I4,9(3X,I3,', ',F6.3))
   52 FORMAT(5X,'PHI-OVERALL ROTN.  NEGATIVE SIGN IMPLIES OPPOSITE SENSE
     1S OF ROTATION')
   56 format(10X,i2,3X,G10.3,2X,G9.3,9X,G9.3,2X,G9.3,4X,G8.2,4X,G8.2)
   53 FORMAT(5X,'PHI-OVERALL TRANSL',2X,'1',78X,G10.3,3X,G9.3/25X,'2',78
     1X,G10.3,3X,G9.3/25X,'3',78X,G10.3,3X,G9.3)
   54 FORMAT(' ','CORRELATION BETWEEN ARGs',I3,' AND',I3,',
     1 WHICH HAVE AT LEAST ONE ATOM IN COMMON'/24X,G10.3,2X,G9.3,7X,G9.3
     2 ,2X,G9.3,5X,G8.2,3X,G8.2)
   55 FORMAT(' ','ONLY ONE OR TWO ATOMS AFFECTED BY THE INTERNAL MOTION.
     1 TOO FEW DATA FOR CORRELATION OF INTERNAL AND OVERALL MOTION')
   57 FORMAT(' ','INTERNAL TORSIONAL AXIS',I3/5X,'DUNITZ-WHITE MODEL, WI
     1TH NO INTERNAL CORRELATIONS: <PHI SQUARED> = ', /29X,G10.3,2X,
     2G9.3,8X,G10.3,2X,G9.3,4X,G10.3,2X,G8.2)
   61 FORMAT(15X,' ARG NO. ',I1,4X,F6.1)
   62 format(/,'  Goodness of fit = ',f5.2,', defined as square root of
     1 [sum of squares of delta(U)/esd(u)'/5x,'divided by (number of
     2 independent observations  -  number of parameters)]',/)
 9005 FORMAT(' ','ONE OR MORE EIGENVALUES OF L FOUND TO BE ZERO OR 
     1 NEGATIVE; changed'/5x,'to 0.000001 radian squared, corresponding
     2 to an amplitude of 0.06 degrees'/5x,'Be wary of rigid-body 
     3 corrections if any Lii is significantly negative'/)
C 
      ENTRY OUTR1
C     CALL FROM MAIN (KOUTP = 2) OR ATINT (INERTIAL SYSTEM, KOUTP = 1)
      Q = 3282.806
      PRINT 49
      DO 100 I = 1,12
      IF(I.GT.6) GO TO 102
      PDD = Q*P(I)
      IF (KOUTP.EQ.1) GO TO 101
      SD = Q*SIGP(I)
      WRITE(*,1,ERR=100) ITBL(I),P(I),SIGP(I),PDD,SD
      GO TO 100
  101 WRITE(*,39,ERR=100)  ITBL(I), P(I),STAR, PDD, STAR
      GO TO 100
  102 IF (I.GT.7) GO TO 103
      PRINT 33
  103 IF(KOUTP.EQ.1) GO TO 104
      WRITE(*,1,ERR=100)  ITBL(I),P(I),SIGP(I)
      GO TO 100
  104 WRITE(*,39,ERR=100)  ITBL(I),P(I),STAR
  100 CONTINUE
      IF(NPARS.EQ.0) GO TO 110
      PRINT 34
      IF (IORIG.LE.0) GO TO 120
      DO 105 I = 13,21
      IF(KOUTP.EQ.1) GO TO 106
      WRITE(*,1,ERR=105)  ITBL(I),P(I),SIGP(I)
      GO TO 105
  106 WRITE(*,39,ERR=105) ITBL(I),P(I),STAR
  105 CONTINUE
      PRINT 5
  110 IF(NONRIG.EQ.0)  GO TO  135
      IF (KOUTP.EQ.1) RETURN
      PRINT 32
      NHP = NP1 + 1
      NHP1 = NP1 + NONRIG
C ***  WHEN ICORL.LT.0, BYPASS CORRLNS INTERNAL & OVERALL MOTION
      IF(ICORL.LT.0) GO TO 1110
      DO 115 KK = 1, nonrig
      I = NP1 + 1 + 7*(KK-1)
      INH = I - NP1
      PD(kk) = P(I)*Q
      SD = SIGP(I)*Q
      SRD = 0.0
      RPD = SQRT(ABS(PD(kk)))
      IF(RPD.NE.0) SRD = SD/(2.0*RPD)
      WRITE(*,2,ERR=111) KK,P(I),SIGP(I),PD(kk),SD,RPD,SRD
  111 IF(NAFA(KK).GE.3.OR.NONSY(KK).EQ.0) GO TO 113
C ***  IF NAFA = 1 OR 2 FOR GEN-POSN ARG, NO CORRELN INTERN & OVERALL MOTION
      WRITE(*,55)
      GO TO 115
  113 continue
      print 52
      DO 114 J = 1,3
      JJ = J + I
      DP(J) = P(JJ)*Q
      DSP(J) = SIGP(JJ)*Q
      ABDP = ABS(DP(J))
      SDP1  = SQRT(ABDP)
      SDP(J) = SIGN(SDP1,DP(J))
      SDSP(J) = 0.0
      IF(ABDP.NE.0) SDSP(J) = DSP(J)/(2.0*SDP1)
      WRITE(*,56,ERR=114) j,P(JJ),SIGP(JJ),DP(J),DSP(J),SDP(J),
     1 SDSP(J)
  114 CONTINUE
      i4 = i + 4
      i6 = i + 6
  108 WRITE(*,53,ERR=115)  (P(J),SIGP(J), J = i4,i6)
  115 CONTINUE
C ***  Now print OVERALL MEAN SQ AMPL ABOUT EACH ARG AXIS
      WRITE(*,50)
      DO 3115 I = 1,NONRIG
      OVAMP = BLLARG(I) + PD(I)
      WRITE(*,61) I, OVAMP
 3115 CONTINUE   
  116 CONTINUE
C ***   INTERGROUP CORRELN INDETERMINATE WITH INTERNAL/OVERALL CORRELN
      IF(ICORL.GE.0) GO TO 135
C ***  PRINT RESULTS FOR PAIRS OF GROUPS CONTAINING COMMON ATOMS
      DO 117 I = 1,6
      JK = I + 1
      DO 117 J = JK,7
      IF(IPAIR(I,J).EQ.0) GO TO 117
      INM = IPAIR(I,J)
      PDD = P(INM)*Q
      SD = SIGP(INM)*Q
      RPD1 = SQRT(ABS(PDD))
      RPD = SIGN(RPD1,PDD)
      SRD = 0.0
      IF(RPD1.NE.0) SRD = SD/(2.0*RPD1)
      WRITE(*,54,ERR=117)  I, J, P(INM),SIGP(INM),PDD,SD,RPD,SRD
  117 CONTINUE
  135 RETURN
C *** FOLLOWING BRANCH IS WHEN CORRELNS TORS & OVERALL MOTION BYPASSED
 1110 DO 1115 I = NHP,NHP1
      INH = I - NP1
      PD(INH) = P(I)*Q
      SD = SIGP(I)*Q
      SRD = 0.0
      RPD = SQRT(ABS(PD(INH)))
      IF(RPD.NE.0) SRD = SD/(2.0*RPD)
      KK = I - NP1
      WRITE(*,57,ERR=1115) KK,P(I),SIGP(I),PD(INH),SD,RPD,SRD
 1115 CONTINUE
C ***  Now print OVERALL MEAN SQ AMPL ABOUT EACH ARG AXIS (no correln)
      write(*,50)
      DO 4115 I = 1,NONRIG
      OVAMP = BLLARG(I) + PD(I)
      WRITE(*,61) I, OVAMP
 4115 CONTINUE   
C ***  NOW PRINT CORRELNS OF ANY GROUPS WITH ATOMS IN COMMON
      GO TO 116
  120 CALL OTHR7
C      THIS PRINTS THAT S IS SYMMETRICAL
      DO 125 I = 13,15
      WRITE(*,1,ERR=125)  ITBL(I),P(I),SIGP(I)
  125 CONTINUE
      DO 130 I = 17,18
      WRITE(*,1,ERR=130)  ITBL(I),P(I),SIGP(I)
  130 CONTINUE
      I = 21
      WRITE(*,1,ERR=110)  ITBL(I),P(I),SIGP(I)
      GO TO 110
C
      ENTRY OUTR2
C     CALL FROM MAIN
      PRINT 45, RWU,RWUDI
      PRINT 7, RMS
      PRINT 46, RMU
      if(isig.ne.0) print 62, gof
      RETURN
C
      ENTRY OUTR3
C     CALL FROM OTHR2
      IF(KOUTP.EQ.3)  GO TO 305
      DO 300 K = 1,3
      SQR = SQRT(ABS(AHL(K,K)))
      DQR = 57.296*SQR
      DEGSQ = 3282.81*AHL(K,K)
      PRINT 3, K,(VL(I,K),I=1,3),AHL(K,K), SQR,DEGSQ,DQR
  300 CONTINUE
      KH = 0
      DO 320 K = 1,3
      IF(AHL(K,K).GE.0.)   GO TO 320
      AHL(K,K) = 0.000001
      INEGL = 1
      KH = KH + 1
  320 CONTINUE
      IF(KH.eq.0)  return
      print 9005
      PRINT 30
      RETURN
  305 DO 310 K = 1,3
      SQR = SQRT(ABS(AHT(K,K)))
      PRINT 3, K,(VT(I,K),I=1,3),AHT(K,K), SQR
  310 CONTINUE
      RETURN
C
      ENTRY OUTR4
C     CALL FROM MAIN
C     IF(KOUTP.EQ.1), CARTESIAN CRYSTAL FRAME.
C     IF(KOUTP.EQ.2),  CRYSTAL SYSTEM.
C
      DO 400 I = 1,NTOT
C ***  skip printout for isotropic atoms
      IF(UOBS(I,2).EQ.0.0) GO TO 400
      IM = MOD(I,11)
      IF(IM.EQ.0)  GO TO 405
      IF(I.EQ.(NA+1))  PRINT 5
      IF(I.EQ.(NA1+NA+1))  PRINT 5
      GO TO (401,402),  KOUTP
  401 PRINT 4, ATNAME(I),(AUOBS(I,K),K=1,6)
      PRINT 6, (AUCALC(I,K),K=1,6)
      DO 420 K = 1,6
      DELTU(K) = AUOBS(I,K) - AUCALC(I,K)
  420 CONTINUE
      PRINT 28, (DELTU(K),K=1,6)
      GO TO 400
  402 PRINT 4, ATNAME(I),(UOBS(I,K),K=1,6)
      PRINT 6, (UCALC(I,K),K=1,6)
      DO 425 K = 1,6
      DELTU(K) = UOBS(I,K) - UCALC(I,K)
  425 CONTINUE
      PRINT 28, (DELTU(K),K=1,6)
      go to 400
  405 CALL OUTH6
      GO TO (411,412), KOUTP
  411 CALL OTHR6
      GO TO 401
  412 CALL OTHR26
      GO TO 402
  400 CONTINUE
      RETURN
C
      ENTRY OUTR5
C     CALL FROM ATINT
      PRINT 5
      DO 510  J = 1,6
      DEL(J) = AUOBS(IAIDX1(1),J) - AUCALC(IAIDX1(1),J)
  510 CONTINUE
      PRINT 8, ATNAME(IAIDX1(1)),(AUOBS(IAIDX1(1
     1),K),K=1,6),(AUCALC(IAIDX1(1),K),K=1,6), (DEL(J), J = 1,6)
      PRINT 13
      DO 500 K = 1,3
      PRINT 9, AUO(K,K),(VUO(I,K),I=1,3),AUC(K,K),(VUC(I,K),I=1,3)
  500 CONTINUE
      PRINT 10
      PRINT 11
      DO 502 K = 1,3
      PRINT 12, K,(AOC(K,M),M=1,3),(AOL(K,M),M=1,3),(AOT(K,M),M=1,3)
  502 CONTINUE
      RETURN
C
      ENTRY OUTR6
C     CALL FROM CORMAT
      IF(IEXU.EQ.0.AND.(NS.eq.-3.or.NS.ge.-1)) PRINT 35
      PRINT 38
      DO 650 I = 1,NNP1
      INDX(I) = 0
      CORR(I) = 0.0
  650 CONTINUE
      NNPA = NNP1 - 1
      DO 670 I = 1,NNPA
      IND = 0
      L = I + 1
      DO 660 J = L,NNP1
      IF(ABS(AN(I,J)).LT.0.50) GO TO 660
C ***  CHANGE 0.50 TO ANOTHER VALUE IF WISH SMALLER, OR ONLY LARGER,
C ***    VALUES OF CORRELATION COEFFICIENT PRINTED.
      IF((NS.EQ.-2.OR.NS.EQ.-4.OR.IEXU.eq.1).and.abs(an(i,j)).lt.0.90) 
     1  go to 660
C ***  When using "experienced user switch", or when NS = -2 or -4, 
C ***         print only largest coeffic
      IND = IND + 1
      INDX(IND) = J
      CORR(IND) = AN(I,J)
  660 CONTINUE
      IF(IND.EQ.0) GO TO 670
      PRINT 51, I, (INDX(K),CORR(K), K = 1,IND)
  670 CONTINUE
      RETURN
C
      ENTRY OUTR7
C     CALL FROM LFRAME
C
C     VL = EIGENVECTORS OF L IN I FRAME OR ORTHOGONAL CRYSTAL SYSTEM
C     AHL(I,I) = EIGENVALUES L IN I FRAME
C     AAHT(3,3)= ORIG. T TENSOR IN I FRAME
C     AHT = EIGENVALUES OF ORIGINAL T TENSOR IN I FRAME
C     VT = EIGENVECTORS OF ORIGINAL T TENSOR IN I FRAME
C     AHS(3,3) = ORIG. S TENSOR IN I FRAME
C     RO (3) = ORIGIN SHIFT IN I FRAME
C     TNEW = NEW T TENSOR IN I FRAME
C     TNEWE = EIGENVALUES OF NEW T IN I FRAME
C     TNEWV = EIGENVECTORS OF NEW T IN I FRAME
C     SNEW = NEW S TENSOR IN I FRAME      (SYMMETRICAL)
C     TROT = TRACE OF OLD T, TRNT = TRACE OF NEW T
C
C     ROL(3) = ORIGIN SHIFT IN L FRAME
C     SL = ORIG. S TENSOR IN L FRAME
C     TL = ORIG. T TENSOR IN L FRAME
C     TLE = EIGENVALUES OF TL, TTLEV= EIGENVECTORS OF TL
C     SO = NEW SYMMETRIC S TENSOR IN L FRAME
C     TO = NEW T TENSOR IN L FRAME, TRACE OF T REDUCED
C     TOE = EIGENVALUES OF TO, TOEV = EIGENVECTORS OF TO
C
      PRINT 15,(I,ROL(I),I=1,3)
      PRINT 17
      DO 700 I = 1,3
      PRINT 16,(SL(I,J),J=1,3),(SO(I,J),J=1,3)
  700 CONTINUE
      PRINT 18
      DO 705 I = 1,3
      PRINT 16, (TL(I,J),J=1,3), (TO(I,J),J=1,3)
  705 CONTINUE
      PRINT 19
      PRINT 20
      DO 710 I = 1,3
      PRINT 21,I,(TLEV(J,I),J=1,3),TLE(I,I),I,(TOEV(J,I),J=1,3),TOE(I,I)
  710 CONTINUE
      PRINT 22, TROT, TRNT
      PRINT 5
  721 CALL OTHR13
C     INERTIAL FRAME
  725 PRINT 15,(I,RO(I),I=1,3)
      PRINT 17
      DO 730 I = 1,3
      PRINT 16, (AHS(I,J),J=1,3),(SNEW(I,J),J=1,3)
  730 CONTINUE
      PRINT 18
      DO 735 I = 1,3
      PRINT 16, (AAHT(I,J),J=1,3),(TNEW(I,J),J=1,3)
  735 CONTINUE
      PRINT 19
      PRINT 20
      DO 740 I = 1,3
      PRINT 21, I,(VT(J,I),J=1,3),AHT(I,I), I,(TNEWV(J,I),J=1,3),TNEWE(I
     1,I)
  740 CONTINUE
      RETURN
C
      ENTRY OUTR8
C     CALL FROM ANGLES
      IF(IBYP.NE.0) GO TO 802
      DO 800 I = 1,3
      PRINT 23, I, (ATCIC(I,J),  J=1,3)
  800 CONTINUE
  802 CALL OTHR16
      DO 805 I = 1,3
      PRINT 47, I,   (ALC(I,J),  J=1,3)
  805 CONTINUE
      CALL OTHR17
      DO 810 I = 1,3
      PRINT 48, I,   (ATC(I,J),  J=1,3)
  810 CONTINUE
      IF(IBYP.NE.0) RETURN
      CALL OTHR18
      DO 815 I = 1,3
      PRINT 47, I,   (ALM(I,J),  J=1,3)
  815 CONTINUE
      CALL OTHR19
      DO 820 I = 1,3
      PRINT 48, I,   (ATM(I,J),  J=1,3)
  820 CONTINUE
      RETURN
C
      ENTRY OUTR9
C     CALL FROM LIBCOR (TO OUTPUT CORRECTED POSITIONS OF ATOMS)
C       (IN THIS VAX VERSION, IT WRITES OUTPUT ON UNIT 7)
      DO 900 I = 1,NTOT
      WRITE (7,24)  ATNAME(I), (AXX(I,K),K=1,3)
C  (THIS WRITE STATEMENT IS JUST "PUNCH 24, ..." FOR CDC OR ANY OTHER
C     SYSTEM THAT HAS A CARD PUNCH)
  900 CONTINUE
      RETURN
C
      ENTRY OUTR10
C     CALL FROM STAS
      DO 1000 K = 1,3
      PRINT 25, K,(RHO(K,J),J=1,3)
 1000 CONTINUE
      PRINT 5
      CALL OTHR23
      DO 1005 K = 1,3
      PRINT 26, K, SCRP(K)
 1005 CONTINUE
      PRINT 5
      CALL OTHR24
      DO 1010 K = 1,3
      PRINT 27, K, EFSCT(K)
 1010 CONTINUE
      PRINT 5
      PRINT 41
      CALL EIGEN(AOT,UH,3)
      PRINT 42,(I,(UH(K,I),K=1,3),AOT(I,I),I=1,3)
      IF(IBYP.NE.0) GO TO 1015
      PRINT 43
      CALL EIGEN(AOL,UH,3)
      PRINT 42,(I,(UH(K,I),K=1,3),AOL(I,I),I=1,3)
 1015 PRINT 44
      CALL EIGEN(AOC,UH,3)
      PRINT 42,(I,(UH(K,I),K=1,3),AOC(I,I),I=1,3)
      RETURN
C
      ENTRY                             OUTR11
C     CALL FROM MAIN
C *****WRITE mean standard deviation AT BOTTOM OF MATRIX
      if(nvib.ge.0) return
      if(msd8.ne.0) WRITE(8,29) SUMSGU
      PRINT 29, SUMSGU
      RETURN
C
      ENTRY OUTR12
C     CALL FROM SOLVE
      CALL OUTH6
      CALL OTHR25
      K = 0
      DO 1200 I = 1,NNP1
      IF(KAN(I).EQ.0)  GO TO 1200
      KAN(K+1) = KAN(I)
      K = K + 1
 1200 CONTINUE
      PRINT 31, (KAN(I),I=1,K)
      RETURN
C
      ENTRY OUTR13
C      CALL FROM MAIN IF(NONRIG.NE.0)
      Q = 3282.806
      DO 1310 I = 1,6
      PLL(I) = P(I)*Q
 1310 CONTINUE
      CALL VMLT(PLL,ALL)
      PRINT 36
      DO 1300 I = 1,NONRIG
      DO 1320 J = 1,3
      VLL(J) = VEC1(I,J)
 1320 CONTINUE
      CALL VMAV(ALL,VLL,BLL)
      IF(BLL.LT.0) GO TO 1330
      SQB = SQRT(BLL)
      BLRAD = BLL/3282.806
 1330 IF(BLL.LT.0) SQB = 0.
      PRINT 37, I, (VEC1(I,J), J = 1,3), BLRAD, BLL, SQB
C ***  TO SAVE BLL (= mean sq amp of L along ARG axis) for each group:
      BLLARG(I) = BLL
C ***   BLLARG(I) into COMMON LOCC on 15.I.90
 1300 CONTINUE
      PRINT 5
      RETURN
C
      ENTRY OUTR14
C ***  THIS HAS BEEN TESTED BUT IT IS NOT IN USE IN THIS VERSION
C    CALL FROM SOLVE TO PRINT EIGENVALUES, EIGENVECTORS OF NORMAL
C       EQUATION MATRIX, USING NEW COMMON  NOREIG
C     PRINT 1445
C     PRINT 1455
C1445 FORMAT('  EIGENVALUES AND EIGENVECTORS OF NORMAL EQUATION MATRIX.
C    1ORDER IS L, T, S IF PRESENT, ALL PHI-PHI, PHI-LAMBDA & PHI-t')
C     DO 1400 I = 1,NNP1
C     SUM = 0.
C     DO 1410 J = 1,NNP1
C     SUM = VE(J,I)*VE(J,I) + SUM
C1410 CONTINUE
C     WRITE(*,1450) I,QV(I,I),SUM,(VE(J,I),J=1,NNP1)
C1450 FORMAT(1H ,I2,3X,F7.3,3X,F5.3,3X,12(F6.3,3X)/2(24X,12(F6.3,3X)/))
C1455 FORMAT(' ','NO.',2X,'EIGENVAL',2X,'SUM SQ',5X,'1',8X,'2',8X,'3',8X
C    X,'4',8X,'5',
C    1  8X,'6',8X,'7',8X,'8',8X,'9',7X,'10',7X,'11',7X,'12'/26X,'13',7X,
C    2'14',7X,'15',7X,'ETC .....')
C1400 CONTINUE
C  POSSIBLY INSERT HERE A PATCH FOR CALCULATING 'ANGLES' BETWEEN VECTORS
      RETURN
      END
C
      SUBROUTINE RD14A
C ***   "RDIN" for NEW input for THMA14.  Note OLD input can be used also.
C ***           Old input will be read by subroutine RDIN, as before.
      COMMON/AMPCLN/NVIB,ICSVIB,NVAT1(40),NVAT2(40),
     1 NCSVIB(10), DCOS(10,3)
      COMMON/AMPCLC/VBAT1(40),VBAT2(40),CSATNM(10,12)
      CHARACTER*4 CSATNM,VBAT1,VBAT2
      COMMON/ATPAR/X(150,3),WT(150),MULT(150),UOBS(150,6),SIGU(150,6),UC
     1ALC(150,6),NUORB(150),SIGB(150,6)
      COMMON/AIDCH/NTNAME(150)
      COMMON//AIDX(3000)
      COMMON/AXESN/ISPAX(15),LT(5,15),LAT(5,15)
      COMMON/AXESC/LBAT(5,15)
      CHARACTER*4 LBAT
      COMMON/CELLP/CD(12),RCD(12),VOL,VST,G(3,3)
      COMMON /CONT1/ISET,NO,NMULT,NA,ICOUNT,NINPAR,NPARS,NINOBS,NANG,NTO
     1T,NPULT,NA1,IFU,IB,NONRIG,NS,ISIG,ISYM,ICORL,IFU1,N8,IEIG,IMAT,
     2 IOUT, IRECAL, IFREQ
      COMMON/CONT2/NP1,NNP1,IORIG,IWU,INOPAR
      COMMON/CONT3/ISOLV,NTOTS,CONSLV,SUMW,RWUDI,RMS,RMU,gof,sumsig,
     1  iscm,msd8
      COMMON/CORDIN/ IRIDE,IMIN,IUNC, IHAT(150), NUNC(20), TUNC(20,3),
     1 TOR(3,3), XCG(3),IHPR
      COMMON/CORDIC/ RIDA(20), RIDB(20), AMIN1(20), AMIN2(20),
     1   UNC1(20), UNC2(20)
      COMMON/FORM/IFMX,IFMB,ILIST
C     COMMON/FORMC/FMSX(18),FMSB(18)
      COMMON/IAID1/IAIDX1(1000)
      COMMON/INOUTN/ NPAGE, KOUTP,  DIS, IATWT
      COMMON/INOUTC/ NAME1, ATNAME(150),TISET(80),TITLE(80),ITBL(29),
     1  NAME2
      COMMON/LOC/ VAF(7,3), PVEC(7,3), V5(7,3), VEC1(7,3)
      COMMON/LOCC/ ATNX(7,2)
      common/locc_/BLLARG(7)
      common/new/isigx,ETA, TK,I11, isigu,nafa(7),NONSY(7),AXMOM(7),
     1  NRBP(150),NCPD,NDAT,NESD, IBYP, IEXU, inegl
      COMMON/SYM/SYMOP(23,3,3),TMAT(3,3),RTMAT(3,3),EPSIJK(3,3,3),
     1 SYML(3)
      DIMENSION XNM(12),RDB(20),RDA(20), AMINA(20),
     1 AMINB(20), B11(150),B22(150),B33(150),B12(150),B13(150),B23(150),
     2  UNCA(20), UNCB(20)
      COMMON/NONAM/ NONAME(7,40)
      CHARACTER*4 NONAME
      EQUIVALENCE (B11(1),AIDX(1)),(B22(1),AIDX(201))
      EQUIVALENCE (B33(1),AIDX(401)),(B12(1),AIDX(601))
      EQUIVALENCE (B13(1),AIDX(801)),(B23(1),AIDX(1001))
      CHARACTER*4  RDA, RDB, AMINA, AMINB, XNM,
     1 ATNX, FMSX, FMSB, UNCA, UNCB
      CHARACTER*4  NTNAME,
     1    RIDA, RIDB, AMIN1, AMIN2, UNC1, UNC2
      REAL MULT
      CHARACTER*4 NAME1,ATNAME,TISET*1,TITLE*1, ITBL*3, NAME2*5
    1 FORMAT(20A4)
    2 FORMAT(6F10.6,I1)
    3 FORMAT(13I5,F10.5)
    4 FORMAT(3F10.5)
    5 FORMAT(3F8.5,14X,A4,4X,F5.1,F5.1)
    6 FORMAT(6F10.6,A4)
   17 FORMAT(' ','  TEMPERATURE = ',F6.1,' K')
   22 FORMAT(6F9.6,I1)
   23 FORMAT(A4,23X,3F9.6,2F5.1)
   24 FORMAT(A4,5X,5F9.6)
   28 FORMAT(' ','**************************************************',/
     1 ' FREE-FORMAT (LIST DIRECTED) INPUT TO BE USED FOR ATOMIC POSITIO
     2N AND DISPLACEMENT PARAMETERS AND THEIR ESDS.'/5X,'BE SURE TO END
     3 EACH LINE WITH A  /  .  MUST HAVE SPACES, COMMAS, OR BOTH BETWEEN
     4 ALL ITEMS OF INPUT DATA.'/5X,'REMEMBER THAT ALL ATOM NAMES MUST B
     5E ENCLOSED WITHIN APOSTROPHES',/         1X,'*********************
     6*****************************',/)
   40 FORMAT(A4,F5.0,6F10.5,2X,I1)
   41 FORMAT(5X,4F10.5)
 9006 FORMAT(' ABSOLUTE VALUE OF ISIG (',I3,') EXCEEDS NTOT (',I3,
     1 ').  CHECK INPUT')
C
      ENTRY RD14A1
  910 IF(IFU1.NE.0) GO TO 1002
C ***  WHEN IFU1 NON-ZERO, DOING SECOND RUN WITH ORIG INPUT ATOMIC PARAM
C *** CLEAR ITEMS FROM POSSIBLE PREVIOUS LIST-DIRECTED READ IN SAME RUN
      DO 912 I = 1,6
  912 CD(I) = 0.
 1002 IF(ILIST.GT.0) PRINT 28
C *** IRECAL SAVED AS IFU1 FROM EARLIER PASS, IF ANY, WITH SAME PARAMS
      IF(IFU1.NE.0) ISAG = ISIG
C ***  SAVE ISIG FROM FIRST PASS 
C ***  IN RDIN, CLEAR HERE CERTAIN ITEMS FROM POSSIBLE PREVIOUS 
C ***        LIST-DIRECTED RUN, BUT in THMA14, INTERP does this clearing
      CALL INTERP(5)
C ***  if IBYP.ne.0, then inertial system bypassed, so do no frequency calcs
      if(IBYP.NE.0) IFREQ = 0
      IF(ETA.EQ.99.) ETA = 0.0
      if(iset.le.5) go to 33
      PRINT 7104, TISET
      PRINT 7105, ((TMAT(I,J),J=1,3),I=1,3),
     1  ((RTMAT(I,J),J=1,3),I=1,3)
 7103 FORMAT('  CONSLV =',F6.3,';  IMAT =',I4,';  IEIG =',I3,
     1  ';  IOUT =', I3)
 7105 FORMAT('   TMAT: ', 3(3F10.5,3X)/
     1  ' RTMAT: ', 3(3F10.5,3X))
 7104 FORMAT('  ', 80A1)
   33 IF(IFU1.NE.0) ISIG = ISAG
      IF(IFU1.NE.0) IB = 8
C ***  WHEN IFU1 NON-ZERO, DOING A SECOND RUN WITH SAME INPUT ATOMIC
C ***   PARAMS.  'THERMAL' PARAMS ALREADY TYPE 8; ISIG SAVED FROM 1ST
  928 IF(NONRIG.GT.7)  CALL OUTH25
      IF(NONRIG.EQ.7) CALL OUTH33
      IF(TK.EQ.0.0) TK = 296.0
C   DEFAULT TEMPERATURE; IF TEMP INPUT AS 0., USE 296.0
      RETURN
C
      ENTRY RD14A3
C ***    For NEW INPUT only (NDAT and NESD not changed from 5 for 'old')
C     ATOMIC COORDINATES + DISPLAEMENT PARAMETERS, NUMBER OF 
C        INDEPENDENT OBSERVATIONS OF EACH INDIVIDUAL ATOM
C ***   In this version, NTOT is no longer input, it is found by program
      NTOT = 0
C ***   NCPD initially = 0; increased each time coords read
      NCPD = NCPD + 1
      IF(ncpd.ne.1.and.ncpd.ne.2) go to 1320
C ***  If 1st or 2nd cpd, NDAT = 11 or 13, NESD = 12 or 14, respectively
      NDAT = NDAT + 2*(NCPD - 1)
      NESD = NESD + 2*(NCPD - 1)
C ----- cljf-change
      call openf(ndat,nesd,ncpd)
      go to 1325
 1320 NDAT = 15 + 2*(NCPD - 3)
      NESD = 16 + 2*(NCPD - 3)
C ----- cljf-change
      call openf(ndat,nesd,ncpd)
 1325 CONTINUE
C ***   WHEN ILIST IS POSITIVE, USING LIST-DIRECTED INPUT
      IF(ILIST.LE.0) GO TO 88
C ***  SOME CLEARING NEEDED FOR LIST-DIRECTED INPUT BECAUSE OF POSSIBLE
C ***    USE OF CURTAILED INPUT LIST, WHICH WOULD RETAIN EARLIER VALUES
      IF(NS.GE.(-2).AND.NS.LT.1.AND.IRECAL.EQ.0) GO TO 610
C ***   WHEN NS IS 0, -1, OR -2, NO SECOND COMPOUND FOLLOWS; WHEN IRECAL = 0,
C ***    NO RECALC WITH DIFFERENT OPTIONS, BUT SAME PARAMETERS, WANTED
      DO 94 I = 1,150
      DO 92 K = 1,6
      UOBS(I,K) = 0.
      SIGU(I,K) = 0.
      SIGB(I,K) = 0.
      IF(K.GT.3) GO TO 92
      X(I,K) = 0.
   92 CONTINUE
      B11(I) = 0.
      B22(I) = 0.
      B33(I) = 0.
      B12(I) = 0.
      B13(I) = 0.
      B23(I) = 0.
      WT(I) = 0.
      MULT(I) = 0.
      NUORB(I) = 0
      ATNAME(I) = '    '
   94 CONTINUE
      GO TO 610
   88 IF (IB.GE.4) GO TO 160
      IF (IFMX.EQ.0.AND.IFMB.EQ.0) GO TO 90
      IF (IFMX.EQ.0.AND.IFMB.NE.0) GO TO 100
      IF (IFMX.GT.0.AND.IFMB.EQ.0) GO TO 110
      IF (IFMX.GT.0.AND.IFMB.NE.0) GO TO 120
      IF (IFMX.LT.0.AND.IFMB.EQ.0) GO TO 130
C      (FOLLOWING ENTRY IS FOR B'S WITH IFMX.LT.0 AND IFMB.NE.0)
      DO 30 I = 1,150
      READ(NDAT,24,end =300) ATNAME(I),WT(I),MULT(I),(X(I,K),K=1,3)
      ntot = ntot + 1
      READ(NDAT,2) B11(I),B22(I),B33(I),B12(I),B13(I),B23(I),NUORB(I)
   30 CONTINUE
  300 GO TO 140
C  FOLLOWING IS FOR IFMX = 0, IFMB = 0, B'S (NOT U'S)
   90 DO 95 I = 1,150
      READ(NDAT,23,end=305) ATNAME(I),(X(I,K),K=1,3),WT(I),MULT(I)
      ntot = ntot + 1
      READ(NDAT,22) B11(I),B22(I),B33(I),B12(I),B13(I),B23(I),NUORB(I)
   95 CONTINUE
  305 GO TO 140
C  FOLLOWING IS FOR IFMX = 0 AND IFMB.NE.0, B'S
  100 DO 105  I = 1,150
      READ(NDAT,23,end=310)  ATNAME(I), (X(I,K),K=1,3),WT(I),MULT(I)
      ntot = ntot + 1
      READ(NDAT,2) B11(I),B22(I),B33(I),B12(I),B13(I),B23(I),NUORB(I)
  105 CONTINUE
  310 GO TO 140
C  FOLLOWING IS FOR IFMX.GT.0 AND IFMB = 0
  110 DO 115 I = 1,150
      READ(NDAT,5,end=315) (X(I,K),K=1,3), ATNAME(I), WT(I), MULT(I)
      ntot = ntot+ 1
      READ(NDAT,22) B11(I),B22(I),B33(I),B12(I),B13(I),B23(I),NUORB(I)
  115 CONTINUE
  315 GO TO 140
C  FOLLOWING IS FOR IFMX.GT.0 AND IFMB.NE.0
  120 DO 125 I = 1,150
      READ(NDAT,5,end=320) (X(I,K),K=1,3), ATNAME(I), WT(I), MULT(I)
      ntot = ntot + 1
      READ(NDAT,2) B11(I),B22(I),B33(I),B12(I),B13(I),B23(I),NUORB(I)
  125 CONTINUE
  320 GO TO 140
C  FOLLOWING IS FOR IFMX.LT.0 AND IFMB = 0, STILL  B'S
  130 DO 135 I = 1,150
      READ(NDAT,24,end=140) ATNAME(I), WT(I), MULT(I), (X(I,K),K=1,3)
      ntot = ntot + 1
      READ(NDAT,22) B11(I),B22(I),B33(I),B12(I),B13(I),B23(I),NUORB(I)
  135 CONTINUE
  140 CALL OUTH6
      CALL OUTH9
      KOUTP = 1
      DO 150 I = 1,NTOT
      IF(NUORB(I).EQ.0)  NUORB(I) = 6
  150 CONTINUE
      CALL OUTP17
      GO TO 600
C   FOLLOWING BRANCH IS WHEN U'S INPUT (TYPE 4 OR TYPE 8)
  160 IF(IFMX.EQ.0.AND.IFMB.EQ.0) GO TO 490
      IF(IFMX.EQ.0.AND.IFMB.NE.0) GO TO 500
      IF(IFMX.EQ.1) GO TO 506
      IF(IFMX.GT.1.AND.IFMB.EQ.0) GO TO 510
      IF(IFMX.GT.1.AND.IFMB.NE.0) GO TO 520
      IF(IFMX.LT.0.AND.IFMB.EQ.0) GO TO 530
C   FOLLOWING IS FOR IFMX.LT.O AND IFMB.NE.0, U'S INPUT
      DO 430 I = 1,150
      READ(NDAT,24,END=330) ATNAME(I),WT(I),MULT(I),(X(I,K),K=1,3)
      NTOT = NTOT + 1
      READ(NDAT,2)  (UOBS(I,K),K=1,6),NUORB(I)
  430 CONTINUE
  330 GO TO 540
C   FOLLOWING IS FOR IFMX.EQ.0 AND IFMB.EQ.0, U'S INPUT
  490 DO 495 I = 1,150
      READ(NDAT,23,END=335) ATNAME(I),(X(I,K),K=1,3),WT(I),MULT(I)
      NTOT = NTOT + 1
      READ(NDAT,22) (UOBS(I,K),K=1,6),NUORB(I)
  495 CONTINUE
  335 GO TO 540
C    FOLLOWING IS FOR IFMX.EQ.0 AND IFMB.NE.0
  500 DO 505 I = 1,150
      READ(NDAT,23,END=340) ATNAME(I),(X(I,K),K=1,3),WT(I),MULT(I)
      NTOT = NTOT + 1
      READ(NDAT,2) (UOBS(I,K), K=1,6), NUORB(I)
  505 CONTINUE
  340 GO TO 540
C ***  FOLLOWING IS FOR SHELX INPUT (IFMB IRRELEVANT)
  506 DO 509 I = 1,150
  503 READ(NDAT,40,END=345) ATNAME(I),WT(I),(X(I,K),K=1,3),MULT(I),
     1  UOBS(I,1),UOBS(I,2),NUORB(I)
      NTOT = NTOT + 1
C ***  SKIP 'AFIX' CARDS IN SHELX INPUT
      IF(ATNAME(I).EQ.'AFIX') GO TO 503
C ***  IF MULT(I) (= OCC IN SHELX) GE.10, SUBTRACT 10
      IF(MULT(I).GE.10.) MULT(I) = MULT(I) - 10.0
      if(UOBS(I,2).NE.0) READ(NDAT,41) UOBS(I,3),UOBS(I,6),UOBS(I,5),
     1  UOBS(I,4)
C ***  CORRECT ANY PARAMETERS THAT ARE TOO LARGE BY 10.0
      DO 507 K = 1,3
  507 IF(X(I,K).GT.6.0) X(I,K) = X(I,K) - 10.
      DO 508 K = 1,6
  508 IF(UOBS(I,K).GT.9.0) UOBS(I,K) = UOBS(I,K) - 10.0
  509 CONTINUE
  345 GO TO 540
C   FOLLOWING IS FOR IFMX.GT.0 AND IFMB = 0
  510 DO 515 I = 1,150
      READ(NDAT,5,END=350) (X(I,K),K=1,3),ATNAME(I),WT(I),MULT(I)
      NTOT = NTOT + 1
      READ(NDAT,22) (UOBS(I,K),K=1,6), NUORB(I)
  515 CONTINUE
  350 GO TO 540
C  FOLLOWING IS FOR IFMX.GT.0 AND IFMB.NE.0
  520 DO 525 I = 1,150
      READ(NDAT,5,END=355) (X(I,K),K=1,3), ATNAME(I), WT(I), MULT(I)
      NTOT = NTOT + 1
      READ(NDAT,2) (UOBS(I,K),K=1,6), NUORB(I)
  525 CONTINUE
  355 GO TO 540
C   FOLLOWING IS FOR IFMX.LT.0 AND IFMB = 0
  530 DO 535 I = 1,150
      READ(NDAT,24,END=540) ATNAME(I),WT(I),MULT(I),(X(I,K),K=1,3)
      NTOT = NTOT + 1
      READ(NDAT,22) (UOBS(I,K), K=1,6), NUORB(I)
  535 CONTINUE
  540 DO 545 I = 1,NTOT
      IF(NUORB(I).EQ.0) NUORB(I) = 6
  545 CONTINUE
  600 PRINT 17,TK
  605 IF(IATWT.EQ.0) CALL XASIGN
C ***  IF XASIGN NOT CALLED, CHECK AT WTS AND IF ANY ARE 1. OR 2.,
C ***     (OR NEG OF THESE); ASSUME THOSE ATOMS ARE H,D AND MAKE IHAT 1
      IF(IATWT.EQ.0) GO TO 3010
      DO 3000 I = 1,NTOT
      IHAT(I) = 0
      WWT = ABS(WT(I))
      IWT = WWT
      IF(IWT.EQ.1.OR.IWT.EQ.2) IHAT(I) = 1
 3000 CONTINUE
 3010 RETURN
  610 CONTINUE
C ***  THIS BRANCH IS FOR LIST-DIRECTED INPUT. (IFMX, IFMB IRRELEVANT)
  630 DO 635 I = 1,150
      READ(NDAT,*,END=658) ATNAME(I),(X(I,K),K=1,3),WT(I),MULT(I)
      NTOT = NTOT + 1
  635 READ (NDAT,*) (UOBS(I,K), K=1,6), NUORB(I)
  658 IF(IB.GE.4) GO TO 540
C ***  IF INPUT WAS B'S, CHANGE "UOBS" TO B'S
      DO 659 I = 1,NTOT
      B11(I) = UOBS(I,1)
      B22(I) = UOBS(I,2)
      B33(I) = UOBS(I,3)
      B12(I) = UOBS(I,4)
      B13(I) = UOBS(I,5)
  659 B23(I) = UOBS(I,6)
      GO TO 540
C
      ENTRY RD14A5
C     READ SIGMA U'S OR OTHER SUBMITTED WEIGHTS
C ***  NESD set in RD14A3
      ISIG = 0
      TWP = 19.7392088
      DO 50 I = 1,150
      IF(ISIGX.NE.0) READ (NESD,23,end=55)
C ***   WHEN SIGX INPUT AS "Y", SIGMAS OF X,Y,Z TO BE
C ***     INPUT (AND IGNORED), INTERMIXED WITH SIGMAS OF U  (OR B)
      IF(ILIST.LE.0) GO TO 720
      DO 718 K = 1,6
  718 SIGB(I,K) = 0.
      READ (NESD,*,END=55) (SIGB(I,K), K = 1,6), NTNAME(I)
      ISIG = ISIG + 1
      GO TO 725
  720 READ (NESD,6,END=55)  (SIGB(I,K),K=1,6),NTNAME(I)
      ISIG = ISIG + 1
  725 IF(IB.GE.4.OR.ISIGU.LT.0) GO TO 50
C        IB = 0 OR 1 MEANS 'SIGU', IF ANY, ARE REALLY SIGB
      DO 48 K = 1,3
      SIGB(I,K) = SIGB(I,K)/(TWP*RCD(K)*RCD(K))
   48 CONTINUE
      SIGB(I,4) = 0.5*SIGB(I,4)/(TWP*RCD(1)*RCD(2))
      SIGB(I,5) = 0.5*SIGB(I,5)/(TWP*RCD(1)*RCD(3))
      SIGB(I,6) = 0.5*SIGB(I,6)/(TWP*RCD(2)*RCD(3))
   50 CONTINUE
   55 IF(ISIG.GT.NTOT) PRINT 9006, ISIG, NTOT
      IF (IB.EQ.8.OR.IB.EQ.1.OR.ISIGU.LT.0) RETURN
C        IB = 4 MEANS INPUT U'S ARE TOO LARGE BY FACTOR 8*(PI SQUARED)
      IF(IB.EQ.4) GO TO 70
C        IB = 0 MEANS EXPLICIT FACTOR OF 2 IN DEFINITION OF B (AND SIGB)
      DO 60 I = 1,ISIG
      SIGB(I,4) = 2.0*SIGB(I,4)
      SIGB(I,5) = 2.0*SIGB(I,5)
      SIGB(I,6) = 2.0*SIGB(I,6)
   60 CONTINUE
      RETURN
   70 FAC = 1.0/(4.0*TWP)
      DO 80 I = 1,ISIG
      DO 80 J = 1,6
      SIGB(I,J) = SIGB(I,J)*FAC
   80 CONTINUE
      RETURN
      END
C
      SUBROUTINE RDIN
C ***  added provision for IEXU here, so RBM5 would recognize it
C ***  slightly modified for THMA14 (no longer read TITLE here)
      COMMON/AMPCLN/NVIB,ICSVIB,NVAT1(40),NVAT2(40),
     1 NCSVIB(10), DCOS(10,3)
      COMMON/AMPCLC/VBAT1(40),VBAT2(40),CSATNM(10,12)
      CHARACTER*4 CSATNM,VBAT1,VBAT2
      COMMON/ATPAR/X(150,3),WT(150),MULT(150),UOBS(150,6),SIGU(150,6),UC
     1ALC(150,6),NUORB(150),SIGB(150,6)
      COMMON/AIDCH/NTNAME(150)
      COMMON//AIDX(3000)
      COMMON/AXESN/ISPAX(15),LT(5,15),LAT(5,15)
      COMMON/AXESC/LBAT(5,15)
      CHARACTER*4 LBAT
      COMMON/CELLP/CD(12),RCD(12),VOL,VST,G(3,3)
      COMMON /CONT1/ISET,NO,NMULT,NA,ICOUNT,NINPAR,NPARS,NINOBS,NANG,NTO
     1T,NPULT,NA1,IFU,IB,NONRIG,NS,ISIG,ISYM,ICORL,IFU1,N8,IEIG,IMAT,
     2 IOUT, IRECAL, IFREQ
      COMMON/CONT2/NP1,NNP1,IORIG,IWU,INOPAR
      COMMON/CONT3/ISOLV,NTOTS,CONSLV,SUMW,RWUDI,RMS,RMU,gof,sumsig,
     1  iscm, msd8
      COMMON/CORDIN/ IRIDE,IMIN,IUNC, IHAT(150), NUNC(20), TUNC(20,3),
     1 TOR(3,3), XCG(3),IHPR
      COMMON/CORDIC/ RIDA(20), RIDB(20), AMIN1(20), AMIN2(20),
     1   UNC1(20), UNC2(20)
      COMMON/FORM/IFMX,IFMB,ILIST
C     COMMON/FORMC/FMSX(18),FMSB(18)
      COMMON/IAID1/IAIDX1(1000)
      COMMON/INOUTN/ NPAGE, KOUTP,  DIS, IATWT
      COMMON/INOUTC/ NAME1, ATNAME(150),TISET(80),TITLE(80),ITBL(29),
     1  NAME2
      COMMON/LOC/ VAF(7,3), PVEC(7,3), V5(7,3), VEC1(7,3)
      COMMON/LOCC/ ATNX(7,2)
      common/locc_/BLLARG(7)
      common/new/isigx,ETA, TK,I11, isigu,nafa(7),NONSY(7),AXMOM(7),
     1  NRBP(150),NCPD,NDAT,NESD, IBYP, IEXU, inegl
      COMMON/SYM/SYMOP(23,3,3),TMAT(3,3),RTMAT(3,3),EPSIJK(3,3,3),
     1 SYML(3)
      DIMENSION XNM(12),RDB(20),RDA(20), AMINA(20),
     1 AMINB(20), B11(150),B22(150),B33(150),B12(150),B13(150),B23(150),
     2  UNCA(20), UNCB(20)
      COMMON/NONAM/ NONAME(7,40)
      CHARACTER*4 NONAME
      EQUIVALENCE (B11(1),AIDX(1)),(B22(1),AIDX(201))
      EQUIVALENCE (B33(1),AIDX(401)),(B12(1),AIDX(601))
      EQUIVALENCE (B13(1),AIDX(801)),(B23(1),AIDX(1001))
      CHARACTER*80 INFM
      CHARACTER*4  RDA, RDB, AMINA, AMINB, XNM,
     1 ATNX, FMSX, FMSB, UNCA, UNCB
      CHARACTER*4  NTNAME,
     1    RIDA, RIDB, AMIN1, AMIN2, UNC1, UNC2
      REAL MULT
      CHARACTER*4 NAME1,ATNAME,TISET*1,TITLE*1, ITBL*3, NAME2*5
    1 FORMAT(20A4)
    2 FORMAT(6F10.6,I1)
    3 FORMAT(13I5,F10.5)
    4 FORMAT(3F10.5)
    5 FORMAT(3F8.5,14X,A4,4X,F5.1,F5.1)
    6 FORMAT(6F10.6,A4)
    9 FORMAT(6F10.6,2I5,2F5.2)
   10 FORMAT(18A4)
   11 FORMAT(' ','  FORMAT FOR X,Y,Z, IS   (A4,23X,3F9.6,2F5.1)' )
   12 FORMAT(' ','FORMAT FOR DISPLACEMENT PARAMETERS IS
     1    (6F9.6,I1)' )
   13 FORMAT(8(A4,2X,I2,2X))
   14 FORMAT(3F10.6,I5)
   15 FORMAT(12(A4,2X))
   16 FORMAT(' ','NO. OF ATOMS FOR MEAN SQUARE AMPLITUDE CALCULATION IN
     1DIRECTION',I4,' IS',I5,', WHICH IS TOO LARGE (MAXIMUM IS 12).')
   17 FORMAT(' ','  TEMPERATURE = ',F6.1,' K')
   18 FORMAT(' ','TEMP INPUT AS 0.0; DEFAULT TEMP OF 296.0 TO BE USED')
   19 FORMAT(' ','  FORMAT FOR X,Y,Z IS   (3F8.5,14X,A4,4X,2F5.1)'  )
   20 FORMAT(' ','  FORMAT FOR X,Y,Z IS   (A4,5X,5F9.6)'  )
   21 FORMAT(' ','FORMAT FOR DISPLACEMENT PARAMETERS IS   (6F10.6,I1)')
   22 FORMAT(6F9.6,I1)
   23 FORMAT(A4,23X,3F9.6,2F5.1)
   24 FORMAT(A4,5X,5F9.6)
   25 FORMAT(' ','ISIGX INPUT NE.0. SIGMAS OF X,Y,Z MIXED WITH SIGMAS OF
     1 U (OR B) ON INPUT.')
   26 FORMAT(' ','NO. OF AFFECTED ATOMS = 0 FOR GROUP ',I2,'; STOP')
   28 FORMAT(' ','**************************************************',/
     1 ' FREE-FORMAT (LIST DIRECTED) INPUT TO BE USED FOR ATOMIC POSITIO
     2N AND DISPLACEMENT PARAMETERS AND THEIR ESDS.'/5X,'BE SURE TO END
     3 EACH LINE WITH A  /  .  MUST HAVE SPACES, COMMAS, OR BOTH BETWEEN
     4 ALL ITEMS OF INPUT DATA.'/5X,'REMEMBER THAT ALL ATOM NAMES MUST B
     5E ENCLOSED WITHIN APOSTROPHES',/         1X,'*********************
     6*****************************',/)
   29 FORMAT('  ISCM input as ',I3,';  MSDA difference matrix will be
     1 screened'/5x,'with only values greater than ',i3,' printed in the
     2 "filtered" version')
   36 FORMAT(' ','ERROR.  NUMBER OF ATOMS INPUT AS ZERO')
   37 FORMAT(' ','CONSLV INPUT AS ',F8.6)
   38 FORMAT(' ','IATWT INPUT NON-ZERO.  NO AT WTS TO BE ASSIGNED.')
   39 FORMAT(' ','SHELX INPUT FOR X,Y,Z AND U VALUES')
   40 FORMAT(A4,F5.0,6F10.5,2X,I1)
   41 FORMAT(5X,4F10.5)
   42 FORMAT(' ','FREE FORMAT INPUT EXCEPT FOR ATOM PARAMETERS, ESDS AND
     1 OTHER LINES INCLUDING ATOM NAMES')
   43 FORMAT(' ','IRIDE  INPUT NE.0.  RIDING ATOM PAIRS TO BE INPUT')
   44 FORMAT(' ','IMIN  INPUT NE.0.  ATOM PAIRS FOR MINIMUM ''THERMAL MO
     1TION'' CORRECTION TO BE INPUT')
   45 FORMAT(' ','IRECAL INPUT NE.0.  ANOTHER CALCULATION WITH SAME ATOM
     1IC PARAMETERS AND CELL DIMENSIONS FOLLOWS')
   46 FORMAT(' ','IUNC.NE.0.  ATOM PAIRS, WITH EQ. POSN AND TRANSLATION
     1COMPONENTS FOR 2ND ATOM, TO BE INPUT FOR CORRECTION FOR'/5X,
     2   'UNCORRELATED (INDEPENDENT) MOTION')
   47 FORMAT(80A1)
 8996 format('  IBYP.eq.2   Do not shift the origin, but calculate and
     1 print effect on T and S'/10x,'of shifting it to c. of m. or
     2 centroid.')
 8997 format('  IEXU.NE.0   Experienced user.  Few explanatory 
     1 printouts.')
 8998 format('  IBYP.NE.0.  No inertial-system calculations')
 8999 FORMAT('  MSD8.NE.0.  MSD differences for atom pairs on UNIT 8')
 9001 FORMAT(' ','IOUT.NE.0.  COORDS corrected for RIGID MOTION to be
     1 output.')
 9002 FORMAT(' ','IMAT.NE.0.  SPECIAL OUTPUT OF NORM EQN MATRIX AT VARIO
     1US STAGES OF THE CALCULATION')
 9003 FORMAT(' ','IEIG.NE.0.  MATRIX OF NORMAL EQUATIONS OUTPUT ON UNIT
     11, UNFORMATTED, ((A(I,J), I=1,N), J=1,N)')
 9004 FORMAT(' ','IRECAL =',I3,',     ISIGX =',I3,',     IRIDE =',I3,
     1 ',     IMIN =',I3,',     IUNC =',I3)
 9005 FORMAT('  IFREQ =',I3,',   IBYP =',I3,',   IATWT =',I3,',
     1   IEXU = ',i2,',   IEIG =',I3,',   IMAT =',I3,',   IOUT =',I3/)
 9006 FORMAT(' ABSOLUTE VALUE OF ISIG (',I3,') EXCEEDS NTOT (',I3,
     1 ').  CHECK INPUT')
C
      ENTRY RDIN1
  910 IF(IFU1.NE.0) GO TO 1002
C ***  WHEN IFU1 NON-ZERO, DOING SECOND RUN WITH ORIG INPUT ATOMIC PARAM
C *** CLEAR ITEMS FROM POSSIBLE PREVIOUS LIST-DIRECTED READ IN SAME RUN
      DO 912 I = 1,6
  912 CD(I) = 0.
      IFMX = 0
      IFMB = 0
      ETA = 0.
      DIS = 0.
C ***  FREE FORMAT INPUT FOR CELL DIM & VARIABLES ON THAT LINE
      READ(5,*) (CD(I),I=1,6), IFMX,IFMB,ETA,DIS
  920 IF(CD(1).GT.0) GO TO 1001
C ***  WHEN A-AXIS LENGTH INPUT AS NEGATIVE, MAKE IT POSITIVE; THIS
C ***    WAS FORMERLY SIGNAL THAT ESD'S OF X,Y,Z MIXED WITH THOSE OF U'S
      CD(1) = - CD(1)
 1001 IF(ETA.EQ.0.0) ETA = -0.25
      IF(ETA.EQ.99.) ETA = 0.0
      IF(DIS.EQ.0.0) DIS = 2.0
 1002 RETURN
C
      ENTRY RDIN2
C     CONTROL LINE AND OPTION LINES
      IF(ILIST.GT.0) PRINT 28
C *** IRECAL SAVED AS IFU1 FROM EARLIER PASS, IF ANY, WITH SAME PARAMS
      IF(IFU1.NE.0) ISAG = ISIG
C ***  SAVE ISIG FROM FIRST PASS; VALUE ON 2ND CONTROL LINE IRRELEVANT
C ***   FREE-FORMAT INPUT NOW FOR THIS 'CONTROL CARD' LINE
C ***  CLEAR CERTAIN ITEMS FROM POSSIBLE PREVIOUS LIST-DIRECTED RUN
      IB = 0
      NONRIG = 0
      IFU = 0
      NS = 0
      ISIG = 0
      ISYM = 0
      ICORL = 0
      IWU = 0
      NVIB = 0
      ICSVIB = 0
      IRECAL = 0
      iscm = 0
      TEMP = 0.0
      CONSLV = 0.
      IMIN = 0
      IATWT = 0
      IRIDE = 0
      ISIGX = 0
      IUNC = 0
      IOUT = 0
      IEXU = 0
      IMAT = 0
      IEIG = 0
      MSD8 = 0
      IBYP = 0
      READ(5,*) NTOT,NO,ISET,IB,NONRIG,NVIB,NS,ISIG,ISYM,ICORL,IWU,IFU,
     1   ICSVIB
   33 IF(IFU1.NE.0) ISIG = ISAG
      IF(IFU1.NE.0) IB = 8
C ***  WHEN IFU1 NON-ZERO, DOING A SECOND RUN WITH SAME INPUT ATOMIC
C ***   PARAMS.  'THERMAL' PARAMS ALREADY TYPE 8; ISIG SAVED FROM 1ST
C ***  READ TWO "OPTION LINES" (NEW, SEPT 1985)
      READ(5,*) TEMP, iscm, MSD8, IRECAL, ISIGX, IRIDE, IMIN, IUNC
      READ(5,*) IFREQ, IBYP, IATWT, IEXU, IEIG, IMAT, IOUT, CONSLV
      IF(CONSLV.NE.0.) PRINT 37, CONSLV
      IF(CONSLV.EQ.0.) CONSLV = 0.01
      IF(TEMP.EQ.0.) PRINT 18
      IF(IATWT.NE.0) PRINT 38
      if(iscm.ne.0) jscm = 2.5*iscm
      IF(iscm.NE.0) PRINT 29, iscm, jscm
      IF(ISIGX.NE.0) PRINT 25
      IF(IRECAL.NE.0) PRINT 45
      IF(IRIDE.NE.0) PRINT 43
      IF(IMIN.NE.0) PRINT 44
      IF(IUNC.NE.0) PRINT 46
      IF(msd8.NE.0) PRINT 8999
      IF(IEIG.NE.0) PRINT 9003
      IF(IMAT.NE.0) PRINT 9002
      IF(IOUT.NE.0) PRINT 9001
      if(IEXU.ne.0) PRINT 8997
      if(IBYP.ne.0) PRINT 8998
      if(ibyp.eq.2) print 8996
      PRINT 9004, IRECAL, ISIGX, IRIDE, IMIN, IUNC
      PRINT 9005, IFREQ, IBYP, IATWT, IEXU, IEIG, IMAT, IOUT
      IF(NTOT.GT.0) GO TO 35
      IF(NTOT.EQ.0) GO TO 34
      NTOT = -NTOT
      GO TO 35
   34 PRINT 36
      STOP
   35 TK = TEMP
      IF(TK.EQ.0.0) TK = 296.0
C   DEFAULT TEMPERATURE; IF TEMP INPUT AS 0., USE 296.0
  928 IF(NONRIG.GT.7)  CALL OUTH25
      IF(NONRIG.EQ.7) CALL OUTH33
      IF(ISET.LE.5)  RETURN
      READ (5,47) (TISET(I),I=1,80)
      READ(5,*) ((TMAT(I,K), K=1,3), I=1,3)
      READ(5,*)  ((RTMAT(I,K),K=1,3),I=1,3)
      RETURN
C
      ENTRY RDIN3
C     ATOMIC COORDINATES + TEMPERATURE PARAMETERS,NUMBER OF INDEPENDENT
C     OBSERVATIONS OF EACH INDIVIDUAL ATOM
C ***   WHEN ILIST IS POSITIVE, USING LIST-DIRECTED INPUT
      IF(ILIST.LE.0) GO TO 88
C ***  SOME CLEARING NEEDED FOR LIST-DIRECTED INPUT BECAUSE OF POSSIBLE
C ***    USE OF CURTAILED INPUT LIST, WHICH WOULD RETAIN EARLIER VALUES
      IF(NS.GE.(-2).AND.NS.LT.1.AND.IRECAL.EQ.0) GO TO 610
C ***   WHEN NS IS 0, -1, OR -2, NO SECOND COMPOUND FOLLOWS; WHEN IRECAL = 0,
C ***    NO RECALC WITH DIFFERENT OPTIONS, BUT SAME PARAMETERS, WANTED
      DO 94 I = 1,NTOT
      DO 92 K = 1,6
      UOBS(I,K) = 0.
      SIGU(I,K) = 0.
      SIGB(I,K) = 0.
      IF(K.GT.3) GO TO 92
      X(I,K) = 0.
   92 CONTINUE
      B11(I) = 0.
      B22(I) = 0.
      B33(I) = 0.
      B12(I) = 0.
      B13(I) = 0.
      B23(I) = 0.
      WT(I) = 0.
      MULT(I) = 0.
      NUORB(I) = 0
      ATNAME(I) = '    '
   94 CONTINUE
      GO TO 610
   88 IF (IB.GE.4) GO TO 160
      IF (IFMX.EQ.0.AND.IFMB.EQ.0) GO TO 90
      IF (IFMX.EQ.0.AND.IFMB.NE.0) GO TO 100
      IF (IFMX.GT.0.AND.IFMB.EQ.0) GO TO 110
      IF (IFMX.GT.0.AND.IFMB.NE.0) GO TO 120
      IF (IFMX.LT.0.AND.IFMB.EQ.0) GO TO 130
C      (FOLLOWING ENTRY IS FOR B'S WITH IFMX.LT.0 AND IFMB.NE.0)
      DO 30 I = 1,NTOT
      READ(5,24) ATNAME(I),WT(I),MULT(I),(X(I,K),K=1,3)
      READ(5,2)  B11(I),B22(I),B33(I),B12(I),B13(I),B23(I),NUORB(I)
   30 CONTINUE
      GO TO 140
C  FOLLOWING IS FOR IFMX = 0, IFMB = 0, B'S (NOT U'S)
   90 DO 95 I = 1,NTOT
      READ(5,23) ATNAME(I),(X(I,K),K=1,3),WT(I),MULT(I)
      READ(5,22) B11(I),B22(I),B33(I),B12(I),B13(I),B23(I),NUORB(I)
   95 CONTINUE
      GO TO 140
C  FOLLOWING IS FOR IFMX = 0 AND IFMB.NE.0, B'S
  100 DO 105  I = 1,NTOT
      READ(5,23)  ATNAME(I),  (X(I,K),K=1,3), WT(I), MULT(I)
      READ(5,2)  B11(I),B22(I),B33(I),B12(I),B13(I),B23(I),NUORB(I)
  105 CONTINUE
      GO TO 140
C  FOLLOWING IS FOR IFMX.GT.0 AND IFMB = 0
  110 DO 115 I = 1,NTOT
      READ(5,5) (X(I,K),K=1,3), ATNAME(I), WT(I), MULT(I)
      READ(5,22) B11(I),B22(I),B33(I),B12(I),B13(I),B23(I),NUORB(I)
  115 CONTINUE
      GO TO 140
C  FOLLOWING IS FOR IFMX.GT.0 AND IFMB.NE.0
  120 DO 125 I = 1,NTOT
      READ(5,5) (X(I,K),K=1,3), ATNAME(I), WT(I), MULT(I)
      READ(5,2) B11(I),B22(I),B33(I),B12(I),B13(I),B23(I),NUORB(I)
  125 CONTINUE
      GO TO 140
C  FOLLOWING IS FOR IFMX.LT.0 AND IFMB = 0, STILL  B'S
  130 DO 135 I = 1,NTOT
      READ(5,24) ATNAME(I), WT(I), MULT(I), (X(I,K),K=1,3)
      READ(5,22) B11(I), B22(I),B33(I), B12(I), B13(I),B23(I),NUORB(I)
  135 CONTINUE
  140 CALL OUTH6
      CALL OUTH9
      KOUTP = 1
      DO 150 I = 1,NTOT
      IF(NUORB(I).EQ.0)  NUORB(I) = 6
  150 CONTINUE
      CALL OUTP17
      GO TO 550
C   FOLLOWING BRANCH IS WHEN U'S INPUT (TYPE 4 OR TYPE 8)
  160 IF(IFMX.EQ.0.AND.IFMB.EQ.0) GO TO 490
      IF(IFMX.EQ.0.AND.IFMB.NE.0) GO TO 500
      IF(IFMX.EQ.1) GO TO 506
      IF(IFMX.GT.1.AND.IFMB.EQ.0) GO TO 510
      IF(IFMX.GT.1.AND.IFMB.NE.0) GO TO 520
      IF(IFMX.LT.0.AND.IFMB.EQ.0) GO TO 530
C   FOLLOWING IS FOR IFMX.LT.O AND IFMB.NE.0, U'S INPUT
      DO 430 I = 1,NTOT
      READ(5,24)  ATNAME(I),WT(I),MULT(I),(X(I,K),K=1,3)
      READ(5,2)  (UOBS(I,K),K=1,6),NUORB(I)
  430 CONTINUE
      GO TO 540
C   FOLLOWING IS FOR IFMX.EQ.0 AND IFMB.EQ.0, U'S INPUT
  490 DO 495 I = 1,NTOT
      READ(5,23) ATNAME(I), (X(I,K),K=1,3), WT(I), MULT(I)
      READ(5,22) (UOBS(I,K),K=1,6),NUORB(I)
  495 CONTINUE
      GO TO 540
C    FOLLOWING IS FOR IFMX.EQ.0 AND IFMB.NE.0
  500 DO 505 I = 1,NTOT
      READ(5,23)  ATNAME(I),  (X(I,K),K=1,3), WT(I), MULT(I)
      READ(5,2) (UOBS(I,K), K=1,6), NUORB(I)
  505 CONTINUE
      GO TO 540
C ***  FOLLOWING IS FOR SHELX INPUT (IFMB IRRELEVANT)
  506 DO 509 I = 1,NTOT
  503 READ(5,40) ATNAME(I),WT(I),(X(I,K),K=1,3),MULT(I),UOBS(I,1),
     1  UOBS(I,2),NUORB(I)
C ***  SKIP 'AFIX' CARDS IN SHELX INPUT
      IF(ATNAME(I).EQ.'AFIX') GO TO 503
C ***  IF MULT(I) (= OCC IN SHELX) GE.10, SUBTRACT 10
      IF(MULT(I).GE.10.) MULT(I) = MULT(I) - 10.0
      READ(5,41) UOBS(I,3),UOBS(I,6),UOBS(I,5),UOBS(I,4)
C ***  CORRECT ANY PARAMETERS THAT ARE TOO LARGE BY 10.0
      DO 507 K = 1,3
  507 IF(X(I,K).GT.6.0) X(I,K) = X(I,K) - 10.
      DO 508 K = 1,6
  508 IF(UOBS(I,K).GT.9.0) UOBS(I,K) = UOBS(I,K) - 10.0
  509 CONTINUE
      GO TO 540
C   FOLLOWING IS FOR IFMX.GT.0 AND IFMB = 0
  510 DO 515 I = 1,NTOT
      READ(5,5)  (X(I,K),K=1,3), ATNAME(I), WT(I), MULT(I)
      READ(5,22) (UOBS(I,K),K=1,6), NUORB(I)
  515 CONTINUE
      GO TO 540
C  FOLLOWING IS FOR IFMX.GT.0 AND IFMB.NE.0
  520 DO 525 I = 1,NTOT
      READ(5,5) (X(I,K),K=1,3), ATNAME(I), WT(I), MULT(I)
      READ(5,2) (UOBS(I,K),K=1,6), NUORB(I)
  525 CONTINUE
      GO TO 540
C   FOLLOWING IS FOR IFMX.LT.0 AND IFMB = 0
  530 DO 535 I = 1,NTOT
      READ(5,24) ATNAME(I), WT(I), MULT(I), (X(I,K),K=1,3)
      READ(5,22) (UOBS(I,K), K=1,6), NUORB(I)
  535 CONTINUE
  540 DO 545 I = 1,NTOT
      IF(NUORB(I).EQ.0) NUORB(I) = 6
  545 CONTINUE
      IF(ILIST.GT.0) GO TO 600
  550 IF(IFMX.EQ.0) GO TO 560
      IF(IFMX.EQ.1) GO TO 565
      IF(IFMX.GT.0) GO TO 570
      WRITE(*,20)
      GO TO 580
  560 WRITE(*,11)
      GO TO 580
  565 WRITE(*,39)
C ***   SHELX INPUT; IFMB IRRELEVANT
      GO TO 600
  570 WRITE(*,19)
  580 IF(IFMB.EQ.0) GO TO 590
      WRITE(*,21)
      GO TO 600
  590 WRITE(*,12)
  600 PRINT 17,TK
  605 IF(IATWT.EQ.0) CALL XASIGN
C ***  IF XASIGN NOT CALLED, CHECK AT WTS AND IF ANY ARE 1. OR 2.,
C ***     (OR NEG OF THESE); ASSUME THOSE ATOMS ARE H,D AND MAKE IHAT 1
      IF(IATWT.EQ.0) GO TO 3010
      DO 3000 I = 1,NTOT
      IHAT(I) = 0
      WWT = ABS(WT(I))
      IWT = WWT
      IF(IWT.EQ.1.OR.IWT.EQ.2) IHAT(I) = 1
 3000 CONTINUE
 3010 RETURN
  610 CONTINUE
C ***  THIS BRANCH IS FOR LIST-DIRECTED INPUT. (IFMX, IFMB IRRELEVANT)
  630 DO 635 I = 1,NTOT
      READ (5,*)  ATNAME(I), (X(I,K), K=1,3), WT(I), MULT(I)
  635 READ (5,*) (UOBS(I,K), K=1,6), NUORB(I)
  658 IF(IB.GE.4) GO TO 540
C ***  IF INPUT WAS B'S, CHANGE "UOBS" TO B'S
      DO 659 I = 1,NTOT
      B11(I) = UOBS(I,1)
      B22(I) = UOBS(I,2)
      B33(I) = UOBS(I,3)
      B12(I) = UOBS(I,4)
      B13(I) = UOBS(I,5)
  659 B23(I) = UOBS(I,6)
      GO TO 540
C
      ENTRY RDIN4
C   ARG INPUT AND INPUT OF PAIRS OF ATOMS FOR RIDING-MOTION and
C      		MINIMUM THERMAL-MOTION CORRECTION
      IF(NONRIG.EQ.0) GO TO 401 
C ***    MIGHT BE HERE WHEN NONRIG = 0 IF WANTED RIDING, MIN, UNCORREL
C ***         CORRECTIONS
      INOPAR = NONRIG
      DO 400 I = 1,NONRIG
      ISPAX(I) = 0
      NONSY(I) = 0
      AXMOM(I) = 0.
      READ(5,*) NAFA(I), LBAT(1,I), LBAT(2,I), NONSY(I), AXMOM(I)
  685 ATNX(I,1) = LBAT(2,I)
      IF(NAFA(I).EQ.0) GO TO 710
      IF(NAFA(I).GT.0) GO TO 700
      NAFA(I) = - NAFA(I)
      ISPAX(I) = 1
  700 IF(NAFA(I).GT.40)  CALL OUTH26
      READ(5,*)  (NONAME(I,K1), K1=1,NAFA(I))
      ATNX(I,2) = NONAME(I,1)
      IF(ISPAX(I).EQ.0) GO TO 400
C ***  READ IN EXTRA THREE ATOM NAMES IF SPECIAL DEFN OF N-R AXIS
      READ(5,*) (LBAT(J,I), J = 3,5)
  395 ATNX(I,1) = LBAT(5,I)
  400 CONTINUE
  401 CONTINUE
C ***  READ HERE ATOM PAIRS FOR RIDING, UNCORRELATED AND MINIMUM CORRNS
C ***       FOR 'THERMAL' MOTION, WITH AN EQ POSN FOR 2ND ATOM OF EACH
C ***       PAIR FOR UNCORRELATED MOTION
C ***  CLEAR ANY EARLIER VALUES IN CASE SEVERAL SUCCESSIVE RUNS
      DO 2000 I = 1,20
      RDA(I) = '    '
      RDB(I) = '    '
      AMINA(I) = '    '
      AMINB(I) = '    '
      UNCA(I) = '    '
      UNCB(I) = '    '
      NUNC(I) = 0
      DO 2000 II = 1,3
      TUNC(I,II) = 0.
 2000 CONTINUE
      IF(IRIDE.EQ.0) GO TO 2020
      READ(5,*) (RDA(I),RDB(I), I = 1,20)
      DO 2010 I = 1,20
      IF(RDA(I).NE.'    ') GO TO 2005
      IRIDE = I - 1
      GO TO 2020
 2005 RIDA(I)= RDA(I)
      RIDB(I)= RDB(I)
 2010 CONTINUE
 2020 IF(IMIN.EQ.0) GO TO 2040
      READ(5,*) (AMINA(I), AMINB(I), I = 1,20)
      DO 2030 I = 1,20
      IF(AMINA(I).NE.'    ') GO TO 2025
      IMIN = I - 1
      GO TO 2040
 2025 WRITE(INFM,1) AMINA(I), AMINB(I)
      READ(INFM,1) AMIN1(I), AMIN2(I)
 2030 CONTINUE
 2040 IF(IUNC.EQ.0) GO TO 2060
      READ(5,*) (UNCA(I),UNCB(I), NUNC(I),(TUNC(I,J),J=1,3), I = 1,20)
      DO 2050 I = 1,20
      IF(UNCA(I).NE.'    ') GO TO 2045
      IUNC = I - 1
      GO TO 2060
 2045 WRITE(INFM,1) UNCA(I), UNCB(I)
      READ(INFM,1) UNC1(I), UNC2(I)
 2050 CONTINUE
 2060 CONTINUE
      IF(NONRIG.EQ.0) RETURN
C ***  NEXT GET NUMBER OF INDEPENDENT ARG PARAMETERS, EXCEPT FOR
C ***    POSSIBLE CORRELN OF GROUPS CONTAINING COMMON ATOMS.  CORRECTION
C ***    FOR THOSE IS MADE IN "CALCUS" IN GETTING TOTAL NO OF PARAMS
      DO 2222 I = 1,NONRIG
      IF(ICORL.GE.0.AND.(NAFA(I).GE.2.OR.(NONSY(I).EQ.0.AND.NO.GE.3)))
     1 INOPAR = INOPAR + 5
 2222 CONTINUE
      RETURN
  710 PRINT 26, I
      STOP
C ***   THIS STOP IS WHEN NAFA(I) FOR ANY GROUP IS INPUT AS ZERO
C
      ENTRY RDIN5
C     READ SIGMA U'S OR OTHER SUBMITTED WEIGHTS
      TWP = 19.7392088
      NSIG = IABS(ISIG)
      IF(NSIG.GT.NTOT) PRINT 9006, NSIG, NTOT
      DO 50 I = 1,NSIG
      IF(ISIGX.NE.0) READ (5,23)
C ***   WHEN ISGX INPUT AS NON-ZERO, SIGMAS OF X,Y,Z TO BE
C ***     INPUT (AND IGNORED), INTERMIXED WITH SIGMAS OF U  (OR B)
      IF(ILIST.LE.0) GO TO 720
      DO 718 K = 1,6
  718 SIGB(I,K) = 0.
      READ (5,*) (SIGB(I,K), K = 1,6), NTNAME(I)
      GO TO 725
  720 READ (5,6)  (SIGB(I,K),K=1,6),NTNAME(I)
  725 IF(IB.GE.4.OR.ISIG.LT.0) GO TO 50
C        IB = 0 OR 1 MEANS 'SIGU', IF ANY, ARE REALLY SIGB
      DO 48 K = 1,3
      SIGB(I,K) = SIGB(I,K)/(TWP*RCD(K)*RCD(K))
   48 CONTINUE
      SIGB(I,4) = 0.5*SIGB(I,4)/(TWP*RCD(1)*RCD(2))
      SIGB(I,5) = 0.5*SIGB(I,5)/(TWP*RCD(1)*RCD(3))
      SIGB(I,6) = 0.5*SIGB(I,6)/(TWP*RCD(2)*RCD(3))
   50 CONTINUE
      IF (IB.EQ.8.OR.IB.EQ.1.OR.ISIG.LT.0) RETURN
C        IB = 4 MEANS INPUT U'S ARE TOO LARGE BY FACTOR 8*(PI SQUARED)
      IF(IB.EQ.4) GO TO 70
C        IB = 0 MEANS EXPLICIT FACTOR OF 2 IN DEFINITION OF B (AND SIGB)
      DO 60 I = 1,NSIG
      SIGB(I,4) = 2.0*SIGB(I,4)
      SIGB(I,5) = 2.0*SIGB(I,5)
      SIGB(I,6) = 2.0*SIGB(I,6)
   60 CONTINUE
      RETURN
   70 FAC = 1.0/(4.0*TWP)
      DO 80 I = 1,NSIG
      DO 80 J = 1,6
      SIGB(I,J) = SIGB(I,J)*FAC
   80 CONTINUE
      RETURN
C
      ENTRY RDIN6
C      READ COORDINATES OF POINT ON ALL SYMMETRY ELEMENTS WHEN ISYM.NE.0
      DO 728 J = 1,3
  728 SYML(J) = 0
      READ (5,*) (SYML(I), I = 1,3)
  735 RETURN
C
      ENTRY RDIN7
C     CALL FROM MAIN IF NVIB.GT.0 OR ICSVIB.NE.0, TO CALCULATE MEAN
C        SQUARE DISPLACEMENT AMPLITUDES IN SPECIFIED DIRECTIONS
C
      IF(NVIB.LE.0) GO TO 200
      READ(5,*) (VBAT1(I),NVAT1(I),VBAT2(I),NVAT2(I), I = 1,NVIB)
  745 DO 190 K = 1,NVIB
      IF(NVAT1(K).EQ.0) NVAT1(K) = 1
      IF(NVAT2(K).EQ.0) NVAT2(K) = 1
  190 CONTINUE
  200 IF (ICSVIB.EQ.0) RETURN
      DO 210 I = 1,ICSVIB
      READ(5,*)  (DCOS(I,J), J=1,3), NCSVIB(I)
  755 L = NCSVIB(I)
      IF(L.LE.12) GO TO 205
      PRINT 16,I,L
      CALL EXIT
  205 READ(5,*,END = 210) (XNM(K), K = 1,L)
      WRITE (INFM,1) (XNM(K), K = 1,L)
      READ (INFM,1) (CSATNM(I,K), K = 1,L)
  210 CONTINUE
      RETURN
      END
C ***
      SUBROUTINE SGTRAN(A,B,BB,NTOS,MM)
C   ADDED JANUARY 1982 TO TRANSFORM VARIANCE-COVARIANCE TENSOR OF THE
C     U'S, FROM CRYSTAL SYSTEM TO ORTHOGONAL SYSTEM WHEN CALLED FROM
C     INERT.  FIRST, CALCULATES ESD'S FOR SYMMETRY-EQUIVALENT ATOMS
C     WITHIN CRYSTAL SYSTEM WHEN CALLED FROM SYMPOS.  ALL CORRELATION
C     BETWEEN U(I,J) OF THE SAME OR DIFFERENT ATOMS IS IGNORED,
C     EXCEPT THAT ARISING FROM THE OBLIQUITY OF THE AXES OF THE CRYSTAL
C     SYSTEM.  THE PRESENT METHOD ASSUMES INTRINSIC COVARIANCE IS ISO-
C     TROPIC AND SAME FOR EVERY ATOM; TO TAKE INTO ACCOUNT CORRELATION
C     COEFFICIENTS IN THE LEAST SQUARES WOULD NECESSITATE INTRODUCING THE
C     ENTIRE COVARIANCE MATRIX FROM THE LEAST-SQUARES REFINEMENT OF THE
C     INDIVIDUAL ATOMS AND CONSIDERING EACH ATOM INDIVIDUALLY.  BASED ON
C     HIRSHFELD & SHMUELI, ACTA CRYST A28, 649-653 (1972)
C
C     A IS A 3X3 TRANSFORMATION MATRIX, USED AS A PRE-FACTOR (OMA FROM
C         INERT, TUS FROM SYMPOS)
C     B IS SIGB(150,6), THE COLUMN VECTOR FOR EACH ATOM'S INPUT SIG'S
C        INITIALLY;  AFTER SYMPOS (BEFORE NPAR AND INERT ARE CALLED),
C        WHEN NO.GE.1, SIGB ALSO INCLUDES ESD'S FOR SYM-EQUIV ATOMS
C     BB THE TRANSFORMED ESD'S OF U ARE PLACED IN BB AND RETURNED THUS
C       AS SIGU(K,I), WHERE K IS ATOM NUMBER AND I VARIES FROM 1 TO 6
C     NTOS IS CURRENT VALUE OF NTOTS (WHICH CHANGES DURING SYMPOS)
C     MM IS PATH-INDICATOR: 1 WHEN CALLED FROM INERT, EQ POSN NO (2 OR
C         MORE) WHEN CALLED FROM SYMPOS
C
      COMMON//AIDX(3000)
      COMMON/CELLP/CD(12),RCD(12),VOL,VST,G(3,3)
      COMMON /CONT1/ISET,NO,NMULT,NA,ICOUNT,NINPAR,NPARS,NINOBS,NANG,NTO
     1T,NPULT,NA1,IFU,IB,NONRIG,NS,ISIG,ISYM,ICORL,IFU1,N8,
     2 IEIG,IMAT, IOUT,IRECAL, IFREQ
      COMMON/INOUTN/ NPAGE, KOUTP,  DIS, IAW
      COMMON/INOUTC/ NAME1, ATNAME(150),TISET(80),TITLE(80),ITBL(29),
     1 NAME2
      common/new/isigx,ETA, TK,I11, isigu,nafa(7),NONSY(7),AXMOM(7),
     1  NRBP(150),NCPD,NDAT,NESD, IBYP, IEXU, inegl
C
      DIMENSION A(3,3),B(150,6),V(3,3,3,3),TV(3,3,3,3),BB(150,6),
     1   VAR(9),VV(9),VX(9),VY(5),SU(3,3),ESD(9)
C
      CHARACTER*4 NAME1,ATNAME,TISET*1,TITLE*1, ITBL*3, NAME2*5
C
      NSIG=IABS(ISIG)
      X = ETA
      IF(MM.GT.1) GO TO 10
C       WHEN MM = 1, ENTER FROM INERT
      KA = 1
      KB = NSIG
      NTS = 0
C       NTS IS A TALLY USED ONLY WHEN MM.GT.1, BUT IT IS ALTERED IN THE
C       MAIN BRANCH (AFTER 15 BELOW) SO PRESET NOW FOR SAFETY
      LN = 1
      NN = 0
C       LN INDICATES EQUIVALENT POSITION, NN IS TALLY FOR ATOM NAMES
      KEQ = NSIG
      GO TO 15
C      WHEN MM.GT.1, ENTER FROM SYMPOS AT MMth EQUIV POSN
   10 KA = 1
      KB = NA
      LN = MM
      NN = 0
      NTS = NTOS - NA
C      WHEN ENTER FROM SYMPOS, TALLY ATOM NUMBER WITH NTS, WHICH
C      STARTS AT NTOT (INCREASED BY 1 BEFORE STORING NEW VALUES)
C      FOR FIRST SYM-EQUIV POSN AND IS CHANGED AFTER NA ATOMS,
C       AS IN SYMPOS
      KEQ = NA
C      LN AND NN ARE NOT PRESENTLY NEEDED WHEN ENTER FROM SYMPOS SINCE
C       THEY ARE ONLY USED IN PRINTING POSITIONS, AND THAT IS NOT NOW
C       DONE IN THIS BRANCH.
   15 DO 100  KK = KA,KB
      CALL VEMA(B,SU,KK)
      NTS = NTS + 1
      NN = NN + 1
      VAR(4) = 0.0
      DO 20 I = 1,3
      VAR(I) = SU(I,I)*SU(I,I)
      VAR(4) = VAR(4) + VAR(I)
   20 CONTINUE
      ZD = 0.
      VAR(4) = VAR(4)/3.0
      ESD(5) = SU(1,2)/SQRT(0.5*(1-X) +
     1          0.5*(1 + X)*RCD(9)*RCD(9))
      ESD(6) = SU(1,3)/SQRT(0.5*(1 - X) +
     1          0.5*(1 + X)*RCD(8)*RCD(8))
      ESD(7) = SU(2,3)/SQRT(0.5*(1 - X) +
     1          0.5*(1 + X)*RCD(7)*RCD(7))
      DO 22 I = 5,7
      VAR(I) = ESD(I)*ESD(I)
   22 IF(ESD(I).EQ.0.) ZD = ZD + 1.0
      IF(ZD.GT.2.5) GO TO 23
      VAR(8) = (VAR(5) + VAR(6) + VAR(7))/(3.0 - ZD)
      GO TO 24
   23 VAR(9) = VAR(4)
      GO TO 25
   24 VAR(9) = (1.0/(6.0 - ZD))*(3.0*VAR(4) + (3.0 - ZD)*VAR(8))
   25 DO 28 I = 1,9
      ESD(I) = SQRT(VAR(I))
   28 CONTINUE
      IF(MM.GT.1.OR.iexu.eq.1.or.NS.LT.0) GO TO 27
C ***  DON'T PRINT TABLE OF AVE VARIANCE WHEN NS NEGATIVE, OR WHEN
C ***    ENTER FROM SYMPOS
      PRINT 900, LN,ATNAME(NN),(ESD(I),I=1,9)
  900 FORMAT(1X,I3,4X,A4,7X,2(3(F7.5,4X),4X,F7.5,8X),F7.5)
C      NOW USE OVERALL AVERAGE VARIANCE, AS CALCULATED ABOVE BY THE
C      RECIPE OF HIRSHFELD & SHMUELI, ACTA CRYST A28, 649 (1972), IN
C      CALCULATION OF ASSUMED ISOTROPIC COVARIANCES (SAME SOURCE).
C        THIS IS DONE SEPARATELY FOR EACH ATOM
   27 CON = VAR(9)
      V(1,1,1,1) = VAR(1)
      V(2,2,2,2) = VAR(2)
      V(3,3,3,3) = VAR(3)
      V(1,2,1,2) = SU(1,2)*SU(1,2)
      V(1,3,1,3) = SU(1,3)*SU(1,3)
      V(2,3,2,3) = SU(2,3)*SU(2,3)
   30 VV(3) = V(1,2,1,2)
      VV(4) = V(1,3,1,3)
      VV(5) = V(2,3,2,3)
C *** NOW USE STANDARD ETA (NOT INPUT ETA, IF DIFFERENT)(21.IV.87)
      X = -0.25
      DO 35 L = 3,5
      LL = 12 - L
      VX(L) = CON*((1-X)*RCD(LL)*RCD(LL) + X)
      VY(L) = CON*RCD(LL)
   35 CONTINUE
      DO 40 I = 1,2
      II = I + 1
      DO 40 J = II,3
      JJ = I + J
      V(J,I,J,I) = VV(JJ)
      V(J,I,I,J) = VV(JJ)
      V(I,J,J,I) = VV(JJ)
      V(I,I,J,J) = VX(JJ)
      V(J,J,I,I) = VX(JJ)
      V(J,I,I,I) = VY(JJ)
      V(I,J,I,I) = VY(JJ)
      V(I,I,J,I) = VY(JJ)
      V(I,I,I,J) = VY(JJ)
      V(I,J,J,J) = VY(JJ)
      V(J,I,J,J) = VY(JJ)
      V(J,J,I,J) = VY(JJ)
      V(J,J,J,I) = VY(JJ)
   40 CONTINUE
      DO 45 L = 7,9
      M = L + 1
      IF(M.EQ.10) M = 7
      N = M + 1
      IF(N.EQ.10) N = 7
      VV(L)=CON*(0.5*(1-X)*RCD(L) + 0.5*(1+X)*RCD(M)*RCD(N))
      VX(L) = CON*(X*RCD(L) + (1-X)*RCD(M)*RCD(N))
   45 CONTINUE
      DO 50 I = 1,3
      J = I + 1
      IF(J.EQ.4) J = 1
      K = J + 1
      IF(K.EQ.4) K = 1
      L = 2*I + J + K
      V(I,I,J,K) = VX(L)
      V(I,I,K,J) = VX(L)
      V(J,K,I,I) = VX(L)
      V(K,J,I,I) = VX(L)
      V(I,J,I,K) = VV(L)
      V(I,J,K,I) = VV(L)
      V(J,I,I,K) = VV(L)
      V(J,I,K,I) = VV(L)
      V(I,K,I,J) = VV(L)
      V(I,K,J,I) = VV(L)
      V(K,I,I,J) = VV(L)
      V(K,I,J,I) = VV(L)
   50 CONTINUE
C       NOW TRANSFORM THE FOURTH-RANK TENSOR, USING A(3,3) AS A PREFACTOR,
C        THAT IS, SUM REPEATEDLY WITH THE SECOND INDEX OF A.  A IS THE MATRIX
C        BROUGHT IN BY THE CALL, AND IS  OMA  FROM INERT OR  TUS  FROM SYMPOS.
      DO 60 I = 1,3
      DO 60 J = 1,3
      DO 60 K = 1,3
      DO 60 L = 1,3
      TV(I,J,K,L) = 0.0
      DO 60 LI = 1,3
      DO 60 LJ = 1,3
      DO 60 LK = 1,3
      DO 60 LL = 1,3
      TV(I,J,K,L) = TV(I,J,K,L) +
     1 A(I,LI)*A(J,LJ)*A(K,LK)*A(L,LL)*V(LI,LJ,LK,LL)
   60 CONTINUE
C  PATCH TO ADJUST SIGMAS WHEN ANY TRANSFORMED DIAGONAL
C    COMPONENT IS NEGATIVE AND PRINT MESSAGE
      NTV = 0
      IF(TV(1,1,1,1).LT.0) PRINT 71
      IF(TV(1,1,1,1).LT.0) NTV = NTV + 1
      IF(TV(2,2,2,2).LT.0) PRINT 72
      IF(TV(2,2,2,2).LT.0) NTV = NTV + 1
      IF(TV(3,3,3,3).LT.0) PRINT 73
      IF(TV(3,3,3,3).LT.0) NTV = NTV + 1
      IF(TV(1,2,1,2).LT.0) PRINT 74
      IF(TV(1,2,1,2).LT.0) NTV = NTV + 1
      IF(TV(1,3,1,3).LT.0) PRINT 75
      IF(TV(1,3,1,3).LT.0) NTV = NTV + 1
      IF(TV(2,3,2,3).LT.0) PRINT 76
      IF(TV(2,3,2,3).LT.0) GO TO 70
      IF(NTV.EQ.0) GO TO 90
   71 FORMAT(' ','VAR. OF U11 NEGATIVE AFTER TRANSF. TO CARTESIAN AXES')
   72 FORMAT(' ','VAR. OF U22 NEGATIVE AFTER TRANSF. TO CARTESIAN AXES')
   73 FORMAT(' ','VAR. OF U33 NEGATIVE AFTER TRANSF. TO CARTESIAN AXES')
   74 FORMAT(' ','VAR. OF U12 NEGATIVE AFTER TRANSF. TO CARTESIAN AXES')
   75 FORMAT(' ','VAR. OF U13 NEGATIVE AFTER TRANSF. TO CARTESIAN AXES')
   76 FORMAT(' ','VAR. OF U23 NEGATIVE AFTER TRANSF. TO CARTESIAN AXES')
C  FOLLOWING BRANCH USED WHEN ANY DIAG TV ELEMENT IS NEG
   70 CON2 = ESD(4)*ESD(4)
      CON = CON2
      CON3 = 0.625*CON2
      CON4 = 0.7906*ESD(4)
      V(1,1,1,1) = CON2
      V(2,2,2,2) = CON2
      V(3,3,3,3) = CON2
      V(1,2,1,2) = CON3
      V(1,3,1,3) = CON3
      V(2,3,2,3) = CON3
      IF(KA.GT.NTOT) GO TO 30
C   PRINT MESSAGE ONLY FOR UNIQUE ATOMS;EARLIER ONLY IF AXES OBLIQUE TOO
      PRINT 910,ATNAME(NN),LN,ESD(4),CON4
  910 FORMAT(' ','VALUE OF ETA AND INPUT SIGMA(U) FOR ATOM ',A4,',POSN '
     1,I2,', LED TO NEGATIVE VARIANCE AFTER TRANSFORMATION TO CARTESIAN
     2 AXES.', /1X,'SIGMAS HAVE BEEN  SMOOTHED , ASSUMING SIGMA(U(II) ='
     3,F8.5, ' AND SIGMA U(IJ) =',F8.5 / 3X,
     4'  SEE DISCUSSION OF ETA AT START OF INSTRUCTIONS.'/)
  920 format(/)
      GO TO 30
   90 L = KK
      IF(MM.GT.1) L = NTS
      BB(L,1) = SQRT(TV(1,1,1,1))
      BB(L,2) = SQRT(TV(2,2,2,2))
      BB(L,3) = SQRT(TV(3,3,3,3))
      BB(L,4) = SQRT(TV(1,2,1,2))
      BB(L,5) = SQRT(TV(1,3,1,3))
      BB(L,6) = SQRT(TV(2,3,2,3))
  100 CONTINUE
      print 920
      IF(NO.EQ.1.OR.KB.EQ.NTOS.OR.MM.GT.1) RETURN
      KA = NTOT + 1
      KB = NTOS
      KEQ = NA
C       NTOS SET EQUAL TO CURRENT NTOTS BY CALL OF THIS SUBROUTINE
C       (WHEN CALLED FROM INERT, CURRENT NTOTS IS FINAL NTOTS)
      LN = LN + 1
      NN = 0
      GO TO 15
      END
C
      SUBROUTINE SOLVE
C *** Modified Feb 17, 1997 for THMA14c, calcs in CCS for ARG params
C ***  modified April 1993 for tetragonal pt gps oriented along x or y
C   MODIFIED SEPT 1985 TO INCLUDE PATCH FOR CALC & PRINT EIGENVALUES
C    AND EIGENVECTORS OF NORMAL EQUATION MATRIX
C
C     SET UP AND SOLVE MATRIX OF NORMAL EQUATIONS
C     SEQUENCE OF THE PARAMETERS OF THE SYSTEM OF LINEAR EQUATIONS
C     L11,L12,L13,L21,...,L33,T11,T12,...,T33,(S11,S12,...,S33), AND
C     THEN PARAMS FOR ARG MOTION:  FIRST, PHI-PHI FOR EACH GROUP
C     AND NEXT, FOR EACH GROUP IN ORDER, PHI-LAMBDA IN TWO DIRECTIONS
C     PERPENDICULAR TO THE LIBRATION AXIS AND PHI-TRANSL PARALLEL AND
C     IN THE TWO PERPENDICULAR DIRNS.
C   ONE DUMMY PARAMETER BECAUSE OF CONSTRAINT TRACE(S) = 0. FOR
C     SYMMETRY HIGHER THAN CI, APPROPRIATE ELEMENTS OF L,T,S SET = 0
C     AND MATRIX CONTRACTED. WHEN, BY SYMMETRY, PARAMETER J = PA-
C     RAMETER I (OR ITS NEGATIVE), MATRIX IS CONTRACTED BY COL I = COL I
C     + (OR -) COL J,ROW I= ROW I+(OR -) ROW J, VECTOR(I) = VECTOR(I) +
C     (OR -) VECTOR(J), AND THEN DELETION OF ROW J, COL J (EXCEPT FOR
C     THE DIAGONAL ELEMENT AND VECTOR ELEMENT J).
C
      COMMON/AIDPAR/AX(150,3),AUOBS(150,6),AUCALC(150,6),WU(150,6),
     1  WU1(150,6)
      COMMON//AIDX(3000)
      COMMON/AMAT/AN(80,80)
      COMMON/ATPAR/X(150,3),WT(150),MULT(150),UOBS(150,6),SIGU(150,6),
     1     UCALC(150,6),NUORB(150),SIGB(150,6)
      COMMON/AXESN/ISPAX(15),LT(5,15),LAT(5,15)
      COMMON/AXESC/LBAT(5,15)
      CHARACTER*4 LBAT
      COMMON /CONT1/ISET,NO,NMULT,NA,ICOUNT,NINPAR,NPARS,NINOBS,NANG,NTO
     1T,NPULT,NA1,IFU,IB,NONRIG,NS,ISIG,ISYM,ICORL,IFU1,N8,
     2 IEIG,IMAT, IOUT,IRECAL, IFREQ
      COMMON/CONT2/NP1,NNP1,IORIG,IWU,INOPAR
      COMMON/CONT3/ISOLV,NTOTS,CONSLV,SUMW,RWUDI,RMS,RMU,gof,sumsig,
     1  iscm,msd8
      COMMON/IAID1/ IAIDX1(1000)
      COMMON/IPAR/ NP(80)
      COMMON/LOC/ VAF(7,3), PVEC(7,3), V5(7,3), A(7,3)
C ***   vec1(7,3) (dir cos of ARG axis) here called A(7,3)
      common/new/isigx,ETA, TK,I11, isigu,nafa(7),NONSY(7),AXMOM(7),
     1  NRBP(150),NCPD,NDAT,NESD, IBYP, IEXU, inegl
C     COMMON/NOREIG/ IMAT, QV(80,80),VE(80,80)
C ***  /NOREIG/ USED HERE AND IN "OUTR" FOR EIGENVAL/VEC OF NORM EQN MAT
      DIMENSION KAN(80), WTT(150), IZ(5)
      DIMENSION AO(80),P(80),IPAIR(7,7)
      EQUIVALENCE (KAN(1),AIDX(961)), (WTT(1),AIDX(451))
      EQUIVALENCE (INDAN,IAIDX1(501)),(IPAIR(1,1),AIDX(1701))
      EQUIVALENCE (P(1),AIDX(801)) 
      EQUIVALENCE (AO(1),AIDX(1041))
      EQUIVALENCE (IPAREX,IAIDX1(500))
      DOUBLE PRECISION  AN
      real mult
C  **** NEED FOLLOWING WHEN ACTIVATE CALC EIGENVAL/VEC OF NORM EQN MATR
C     DOUBLE PRECISION  QV,VE
C
    1 FORMAT(' ',5X,72H AT LEAST ONE DIAGONAL ELEMENT OF L IS NEGATIVE.
     1MODEL OR DATA SUSPECT.  )
    2 FORMAT(' ',5X,72H AT LEAST ONE DIAGONAL ELEMENT OF T IS NEGATIVE.
     1MODEL OR DATA SUSPECT.  )
    3 FORMAT(' ',5X, 'MEAN SQUARE AMPLITUDE OF LIBRATION OF AT LEAST
     1 ONE PRESUMED ARG IS NEGATIVE.'/5x,'MODEL OR DATA SUSPECT.')
C
C    DECREASE WEIGHTS TO AVOID OVERFLOW PROBLEMS (MAX PERMISSIBLE
C     NUMBER ON VAX IS 10**38; THAT ON 3033 IS 10**78)
C ***  CONSLV DEFAULT IS 0.01 UNLESS SOME OTHER VALUE INPUT
      DO 5 I = 1,NTOTS
      DO 5 J = 1,6
      WU(I,J) = WU(I,J)*CONSLV
    5 CONTINUE
C *** CLEAR THE ELEMENTS OF THE MATRIX (AN) AND THE VECTOR (P)
      DO 10 I = 1,80
      P(I) = 0.
      DO 10 K = 1,80
      AN(I,K) = 0.
   10 CONTINUE
      NMA = NP1
C ***  NMA WILL BE THE ACTUAL DIMENSION OF THE MATRIX
      NNP1 = NP1
      IF(NONRIG.EQ.0) GO TO 15
C ***  WHEN NO NONRIGID GROUPS, CAN SKIP ALL EXPANSION OF MATRIX THAT
C ***    INVOLVES THEM
      NNP1 = NNP1 + NONRIG
      IF(ICORL.GE.0) NNP1 = NNP1 + 6*NONRIG
C ***  (WHEN ICORL.GE.0, CALCULATING CORRELNS INTERNAL & OVERALL MOTION)
C ***   BUT NO CORRELATIONS POSSIBLE FOR GROUPS WITH ONLY ONE ATOM,
C ***   and they're questionable for two-atom ARGs
      DO 2010 I =1,NONRIG
      IF(NAFA(I).LT.3.AND.ICORL.GE.0.AND.NONSY(I).NE.0) NNP1 = NNP1-6
 2010 CONTINUE
      IF(NNP1.GT.78) GO TO 999
C ***  INTERGROUP CORRELN INDETERMINATE WITH OVERALL/INTERNAL CORRELN
      IF(ICORL.GE.0) GO TO 18
C ***  FOLLOWING PATCH (THRU 19) CLEARS IPAIR(I,J) AND THEN SETS IT UP
C ***    AS INDEX OF GROUPS THAT CONTAIN COMMON ATOMS.  IPAIR IS
C ***    SET EQUAL TO THE PARAMETER NUMBER FOR CORRELN OF PHI VALUES
C ***    FOR THESE GROUPS I AND J.
    9 DO 11 I = 1,7
      DO 11 J = 1,7
   11 IPAIR(I,J) = 0
      DO 19 I = 1,NA
      J1 = 0
      NN = NRBP(I)
      DO 12 J = 1,5
      IH = NN/16
      IZ(J) = NN - 16*IH
      IF(IZ(J).EQ.0) GO TO 13
      NN = IH
      J1 = J1 + 1
   12 CONTINUE
   13 IF(J1.LE.1) GO TO 19
C *** WHEN J1 IS 2 OR 3, ATOM I IS IN 2 OR 3 DIFFERENT N-R GROUPS
      KK = IZ(1)
      LL = IZ(2)
      IF(IPAIR(KK,LL).NE.0) GO TO 14
      NNP1 = NNP1 + 1
      IPAIR(KK,LL) = NNP1
      IPAIR(LL,KK) = IPAIR(KK,LL)
   14 IF(J1.EQ.2) GO TO 19
      MM = IZ(3)
      IF(IPAIR(KK,MM).NE.0) GO TO 16
      NNP1 = NNP1 + 1
      IPAIR(KK,MM) = NNP1
      IPAIR(MM,KK) = IPAIR(KK,MM)
   16 IF(IPAIR(LL,MM).NE.0) GO TO 19
      NNP1 = NNP1 + 1
      IPAIR(LL,MM) = NNP1
      IPAIR(MM,LL) = IPAIR(LL,MM)
   19 CONTINUE
   18 CONTINUE
      NMA = NNP1
   15 KB = 1
      KE = NA
      ISY = 0
C       ISY = 0 DURING CALCULATIONS FOR UNIQUE POSITIONS. SET TO -1
C FOR CALCULATIONS FOR ALL SYMMETRY-RELATED POSITIONS.
      I1 = NTOT
      J1 = 0
      IF(NONRIG.EQ.0) GO TO 45
C      IF ARGs PRESENT, CALC LIBR AXES FOR THEM FOR INPUT POSITIONS
C        -- THEN, CALL "LOCAL" AND CALC AXES FOR LOCAL REF SYSTEMS
      CALL DERNOP
      ILOC = 1
      CALL LOCAL(ILOC)
   45 DO 22 K = KB,KE
      J1 = J1 + 1
      IF(WTT(K).EQ.800.0) GO TO 22
C  ATOMS WITH WEIGHT 800.0 TO BE IGNORED IN ANALYSIS OF MOTION,
C    EXCEPT INSOFAR AS THEY DEFINE ARG AXES AND
C    ARE REPRODUCED BY SYMMETRY OPERATIONS FOR THAT PURPOSE
      CALL DERIVP(K)
      IF(NRBP(K).EQ.0)  GO TO 21
      CALL DERNP(K)
   21 DO 20 K1 = 1,6
C *** UNTIL 21.IV.87, NEXT LINE SAID "GO TO 22" -- SINCE NO ZERO
C ***  WTS FORMERLY PERMITTED, NO PROBLEMS CAUSED, BUT IT IS NOT
C ***  LOGICAL, AND NOW PERMIT ZERO WTS FOR U(I,J) IDENTICALLY 0
C      IF(WU(K,K1).EQ.0.)  GO TO 20
      CALL INTSET(K1,I,L)
      CALL DERIV(I,L)
      IF(NONRIG.EQ.0)  GO TO 25
      IF(NRBP(K).EQ.0)  GO TO 70
      CALL DERNON(K,I,L)
      GO TO 25
   70 NHP1 = NP1 + 1
      DO 75 I = NHP1,NNP1
      AO(I) = 0.
   75 CONTINUE
C     SET UP MATRIX AND VECTOR FOR NNP1 UNRESTRICTED PARAMETERS
   25 DO 30 I = 1,NNP1
C   AO(I) COME FROM SUBROUTINES DERIV AND DERNON
      IF(WU(K,K1).EQ.0.) WU(K,K1) = CONSLV
      AO(I) = AO(I)*WU(K,K1)
      P(I) = P(I) + AO(I)*AUOBS(K,K1)*WU(K,K1)
      DO 30 J = 1,I
      AN(I,J) = AN(I,J) + AO(I)*AO(J)
      AN(J,I) = AN(I,J)
   30 CONTINUE
   20 CONTINUE
      IF(NONRIG.EQ.0) GO TO 22
      IF(NO.EQ.1) GO TO 22
      IF (J1.LT.NA) GO TO 22
C      FOLLOWING IS TO GIVE CORRECT LIBRATION AXES FOR ARGs
C        IN SYM-RELATED POSITIONS.  FIRST TIME I1 = NTOT. LATER I1 = NA.
C        HOWEVER, DERNOP NOT CALLED AGAIN AFTER FINISH LAST POSITION.
      IF(ISY.EQ.(-1).AND.K.EQ.NTOTS) GO TO 22
      J1 = 0
      ILOC = ILOC + 1
C ***  ILOC IS A TALLY FOR EQUIV POSNS, USED ONLY IN LABELLING OUTPUT
      DO 320 I = 1,NONRIG
C ***  WHEN ISPAX NOT ZERO, FIVE ATOMS USED TO DEFINE NONRIGID AXES.
C ***    OTHERWISE ONLY TWO ARE USED
      J2 = 2
      IF(ISPAX(I).NE.0) J2 = 5
      DO 320 J = 1,J2
      LAT(J,I) = LAT(J,I) + I1
  320 CONTINUE
      CALL DERNOP
      CALL LOCAL(ILOC)
   22 CONTINUE
      IF(IMAT.LT.100) GO TO 35
      CALL OUTH6
      DO 32 I=1,NNP1
 1031 format(3x,'Matrix elements and I,P(I) for row ',i2,':')
      print 1031, I
      PRINT 31,(j, AN(I,J),J=1,NNP1),I,P(I)
   31 FORMAT(1H ,8(1x,I2,2X,E10.4))
      PRINT 33
   33 FORMAT(/)
   32 CONTINUE
   35 CONTINUE
      IF(NO.LE.2) GO TO 55
C      MOLECULES WITH SYMMETRY C1 HAVE ONLY NA ATOMS FOR ANALYSIS.
C        THOSE WITH SYMMETRY CI (NO 2) HAVE ALL CONTRIBUTIONS TO NORMAL
C        EQUATIONS IDENTICAL FOR SYM-RELATED ATOMS WHEN REFERRED TO THE
C        CENTER OF SYMMETRY (CENTER OF MASS) AS ORIGIN.
      IF(ISY.NE.0) GO TO 55
C      SET SUMMATION LIMITS FOR CALCULATING CONTRIBUTIONS TO NORMAL
C       EQUATIONS FOR ALL ATOMS IN THE MOLECULE (GENERATED BY SYMPOS)
      KB = NTOT + 1
      KE = NTOTS
      I1 = NA
      ISY = -1
      GO TO 45
   55 IF(NPARS.EQ.0)  GO TO 110
      NSUM = 0
      DO 80 I = 13,21,4
      NSUM = NSUM + NP(I)
   80 CONTINUE
      IF(NSUM.EQ.0)  GO TO 100
C     IMPOSE RESTRICTION THAT TRACE OF S EQUALS 0 IF NOT ALREADY SO.
      NMA = NMA + 1
      IF(NMA.GT.80)  GO TO 999
      DO 90 I = 13,21,4
      AN(I,NMA) = 1.
      AN(NMA,I) = 1.
   90 CONTINUE
  100 IF(NP(14).NE.NP(16))  GO TO 110
      IF(NP(15).NE.NP(19))  GO TO 110
      IF(NP(18).NE.NP(20))  GO TO 110
      IORIG = 0
  110 IF(IMAT.GE.250) GO TO 42
C     SET CONSTRAINTS FOR PARAMETERS REQUIRED BY POINT GROUP SYMMETRY
C     AND ARG REQUIREMENTS
      DO 120 I = 1,NNP1
C ***  NP(I) SET UP IN "SYMET" OR "NPAR" FOR PARAM 1-21 (OR 1-12),
C ***       IN MAIN FOR THOSE INVOLVING ATTACHED RIGID GROUPS
      IF(NP(I).EQ.I)  GO TO 120
      IF(NP(I).EQ.0) GO TO 160
      IF(NPARS.EQ.0) GO TO 170
C ***   NEXT LINE CHANGED 16.IV.93
      IF((I.NE.17.and.I.NE.21).OR.ISET.GT.3) GO TO 170
C     S22 (I=17) MAY EQUAL S11 (I = 13) OR -S11 IN CERTAIN POINT GROUPS.
C       THIS IS HANDLED BY EXPANSION OF MATRIX TO BE CONSISTENT WITH THE
C       CONDITION TRACE OF S = 0 (ABOVE). IF S33 = S22 = S11, EACH = 0.
C ***  Changes April 1993 to allow for tetragonal pt gps in cubic xtals
      NMA = NMA + 1
      if(iset.ne.1) go to 125
      IF(NP(17).GT.0) GO TO 115
      AN(17,NMA) = 1.
      AN(NMA,17) = 1.
      GO TO 117
  115 AN(17,NMA) = -1.
      AN(NMA,17) = -1.
  117 AN(13,NMA) = 1.
      AN(NMA,13) = 1.
      GO TO 120
  125 if(iset.eq.3) go to 130
      if(np(21).gt.0) go to 127
      an(21,nma) = 1.
      an(nma,21) = 1.
      go to 129 
  127 an(21,nma) = -1.
      an(nma,21) = -1.
  129 an(17,nma) = 1.
      an(nma,17) = 1.
      go to 120
  130 if(np(21).gt.0) go to 132
      an(21,nma) = 1.
      an(nma,21) = 1.
      go to 117 
  132 an(21,nma) = -1.
      an(nma,21) = -1.
      go to 117 
  170 CONTINUE
C     IMPOSE OTHER CONSTRAINTS BY CONTRACTING AND FOLDING MATRIX
      IF(NP(I)) 140,160,190
  140 INP = IABS(NP(I))
C     PARAM I = NEGATIVE OF PARAM INP
      DO 145 K=1,NNP1
      AN(K,INP) = AN(K,INP)-AN(K,I)
  145 CONTINUE
      DO 147 K=1,NNP1
      AN(INP,K) =AN(INP,K) - AN(I,K)
  147 CONTINUE
      P(INP) = P(INP) - P(I)
      DO 148 K=1,NNP1
      AN(K,I) = 0
      AN(I,K) = 0
  148 CONTINUE
      AN(I,I) = 1.
      P(I) = 0
      GO TO 120
C     PARAM I = PARAM IJ
  190 IJ=NP(I)
      DO 195 K=1,NNP1
      AN(K,IJ) = AN(K,IJ)+AN(K,I)
  195 CONTINUE
      DO 197 K=1,NNP1
      AN(IJ,K) = AN(IJ,K) + AN(I,K)
  197 CONTINUE
      P(IJ) = P(IJ) + P(I)
      DO 198 K=1,NNP1
      AN(K,I) = 0
      AN(I,K) = 0
  198 CONTINUE
      AN(I,I) = 1.
      P(I) = 0
      GO TO 120
C     IF (NP(I).EQ.0)  DELETE ITH PARAMETER
  160 DO 165 J = 1,NNP1
      AN(I,J) = 0.
      AN(J,I) = 0.
  165 CONTINUE
      P(I) = 0.
      AN(I,I) = 1.
  120 CONTINUE
   43 CONTINUE
      if(nonrig.eq.0.or.icorl.lt.0) go to 1043
C *** Impose constraint  SUM [J = 1,3] a(I,J)*<ova-lambda(I)> = 0 for
C ***    each ARG, with a(I,J) the dir cos of Ith ARG axis in the CCS
      do 4100 I = 1,nonrig
      KK = 7*(I-1) + 1 + NP1
C ***  Since NP1 = 21 in general (12 when S vanishes), KK = 22 or 13
C ***    for first ARG, 29 or 20 for second, 36 or 27 for third, ...
      nma = nma + 1
      do 4090 J = 1,3
      JJ = J + KK 
C ***  Thus JJ will be, successively (in general case) 23,24,25; then
C ***     30,31,32;  37,38,39;  44,.......
      AN(JJ,NMA) = a(i,J)
      AN(NMA,JJ) = a(I,J)
 4090 continue
C ***   AN(I,I) to I = 80 already set to zero when AN cleared initially
 4100 continue
 1043 IF(IMAT.LT.200.OR.NO.LE.2) GO TO 42
C ***  WHEN NO.LE.2), THERE ARE NO SYMMETRY OPERATIONS AFFECTING U'S
      CALL OUTH6
      DO 40 I=1,NNP1
      print 1031, I
      PRINT 31,(j, AN(I,J),J=1,NNP1),I,P(I)
      PRINT 33
   40 CONTINUE
   42 CONTINUE
C *** PATCH FOR OUTPUT OF MATRIX WHEN IEIG.GT.0, UNFORMATTED ON UNIT 1
C ***    AND FORMATTED ON UNIT 2 (FOR CHECKING) (LATTER NOT OPERATIVE)
C ***  FURTHER, IF IEIG .GT.1, PROVISION FOR LATER-TO-BE-ADDED CALC
C ***    OF EIGENVALUES, EIGENVECTORS OF NORM EQN MATRIX IN THIS PROGR
      IF(IEIG.LE.0) GO TO 3200
C ***  SUBSTITUTE NEXT LINE FOR PREV IF INCLUDE CALC, PRINT OF EIGENVALS
C ***     AND EIGENVECTORS IN THIS PROGRAM (SEE BETWEEN C3000 AND 3200)
C     IF(IEIG.LE.0) GO TO 3000
C     DO 3100 I = 1,NNP1
C     WRITE(2,3500) I, (AN(I,J), J = 1,NNP1)
C3500 FORMAT(2X,I2,10(2X,F10.6),/3(5X,10(2X,F10.6),/))
C3100 CONTINUE
      WRITE (1) ((AN(I,J),J=1,NNP1), I = 1,NNP1)
      WRITE(*,3510) NNP1, NNP1
 3510 FORMAT(' ','MATRIX OF NORMAL EQUATIONS WRITTEN ON UNIT 1, UNFORMAT
     1TED, ((A(I,J), J = 1,',I3,'), I = 1,',I3,')')
C3000 IF(IEIG.LE.1) GO TO 3200
C *** PATCH FOR CALC, PRINT EIGENVALUES, VECTORS OF NORM EQN MATRIX
C     DO 2000 III = 1,NNP1
C     DO 2000 JJJ = 1,NNP1
C     QV(III,JJJ) = AN(III,JJJ)
C2000 CONTINUE
C     CALL EIGEND(QV,VE,NMA)
C     CALL OUTR14
C ***  END OF PATCH
 3200 CALL MATNVV(AN,NMA,80,1,P,DET)
      IF(IMAT.GE.100) PRINT 1045, (I,P(I), I = 1,NNP1)
 1045 FORMAT(10X,I5,5X,F15.8)
C ***  OPTIONAL PRINT PATCH FOR INVERTED MATRIX
      IF(IMAT.NE.175.AND.IMAT.NE.225) GO TO 1060
      CALL OUTH6
      DO 1050 I = 1,NNP1
      print 1031, I
      PRINT 31,(j, AN(I,J),J=1,NNP1),I,P(I)
      PRINT 33
 1050 CONTINUE
 1060 INDAN = 0
      DO 200 I = 1,NNP1
      KAN(I) = 0
      IF(AN(I,I).GE.0.)  GO TO 200
      KAN(I) = I
      INDAN = 1
  200 CONTINUE
      IF(INDAN.EQ.0)  GO TO 210
      CALL OUTR12
      GO TO 220
  210 CALL OUTH6
  220 IF(IMAT.GE.250) GO TO 1010
      DO 1000 I = 2,NNP1
C     THIS SECTION RESETS THE VALUES OF PARAMETERS DELETED BECAUSE
C          THEY ARE RELATED BY SYMMETRY TO OTHERS.   THOSE DELETED
C          BECAUSE THEY ARE IDENTICALLY ZERO ARE NOT RESET, BUT THEIR
C          ESD'S AND CORRELATION COEFFICIENTS ARE SET TO ZERO.
C       NP(1) ALWAYS IS 1.
      IF(NP(I).EQ.I) GO TO 1000
      IF (NP(I).EQ.0) GO TO 500
      IF(NPARS.EQ.0) GO TO 230
C     NEED NOT RESET S11, S22, S33 BECAUSE THEY WERE LINKED BY EXPANSION
C       OF MATRIX IF SYMMETRY-RELATED AND NON-ZERO.
      IF(I.EQ.13.OR.I.EQ.17.OR.I.EQ.21) GO TO 1000
  230 L = I - 1
      DO 900 J = 1,L
      IF(NP(I).EQ.J) GO TO 800
  900 CONTINUE
      K = -NP(I)
      DO 700 J = 1,L
      IF(K.EQ.J) GO TO 600
  700 CONTINUE
      GO TO 1000
  600 P(I) = -P(J)
      DO 610 K = 1,NNP1
      AN(I,K) = -AN(J,K)
      AN(K,I) = -AN(K,J)
  610 CONTINUE
      AN(I,I) = AN(J,J)
      GO TO 1000
  800 P(I) = P(J)
      DO 810 K = 1,NNP1
      AN(I,K) = AN(J,K)
      AN(K,I) = AN(K,J)
  810 CONTINUE
      AN(I,I) = AN(J,J)
      GO TO 1000
C        SET ESD'S AND RHO'S TO ZERO FOR PARAMETERS THAT ARE IDENTICALLY
C          ZERO BECAUSE OF SYMMETRY AND PERHAPS CONDITION TRACE(S) = 0.
  500 DO 510 K = 1,NNP1
      AN(K,I) = 0.0
      AN(I,K) = 0.0
  510 CONTINUE
 1000 CONTINUE
 1010 CONTINUE
C      PRINT MESSAGE IF ANY L(I,I), T(I,I), OR ARG PARAMETER
C        IS NEGATIVE.
      IF(P(1).LT.0) GO TO 400
      IF(P(4).LT.0) GO TO 400
      IF(P(6).LT.0) GO TO 400
      GO TO 410
  400 PRINT 1
  410 IF(P(7).LT.0) GO TO 420
      IF(P(10).LT.0) GO TO 420
      IF(P(12).LT.0) GO TO 420
      GO TO 430
  420 PRINT 2
  430 IF (NONRIG.EQ.0) GO TO 460
      NHP1 = NP1 + 1
      NHPA1 = NP1 + NONRIG
      DO 440 I = NHP1,NHPA1
      IF(P(I).GE.0) GO TO 440
      PRINT 3
      GO TO 460
  440 CONTINUE
  460 CONTINUE
      ISOLV = 1
      RETURN
  999 IPAREX = -1
C     NUMBER OF PARAMETERS EXCEEDS DIMENSION OF MATRIX
      RETURN
      END
C
      SUBROUTINE SORT
C     SORT ATOMS INTO APPROPRIATE GROUPS, ANALYSIS + INERTIA, ANALYSIS,
C     INERTIA + INTERPRETATION  AND INTERPRETATION ONLY
C ***   MODIFIED 14.IV.87 TO CHECK IF ANY TWO ATOM NAMES ARE SAME
      COMMON/AIDPAR/AX(150,3),AUOBS(150,6),AUCALC(150,6),WU(150,6),
     1  WU1(150,6)
      COMMON/ATPAR/X(150,3),WT(150),MULT(150),UOBS(150,6),SIGU(150,6),UC
     1ALC(150,6),NUORB(150),SIGB(150,6)
      COMMON/AIDCH/NTNAME(150)
      COMMON//AIDX(3000)
      COMMON /CONT1/ISET,NO,NMULT,NA,ICOUNT,NINPAR,NPARS,NINOBS,NANG,NTO
     1T,NPULT,NA1,IFU,IB,NONRIG,NS,ISIG,ISYM,ICORL,IFU1,N8,
     2 IEIG,IMAT, IOUT,IRECAL, IFREQ
      COMMON/CORDIN/IRIDE,IMIN,IUNC, IHAT(150), NUNC(20), TUNC(20,3),
     1 TOR(3,3), XCG(3),IHPR
      COMMON/IAID1/IAIDX1(1000)
      COMMON/INOUTN/ NPAGE, KOUTP,  DIS, IAW
      COMMON/INOUTC/ NAME1, ATNAME(150),TISET(80),TITLE(80),ITBL(29),
     1 NAME2
      DIMENSION AMULT(150),AWT(150),INU(150),IK8(150)
      DIMENSION IK(150), IK1(150), IK2(150), IKH(150), IHT(150)
      EQUIVALENCE (IK8(1),AIDX(351))
C  USING BLANK COMMON AIDX HERE FOR INTEGER VARIABLE BECAUSE IAID1 FULL
C
      CHARACTER*4 NTNAME
      CHARACTER*4 NAME1,ATNAME,TISET*1,TITLE*1, ITBL*3, NAME2*5
      REAL   MULT
      EQUIVALENCE (IK(1),IAIDX1(801)),(IK1(1),IAIDX1(201))
      EQUIVALENCE (IK2(1),IAIDX1(351)),(IKH(1),IAIDX1(501))
      EQUIVALENCE (INU(1),IAIDX1(651))
      EQUIVALENCE (AMULT(1),AIDX(1)),(AWT(1),AIDX(201))
C
  901 FORMAT(' ','INPUT ATOMS ',I3,' AND ',I3,' HAVE SAME NAME, ',A4)
  902 FORMAT(' ','AT LEAST THREE PAIRS OF ATOMS WITH SAME NAMES. NO MORE
     1 WILL BE CHECKED.')
  903 FORMAT(' ','  MAKE ATOM NAMES UNIQUELY DIFFERENT, SINCE NAMES ARE
     1USED FOR SORTING, FOR IDENTIFYING ESD''S AND ARG AXES, AND FOR'/
     23X,'OTHER SIMILAR PURPOSES.')
      NSA = 0
      II = NTOT - 1
      DO 5 I = 1,II
      JJ = I + 1
      DO 5 J = JJ,NTOT
      IF(ATNAME(I).NE.ATNAME(J)) GO TO 5
      NSA = NSA + 1
      WRITE(6,901) I, J, ATNAME(I)
      IF(NSA.LT.3) GO TO 5
      PRINT 902
      PRINT 903
      STOP
    5 CONTINUE
      IF(NSA.EQ.0) GO TO 7
      PRINT 903
      STOP
    7 NA = 0
      NA1 = 0
      KH = 0
      K2 = 0
      K1 = 0
      K8 = 0
      K = 0
C     K WILL BE THE NUMBER OF ATOMS WITH POS WTS OTHER THAN 800.
C       AND 999.9; KH IS THE NUMBER OF ATOMS WITH WTS 0.0 (NOTE
C       THIS IS AFTER SUBR XASIGN, SO INPUT WTS OF 0.0 MAY HAVE
C       BEEN CHANGED IF THE ATOM WAS RECOGNIZED CHEMICALLY
C
C     K AND KH COUNT ATOMS FOR ANALYSIS; K8 COUNTS ATOMS WITH WT
C       800., INCLUDED IN NA, BUT SKIPPED IN THE ANALYSIS.  K1
C       COUNTS ATOMS FOR SYSTEM OF INERTIA ONLY (NEG WTS), AND
C       K2 COUNTS ATOMS FOR INTERPRETATION ONLY (WT = 999.9)
      DO 10 I = 1,NTOT
      IF(WT(I).EQ.999.9) GO TO 50
      IF(WT(I).NE.800.0) GO TO 35
      K8 = K8 + 1
      IK8(K8) = I
      NA = NA + 1
      GO TO 9
   35 IF(WT(I)) 70,45,40
   40 K = K + 1
      NA = NA + 1
      IK(K) = I
      GO TO 9
   45 KH = KH + 1
      NA = NA + 1
      IKH(KH) = I
      GO TO 9
   70 K1 = K1 + 1
      NA1 = K1
      IK1(K1) = I
      GO TO 9
   50 K2 = K2 + 1
      IK2(K2) = I
    9 CONTINUE
   10 CONTINUE
      N8 = K8
C ***  SAVE NO. OF ATOMS OF WT 800.0 AS N8 (USED IN MAIN, BETWEEN
C ***    235 AND 255; IN CALCUS NEAR END, AT 60; IN OUTP, IN
C ***    OUTP3 AND OUTP10; IN UCRYST JUST AFTER 10 -- TO FIX AN
C ***    OUTPUT LABEL OR A MEASURE OF AGREEMENT BETWEEN Uobs AND
C ***    Ucalc, SINCE ATOMS OF WT 800.0 HAVE BEEN COUNTED IN NA)
      IF(NA.NE.0)  GO TO 15
      CALL OUTH11
      CALL EXIT
   15 I1 = 1
      I2 = NA
      IKC = 0
      IF(KH.EQ.0)  GO TO 60
      DO 120 I = 1,KH
      IK(K+I) = IKH(I)
  120 CONTINUE
C   FOLLOWING PUTS ATOMS OF WT 800.0 AT END OF GROUP FOR 'ANALYSIS'
   60 IF(K8.EQ.0) GO TO 65
      DO 130 I = 1,K8
      IK(K + KH + I) = IK8(I)
  130 CONTINUE
   65 DO 20 I = I1,I2
      N = IK(I)
      DO 25 K = 1,3
   25 AX(I,K) = X(N,K)
      AWT(I) = WT(N)
      AMULT(I) = MULT(N)
      INU(I) = NUORB(N)
      NTNAME(I) = ATNAME(N)
      IHT(I) = IHAT(N)
      DO 26 K = 1,6
      AUOBS(I,K) = UOBS(N,K)
   26 CONTINUE
   20 CONTINUE
      IKC = IKC + 1
      IF(IKC.EQ.3)  GO TO 3
      IF(NA1.EQ.0)  IKC = IKC + 1
      GO TO (1,2), IKC
    1 I1 = NA + 1
      I2 = NA + NA1
      K = 0
      DO 80 I = I1,I2
      K = K + 1
      IK(I) = IK1(K)
   80 CONTINUE
      GO TO 65
    2 I1 = NA + NA1 + 1
      IF(I1.GT.NTOT)  GO TO 3
      I2 = NTOT
      K = 0
      DO 90 I = I1,I2
      K = K + 1
      IK(I) = IK2(K)
   90 CONTINUE
      GO TO 65
    3 DO 100 I = 1,NTOT
      DO 105 K = 1,3
      X(I,K) = AX(I,K)
  105 CONTINUE
      MULT(I) = AMULT(I)
      NUORB(I) = INU(I)
      WT(I) = AWT(I)
      ATNAME(I) = NTNAME(I)
      IHAT(I) = IHT(I)
      DO 110 K = 1,6
      UOBS(I,K) = AUOBS(I,K)
  110 CONTINUE
  100 CONTINUE
      RETURN
      END
      SUBROUTINE SORTSG(NSIG)
C ***  ALTERED 23.I.87 SO LOOKS ONLY AT FIRST (NA-N8) (SORTED) INPUT
C ***    ATOMS, WHERE N8 IS THE NUMBER WITH WEIGHT 800.0
C     SORT INPUT OF SIGMA U'S INTO SEQUENCE OF ATOMS FOR ANALYSIS
C       AND GENERATE SIGU(I,K) FOR EACH ATOM OF WT 800.0 IF NO SIGU
C       WAS INPUT FOR THAT ATOM.  SORTING IS ON BASIS OF ATOM NAMES,
C       WHICH ARE  ATNAME  FOR INPUT PARAMETERS AND  NTNAME  FOR ESDS
C
      COMMON/ATPAR/X(150,3),WT(150),MULT(150),UOBS(150,6),SIGU(150,6),UC
     1ALC(150,6),NUORB(150),SIGB(150,6)
      COMMON//AIDX(3000)
      COMMON/AIDCH/NTNAME(150)
      COMMON/CONT1/ISET,NO,NMULT,NA,ICOUNT,NINPAR,NPARS,NINOBS,NANG,
     1 NTOT,NPULT,NA1,IFU,IB,NONRIG,NS,ISIG,ISYM,ICORL,IFU1,N8,
     2 IEIG,IMAT, IOUT,IRECAL, IFREQ
      COMMON/IAID1/IAIDX1(1000)
      COMMON/INOUTN/ NPAGE, KOUTP,  DIS, IAW
      COMMON/INOUTC/ NAME1, ATNAME(150),TISET(80),TITLE(80),ITBL(29),
     1 NAME2
      DIMENSION SIGH(6)
      EQUIVALENCE (SIGH(1),AIDX(1))
C
      CHARACTER*4  NTNAME,INAME
      CHARACTER*4 NAME1,ATNAME,TISET*1,TITLE*1, ITBL*3, NAME2*5
      real mult
C
      IF(NSIG.EQ.1)  RETURN
      NST = 0
      I2 = NA - N8
C ***  THUS I2 IS THE NUMBER OF ATOMS WHOSE U'S ARE TO BE USED IN THE
C ***     ANALYSIS OF MOTION.  THESE I2 ATOMS HAVE BEEN SORTED INTO
C ***     THE FIRST I2 POSITIONS IN ATOM-PARAMETER LIST
      DO 10 I = 1,I2
      DO 20 K = 1,NSIG
      IF(ATNAME(I).EQ.NTNAME(K))  GO TO 30
      IF(K.NE.NSIG) GO TO 20
      NST = NST + 1
C   WHEN K = I2, NO ATOM NAMES HAVE MATCHED
      PRINT 100, ATNAME(I), NSIG
  100 FORMAT(' ','ATOM NAME ',A4,' IN SORTED ATOM INPUT MATCHES NONE',
     1' OF THE',I4,' ATOM NAMES INPUT WITH ESDs.  Us FOR THIS ATOM'
     2/3X,'ARE TO BE INCLUDED IN THE ANALYSIS OF MOTION; ESDs MUST ',
     3'ALSO BE, IF THEY ARE INPUT FOR ANY ATOMS.')
      GO TO 20
   30 INAME = NTNAME(I)
      NTNAME(I) = NTNAME(K)
      NTNAME(K) = INAME
      DO 40 IH = 1,6
      SIGH(IH) = SIGB(I,IH)
      SIGB(I,IH) = SIGB(K,IH)
      SIGB(K,IH) = SIGH(IH)
   40 CONTINUE
      GO TO 10
   20 CONTINUE
   10 CONTINUE
      IF(NST.NE.0) STOP
C  NST NON-ZERO MEANS AT LEAST ONE NON-MATCH OF ATOM NAMES
      IF(N8.EQ.0) RETURN
C  GENERATE SIGB(I,K) = 1.0 FOR ATOMS OF WT 800.0 (WHICH ARE
C     AT THE END OF THE FIRST NA ATOMS) IF ESDS INPUT FOR FEWER
C *** THAN NA ATOMS.  NOTE THESE ARE NOW GENERATED REGARDLESS
C *** OF ANY THAT MAY HAVE BEEN INPUT.  INPUT VALUES IGNORED
      N1 = NA - N8 + 1
      NT = 0
      DO 50 I = N1,NA
      IF(WT(I).NE.800.0) GO TO 50
      NT = NT + 1
      DO 45 K = 1,6
      SIGB(I,K) = 1.0
   45 CONTINUE
   50 CONTINUE
      IF(NT.NE.0) PRINT 110, NT
  110 FORMAT(/' SIGB(I,K) = 1.0 GENERATED FOR ',I3,
     1 ' ATOMS OF WT 800.0')
      NT = NT + NSIG
      IF(NT.LT.NA) GO TO 300
C  NOW CHANGE ISIG TO NA OR -NA SO OK FOR VIBAMP AND SGTRAN
      IF(ISIG.LT.0) GO TO 150
      ISIG = NA
      RETURN
  150 ISIG = -NA
      RETURN
  300 PRINT 105
      STOP
  105 FORMAT(' ','ABSOLUTE VALUE OF ISIG ADDED TO NO. OF ATOMS OF WEIGHT
     1 800.0 IS LESS THAN NA.  CHECK INPUT.')
      END
      SUBROUTINE STAS
C
C     CALCULATE ALTERNATIVE SYSTEM OF INTERPRETATION WITH NON-INTERSECTI
C     AXES OF LIBRATION.  IF ONE OR MORE EIGENVALUES OF THE L-TENSOR 
C     HAVE BEEN FOUND TO BE NEGATIVE OR ZERO,   INEGL = 1, AND THE
C     CALCULATION OF ALTERNATIVE SYSTEM OF INTERPRETATION SKIPPED
C
C *** if IBYP.ne.0, references to I frame here will be to Cartes Xtal Sys
C     VL = EIGENVECTORS OF L IN I FRAME
C     AHL(I,I) = EIGENVALUES L IN I FRAME
C     VLT = TRANSPOSE OF VL
C     AHS(3,3) = ORIG. S TENSOR IN I FRAME
C     SL = ORIG. S TENSOR IN L FRAME
C
      COMMON//AIDX(3000)
      COMMON /CONT1/ISET,NO,NMULT,NA,ICOUNT,NINPAR,NPARS,NINOBS,NANG,NTO
     1T,NPULT,NA1,IFU,IB,NONRIG,NS,ISIG,ISYM,ICORL,IFU1,N8,
     2 IEIG,IMAT, IOUT,IRECAL, IFREQ
      COMMON/CONT2/NP1,NNP1,IORIG,IWU,INOPAR
      common/new/isigx,ETA, TK,I11, isigu,nafa(7),NONSY(7),AXMOM(7),
     1  NRBP(150),NCPD,NDAT,NESD, IBYP, IEXU, inegl
      COMMON/SYM/SYMOP(23,3,3),TMAT(3,3),RTMAT(3,3),EPSIJK(3,3,3),
     1 SYML(3)
      COMMON/TMCSIS/TCIC(3,3),TCIU(3,3),TCINVC(3,3),TCINVU(3,3),SCG(3),
     1 OMIN(3,3), TROI(3,3), oma(3,3)
      DIMENSION EFSCT(3),SCRP(3),RHO(3,3),SL(3,3),AHL(3,3),AHS(3,3)
      DIMENSION P(80),VL(3,3),VLT(3,3)
      DIMENSION AOT(3,3),V(6),UH(3,3),AOC(3,3),AOL(3,3),TTCNVU(3,3)
      EQUIVALENCE(EFSCT(1),AIDX(601)),(SCRP(1),AIDX(605))
      EQUIVALENCE(RHO(1,1),AIDX(2811))
      EQUIVALENCE (VL(1,1),AIDX(2641)),(AHL(1,1),AIDX(2601))
      EQUIVALENCE (P(1),AIDX(801)),(AHS(1,1),AIDX(2781))
      EQUIVALENCE (SL(1,1),AIDX(2791)),(VLT(1,1),AIDX(2821))
      EQUIVALENCE (UH(1,1),AIDX(2490)),(V(1),AIDX(2435)),(AOT(1,1),
     1 AIDX(2721)),(AOL(1,1),AIDX(2711)),(AOC(1,1),AIDX(2701))
     2 , (TTCNVU(1,1),AIDX(2751))
C
      CALL TRAMA(VL,VLT)
      IF(NPARS.EQ.0.OR.INEGL.NE.0) RETURN
      M = 12
      DO 10 I = 1,3
      DO 10 K = 1,3
      M = M + 1
      AHS(I,K) = P(M)
   10 CONTINUE
      CALL TRIPLE(VLT,AHS,VL,SL)
      DO 15 I = 1,3
      DO 15 J = 1,3
      RHO(I,J) = 0.
   15 CONTINUE
      DO 20 I = 1,3
      DO 20 J = 1,3
      DO 20 K = 1,3
      RHO(J,I) = RHO(J,I) + EPSIJK(I,J,K)*SL(J,K)/AHL(J,J)
   20 CONTINUE
      DO 30 I = 1,3
      SCRP(I) = SL(I,I)/AHL(I,I)
      EFSCT(I) = SCRP(I)*SQRT(AHL(I,I))
   30 CONTINUE
      DO 100 I=1,6
      K=I+6
  100 V(I) = P(K)
C     V(I) IS NOW ORIGINAL T IN I-FRAME
      CALL VMLT(V,UH)
      CALL TRIPLE(VLT,UH,VL,AOT)
C     AOT IS NOW ORIGINAL T IN L-FRAME
C     CALCULATE REDUCED T FOR THIS DESCRIPTION
      DO 110 K=1,3
      J = K+1
      IM = MOD(K,3) + 1
      JM = MOD(J,3) + 1
      AOT(K,K) = AOT(K,K) - SL(IM,K)*SL(IM,K)/AHL(IM,IM)
     .          -SL(JM,K)*SL(JM,K)/AHL(JM,JM)
      AOT(K,IM)=AOT(K,IM)-SL(K,K)*SL(K,IM)/AHL(K,K)-SL(IM,K)*SL(IM,IM)/
     .    AHL(IM,IM) - SL(JM,K)*SL(JM,IM)/AHL(JM,JM)
      AOT(IM,K) = AOT(K,IM)
  110 CONTINUE
      CALL TRIPLE(VL,AOT,VLT,AOL)
      CALL TRAMA(TROI,UH)
      CALL TRIPLE(TROI,AOL,UH,AOC)
C     REDUCED T IS NOW AOT IN L-FRAME, AOL IN INERTIAL FRAME, AOC IN
C     CARTESIAN CRYSTAL SYSTEM
      IF(iexu.eq.1.or.NS.LT.0) RETURN
      CALL OUTH6
C     PRINT SCREW PITCHES, EFFECTIVE SCREW TRANSLATIONS AND REDUCED T
      CALL OTHR22
      CALL OUTR10
      RETURN
      END
      SUBROUTINE STEST
C
C     TEST IF S TENSOR SYMMETRICAL IN NON-ORTHOGONAL CRYSTAL SYSTEM
C
      COMMON//AIDX(3000)
      COMMON/CONT2/NP1,NNP1,IORIG,IWU,INOPAR
      DIMENSION P(80)
      EQUIVALENCE (P(1),AIDX(801))
C
      EPS = 0.00001
      IF(ABS(P(14)-P(16)).GE.EPS)  RETURN
      IF(ABS(P(15)-P(19)).GE.EPS)  RETURN
      IF(ABS(P(18)-P(20)).GE.EPS)  RETURN
      IORIG = 0
      RETURN
      END
      SUBROUTINE SYMET
C ***  modified April 1993 for tetragonal pt groups in cubic crystals
C     SYMET PRODUCES ALL THE NECESSARY SYMMETRY OPERATIONS FOR A
C     PARTICULAR POINT GROUP.
C
      COMMON//AIDX(3000)
      COMMON /CONT1/ISET,NO,NMULT,NA,ICOUNT,NINPAR,NPARS,NINOBS,NANG,NTO
     1T,NPULT,NA1,IFU,IB,NONRIG,NS,ISIG,ISYM,ICORL,IFU1,N8,
     2 IEIG,IMAT, IOUT,IRECAL, IFREQ
      COMMON/CONT3/ISOLV,NTOTS,CONSLV,SUMW,RWUDI,RMS,RMU,gof,sumsig,
     1  iscm,msd8
      COMMON/IAID1/ IAIDX1(1000)
      COMMON/INOUTN/ NPAGE, KOUTP,  DIS, IAW
      COMMON/INOUTC/ NAME1, ATNAME(150),TISET(80),TITLE(80),ITBL(29),
     1 NAME2
      COMMON/IPAR/NP(80)
      common/new/isigx,ETA, TK,I11, isigu,nafa(7),NONSY(7),AXMOM(7),
     1  NRBP(150),NCPD,NDAT,NESD, IBYP, IEXU, inegl
      COMMON/SYM/SYMOP(23,3,3),TMAT(3,3),RTMAT(3,3),EPSIJK(3,3,3),
     1 SYML(3)
C
      DIMENSION IAID(50)
      DIMENSION NS1(1),NS2(2),NS3(2),NS6(2),NS10(4),NS16(4),NS25(4)
      DIMENSION NS47(8),NS75(4),NS81(4),NS83(8),NS89(8),NS99(8),NS111(8)
      DIMENSION NS123(16),NS143(3),NS146(3),NS147(6),NS148(6),NS149(6)
      DIMENSION NS150(6),NS155(6),NS156(6),NS157(6),NS160(6),NS162(12)
      DIMENSION NS164(12),NS166(12),NS168(6),NS174(6),NS175(12)
      DIMENSION NS177(12),NS183(12),NS187(12),NS189(12),NS191(24)
      DIMENSION NS195(12),NS200(24),NS207(24),NS215(24),NS221(48)
      DIMENSION NPS1(21), NPS6(5), NPS7(4), NPS8(12), NPS9(12),NPS10(9)
      DIMENSION NPS11(9), NPS12(9), nps2(21),nps3(21)
      DIMENSION TNAME1(41),TNAME2(41)
C
      EQUIVALENCE(IATEX,IAIDX1(500))
      EQUIVALENCE (IAIDX1(499),NHA)
      EQUIVALENCE(IAIDX1(351),IAID(1))
      CHARACTER*4 NAME1,ATNAME,TISET*1,TITLE*1, ITBL*3, TNAME1
      CHARACTER*5 NAME2, TNAME2
C
C        THE FOLLOWING DATA STATEMENTS ARE VALID ONLY FOR CDC VERSIONS
C          OF MAIN.  THEY HAVE BEEN HERE CONVERTED TO COMMENTS BUT HAVE
C          BEEN LEFT IN FOR CHECKING OR POSSIBLE RECONVERSION.
C          (THIS APPLIES TO SYMOP AND EPSIJK ONLY. THEY ARE NOW INITIAL-
C          IZED IN A BLOCK DATA SUBPROGRAM.)
C
C     DATA (((EPSIJK(I,J,K),K=1,3),J=1,3),I=1,3)/0.,0.,0.,0.,0.,1.,0.,-1
C    1.,0.,0.,0.,-1.,0.,0.,0.,1.,0.,0.,0.,1.,0.,-1.,0.,0.,0.,0.,0./
C     DATA ((SYMOP( 1,I,K),K=1,3),I=1,3)/1.,0.,0.,0.,1.,0.,0.,0.,1./
C     DATA ((SYMOP( 2,I,K),K=1,3),I=1,3)/1.,0.,0.,0.,-1.,0.,0.,0.,-1./
C     DATA ((SYMOP( 3,I,K),K=1,3),I=1,3)/-1.,0.,0.,0.,1.,0.,0.,0.,-1./
C     DATA ((SYMOP( 4,I,K),K=1,3),I=1,3)/-1.,0.,0.,0.,-1.,0.,0.,0.,1./
C     DATA ((SYMOP( 5,I,K),K=1,3),I=1,3)/0.,1.,0.,1.,0.,0.,0.,0.,-1./
C     DATA ((SYMOP( 6,I,K),K=1,3),I=1,3)/0.,-1.,0.,-1.,0.,0.,0.,0.,-1./
C     DATA ((SYMOP( 7,I,K),K=1,3),I=1,3)/-1.,1.,0.,0.,1.,0.,0.,0.,-1./
C     DATA ((SYMOP( 8,I,K),K=1,3),I=1,3)/1.,0.,0.,1.,-1.,0.,0.,0.,-1./
C     DATA ((SYMOP( 9,I,K),K=1,3),I=1,3)/1.,-1.,0.,0.,-1.,0.,0.,0.,-1./
C     DATA ((SYMOP(10,I,K),K=1,3),I=1,3)/-1.,0.,0.,-1.,1.,0.,0.,0.,-1./
C     DATA ((SYMOP(11,I,K),K=1,3),I=1,3)/0.,-1.,0.,1.,0.,0.,0.,0.,1./
C     DATA ((SYMOP(12,I,K),K=1,3),I=1,3)/0.,1.,0.,-1.,0.,0.,0.,0.,1./
C     DATA ((SYMOP(13,I,K),K=1,3),I=1,3)/0.,-1.,0.,1.,-1.,0.,0.,0.,1./
C     DATA ((SYMOP(14,I,K),K=1,3),I=1,3)/-1.,1.,0.,-1.,0.,0.,0.,0.,1./
C     DATA ((SYMOP(15,I,K),K=1,3),I=1,3)/1.,-1.,0.,1.,0.,0.,0.,0.,1./
C     DATA ((SYMOP(16,I,K),K=1,3),I=1,3)/0.,1.,0.,-1.,1.,0.,0.,0.,1./
C     DATA ((SYMOP(17,I,K),K=1,3),I=1,3)/-1.,0.,0.,0.,-1.,0.,0.,0.,-1./
C     DATA ((SYMOP(18,I,K),K=1,3),I=1,3)/0.,0.,1.,1.,0.,0.,0.,1.,0./
C     DATA ((SYMOP(19,I,K),K=1,3),I=1,3)/0.,1.,0.,0.,0.,1.,1.,0.,0./
C     DATA ((SYMOP(20,I,K),K=1,3),I=1,3)/0.,-0.707106781,-0.707106781,0.
C    1,0.707106781,-0.707106781,1.,0.,0./
C     DATA ((SYMOP(21,I,K),K=1,3),I=1,3)/0.,0.,1.,-0.707106781,0.7071067
C    181,0.,-0.707106781,-0.707106781,0./
C     DATA ((SYMOP(22,I,K),K=1,3),I=1,3)/0.,0.,-1.,-1.,0.,0.,0.,-1.,0./
C     DATA ((SYMOP(23,I,K),K=1,3),I=1,3)/0.,-1.,0.,0.,0.,-1.,-1.,0.,0./
C
      DATA NS1   /010101/, NS2          /010101,170101/
      DATA  NS3          /010101,010401/, NS6          /010101,170401/
      DATA  NS10          /010101,170101,010401,170401/
      DATA  NS16          /010101,010401,010201,010301/
      DATA  NS25          /010101,010401,170201,170301/
      DATA  NS47          /010101,170101,010201,010301,010401,170201,170
     1301,170401/
      DATA  NS75          /010101,010401,011101,011201/
      DATA  NS81          /010101,010401,171101,171201/
      DATA  NS83          /010101,010401,170401,170101,011101,011201,171
     1101,171201/
      DATA  NS89          /010101,010401,010201,010301,011101,011201,010
     1501,010601/
      DATA  NS99          /010101,010401,011101,011201,170201,170301,170
     1601,170501/
      DATA  NS111          /010101,010401,010301,010201,171101,171201,17
     10601,170501/
      DATA  NS123           /010101,010401,170401,170101,170201,170301,0
     110201,010301,011101,011201,171201,171101,170601,170501,010501,0106
     201/
      DATA  NS143          /010101,011301,011401/
      DATA  NS146          /010101,011801,011901/
      DATA  NS147          /010101,011301,011401,170101,171301,171401/
      DATA  NS148          /010101,011801,011901,170101,171801,171901/
      DATA  NS149          /010101,011301,011401,010601,010701,010801/
      DATA  NS150          /010101,011301,011401,010501,010901,011001/
      DATA  NS155          /010101,011801,011901,010601,061901,061801/
      DATA  NS156          /010101,011301,011401,170501,171001,170901/
      DATA  NS157          /010101,011301,011401,170601,170801,170701/
      DATA  NS160          /010101,011801,011901,170601,170619,170618/
      DATA  NS162           /010101,011301,011401,170101,171301,171401,1
     170601,170801,170701,010601,010801,010701/
      DATA  NS164           /010101,011301,011401,170101,171301,171401,1
     170501,171001,170901,010501,011001,010901/
      DATA  NS166           /010101,011801,011901,170601,170619,170618,1
     170101,171801,171901,010601,010619,010618/
      DATA  NS168          /010101,011301,011401,010401,011501,011601/
      DATA  NS174          /010101,011301,011401,170401,171501,171601/
      DATA  NS175           /010101,011301,011401,170101,171301,171401,0
     110401,011501,011601,170401,171501,171601/
      DATA  NS177           /010101,011301,011401,010401,011501,011601,0
     110501,011001,010901,010601,010801,010701/
      DATA  NS183           /010101,011301,011401,010401,011601,011501,1
     170601,170701,170801,170501,171001,170901/
      DATA  NS187           /010101,011301,011401,170401,171601,171501,1
     170501,171001,170901,010601,010801,010701/
      DATA  NS189           /010101,011301,011401,170401,171601,171501,1
     170601,170801,170701,010501,011001,010901/
      DATA  NS191           /010101,011301,011401,170601,170801,170701,0
     110401,011601,011501,170501,171001,170901,170401,171501,171601,0105
     201,011001,010901,170101,171301,171401,010601,010801,010701/
      DATA  NS195           /010101,011801,011901,010201,021801,021901,0
     110301,031801,031901,010401,041801,041901/
      DATA  NS200           /010101,011801,011901,170101,171801,171901,0
     110201,021801,021901,170201,170218,170219,010301,031801,031901,1703
     201,170318,170319,010401,041801,041901,170401,170418,170419/
      DATA  NS207           /010101,011801,011901,180619,010601,190618,0
     110201,021801,021901,180519,011101,180501,010301,031801,031901,1811
     219,011201,190518,010401,041801,041901,051801,010501,191118/
      DATA  NS215           /010101,011801,011901,170618,170601,230618,0
     110201,021801,021901,220519,171101,171805,010301,031801,031901,2211
     219,171201,230518,010401,041801,041901,170518,170501,231118/
      DATA  NS221           /010101,011801,011901,170618,170601,230618,0
     110201,021801,021901,220519,171101,171805,010301,031801,031901,2211
     219,171201,230518,010401,041801,041901,170518,170501,231118,170101,
     3171801,171901,010618,010601,190618,170201,170218,170219,180519,011
     4101,180105,170301,170318,170319,181119,011201,190518,170401,170418
     5,170419,010518,010501,191118/
C
      DATA  NPS1           /1,0,0,1,0,6,7,0,0,7,0,12,13,14,0,14,13,0,0,0
     1,0/
C *** April 1993  NPS2 and NPS3 are new, for tetrag pt groups along a, b
      DATA  NPS2           /1,0,0,4,0,4,7,0,0,10,0,10,0,0,0,0,17,18,0,18
     1,17/
      DATA  NPS3           /1,0,0,4,0,1,7,0,0,10,0,7,13,0,15,0,0,0,15,0
     1,13/
      DATA NPS6          /0,14,0,-14,0/
      DATA  NPS7          /0,0,0,-13/
      DATA  NPS8           /1,2,2,1,2,1,7,8,8,7,8,7/
      DATA  NPS9           /1,0,0,1,0,1,7,0,0,7,0,7/
      DATA  NPS10          /0,14,15,15,0,14,14,15,0/
      DATA  NPS11          /0,14,14,14,0,14,14,14,0/
      DATA  NPS12          /0,14,-14,-14,0,14,14,-14,0/
      DATA TNAME1/'C1','CI','C2','CS','C2H','D2','C2V','D2H','C4','S4',
     1 'C4H','D4','C4V','D2D','D4H','C3','C3','C3I','C3I','D3','D3',
     2'D3','C3V','C3V','C3V','D3D','D3D','D3D','C6','C3H','C6H','D6',
     3 'C6V','D3H','D3H','D6H','T','TH','O','TD','OH'/
      DATA TNAME2/'1','-1','2','M','2/M','222','MM2','MMM','4','-4',
     1 '4/M','422','MM4','-42M','4/MMM','3','CUBIC','-3','CUBIC','312',
     2 '321','CUBIC','3M1','31M','CUBIC','-31M','-3M1','CUBIC','6','-6',
     3 '6/M','622','6MM','-6M2','-62M','6/MMM','23','M3','432','-43M',
     4 'M3M'/
C
C     IF ISET.GT.5 TMAT AND RTMAT IS READ AS INPUT
      IF(ISET.GT.5)  GO TO 1000
      GO TO (300,310,320,330,340), ISET
C     ISET = 1,  Z-AXIS = PRINCIPAL AXIS
  300 DO 305 I=1,3
      DO 305 K=1,3
      TMAT(I,K) = SYMOP(1,I,K)
      RTMAT(I,K) = SYMOP(1,I,K)
  305 CONTINUE
      GO TO 1000
C     ISET = 2   X-AXIS = PRINCIPAL AXIS
  310 DO 315 I=1,3
      DO 315 K=1,3
      TMAT(I,K) = SYMOP(18,I,K)
      RTMAT(I,K) = SYMOP(19,I,K)
  315 CONTINUE
      GO TO 1000
C     ISET = 3   Y-AXIS = PRINCIPAL AXIS
  320 DO 325 I=1,3
      DO 325 K=1,3
      TMAT(I,K) = SYMOP(19,I,K)
      RTMAT(I,K) = SYMOP(18,I,K)
  325 CONTINUE
      GO TO 1000
C     ISET = 4   XY-DIAGONAL = PRINCIPAL AXIS
  330 DO 335 I=1,3
      DO 335 K=1,3
      TMAT(I,K) = SYMOP(20,I,K)
      RTMAT(I,K) = SYMOP(21,I,K)
  335 CONTINUE
C     ISET = 5  XYZ-DIAGONAL = PRINCIPAL AXIS FOR GROUPS IN CUBIC
C        CRYSTALS WITH POINT GROUPS SPECIFIED AS 146 (C3), 148 (C3I),
C        155 (D3), 160 (C3V), OR 166 (D3D)
  340 DO 345 I = 1,3
      DO 345 K = 1,3
      TMAT(I,K) = SYMOP(1,I,K)
      RTMAT(I,K) = SYMOP(1,I,K)
  345 CONTINUE
 1000 IF(NO.LE. 47)  GO TO  400
C      THE SYMMETRY CONSTRAINTS WILL BE PRESET FOR ALL POINT GROUPS
C        WITH HIGHER THAN ORTHORHOMBIC SYMMETRY
C ***  April 1993:  the following DO 350 loop has been modified.  As it
C ***     was. it was fine for c-axis unique, but now have introduced NPS2
C ***     and NPS3 to take care of tetrag pt groups with 4-fold along a,b
      DO 350 I = 1,21
      NP(I) = NPS1(I)
      if(iset.eq.2) np(i) = nps2(i)
      if(iset.eq.3) np(i) = nps3(i)
  350 continue
      IF(NO.LE.123)  GO TO  410
      IF(NO.LE.160)  GO TO  420
      IF(NO.LE.183)  GO TO  430
      IF(NO.EQ.187)  GO TO 187
      IF(NO.EQ.189)  GO TO 189
      IF(NO.EQ.191)  GO TO 191
      IF(NO.GE.195) GO TO 1965
C     ALL GROUPS WITH CUBIC SYMMETRY HAVE CERTAIN COMMON FEATURES
 1960 IF(NO.EQ.195)  GO TO 195
      IF(NO.EQ.200)  GO TO 200
      IF(NO.EQ.207)  GO TO 207
      IF(NO.EQ.215)  GO TO 215
      IF(NO.EQ.221)  GO TO 221
      GO TO 999
 1965 NPARS = 0
      NPULT = 1
      DO 1966 I = 1,12
 1966 NP(I) = NPS9(I)
      GO TO 1960
  187 NAME1 = TNAME1(34)
      NAME2 = TNAME2(34)
      NMULT = 12
      NPARS = 0
      NPULT = 2
      DO 1870 K = 1,NMULT
 1870 IAID(K) = NS187(K)
      DO 1871 K = 13,17
 1871 NP(K) = 0
      GO TO 3000
  189 NAME1 = TNAME1(35)
      NAME2 = TNAME2(35)
      NMULT = 12
      NPARS = 0
      NPULT = 2
      DO 1890 K = 1,NMULT
 1890 IAID(K) = NS189(K)
      DO 1891 K = 13,17
 1891 NP(K) = 0
      GO TO 3000
  191 NAME1 = TNAME1(36)
      NAME2 = TNAME2(36)
      NMULT = 24
      NPARS = 0
      NPULT = 2
      DO 1910 K = 1,NMULT
 1910 IAID(K) = NS191(K)
      DO 1911 K = 13,17
 1911 NP(K) = 0
      GO TO 3000
  195 NAME1 = TNAME1(37)
      NAME2 = TNAME2(37)
      NMULT = 12
      DO 1950 K = 1,NMULT
 1950 IAID(K) = NS195(K)
      GO TO 3000
  200 NAME1 = TNAME1(38)
      NAME2 = TNAME2(38)
      NMULT = 24
      DO 2000 K = 1,NMULT
 2000 IAID(K) = NS200(K)
      GO TO 3000
  207 NAME1 = TNAME1(39)
      NAME2 = TNAME2(39)
      NMULT = 24
      DO 2070 K = 1,NMULT
 2070 IAID(K) = NS207(K)
      GO TO 3000
  215 NAME1 = TNAME1(40)
      NAME2 = TNAME2(40)
      NMULT = 24
      DO 2150 K = 1,NMULT
 2150 IAID(K) = NS215(K)
      GO TO 3000
  221 NAME1 = TNAME1(41)
      NAME2 = TNAME2(41)
      NMULT = 48
      DO 2210 K = 1,NMULT
 2210 IAID(K) = NS221(K)
      GO TO 3000
  400 IF(NO.EQ.1)  GO TO 1
      IF(NO.EQ.2)  GO TO 2
      IF(NO.EQ.3)  GO TO 3
      IF(NO.EQ.6)  GO TO 6
      IF(NO.EQ.10)  GO TO 10
      IF(NO.EQ.16)  GO TO 16
      IF(NO.EQ.25)  GO TO 25
      IF(NO.EQ.47)  GO TO 47
      GO TO 999
    1 NAME1 = TNAME1(1)
      NAME2 = TNAME2(1)
      NMULT = 1
      DO 1001 K = 1,NMULT
 1001 IAID(K) = NS1(K)
      GO TO 3000
    2 NAME1 = TNAME1(2)
      NAME2 = TNAME2(2)
      NMULT = 2
      DO 1002 K = 1,NMULT
 1002 IAID(K) = NS2(K)
      GO TO 3000
    3 NAME1 = TNAME1(3)
      NAME2 = TNAME2(3)
      NMULT = 2
      DO 1003 K = 1,NMULT
 1003 IAID(K) = NS3(K)
      GO TO 3000
    6 NAME1 = TNAME1(4)
      NAME2 = TNAME2(4)
      NMULT = 2
      DO 1006 K = 1,NMULT
 1006 IAID(K) = NS6(K)
      GO TO 3000
   10 NAME1 = TNAME1(5)
      NAME2 = TNAME2(5)
      NMULT = 4
      DO 1010 K = 1,NMULT
 1010 IAID(K) = NS10(K)
      GO TO 3000
   16 NAME1 = TNAME1(6)
      NAME2 = TNAME2(6)
      NMULT = 4
      DO 1016 K = 1,NMULT
 1016 IAID(K) = NS16(K)
      GO TO 3000
   25 NAME1 = TNAME1(7)
      NAME2 = TNAME2(7)
      NMULT = 4
      DO 1025 K = 1,NMULT
 1025 IAID(K) = NS25(K)
      GO TO 3000
   47 NAME1 = TNAME1(8)
      NAME2 = TNAME2(8)
      NMULT = 8
      DO 1047 K = 1,NMULT
 1047 IAID(K) = NS47(K)
      GO TO 3000
  410 IF(NO.EQ.75)  GO TO 75
      IF(NO.EQ.81)  GO TO 81
      IF(NO.EQ.83)  GO TO 83
      IF(NO.EQ.89)  GO TO 89
      IF(NO.EQ.99)  GO TO 99
      IF(NO.EQ.111)  GO TO 111
      IF(NO.EQ.123)  GO TO 123
      GO TO 999
   75 NAME1 = TNAME1(9)
      NAME2 = TNAME2(9)
      NMULT = 4
      NPARS = 2
      NPULT = 2
      DO 1075 K = 1,NMULT
 1075 IAID(K) = NS75(K)
      if(iset.eq.1) then
         NP(16) = -14
         NP(21) = 21
         GO TO 3000
         endif
      if(iset.eq.2) then 
         NP(20) = -18
         np(13) = 13
         go to 3000
         endif
      if(iset.eq.3) then
         np(19) = -15
         np(17) = 17
         go to 3000
         endif
   81 NAME1 = TNAME1(10)
      NAME2 = TNAME2(10)
      NMULT = 4
      NPARS = 2
      NPULT = 2
      DO 1081 K = 1,NMULT
 1081 IAID(K) = NS81(K)
      IF(ISET.EQ.1) NP(17) = -13
      IF(ISET.EQ.2) NP(21) = -17
      IF(ISET.EQ.3) NP(21) = -13
      GO TO 3000
   83 NAME1 = TNAME1(11)
      NAME2 = TNAME2(11)
      NMULT = 8
      NPARS = 0
      NPULT = 2
      DO 1083 K = 1,NMULT
 1083 IAID(K) = NS83(K)
      DO 1084 I = 13,21
 1084 NP(I) = 0
      GO TO 3000
   89 NAME1 = TNAME1(12)
      NAME2 = TNAME2(12)
      NMULT = 8
      NPARS = 1
      NPULT = 2
      DO 1089 K = 1,NMULT
 1089 IAID(K) = NS89(K)
      DO 1090 I = 14,16
 1090 NP(I) = 0
      do 1091 I = 18,20
 1091 NP(I) = 0
      if(iset.eq.1) NP(21) = 21
      if(iset.eq.2) np(13) = 13
      if(iset.eq.3) np(17) = 17
      GO TO 3000
   99 NAME1 = TNAME1(13)
      NAME2 = TNAME2(13)
      NMULT = 8
      NPARS = 1
      NPULT = 2
      DO 1099 K = 1,NMULT
 1099 IAID(K) = NS99(K)
      DO 1101 I = 13,21
 1101 NP(I) = 0
      if(iset.eq.1) np(14) = 14
      if(iset.eq.1) np(16) = -14
      if(iset.eq.2) np(18) = 18
      if(iset.eq.2) np(20) = -18
      if(iset.eq.3) np(15) = 15
      if(iset.eq.3) np(19) = -15
      GO TO 3000
  111 NAME1 = TNAME1(14)
      NAME2 = TNAME2(14)
      NMULT = 8
      NPARS = 1
      NPULT = 2
      DO 1111 K = 1,NMULT
 1111 IAID(K) = NS111(K)
      DO 1112 I = 13,21
 1112 NP(I) = 0
      if(iset.eq.1) np(13) = 13
      if(iset.eq.1) np(17) = -13
      if(iset.eq.2) np(17) = 17
      if(iset.eq.2) np(21) = -17
      if(iset.eq.3) np(13) = 13
      if(iset.eq.3) np(21) = -13
      GO TO 3000
  123 NAME1 = TNAME1(15)
      NAME2 = TNAME2(15)
      NMULT = 16
      NPARS = 0
      NPULT = 2
      DO 1123 K = 1,NMULT
 1123 IAID(K) = NS123(K)
      DO 1124 I = 13,21
 1124 NP(I) = 0
      GO TO 3000
  420 IF(NO.EQ.143)  GO TO 143
      IF(NO.EQ.146)  GO TO 146
      IF(NO.EQ.147)  GO TO 147
      IF(NO.EQ.148)  GO TO 148
      IF(NO.EQ.149)  GO TO 149
      IF(NO.EQ.150)  GO TO 150
      IF(NO.EQ.155)  GO TO 155
      IF(NO.EQ.156)  GO TO 156
      IF(NO.EQ.157)  GO TO 157
      IF(NO.EQ.160)  GO TO 160
      GO TO 999
  143 NAME1 = TNAME1(16)
      NAME2 = TNAME2(16)
      NMULT = 3
      NPARS = 2
      NPULT = 2
      DO 1143 K = 1,NMULT
 1143 IAID(K) = NS143(K)
      NP(16) = -14
      NP(21) = 21
      GO TO 3000
  146 NAME1 = TNAME1(17)
      NAME2 = TNAME2(17)
      NMULT = 3
      NPARS = 2
      NPULT = 2
      DO 1146 K = 1,NMULT
 1146 IAID(K) = NS146(K)
      DO 1128 I = 1,12
 1128 NP(I) = NPS8(I)
      DO 1129 I = 13,21
      K = I - 12
 1129 NP(I) = NPS10(K)
      GO TO 3000
  147 NAME1 = TNAME1(18)
      NAME2 = TNAME2(18)
      NMULT = 6
      NPARS = 0
      NPULT = 2
      DO 1147 K = 1,NMULT
 1147 IAID(K) = NS147(K)
      DO 1130 I = 13,17
 1130 NP(I) = 0
      GO TO 3000
  148 NAME1 = TNAME1(19)
      NAME2 = TNAME2(19)
      NMULT = 6
      NPARS = 0
      NPULT = 2
      DO 1148 K = 1,NMULT
 1148 IAID(K) = NS148(K)
      DO 1131 I = 1,12
 1131 NP(I) = NPS8(I)
      DO 1132 I = 13,17
 1132 NP(I) = 0
      GO TO 3000
  149 NAME1 = TNAME1(20)
      NAME2 = TNAME2(20)
      NMULT = 6
      NPARS = 1
      NPULT = 2
      DO 1149 K = 1,NMULT
 1149 IAID(K) = NS149(K)
      DO 1133 I = 14,16
 1133 NP(I) = 0
      NP(21) = 21
      GO TO 3000
  150 NAME1 = TNAME1(21)
      NAME2 = TNAME2(21)
      NMULT = 6
      NPARS = 1
      NPULT = 2
      DO 1150 K = 1,NMULT
 1150 IAID(K) = NS150(K)
      DO 1134 I = 14,16
 1134 NP(I) = 0
      NP(21) = 21
      GO TO 3000
  155 NAME1 = TNAME1(22)
      NAME2 = TNAME2(22)
      NMULT = 6
      NPULT = 2
      NPARS = 1
      DO 1155 K = 1,NMULT
 1155 IAID(K) = NS155(K)
      DO 1135 I = 1,12
 1135 NP(I) = NPS8(I)
      DO 1136 I = 13,21
      K = I - 12
 1136 NP(I) = NPS11(K)
      GO TO 3000
  156 NAME1 = TNAME1(23)
      NAME2 = TNAME2(23)
      NMULT = 6
      NPARS = 1
      NPULT = 2
      DO 1156 K = 1,NMULT
 1156 IAID(K) = NS156(K)
      DO 1137 I = 13,17
      K = I - 12
 1137 NP(I) = NPS6(K)
      GO TO 3000
  157 NAME1 = TNAME1(24)
      NAME2 = TNAME2(24)
      NMULT = 6
      NPARS = 1
      NPULT = 2
      DO 1157 K = 1,NMULT
 1157 IAID(K) = NS157(K)
      DO 1138 I = 13,17
      K = I - 12
 1138 NP(I) = NPS6(K)
      GO TO 3000
  160 NAME1 = TNAME1(25)
      NAME2 = TNAME2(25)
      NMULT = 6
      NPARS = 1
      NPULT = 2
      DO 1160 K = 1,NMULT
 1160 IAID(K) = NS160(K)
      DO 1139 I = 1,12
 1139 NP(I) = NPS8(I)
      DO 1140 I = 13,21
      K = I - 12
 1140 NP(I) = NPS12(K)
      GO TO 3000
  430 IF(NO.EQ.162)  GO TO 162
      IF(NO.EQ.164)  GO TO 164
      IF(NO.EQ.166)  GO TO 166
      IF(NO.EQ.168)  GO TO 168
      IF(NO.EQ.174)  GO TO 174
      IF(NO.EQ.175)  GO TO 175
      IF(NO.EQ.177)  GO TO 177
      IF(NO.EQ.183)  GO TO 183
      GO TO 999
  162 NAME1 = TNAME1(26)
      NAME2 = TNAME2(26)
      NMULT = 12
      NPARS = 0
      NPULT = 2
      DO 1162 K = 1,NMULT
 1162 IAID(K) = NS162(K)
      DO 1163 I = 13,17
 1163 NP(I) = 0
      GO TO 3000
  164 NAME1 = TNAME1(27)
      NAME2 = TNAME2(27)
      NMULT = 12
      NPARS = 0
      NPULT = 2
      DO 1164 K = 1,NMULT
 1164 IAID(K) = NS164(K)
      DO 1165 I = 13,17
 1165 NP(I) = 0
      GO TO 3000
  166 NAME1 = TNAME1(28)
      NAME2 = TNAME2(28)
      NMULT = 12
      NPARS = 0
      NPULT = 2
      DO 1166 K = 1,NMULT
 1166 IAID(K) = NS166(K)
      DO 1167 I = 1,12
 1167 NP(I) = NPS8(I)
      DO 1169 I = 13,17
 1169 NP(I) = 0
      GO TO 3000
  168 NAME1 = TNAME1(29)
      NAME2 = TNAME2(29)
      NMULT = 6
      NPARS = 2
      NPULT = 2
      DO 1168 K = 1,NMULT
 1168 IAID(K) = NS168(K)
      NP(16) = -14
      NP(21) = 21
      GO TO 3000
  174 NAME1 = TNAME1(30)
      NAME2 = TNAME2(30)
      NMULT = 6
      NPARS = 0
      NPULT = 2
      DO 1174 K = 1,NMULT
 1174 IAID(K) = NS174(K)
      DO 1170 I = 13,17
 1170 NP(I) = 0
      GO TO 3000
  175 NAME1 = TNAME1(31)
      NAME2 = TNAME2(31)
      NMULT = 12
      NPARS = 0
      NPULT = 2
      DO 1175 K = 1,NMULT
 1175 IAID(K) = NS175(K)
      DO 1171 I = 13,17
 1171 NP(I) = 0
      GO TO 3000
  177 NAME1 = TNAME1(32)
      NAME2 = TNAME2(32)
      NMULT = 12
      NPARS = 1
      NPULT = 2
      DO 1177 K = 1,NMULT
 1177 IAID(K) = NS177(K)
      DO 1178 I = 14,16
 1178 NP(I) = 0
      NP(21) = 21
      GO TO 3000
  183 NAME1 = TNAME1(33)
      NAME2 = TNAME2(33)
      NMULT = 12
      NPARS = 1
      NPULT = 2
      DO 1183 K = 1,NMULT
 1183 IAID(K) = NS183(K)
      DO 1184 I = 13,17
      K = I - 12
 1184 NP(I) = NPS6(K)
 3000 CONTINUE
      IF(iexu.eq.0.and.(NS.GE.-1 .OR. NS.EQ.-3)) CALL OUTP5
C     PRINT NAME1,NAME2,NMULT
      NHA = NA + NA1
      NHT = NTOT + NHA*(NMULT - 1)
      IF(NHT.GT.150)  GO TO 998
C     ONLY A TOTAL OF 150 ATOMS, UNIQUE AND GENERATED, ALLOWED
      CALL SYMPOS
      RETURN
  998 NTOT = NHT
      CALL OUTH13
      GO TO 997
  999 CALL OUTH5
  997 IATEX = -1
      RETURN
      END
C
      SUBROUTINE SYMPOS
C *****EFM MARCH 1991 CALCULATE WTS AND MULTS FOR SYMMETRY-EQUIVALENT
C *****ATOMS
C     CALCULATE NMULT TRANSFORMATION MATRICES AIDS(I,J,K) AND COMPLETE
C        SET OF SYMMETRY-RELATED ATOMIC POSITIONS FOR CALCULATION OF
C        INERTIAL TENSOR AND SYM-RELATED POSITIONS, U'S, AND SIGU'S FOR
C        NORMAL EQUATIONS
C
C ***  19.IV.87  ADDED EXTENSION OF ATNAME TO INCLUDE ALL ATOMS
C ***     AND MM = 2 FOR 2nd CALL OF SGTRAN (FOR 2nd AND FURTHER POSNS)
C
      COMMON/AIDPAR/AX(150,3),AUOBS(150,6),AUCALC(150,6),WU(150,6),
     1  WU1(150,6)
      COMMON/ATPAR/X(150,3),WT(150),MULT(150),UOBS(150,6),SIGU(150,6),UC
     1ALC(150,6),NUORB(150),SIGB(150,6)
      COMMON//AIDX(3000)
      COMMON/CELLP/CD(12),RCD(12),VOL,VST,G(3,3)
      COMMON /CONT1/ISET,NO,NMULT,NA,ICOUNT,NINPAR,NPARS,NINOBS,NANG,NTO
     1T,NPULT,NA1,IFU,IB,NONRIG,NS,ISIG,ISYM,ICORL,IFU1,N8,
     2 IEIG,IMAT, IOUT,IRECAL, IFREQ
      COMMON /CONT2/ NP1,NNP1,IORIG,IWU,INOPAR
      COMMON/CONT3/ISOLV,NTOTS,CONSLV,SUMW,RWUDI,RMS,RMU,gof,sumsig,
     1  iscm,msd8
      COMMON/INOUTC/ NAME1, ATNAME(150),TISET(80),TITLE(80),ITBL(29),
     1 NAME2
      COMMON/IAID1/ IAIDX1(1000)
      common/new/isigx,ETA, TK,I11, isigu,nafa(7),NONSY(7),AXMOM(7),
     1  NRBP(150),NCPD,NDAT,NESD, IBYP, IEXU, inegl
      COMMON/SYM/SYMOP(23,3,3),TMAT(3,3),RTMAT(3,3),EPSIJK(3,3,3),
     1 SYML(3)
C
      DIMENSION AIDS(48,3,3),DET(48),AIDH(3,3)
      DIMENSION AXX(150,3), AXWT(150), WTT(150)
      DIMENSION AIDH1(3,3),IAID(50)
      DIMENSION VH(3),VH1(3),AU(3,3),AUS(3,3),TUS(3,3),TTUS(3,3)
C
      EQUIVALENCE (TUS(1,1),AIDX(2600)),(TTUS(1,1),AIDX(2610))
      EQUIVALENCE (AU(1,1),AIDX(2620)),(AUS(1,1),AIDX(2630))
      EQUIVALENCE (VH(1),AIDX(2640)),(VH1(1),AIDX(2645))
      EQUIVALENCE (IAIDX1(499),NHA) 
      EQUIVALENCE (AXX(1,1),AIDX(1)),(AXWT(1),AIDX(601))
      EQUIVALENCE(IAIDX1(351),IAID(1))
      EQUIVALENCE(IAIDX1(498),M1), (WTT(1),AIDX(451))
      EQUIVALENCE(IAIDX1(497),M2),(IAIDX1(496),M3)
      EQUIVALENCE (AIDH(1,1),AIDX(2901)),(AIDH1(1,1),AIDX(2911))
      EQUIVALENCE (AIDS(1,1,1),AIDX(2001)),(DET(1),AIDX(2501))
C
      CHARACTER*4 NAME1, ATNAME, TISET*1,TITLE*1,ITBL*3,NAME2*5
       REAL MULT
C
      IF(ISYM.NE.0) GO TO 101
C      SET VALUE OF SYML(I) AS 0.0 IF ORIGIN LIES ON ALL SYM ELEMENTS
      DO 100 I = 1,3
      SYML(I) = 0.0
  100 CONTINUE
  101 CONTINUE
      DO 102 I = 1,NTOT
  102 WTT(I) = WT(I)
      ICOUNT = 0
      DO 3010  I=1,NMULT
      DET(I) = 1.
C     M1 = ADDRESS SYMOP 1, M2 = ADDRESS SYMOP 2, M3 = ADDRESS SYMOP 3
      M1 = IAID(I)/10000
      IF(M1.EQ.17)  GO TO 3006
      IF(M1.EQ.22)  GO TO 3006
      IF(M1.EQ.23)  GO TO 3006
      GO TO 3005
 3006 DET(I) = -1.
 3005 M2 = (IAID(I) - M1*10000)/100
      M3 = (IAID(I) - M1*10000 - M2*100)
      CALL TRIPMA(M1,M2,M3)
C     RESULTS OF TRIPMA IN AIDH(3,3)
      CALL TRIPLE(TMAT,AIDH,RTMAT,AIDH1)
      DO 3015 I1=1,3
      DO 3015 I2=1,3
 3015 AIDS(I,I1,I2) = AIDH1(I1,I2)
      DO 3011 J = 1,NHA
C  NHA (FROM END OF SYMET) = NO. OF UNIQUE ATOMS FOR INERTIAL SYSTEM,
C    WHICH INCLUDES ALL WITH WT OTHER THAN 999.9. THOSE WITH WT = 800.0
C    WILL CONTRIBUTE NOTHING BUT ARE INCLUDED AT THIS POINT
      ICOUNT = ICOUNT + 1
      CALL VECH(X,J,VH)
C        MOVE MOLECULE SO SYMMETRY ELEMENT IS THROUGH ORIGIN SO THAT THE
C          SYMMETRY OPERATIONS STORED IN SYMET ARE APPLICABLE
      DO 3020 K = 1,3
      VH(K) = VH(K) - SYML(K)
 3020 CONTINUE
      CALL MATVEC(AIDH1,VH,VH1)
      DO 3030 K = 1,3
      AXX(ICOUNT,K) = VH1(K) + SYML(K)
 3030 CONTINUE
C ***  AXX, CREATED HERE AND USED IN INERT, ARE AT THIS POINT THE
C ***    CRYSTAL SYSTEM POSNS REL TO ORIGINAL ORIGIN, FOR ALL ATOMS IN
C ***    THE INERTIAL SYSTEM, UNIQUE AND SYMMETRY-GENERATED
      AXWT(ICOUNT) = WT(J)*MULT(J)
 3011 CONTINUE
 3010 CONTINUE
C     CREATE ADDITIONAL SET OF X,UOBS,SIGU FOR THE NA*(NMULT-1) ATOMS
C        BEYOND THE FIRST NTOT ATOMS
      IF(NO.EQ.1) RETURN
C     NO ADDITIONAL SYMMETRY-RELATED ATOMS FOR C1
      NTOTS = NTOT
      DO 20 I = 2,NMULT
      DO 25 I1 = 1,3
      DO 25 J1 = 1,3
      TUS(I1,J1) = AIDS(I,I1,J1)
C     TUS IS TRANSFORMATION MATRIX FOR UOBS
   25 CONTINUE
      CALL TRAMA(TUS,TTUS)
C     TTUS = TRANSPOSE OF TUS
      DO 30 J = 1,NA
      NTOTS = NTOTS + 1
      WTT(NTOTS) = WT(J)
C ***** EFM 3/91
      WT(NTOTS) = WT(J)
      mult(ntots) = mult(j)
C  THIS GENERATES WTS FOR THE NA*(NMULT-1) ATOMS GENERATED BY SYMMETRY;
C     THOSE FOR THE FIRST NTOT WERE INPUT AND EQUATED TO WTT ABOVE.
      ATNAME(NTOTS) = ATNAME(J)
      CALL VECH(X,J,VH)
      DO 40  K = 1,3
      VH(K) = VH(K) - SYML(K)
   40 CONTINUE
      CALL MATVEC(TUS,VH,VH1)
      DO 35 JX = 1,3
      X(NTOTS,JX) = VH1(JX) + SYML(JX)
   35 CONTINUE
C     ADDITIONAL X'S CREATED
      CALL VEMA(UOBS,AU,J)
C     CREATE ADDITIONAL SET OF SYMMETRY RELATED UOBS
C     TUS * UOBS * TTUS
      CALL TRIPLE(TUS,AU,TTUS,AUS)
      CALL MAVE(AUS,UOBS,NTOTS)
   30 CONTINUE
      IF(ISIG.LE.0) GO TO 20
      IF(IWU.EQ.1) GO TO 20
C     ADDITIONAL SIGU'S TO BE CREATED IF ISIG.GT.0 AND IWU.NE.1
C ***  FORMERLY SET MM = 1 HERE; NOW USE  I (= EQ POSN NO) INSTEAD
      CALL SGTRAN(TUS,SIGB,SIGU,NTOTS,I)
   20 CONTINUE
      N = NTOT + 1
      DO 200 I = N,NTOTS
      DO 200 J = 1,6
      SIGB(I,J) = SIGU(I,J)
  200 CONTINUE
      CALL OUTP4
      IF(iexu.eq.1.or.NS.LT.0) RETURN
C      DO NOT PRINT SYMMETRY-EQUIVALENT PARAMS WHEN NS NEGATIVE
C      DO NOT PRINT TRANSFORMED ESD'S WHEN NS NEGATIVE (MAIN,BEFORE 125)
      CALL OUTH6
      CALL OUTP6
      RETURN
      END
C
      SUBROUTINE TRAMA(A,B)
C     	CALCULATE TRANSPOSE
      DIMENSION A(3,3),B(3,3)
      DO 10 I = 1,3
      DO 10 K = 1,3
      B(I,K) = A(K,I)
   10 CONTINUE
      RETURN
      END
C
      SUBROUTINE TRAN14
C *** modified from TRAN15, for use in THMA14c, to transform ARG 
C ***	parameters from the CCS to each LOCAL system
C ***    CALLED BY MAIN, just before 215, WHENEVER ARGs ARE PRESENT,
C ***	    UNLESS no correlations of internal & overall motion
      COMMON//AIDX(3000)
      COMMON/CONT1/ISET,NO,NMULT,NA,ICOUNT,NINPAR,NPARS,NINOBS,NANG,NTOT
     1,NPULT,NA1,IFU,IB,NONRIG,NS,ISIG,ISYM,ICORL,IFU1,N8,
     2 IEIG,IMAT, IOUT, IRECAL, IFREQ
      COMMON/CONT2/NP1,NNP1,IORIG,IWU,INOPAR
      COMMON/LOCC/ATNX(7,2)
      character atnx*4
      common/locc_/BLLARG(7)
      COMMON/LOC/ B(7,3), C(7,3), V5(7,3), A(7,3)
      common/new/isigx,ETA, TK,I11, isigu,nafa(7),NONSY(7),AXMOM(7),
     1  NRBP(150),NCPD,NDAT,NESD, IBYP, IEXU, inegl
      common/TRAN/CHI(7),PLC(7,3),PTC(7,3),PLCD(7,3),PTCD(7,3),
     1 SGPL(7,3),SGPLD(7,3),SGPT(7,3),SGPTD(7,3), CLLA(7,3),
     2 argax(7,3,3), argloc(7,3,3)
      dimension  al(3), as(3), pl(6), PLL(3,3), s(3,3), phl(3), pht(3),
     1  phlloc(3),phtloc(3), phlld(3), sqpl(3), ak(3)
      DIMENSION SIGP(80),P(80)
      EQUIVALENCE (P(1),AIDX(801)) 
      EQUIVALENCE (SIGP(1),AIDX(881))
    1 FORMAT('  Components of <phi-la> along LOCAL axes; first line
     1 radians sq, second line degrees sq.'/10x,'Correlation of phi
     2 with lambda along ARG axis is indeterminate.')
    2 FORMAT(5x,3(g10.3,'(',g9.3,')',3X)/5x,3(g10.3,'(',g9.3,')',3X))
    3 FORMAT('  Components of <phi-t> along LOCAL axes;; first line
     1 radian-Angstrom, second line degree-Angstrom')
C		/10x, 'NO
C     2 OFFSET CORRECTION APPLIED to THMA values for <phi-tperp1>
C     3 and <phi-tperp2> in the LOCAL system')
    4 FORMAT(5x,3(g10.3,'(',g9.3,')',3X)/5x,3(g10.3,'(',g9.3,')',3X))
    5 FORMAT('  Motion about axis of ARG No.', i2,':',/45x,'RAD. Sq.',
     1 7x,'DEG. Sq.',6x,'DEG.'/2x,'<phi phi> + 2<phi lambda parallel>
     2:',4x,G15.5,4x,g10.3,4x,g7.2/5x,'L',35x,G15.5,4x,g10.3,4x,g7.2/
     3 2x,'Overall',32x,G15.5,4x,g10.3,4x,g7.2)
   56 FORMAT(' ', 'CORRELATIONS OF OVERALL AND INTERNAL MOTION ARE EXPRE
     1SSED IN A LOCAL REFERENCE SYSTEM FOR EACH GROUP.'/3X,'AXIS 1 IS PA
     2RALLEL TO THE LIBRATION AXIS OF THE GROUP, AXIS 2 IS IN THE DIRECT
     3ION OF MOTION OF FIRST ATOM OF GROUP,'/3X,'AND AXIS 3 IS NORMAL TO
     4 THE FIRST TWO (IN A RIGHT-HANDED SYSTEM).  PHI-LAMBDA CORRELATION
     5 PARALLEL TO THE TORSIONAL'/3X,'AXIS IS NOT SEPARABLE FROM PHI-PHI
     6.')
  663 format(/'  CHECK constraint on a(I,J)*<phi lambda(j)> for each
     1 ARG.  This sum should be 0.0000 for each ARG.'/3x,'This sum
     2 is also the contribution of <phi lambda> along the ARG axis.'/
     3 5x, I2, 5x, 'Sum = ', F8.5)
  664 format('  Contributions of <phi lambda> along other LOCAL axes
     1 for ARG No. ',i2,', in sq radians and sq degrees:'
     2 /5x,'Along PERP 1',2x, F8.5,5x,f8.2
     3 /5x, 'Along PERP 2', 2x, f8.5,5x,f8.2)
  665 format('  Contributions of <phi t> along the LOCAL axes,
     1 for ARG No. ',i2,', in radian-Angstrom:'
     2 /5x,'Along the ARG axis',2x, f8.5/5x,'Along PERP 1',
     3 2x, F8.5/5x, 'Along PERP 2', 2x, f8.5)
C
C ***  UNIT VECTORS FOR LOCAL AXIAL SYSTEM FOR EACH GROUP, I, WILL BE:
C ***   A(i,j) [= VEC1(I,J)]   VECTOR PARALLEL TO LIBRATION AXIS
C ***   B(i,j) [= VAF(I,J])]  VECTOR PARALLEL TO MOTION OF 1ST AFFECTED ATOM
C ***   C(i,j) [= PVEC(I,J)]   UNIT VECTOR NORMAL TO FIRST TWO
C ***    and all together are  ARGAX(i,j,k) (i = ARG no, j = axis, k=1,3)
C ***  VEC1 COMES FROM SUBR DERNOP, THE OTHER TWO FROM SUBR LOCAL
C ***     V5 COMES FROM SUBROUTINE DERP15, VIA COMMON/LOC/
C *** Note: After first 21 (or 12) L,T,S parameters, next 7 are those
C ***   for first ARG:  <phi phi> + 2<phi lamparallel> about ARG axis,
C ***   then correlns of internal motion with the MAIN libration
C ***   about the three CCS axes, then with translation about CCS axes
C
      Q = 3282.806
      NHP = NP1 + 1
C ***   NP1 = 21 or 12; NNP1 (set in SOLVE) = total no. of params
C ***      K IS TALLY FOR PARAMETER NUMBER
C ***  THUS K = NHP through NHP + 6 FOR 1ST N-R GROUP, and same MOD(7) for
C ***    subsequent ARGs.  For each ARG, 1 is <phi phi> + 2<phi lambda-
C ***    parallel> about ARG axis; 2,3,4 are <ova-lambda> along each CCS; 
C ***    5,6,7 are <phi-transl> along the CCS (crystal cartesian axes)
C ***  Parameters initially are in CCS system for each ARG; here they are
C ***    transformed to the LOCAL system for each ARG, for comparison with
C ***    earlier results and for possible convenience of user.
      do 3000 i = 1,nonrig
      do 3000 k = 1,3
      argax(i,1,k) = A(i,k)
      argax(i,2,k) = B(i,k)
      argax(i,3,k) = C(i,k)
 3000 continue
      print 56
C *** Calc, print sum of vec1(I,J)*<ova-lambda(J)> for each ARG (I)
C ***  and contributions of <ova-lambda> and <ova-t> along local axes
      DO 4117 KK = 1,NONRIG
      NHP = NP1 + 7*(KK-1) + 1
      I = NHP
      sumcon = 0.
      sump1 = 0.
      sump2 = 0.
      sumtpr = 0.
      sumtp1 = 0.
      sumtp2 = 0.
      do 4116 J = 1,3
      j3 = J + 3
      SUMCON = sumcon + a(KK,J)*P(I+J)
      SUmp1 = sump1 + B(KK,J)*P(I+J)
      SUMp2 = sump2 + c(KK,J)*P(I+J)
      SUMtpr = sumtpr + a(KK,J)*P(I+J3)
      SUMtp1 = sumtp1 + b(KK,J)*P(I+J3)
      SUMtp2 = sumtp2 + c(KK,J)*P(I+J3)
 4116 CONTINUE   
      WRITE(*,663) KK, sumcon
      sump1d = sump1*Q
      sump2d = sump2*Q
      write(*,664) kk, sump1,sump1d, sump2,sump2d
      write(*,665) kk, sumtpr, sumtp1, sumtp2
 4117 continue
      DO 115 I = 1,nonrig
      K = NP1 + 7*(I-1) + 1
C ***   Thus, I = serial no. of the ARG
C ***   Thus, J = no. of the parameter for EACH ARG
C ***     and K = program parameter number for each param in turn
C ***   Add overall MAIN rotn about ARG axis to that of ARG
      xbl = bllarg(i)/q
C ***   BLLARG(I) is in degrees sq (from OUTR13)
      If(bllarg(i).lt.0) then
          sqb = 0
          go to 1140
        else
          SQB = sqrt(bllarg(I))
        endif
 1140 xx = p(k) + xbl
      xxd = xx*q
      if(xxd.lt.0.) then
         sqxd = 0.
         go to 114
         else  
         sqxd = sqrt(xxd)
         endif
  114 pd = p(k)*q
      if(pd.lt.0.) then
         sqpd = 0.
         go to 116
         else  
         sqpd = sqrt(pd)
         endif
  116 PRINT 5, I, P(k), pd, sqpd, xbl, bllarg(i), sqb, xx, xxd, sqxd
  115 continue
      RETURN
      END
C
      SUBROUTINE TRIPLE(A,B,C,D)
C
      DIMENSION A(3,3),B(3,3),C(3,3),D(3,3)
      DO 1 I=1,3
      DO 1 J=1,3
      D(I,J)=0.
      DO 1 K=1,3
      DO 1 L=1,3
    1 D(I,J)=D(I,J)+A(I,K)*B(K,L)*C(L,J)
      RETURN
      END
      SUBROUTINE TRIPMA(MA1,MA2,MA3)
C
C     RESULTS OF TRIPMA IN COMMON// AIDX(2901-2909)
      COMMON//AIDX(3000)
      COMMON/SYM/SYMOP(23,3,3),TMAT(3,3),RTMAT(3,3),EPSIJK(3,3,3),
     1 SYML(3)
      DIMENSION B(3,3)
      EQUIVALENCE (AIDX(2901),B(1,1))
      DO 1 I=1,3
      DO 1 J=1,3
      B(I,J) = 0.
      DO 1 K=1,3
      DO 1 L=1,3
    1 B(I,J) = B(I,J) + SYMOP(MA1,I,K)*SYMOP(MA2,K,L)*SYMOP(MA3,L,J)
      RETURN
      END
      SUBROUTINE UCRYST
C ***   modified re agreement factors, 7.X.91
C     TRANSFORM UCALC TO CRYSTAL SYSTEM FROM CARTESIAN CRYSTAL SYSTEM
C        FOR OBLIQUE CRYSTAL AXES
C
      COMMON/AIDPAR/AX(150,3),AUOBS(150,6),AUCALC(150,6),WU(150,6),
     1  WU1(150,6)
      COMMON/ATPAR/X(150,3),WT(150),MULT(150),UOBS(150,6),SIGU(150,6),UC
     1ALC(150,6),NUORB(150),SIGB(150,6)
      COMMON//AIDX(3000)
      COMMON /CONT1/ISET,NO,NMULT,NA,ICOUNT,NINPAR,NPARS,NINOBS,NANG,NTO
     1T,NPULT,NA1,IFU,IB,NONRIG,NS,ISIG,ISYM,ICORL,IFU1,N8,
     2 IEIG,IMAT, IOUT,IRECAL, IFREQ
      COMMON/CONT2/NP1,NNP1,IORIG,IWU,INOPAR
      COMMON/CONT3/ISOLV,NTOTS,CONSLV,SUMW,RWUDI,RMS,RMU,gof,sumsig,
     1  iscm,msd8
      common/new/isigx,ETA, TK,I11, isigu,nafa(7),NONSY(7),AXMOM(7),
     1  NRBP(150),NCPD,NDAT,NESD, IBYP, IEXU, inegl
      COMMON/TMCSIS/TCIC(3,3),TCIU(3,3),TCINVC(3,3),TCINVU(3,3),SCG(3),
     1 OMIN(3,3), TROI(3,3), oma(3,3)
      DIMENSION AUCA(3,3),UCH(3,3),TTCNVU(3,3)
      DIMENSION TOMIN(3,3)
      EQUIVALENCE(AUCA(1,1),AIDX(2731)),(UCH(1,1),AIDX(2741))
      EQUIVALENCE(TTCNVU(1,1),AIDX(2751))
      EQUIVALENCE (TOMIN(1,1),AIDX(1923))
      EQUIVALENCE (RWU,AIDX(2897))
      real mult
C
      IF(NANG.NE.0) GO TO 5
      DO 8 I=1,NTOT
      DO 8 K=1,6
      UCALC(I,K) = AUCALC(I,K)
    8 CONTINUE
      RETURN
    5 WSUM = 0.
      SUM = 0.
      SUMOB = 0.
      sumdi = 0.
      sumobdi = 0.
      sdu = 0.
      sdg = 0.
      CALL TRAMA(OMIN,TOMIN)
      IF(I11.NE.0.AND.ISIG.LE.0) GO TO 30
      IF(I11.EQ.0.AND.ISIGU.LE.0) GO TO 30
      IF(IWU.EQ.1) GO TO 30
C     RECOVER WU CORRESPONDING TO INPUT SIGU FOR CALC RMS
      DO 25 I=1,NA
      DO 25 K=1,6
   25 WU(I,K) = WU1(I,K)
C ***  WU1 come from SUBROUTINE INERT, and = sumsig/sigb(i,k),
C ***    unless sigb input was zero, in which case wu1 set to zero
   30 DO 10 I = 1,NTOT
      CALL VEMA(AUCALC,AUCA,I)
      CALL TRIPLE(OMIN,AUCA,TOMIN,UCH)
      CALL MAVE(UCH,UCALC,I)
      IF(I.GT.NA)  GO TO 10
      IF(WT(I).EQ.800.0) GO TO 10
C ***   DON'T WANT TO INCLUDE DUMMY ATOMS IN CALC STATISTICS (ONLY
C ***     THOSE DUMMIES WITH WT 800.0 ARE IN FIRST NA ATOMS)
      DO 20 K = 1,6
      DELT = (UOBS(I,K) - UCALC(I,K))*WU(I,K)
      SUM = SUM + DELT * DELT
      WSUM = WSUM + WU(I,K)*WU(I,K)
      SUMOB = SUMOB +    ((UOBS(I,K))*WU(I,K))**2
      du = uobs(i,k) - ucalc(i,k)
      sdu = sdu + du*du
C ***   see comment above about WU1, which are equated to WU
      if(wu(i,k).eq.0.) go to 20
      if(sumsig.eq.0.) go to 19
      esd = sumsig/wu(i,k)
      sdg = sdg + (du/esd)**2
      if(k.gt.3) go to 20
   19 sumdi = sumdi + delt*delt
      sumobdi = sumobdi + (uobs(i,k)*wu(i,k))**2
   20 CONTINUE
   10 CONTINUE
C ***  next statement commented out 7.X.91
C      RMS = SQRT((SUM/(NINOBS-NINPAR))*FLOAT(6*(NA-N8))/WSUM)
      rms = sqrt(sdu/ninobs)
      if(isig.ne.0) gof = sqrt(sdg/(ninobs-ninpar))
      if(wsum.eq.0.or.sumob.eq.0.or.sumobdi.eq.0.) return
      RMU = SQRT(SUM/WSUM)
      RWU = SQRT(SUM/SUMOB)
      rwudi = sqrt(sumdi/sumobdi)
      RETURN
      END
      SUBROUTINE VECH(V,I,VH)
C
C     FIND INDIVIDUAL VECTOR (3 ELEMENTS) FROM AN ARRAY(150,3)
      DIMENSION V(150,3), VH(3)
      DO 10 K = 1,3
      VH(K) = V(I,K)
   10 CONTINUE
      RETURN
      END
      SUBROUTINE VEMA(V,A,I)
C
C     CONVERTS VECTOR (UOBS FOR EXAMPLE) TO SYMMETRICAL (3,3) MATRIX
      DIMENSION A(3,3),V(150,6)
      DO 10 K = 1,3
      A(K,K) = V(I,K)
   10 CONTINUE
      A(2,1) = V(I,4)
      A(3,1) = V(I,5)
      A(3,2) = V(I,6)
      A(1,2) = A(2,1)
      A(1,3) = A(3,1)
      A(2,3) = A(3,2)
      RETURN
      END
C
      SUBROUTINE VIBAMP
C *** Include provision for calculating MSDA table for ALL unique
C ***   interactions, not just those for the first 32 atoms (Nov 95)
C *** Include screening option for MSDA table (ISCM.ne.0), Oct 95
C ***    screened matrix output on UNIT 8, with other MSDA matrices
C  CALCULATES MEAN SQUARE DISPLACEMENT AMPLITUDES ('MSDA') IN DIRECTIONS
C        SPECIFIED BY PAIRS OF ATOMS INPUT ON LINES (7A), CONTROLLED BY
C        PARAMETER NVIB ON LINE (3), AND FOR SPECIFIED ATOMS IN SPECI-
C        FIED DIRECTIONS (LINES (7B)), CONTROLLED BY ICSVIB ON LINE (3)
C     WHEN NVIB.LT.0, CALCULATES DISPLACEMENT AMPLITUDES IN DIRECTIONS
C        CORRESPONDING TO THE VECTORS BETWEEN ALL PAIRS OF ATOMS
C        INCLUDED IN THE THERMAL ANALYSIS (AND FOR OTHER ATOMS INPUT IN
C        THE ASYMMETRIC UNIT AS WELL, EXCEPT ISOTROPIC ONES)
C
      COMMON// AIDX(3000)
      COMMON/AIDPAR/AX(150,3),AUOBS(150,6),AUCALC(150,6),WU(150,6),
     1  WU1(150,6)
      COMMON/AMPCLN/NVIB,ICSVIB,NVAT1(40),NVAT2(40),
     1 NCSVIB(10), DCOS(10,3)
      COMMON/AMPCLC/VBAT1(40),VBAT2(40),CSATNM(10,12)
      CHARACTER*4 CSATNM,VBAT1,VBAT2
      COMMON/ATPAR/X(150,3),WT(150),MULT(150),UOBS(150,6),SIGU(150,6),UC
     1ALC(150,6),NUORB(150),SIGB(150,6)
      COMMON /CONT1/ISET,NO,NMULT,NA,ICOUNT,NINPAR,NPARS,NINOBS,NANG,NTO
     1T,NPULT,NA1,IFU,IB,NONRIG,NS,ISIG,ISYM,ICORL,IFU1,N8,
     2  IEIG, IMAT, IOUT, IRECAL, IFREQ
      COMMON/CONT3/ISOLV,NTOTS,CONSLV,SUMW,RWUDI,RMS,RMU,gof,sumsig,
     1  iscm,msd8
      COMMON/CORDIN/ IRIDE, IMIN, IUNC, IHAT(150), NUNC(20),TUNC(20,3),
     1 TOR(3,3), XCG(3),IHPR
      COMMON/IAID1/ IAIDX1(1000)
      COMMON/INOUTN/ NPAGE, KOUTP,  DIS, IATWT
      COMMON/INOUTC/ NAME1, ATNAME(150),TISET(80),TITLE(80),ITBL(29),
     1 NAME2
      common/new/isigx,ETA, TK,I11, isigu,nafa(7),NONSY(7),AXMOM(7),
     1  NRBP(150),NCPD,NDAT,NESD, IBYP, IEXU, inegl
      DIMENSION DEL(3),AUO(3,3),V(3),MSV(31,31),ATOM(31),NPOS(31)
      dimension msv2(31,31), msv3(31,31),anam(32), iexc(150), LSTA(10)
      DIMENSION AUP(3,3), VV(3), WTT(150)
      EQUIVALENCE (WTT(1),AIDX(451))
      CHARACTER*4 NAME1,ATNAME,TISET*1,TITLE*1,ITBL*3, NAME2*5
      CHARACTER*4 ATOM,IBLANK,msv,MSV2, msv3, anam
      real mult
      DATA IBLANK/' '/
    1 FORMAT(1H ,'MEAN SQUARE DISPLACEMENT AMPLITUDES (MSDA) IN ANGSTROM
     1S SQUARED FOR ATOMS IN VARIOUS SPECIFIED DIRECTIONS. DIFF IS THE'/
     2'    MSDA FOR ATOM 2 MINUS THE MSDA FOR ATOM 1.',40x,'KEYMSD'/)
    2 FORMAT(1H ,'  DIRECTIONS DEFINED BY LINES BETWEEN SPECIFIED PAIRS
     1 OF ATOMS:',//,1H ,'ATOM',7X,'ATOM', 16X,
     2          'DIRECTION COSINES RELATIVE TO',8X,'MSDA FROM UOBS',
     3 8X,'SIGMA',8X,'MSDA FROM UCALC',/
     4 ,1H ,1X,' 1',4X,'POS.',2X,'2',4X,'POS.',4X,'DIST',4x,
     5 'CARTESIAN CRYSTAL AXES',7X,'ATOM 1', 3X,'ATOM 2',3X,'DIFF',5X,
     6 'DIFF',6X,'ATOM 1',3X,'ATOM 2',3X,'DIFF',/)
    3 FORMAT(1H ,1X,A4,2X,I2,3X,A4,2X,I2,3X,f6.3,2x,3(F8.5,2X),3X,
     1 3(F6.4,3X),F6.4,3X,3(F6.4,3X))
    4 FORMAT(' ',//,1H ,'  DIRECTIONS DEFINED BY DIRECTION COSINES INPUT
     1:',//,1H ,14X,'DIRECTION COSINES RELATIVE TO',19X,'MSDA FROM',4X,
     2 'MSDA FROM'/,1H ,2X,'NO.',12X,'CARTESIAN CRYSTAL AXES',15X,
     3 'ATOM',7X,'UOBS',8X,'UCALC')
    5 FORMAT(' ',I4,10X,3(F8.5,2X))
    6 FORMAT(' ',54X,A4,6X,2(F6.4,7X))
    7 FORMAT(1H ,54X,A4,6X,2(F6.4,7X))
    8 FORMAT(' ',2X,'AVE. DIFF =',F10.4,/' ',2X,'R.M.S. DIFF =', F8.4)
    9 FORMAT(' ',2X,'THE SUM OF THE SQUARES OF (DIFF/SIGMA) FOR ATOM PAI
     *RS FOR WHICH NEITHER ATOM HAS NEG WT OR WT 800.0 OR 999.9 IS:',
     1                               F10.2,/' ',4X, 'SIGMA HERE IS THE E
     2.S.D. OF DIFFERENCE IN MSDA FOR THE TWO ATOMS IN EACH PAIR.',/
     3 ' ',4X,'THE TOTAL NUMBER OF ATOM PAIRS (NOT INCLUDING ANY WITH AN
     4 ATOM OF WT 800.0, 999.9 OR NEGATIVE) IS', I6)
   10 FORMAT(' MATRIX OF DIFFS OF OBS MSDA. VALUE LISTED IS 10000*MSDA F
     1OR COLUMN ATOM MINUS THAT FOR ROW ATOM, ALONG LINE BETWEEN THEM'
     2 //' ATOM->',31A4)
   11 FORMAT(' ',A4,1X,31a4)
   12 FORMAT(1H ,'POSN->',31(I2,2X))
   13 FORMAT(' ',2x,'AVE. DIFF. FOR BONDED ATOMS (distance <',F6.2,'), 
     1  NOT including any pairs involving H atoms,  =
     2',F10.4,/' ',5X,'R.M.S. DIFF =',F8.4/
     3  6x,'and for X-H pairs, not including H..H, AVE DIFF =',
     4  F10.4,/' ',10X,'and R.M.S. DIFF =',F8.4/)
   14 FORMAT(//' MATRIX OF DIFFS OF OBS MSDA. VALUES FOR BONDED ATOMS'
     1//' ATOM->',31A4)
   15 FORMAT(//' MATRIX OF DIFFS OF OBS MSDA AFTER SCREENING VALUES 
     1 SMALLER THAN 2.5x ESTIMATED SIGMA of DIFF'//' ATOM->',31A4)
   16 format(i4)
   17 FORMAT(80a1)
   18 FORMAT(//'  *NOTE: TABLE MAY CONTAIN DUPLICATES BECAUSE OF
     1 SYMMETRY!'/)
   19 FORMAT('  ATOMS ',A4,',',I2,'   AND ',A4,',',I2,'   ARE AT SAME 
     1 POSITION, SO MEANINGLESS TO CALCULATE MSDA ALONG THE'/5X,
     2 'VECTOR BETWEEN THEM')
   21 format('  Mean esd of Uii input as ',i4,';  3.5 times this is '
     1,i4,', which is about 2.5 times the mean esd of a difference'/
     2 5x,'of MSDA terms, significant at about the 1% level.')
  113 FORMAT(' ',2x,'AVE. DIFF. FOR BONDED ATOMS (distance <',F6.2,
     1  ') =',F10.4/' ',5X,'R.M.S. DIFF =',F8.4/)
C
      IF(NVIB.EQ.0) GO TO 100
      INDIC = 0
      CHI = 0.0
      SDOBS = 0.0
      SDSQ = 0.0
      bdobs = 0.0
      bdobsq = 0.0
      lb = 0
      lbh = 0
      bdhobs = 0.0
      bdhobsq = 0.0
C *** SET SIGDF.EQ.0; OTHERWISE LAST VALUE FROM PRECEDING STRUCTURE
C        PRINTED WHEN ISIG.LE.0
      SIGDF = 0.0
      IF(iscm.eq.0) go to 22
C ***  use 3.5 times the mean esd of Uii, or about 2.5x esd of MSDA diff
C ***     as screening value.  Input ISCM as approx mean esd of Uii
      scm = 3.5*iscm
      jscm = scm
   22 IF(iexu.eq.0.and.NS.GE.0.AND.NVIB.LE.-2) PRINT 2
      IF(NVIB.LT.0) GO TO 200
      PRINT 2
      DO 80 I = 1,NVIB
      DO 20 K = 1,NTOT
      IF(VBAT1(I).EQ.ATNAME(K)) then
         if(NVAT1(I).eq.1) I1 = K
         if(NVAT1(I).GT.1)  I1 = K + NTOT + NA*(NVAT1(I) - 2)
         endif
      IF(VBAT2(I).EQ.ATNAME(K)) then
         if(NVAT2(I).eq.1) I2 = K
         if(NVAT2(I).GT.1)  I2 = K + NTOT + NA*(NVAT2(I) - 2)
         endif
   20 CONTINUE
      XL2 = 0.0
      DO 30 J = 1,3
      DEL(J) = AX(I2,J) - AX(I1,J)
      XL2 = XL2 + DEL(J)*DEL(J)
   30 CONTINUE
      if(xl2.ne.0.) go to 35
C ***  ASKING FOR MSDA BETWEEN ATOMS AT SAME POSITION
      INDIC = 1
      print 19, VBAT1(I), NVAT1(I), VBAT2(I), NVAT2(I)
      GO TO 41
   35 XL2 = SQRT(XL2)
      DO 40 K = 1,3
      V(K) = DEL(K)/XL2
   40 CONTINUE
   41 CALL VEMA(AUOBS,AUO,I1)
      CALL VMAV(AUO,V,SVO1)
      CALL VEMA(AUOBS,AUO,I2)
      CALL VMAV(AUO,V,SVO2)
      DOBS = SVO1 - SVO2
  255 IF(WTT(I1).EQ.800.0.OR.WTT(I2).EQ.800.0.OR.WTT(I1).EQ.999.9.OR.WTT
     1(I2).EQ.999.9.OR.WTT(I1).LT.0.0.OR.WTT(I2).LT.0.0) GO TO 280
C   SET MSDA DIFFS FOR PAIRS INVOLVING DUMMY ATOMS (WTS 800.0 OR 999.9)
C     OR ATOMS WITH NEG WT (INCL ISOTROPIC ATOMS) ARBITRARILY TO 0.0
C     AND DO NOT INCLUDE SUCH PAIRS IN STATISTICS
C   HOWEVER, MSDA VALUES WILL BE PRINTED IN CASE SOME DUMMY ATOMS WERE
C     USED FOR SPECIAL PURPOSES
      SDOBS = SDOBS + ABS(DOBS)
      SDSQ = SDSQ + DOBS*DOBS
C ***   IF ISIG IS POSITIVE, SIGMAS OF U'S INPUT
      IF(ISIG.LE.0) GO TO 50
C ***   IF ISIG = NTOT, SIGU INPUT FOR ALL ATOMS INPUT.  HOWEVER, IF
C          NA IS LESS THAN NTOT AND ISIG = NA, THEN NO SIGU INPUT FOR
C          THE (NTOT - NA) ATOMS NOT INCLUDED IN THE ANALYSIS.  THESE
C          ATOMS MUST THUS BE OMITTED IN 'CHI SQUARED' CALCULATION.
      IF(ISIG.EQ.NTOT) GO TO 290
      IF(NA.EQ.NTOT) GO TO 290
      IF(I1.GT.NA.AND.I1.LE.NTOT) GO TO 280
      IF(I2.GT.NA.AND.I2.LE.NTOT) GO TO 280
      GO TO 290
  280 SIGDF = 0.0
      GO TO 50
C *** CALCULATE E.S.D. OF DIFF. OF MSDA'S ('SIGDF') IGNORING COVARIANCE
  290 CALL VEMA(SIGU,AUO,I1)
      CALL VEMA(SIGU,AUP,I2)
      DO 300 II = 1,3
      DO 300 JJ = 1,3
  300 AUO(II,JJ) = 2.*(AUO(II,JJ)*AUO(II,JJ) + AUP(II,JJ)*AUP(II,JJ))
      DO 302 II = 1,3
  302 AUO(II,II) = 0.5*AUO(II,II)
C *** ELEMENTS OF AUO NOW CONTAIN THE SUM OF SIGMA SQUARED FOR CORRESP.
C     ELEMENTS OF U FOR THE ATOMS IN THE BOND, WITH AN ADDITIONAL FACTOR
C     OF TWO WITH THE CROSS-TERMS BECAUSE COVAR(IJ,JI) = 1.
      DO 310 II = 1,3
  310 VV(II) = V(II)*V(II)
      CALL VMAV(AUO,VV,SIGDF)
      SIGDF = SQRT(SIGDF)
C *** ASSUME SIGMAS OF SYM-EQUIVALENT U'S INPUT WITH SAME VALUE AS THE
C       SIGMA OF THE CORRESPONDING UNIQUE U
      IF(SIGDF.EQ.0.) GO TO 50
      CHI = CHI + (DOBS/SIGDF)**2
C *** CANNOT CALCULATE MSDA FROM UCALC FOR ATOMS OUTSIDE THE ASYM. UNIT
C          INPUT SINCE AUCALC NOT EVALUATED FOR SUCH ATOMS (SEE CALCUS).
   50 IF(NVAT1(I).GT.1.OR.NVAT2(I).GT.1) GO TO 60
C ***  NVAT1 AND NVAT2 ARE EQUIV POSNS FOR INPUT ATOMS WHEN NVIB.GT.0
      CALL VEMA(AUCALC,AUO,I1)
      CALL VMAV(AUO,V,SVC1)
      CALL VEMA(AUCALC,AUO,I2)
      CALL VMAV(AUO,V,SVC2)
      DCAL = SVC1 - SVC2
      PRINT 3,VBAT1(I),NVAT1(I),VBAT2(I),NVAT2(I),XL2,(V(K),K=1,3),
     1 SVO1,SVO2,DOBS,SIGDF,SVC1,SVC2,DCAL
      GO TO 80
   60 PRINT 3,VBAT1(I),NVAT1(I),VBAT2(I),NVAT2(I),XL2,(V(K),K=1,3),
     1 SVO1,SVO2,DOBS,SIGDF
   80 CONTINUE
      DNV = NVIB
      AVE = SDOBS/DNV
      RMSD = SQRT(SDSQ/DNV)
      PRINT 8, AVE, RMSD
      PRINT 9, CHI , NVIB
  100 IF(ICSVIB.EQ.0) RETURN
      IF(NVIB.GT.10) CALL OUTH6
      PRINT 1
      PRINT 4
      NT = 0
      DO 150 I = 1,ICSVIB
      DO 110 K = 1,3
  110 V(K) = DCOS(I,K)
      L = NCSVIB(I)
      NT = NT + L
C ***     NT IS TALLY FOR PAGINATION
      IF(NT.LE.40) GO TO 115
      CALL OUTH6
      PRINT 4
      NT = 0
  115 PRINT 5,I,(V(K), K = 1,3)
      DO 150 J = 1,L
      DO 120 K = 1,NTOT
      IF(CSATNM(I,J).EQ.ATNAME(K)) I1 = K
  120 CONTINUE
      CALL VEMA(AUOBS,AUO,I1)
      CALL VMAV(AUO,V,SVO1)
      CALL VEMA(AUCALC,AUO,I1)
      CALL VMAV(AUO,V,SVC1)
      IF(J.EQ.1) GO TO 140
      PRINT 7,CSATNM(I,J),SVO1,SVC1
      GO TO 150
  140 PRINT 6,CSATNM(I,J),SVO1,SVC1
  150 CONTINUE
      RETURN
  200 K = NA - N8
      IF(NO.EQ.1) K = K - 1
C ***  K then is no of unique atoms TO BE USED IN THE MATRIX, or 1 less 
C ***    if no symmetry; NO OF ROWS is NA-N8, or (NA - N8 -1), and atoms
C ***    not to be used are always sorted to the end of the unique pack.
      NT = 0
      NTT = 0
      IREFT = 0
      DO 205 I = 1,NTOTS
      iexc(I) = 0
      IF(WTT(I).NE.800.0.AND.WTT(I).NE.999.9.AND.WTT(I).GE.0.0) GOTO 204
C ***   ISOTROPIC ATOMS AND ATOMS WITH WTS 800., 999.9 OR NEGATIVE WILL BE
C ***     SKIPPED IN FORMING MSDA MATRIX. (ISOTROPIC made neg by XASIGN).
      iexc(I) = 1
  204 IF(uobs(I,2).ne.0.0) go to 205
      iexc(i) = 1
  205 CONTINUE
      LREF0 = (NA-N8)*NMULT - 1
 3250 I0 = 0
      LREF1 = LREF0
      nset = 1
 3235 LREF1 = LREF1 - 31
      IF(LREF1.LE.0) THEN
         LREF1 = LREF1 + 31
        ELSE
         NSET = NSET + 1
         go to 3235
        endif
C ***  NSET is the number of matrices of any GIVEN kind (all MSDA, screened, ..)
C ***      to be printed in the first row of matrices
      LSTA(NSET) = 1
C ***  LREF1 is the number of cols printed in first matrix of any cycle
C ***     It is the same for ANY row-cycle
C ***  LREF is the number of cols to be printed in ANY matrix of cycle
C ***      IT IS 31 AFTER FIRST MATRICES PRINTED IF > 32 ATOMS, unless
C ***      matrix is diagonal, when LREF is decreased by 1 after each row
C ***  LSTA(I) is ONE LESS than the starting value of L for Ith matrix in 
C ***     any row-cycle (up to 31 rows, and all columns).  
      IF(NSET.EQ.1) GO TO 3805
      J = 1
      NCT = 0
      LR = LREF1
      do 3800 KI = 1,NTOTS
      I = NTOTS - KI + 1
        IF(IEXC(I).EQ.1)  GO TO 3800
        NCT = NCT + 1
        IF(NCT.LE.LR)  then
            GO TO 3800
          else
            LSTA(J) = I
          endif
        IF(J.EQ.NSET) GO TO 3805
        J = J + 1
        LR = 31
        NCT = 1
 3800 CONTINUE
 3805 CONTINUE
      IREFN = K
 3225 IREFN = IREFN - 31
      IF(IREFN.LE.0) THEN
         IREFN = IREFN + 31
        ELSE
         go to 3225
        endif
C ***   IREFN IS NOW THE NO OF ROWS IN LAST ROW-CYCLE TO BE PRINTED
      NIR = 0
C ***    NIR IS TALLY OF TOTAL ROWS PRINTED 
 3260 CONTINUE
      LREF = LREF1
      IREFT = IREFT + 31
      IREF = 31
      if(IREFT.gt.k) IREF = IREFN
      IRECT = 1
      if(LREF0.le.32) irect = 0
      LST = LSTA(1)
      I = I0
      MM = 1
 1200 DO 201 II = 1,31
      anam(II) = iblank 
      atom(II) = iblank
      NPOS(II) = 0
      DO 201 J = 1,31
      msv(ii,J) = iblank
      msv2(ii,j) = IBLANK
      msv3(ii,j) = IBLANK
  201 CONTINUE
C ***   IR IS TALLY FOR ROW ATOMS, LC FOR COLUMN ATOMS FOR MSDA MATRIX
C ***   Don't confuse POSITION tallies with ATOM tallies (I,L)
      IR = 0
C ***    NI is equiv posn for first atom, NEVER changed from 1, but
C ***      it is used in PRINT 3 (below), and FORMAT 3 is also used for
C ***      printing eq posn when NVIB positive (2nd position, now I2)
      NI = 1
C ***  I is running index for first atom being considered; for each
C ***    first atom, run through all (NTOTS if NO.GT.1) others (L)
  250 I=I+1
C ***   LST is starting value of L for a given matrix WITHIN a row cycle
C ***   IRECT eq 0 when doing next a diagonal matrix
      if((LST-I0).LE.31) irect = 0
      IF((I-1).GT.NTOT) GO TO 252
C *** SKIP DUMMY ATOMS AND ATOMS WITH NEG WT IN FORMING MSDA MATRIX
C ***     SKIP  ISOTROPIC ATOMS  FOR LISTING AS WELL
      IF(UOBS(I,2).EQ.0.) GO TO 250
      IF(WTT(I).EQ.800.0.OR.WTT(I).EQ.999.9.OR.WTT(I).LT.0.0) then
           if(nvib.eq.-1) go to 250
           GOTO 4250
         endif
      IR = IR + 1
      if(irect.eq.0.and.ir.GT.1) lref = lref - 1
      if(IR.gt.IREF) then
          I = I - 1
          go to 2252
        ENDIF
      IF(IRECT.EQ.0) nir = nir + 1
      if(NIR.GT.NA) GO TO 252
C ***  When doing a diagonal part, start with column atom (L) one more
C ***    than row atom (I) and increase it by one for each new row, but
C ***    when doing a rectangular part, do not increase col atom start
C ***    when change row atom
 4250 if(IRECT.eq.0) go to 2250
      L = LST
      LC = 0
      GO TO 251
 2250 L=I 
      LC = 0
  251 L=L+1
      if(iexc(L).eq.1) go to 251
      LN = LREF
  256 dobs = 0.0
C ***  Clear DOBS so when atoms skipped, prev value not saved
      if(LC.GE.LREF) go to 250
      IF(L.GT.NTOTS) GO TO 250
      IF(WTT(I).EQ.800.0.OR.WTT(I).EQ.999.9.OR.WTT(I).LT.0.0) then
C           if(uobs(i,2).eq.0) go to 250
           if(nvib.eq.-1) go to 251
           GOTO 2251
         endif
C ***  SKIP ISOTROPIC ATOMS FOR EVERYTHING, AND SKIP OTHERS WITH NEG
C         WT AND DUMMY ATOMS FOR MATRIX  (use them in printing LIST)
      LC = LC + 1
 2251 XL2 = 0.0
      DO 210 J = 1,3
      DEL(J) = AX(I,J) - AX(L,J)
      XL2 = XL2 + DEL(J)*DEL(J)
  210 CONTINUE
C *** OMIT CALCULATION WHEN ATOM LIES ON SYMMETRY ELEMENT.
C ***   (FOR EQUIV ATOMS LYING ON A SYM ELEMENT, XL2 WILL BE 0.0)
      IF(XL2.EQ.0.) GO TO 225
      XL2 = SQRT(XL2)
      DO 215 J = 1,3
      V(J) = DEL(J)/XL2
  215 CONTINUE
      CALL VEMA(AUOBS,AUO,I)
      CALL VMAV(AUO,V,SVO1)
      CALL VEMA(AUOBS,AUO,L)
      CALL VMAV(AUO,V,SVO2)
      DOBS = SVO2 - SVO1
      IF(WTT(I).EQ.800.0.OR.WTT(I).EQ.999.9.OR.WTT(I).LT.0.0) GOTO 225
      IF(WTT(L).EQ.800.0.OR.WTT(L).EQ.999.9.OR.WTT(L).LT.0.0) GOTO 225
      IF(IR.GT.31.OR.LC.GT.32) GO TO 225
C     DIFFS OF OBS MSDA IN 31 BY 31 MATRIX (FOR UP TO 32 ATOMS).
C     COLUMNS (LL) ARRAYED IN DESCENDING ORDER
      LL = LN - LC + 1
C ***  SAVE ATOM NAME FOR ROW
      ANAM(IR) = ATNAME(I)
      IF(DOBS.LT.0) GOTO 218
      mobs =(DOBS + 0.00005)*(1.E4)
C ***  For an IBM machine, the leading C should be removed from the following 
C ***    commented line, and the "encode" statement commented out (or deleted)
      write(unit=MSV(IR,LL),FMT=16) mobs
C      encode(4,16,MSV(IR,LL)) mobs
      if(xl2.le.dis) msv2(ir,ll) = msv(ir,ll)
      if(iscm.eq.0) go to 225
      mobsab = iabs(mobs)
      if(mobsab.gt.jscm) msv3(ir,ll) = msv(ir,ll)
      GOTO 225
  218 mobs =(DOBS - .00005)*1.E4
C ***  For an IBM machine, the leading C should be removed from the following 
C ***    commented line, and the "encode" statement commented out (or deleted)
      write(unit=MSV(IR,LL),FMT=16) mobs
C      encode(4,16,MSV(IR,LL)) mobs
      if(xl2.le.dis) msv2(ir,ll) = msv(ir,ll)
      if(iscm.eq.0) go to 225
      mobsab = iabs(mobs)
      if(mobsab.gt.jscm) msv3(ir,ll) = msv(ir,ll)
  225 if(IEXC(L).EQ.1) GO TO 251
C ***  previous line new 13.XII.95 (next line WAS 225)
      IF(L.GT.NTOT) GO TO 230
      NL = 1
      KL = L
      GO TO 235
  230 NL = (L - NTOT - 1)/NA + 2
      KL = L - NTOT - NA*(NL - 2)
  235 IF(LC.GT.32.OR.I.GT.(I0 + 1)) GO TO 236
      IF(WTT(KL).EQ.800.0.OR.WTT(KL).EQ.999.9.OR.WTT(KL).LT.0.0)GOTO 236
      KK = LREF
      j = KK + 1 - LC
C ***   J IS NOW THE INDEX FOR LABELLING COLS ACROSS TOP OF MATRIX
      ATOM(J) = ATNAME(KL)
      NPOS(J) = NL
  236 IF(I.GT.NA.OR.L.GT.NA) GO TO 238
      CALL VEMA(AUCALC,AUO,I)
      CALL VMAV(AUO,V,SVC1)
      CALL VEMA(AUCALC,AUO,L)
      CALL VMAV(AUO,V,SVC2)
      DCAL = ABS(SVC2 - SVC1)
  238 I1 = I
      I2 = L
      IF(WTT(I1).EQ.800.0.OR.WTT(I2).EQ.800.0.OR.WTT(I1).EQ.999.9.OR.WTT
     1(I2).EQ.999.9.OR.WTT(I1).LT.0.0.OR.WTT(I2).LT.0.0) GO TO 1280
C   SET MSDA DIFFS FOR PAIRS INVOLVING DUMMY ATOMS (WTS 800.0 OR 999.9)
C     OR ATOMS WITH NEG WT (INCL ISOTROPIC ATOMS) ARBITRARILY TO 0.0
C     AND DO NOT INCLUDE SUCH PAIRS IN STATISTICS
C   HOWEVER, MSDA VALUES WILL BE PRINTED IN CASE SOME DUMMY ATOMS WERE
C     USED FOR SPECIAL PURPOSES
      if(xl2.gt.dis) go to 2388
      if(ihat(i1).ne.0.or.ihat(i2).ne.0) go to 2386
      bdobs = bdobs + abs(dobs)
      bdobsq = bdobsq + dobs*dobs
      lb = lb+1
      go to 2388
 2386 if(ihat(i1).ne.0.and.ihat(i2).ne.0) go to 2388
C ***   don't include H..H distances in the X-H sums
      bdhobs = bdhobs + abs(dobs)
      bdhobsq = bdhobsq + dobs*dobs
      lbh = lbh + 1
 2388 SDOBS = SDOBS + ABS(DOBS)
      SDSQ = SDSQ + DOBS*DOBS
C ***   IF ISIG IS POSITIVE, SIGMAS OF U'S INPUT
      IF(ISIG.LE.0) GO TO 260
C ***   IF ISIG = NTOT, SIGU INPUT FOR ALL ATOMS INPUT.  HOWEVER, IF
C          NA IS LESS THAN NTOT AND ISIG = NA, THEN NO SIGU INPUT FOR
C          THE (NTOT - NA) ATOMS NOT INCLUDED IN THE ANALYSIS.  THESE
C          ATOMS MUST THUS BE OMITTED IN 'CHI SQUARED' CALCULATION.
      IF(ISIG.EQ.NTOT) GO TO 1290
      IF(NA.EQ.NTOT) GO TO 1290
      IF(I1.GT.NA.AND.I1.LE.NTOT) GO TO 1280
      IF(I2.GT.NA.AND.I2.LE.NTOT) GO TO 1280
      GO TO 1290
 1280 SIGDF = 0.0
      GO TO 260
C *** CALCULATE E.S.D. OF DIFF. OF MSDA'S ('SIGDF') IGNORING COVARIANCE
 1290 CALL VEMA(SIGU,AUO,I1)
      CALL VEMA(SIGU,AUP,I2)
      DO 1300 II = 1,3
      DO 1300 JJ = 1,3
 1300 AUO(II,JJ) = 2.*(AUO(II,JJ)*AUO(II,JJ) + AUP(II,JJ)*AUP(II,JJ))
      DO 1302 II = 1,3
 1302 AUO(II,II) = 0.5*AUO(II,II)
C *** ELEMENTS OF AUO NOW CONTAIN THE SUM OF SIGMA SQUARED FOR CORRESP.
C     ELEMENTS OF U FOR THE ATOMS IN THE BOND, WITH AN ADDITIONAL FACTOR
C     OF TWO WITH THE CROSS-TERMS BECAUSE COVAR(IJ,JI) = 1.
      DO 1310 II = 1,3
 1310 VV(II) = V(II)*V(II)
      CALL VMAV(AUO,VV,SIGDF)
      SIGDF = SQRT(SIGDF)
C *** ASSUME SIGMAS OF SYM-EQUIVALENT U'S INPUT WITH SAME VALUE AS THE
C       SIGMA OF THE CORRESPONDING UNIQUE U
      IF(SIGDF.EQ.0.) GO TO 260
      CHI = CHI + (DOBS/SIGDF)**2
  260 IF(I.GT.NA.OR.L.GT.NA) GO TO 240
C ***** Do not print values for vectors with distance zero  EFM 3/91
C *** 10.IV.87 COMPLETE MSDA DIFF LIST PRINTED NOW ONLY IF NVIB.LE.-2
      IF(iexu.eq.1.or.NS.LT.0.OR.NVIB.GE.-1.or.xl2.eq.0.) GO TO 245
      PRINT 3,ATNAME(I), NI,ATNAME(KL),NL,XL2,(V(J),J=1,3),SVO1,SVO2,
     1 DOBS,SIGDF,SVC1,SVC2,DCAL
      GO TO 245
  240 IF(IEXU.EQ.1.OR.NS.LT.0.OR.NVIB.GE.-1.or.xl2.eq.0.) GO TO 245
      PRINT 3, ATNAME(I), NI,ATNAME(KL),NL,XL2,(V(J),J=1,3),SVO1,SVO2,
     1 DOBS,SIGDF
  245 XW1 = WTT(I1)
      XW2 = WTT(I2)
      IF(XW1.NE.800.0.AND.XW2.NE.800.0.AND.XW1.NE.999.9.AND.XW2.NE.999.9
     1.AND.XW1.GE.0.AND.XW2.GE.0.and.xl2.gt.0.) NTT = NTT + 1
      NT = NT + 1
C ***   NT IS A TALLY FOR PAGINATION
      IF(NT.LE.49) GO TO 251
      NT = 0
      IF(IEXU.EQ.1.OR.NS.LT.0.OR.NVIB.GE.-1) GO TO 251
      CALL OUTH6
      PRINT 2
      GO to 251
 2252 CALL OUTH6
      PRINT 10, (ATOM(J), J = 1,KK)
      PRINT 12, (NPOS(J), J = 1,KK)
      if(msd8.ne.0) WRITE(8,10) (ATOM(J), J = 1,KK)
      if(msd8.ne.0) WRITE(8,12) (NPOS(J), J = 1,KK)
C     THIS PRINTS HEADING FOR MSV MATRIX, COLUMNS IN DESCENDING ORDER
C ***  max no of rows to be printed at a given time is IREF (.LE.31)
C ***      IREF is 31(n + 1), where n is no. of row cycles completed
C ***		-- i.e., 31 during first cycle, 62 during 2nd, ...
C ***           until LAST row cycle, when it is IREFN
      KL = IREF
      IF(IRECT.EQ.0) GO TO 268
C ***  this branch is for rectangular matrices
      DO 270 II = 1,KL
      if(msd8.ne.0) WRITE(8,11) Anam(II),(msv(ii,J), J = 1,KK)
  270 PRINT 11, anam(II),(msv(ii,J), J = 1,KK)
      go to 4260
  268 KJ = KK + 1
      DO 275 II = 1,KL
      KJ = KJ - 1
      if(msd8.ne.0) WRITE(8,11) anam(II),(msv(ii,J), J = 1,KJ)
  275 PRINT 11, anam(II),(msv(ii,J), J = 1,KJ)
 4260 call outh6
      PRINT 14, (ATOM(J), J = 1,KK)
      PRINT 12, (NPOS(J), J = 1,KK)
      if(msd8.ne.0) WRITE(8,14) (ATOM(J), J = 1,KK)
      if(msd8.ne.0) WRITE(8,12) (NPOS(J), J = 1,KK)
C     THIS PRINTS HEADING FOR MSV2 MATRIX, COLUMNS IN DESCENDING ORDER
      IF(IRECT.EQ.0) GO TO 3710
C ***  this branch is for rectangular matrices of bonded pairs
      DO 2700 II = 1,KL
      if(msd8.ne.0) WRITE(8,11) anam(II),(msv2(ii,J), J = 1,KK)
 2700 PRINT 11, anam(II),(msv2(ii,J), J = 1,KK)
      go to 2750
 3710 KJ = KK + 1
      DO 2720 II = 1,KL
      KJ = KJ - 1
      if(msd8.ne.0) WRITE(8,11) anam(II),(msv2(ii,J), J = 1,KJ)
 2720 PRINT 11, anam(II),(msv2(ii,J), J = 1,KJ)
 2750 if(no.gt.1.AND.msd8.ne.0) WRITE(8,18)
      if(no.gt.1) PRINT 18
      if(iscm.eq.0) go to 2710
      PRINT 15, (ATOM(J), J = 1,KK)
      PRINT 12, (NPOS(J), J = 1,KK)
      if(msd8.ne.0) WRITE(8,15) (ATOM(J), J = 1,KK)
      if(msd8.ne.0) WRITE(8,12) (NPOS(J), J = 1,KK)
C     THIS PRINTS HEADING FOR MSV3 MATRIX, COLUMNS IN DESCENDING ORDER
      IF(IRECT.EQ.0) GO TO 2850
C ***  this branch is for screened rectangular matrices
      DO 2705 II = 1,kl
      if(msd8.ne.0) WRITE(8,11) anam(II),(msv3(ii,J), J = 1,KK)
 2705 PRINT 11, anam(II),(msv3(ii,J), J = 1,KK)
      go to 2880
 2850 kj = KK + 1
      do 2870 ii = 1,kl
      KJ = KJ - 1
      if(msd8.ne.0) WRITE(8,11) anam(II),(msv3(ii,J), J = 1,KJ)
 2870 PRINT 11, anam(II),(msv3(ii,J), J = 1,KJ)
 2880 print 21, iscm, jscm
      if(msd8.ne.0) write(8,21) iscm, jscm
 2710 IF(IRECT.EQ.0) THEN
          I0 = I0 + 31
          LREF0 = LREF0 - 31
          IF(LREF0.LE.0) LREF0 = LREF0 + 31
          go to 3260
        else
        LREF = 31
         I = I0
       ENDIF
      MM = MM + 1
      LST = LSTA(MM)
      IF(LST.LT.32) IRECT = 0
      go to 1200
  252 DNTT = NTT
      if(dntt.ne.0) AVE = SDOBS/DNTT
      if(dntt.ne.0) RMSD = SQRT(SDSQ/DNTT)
      dlb=lb
      IF(LB.NE.0) THEN 
          aveb= bdobs/dlb
          rmsb=sqrt(bdobsq/dlb)
        ENDIF
      dlbh = lbh
      IF(LBH.NE.0) THEN
          avebh = bdhobs/dlbh
          rmsbh = sqrt(bdhobsq/dlbh)
        ENDIF
      if(msd8.ne.0) WRITE(8,8)AVE, RMSD
      if(msd8.ne.0) WRITE(8,9)CHI, NTT
      PRINT 8, AVE,RMSD
      PRINT 9, CHI, NTT
      IF(LBH.NE.0) THEN
          if(msd8.ne.0) WRITE(8,13) DIS, AVEB, RMSB, avebh, rmsbh
          Print 13, dis,aveb,rmsb, avebh, rmsbh
        ELSE
          if(msd8.ne.0) WRITE(8,113) DIS, AVEB, RMSB
          Print 113, dis,aveb,rmsb 
        endif
C ***   NOW SET NVIB = 11 SO GET NEW PAGE IF ICSVIB.NE.0 (SEE AFTER 100)
 2711 if(icsvib.ne.0)  NVIB = 11
      GO TO 100
      END
C
      SUBROUTINE VMAV(A,V,B)
C
C     MULTIPLIES 3X3 MATRIX (A) BY VECTORS (V) TO GET SCALAR (B), FOR
C       EXAMPLE, IN CALCULATING A MEAN SQ. VIB. AMP. IN A GIVEN DIREC-
C       TION.  USED IN SUBROUTINE VIBAMP
C
      DIMENSION A(3,3), V(3)
      B = 0.0
      DO 10  I = 1,3
      DO 10  J = 1,3
      B = B + V(I)*A(I,J)*V(J)
   10 CONTINUE
      RETURN
      END
C
      SUBROUTINE VMLT(V,A)
C
C     CONVERTS L AND T FROM VECTOR FORM TO SYMMETRICAL ARRAYS
C     SEQUENCE OF L AND T VECTORS L11,L12,L13,L22,L23,L33....
C
      DIMENSION A(3,3), V(6)
      L = 0
      DO 10 I = 1,3
      DO 10 K = I,3
      L = L + 1
      A(I,K) = V(L)
      A(K,I) = V(L)
   10 CONTINUE
      RETURN
      END
      SUBROUTINE WEIGHT(NSIG)
C
C     SET WORKING WEIGHTS WU(I,K) = SUMSIG/SIGU(I,K), IF SIGMAS OF U
C     WERE INPUT (SUMSIG = MEAN ESD OF U, CALCD IN MAIN, 145-175)
C
      COMMON/AIDPAR/AX(150,3),AUOBS(150,6),AUCALC(150,6),WU(150,6),
     1  WU1(150,6)
      COMMON/ATPAR/X(150,3),WT(150),MULT(150),UOBS(150,6),SIGU(150,6),UC
     1ALC(150,6),NUORB(150),SIGB(150,6)
      COMMON//AIDX(3000)
      COMMON /CONT1/ISET,NO,NMULT,NA,ICOUNT,NINPAR,NPARS,NINOBS,NANG,NTO
     1T,NPULT,NA1,IFU,IB,NONRIG,NS,ISIG,ISYM,ICORL,IFU1,N8,
     2  IEIG, IMAT, IOUT, IRECAL, IFREQ
      COMMON/CONT2/NP1,NNP1,IORIG,IWU,INOPAR
      COMMON/CONT3/ISOLV,NTOTS,CONSLV,SUMW,RWUDI,RMS,RMU,gof,sumsig,
     1  iscm,msd8
      COMMON/IAID1/ IAIDX1(1000)
      COMMON/IPAR/ NP(80)
      common/new/isigx,ETA, TK,I11, isigu,nafa(7),NONSY(7),AXMOM(7),
     1  NRBP(150),NCPD,NDAT,NESD, IBYP, IEXU, inegl
      real mult
C
      NAP1 = NA + 1
      IF(ISIG.EQ.0)  GO TO 20
      IF(I11.NE.0.AND.ISIG.LT.0)  GO TO 35
      IF(I11.EQ.0.AND.ISIGU.LT.0)  GO TO 35
C NEXT LINE COMMENTED OUT 24.II.87, ADJUSTED IN DO 10 LOOP BELOW)
C   UNTIL THIS CHANGE MADE, WU(I,K) = 0.0 BEYOND ASYM UNIT WHEN IWU = 1
C     IF(IWU.EQ.1)  GO TO 40
      KA = 1
      KB = NSIG
  110 DO 10 I = KA,KB
      DO 10 K = 1,6
      IF(IWU.EQ.1) GO TO 8
      WU(I,K) = 0.
      IF(SIGU(I,K).EQ.0.)  GO TO 10
      WU(I,K) = SUMSIG/SIGU(I,K)
C       SUMSIG IS THE MEAN ESD OF U, CALCULATED IN MAIN ROUTINE, STATE-
C          MENTS 145-175
      GO TO 10
    8 WU(I,K) = 1.0
   10 CONTINUE
      IF(KB.EQ.NTOT) GO TO 100
C     THE FIRST TIME THROUGH, KB = NSIG, WHICH EQUALS EITHER NA OR NTOT.
C        IF IT EQUALS NTOT ALL WU HAVE ALREADY BEEN CALCULATED FOR THE
C        UNIQUE ATOMS.  IF NSIG EQUALS NA (AND NA IS LESS THAN NTOT),
C        THERE ARE (NTOT - NA) STILL TO BE DONE BEFORE CONSIDERING THE
C        SYMMETRY-RELATED ATOMS.  NOTE THAT THOUGH IT NEEDS WU'S FOR
C        THE UNIQUE ATOMS ONLY FOR THE FIRST NA AS FAR AS THE NORMAL
C        EQUATIONS ARE CONCERNED, IT CHECKS WU IN THE CALCULATION OF
C        THE UCALC VALUES FROM THE RIGID-BODY PARAMETERS (IN CALCUS),
C        AND IT CALCULATES THEM FOR ALL NTOT ATOMS.
      IF(KB.EQ.NTOTS) RETURN
C     AFTER THE SECOND TIME THROUGH, KB WILL EQUAL NTOTS
   15 DO 5 I = NAP1,NTOT
      DO 5 K = 1,6
      SIGU(I,K) = 1.
      WU(I,K) = 1.
    5 CONTINUE
  100 IF(NO.EQ.1) RETURN
      KA = NTOT + 1
      KB = NTOTS
      GO TO 110
   20 DO 25 I = 1,NTOTS
      DO 25 K = 1,6
      WU(I,K) = 1.
   25 CONTINUE
      RETURN
   35 IF(NSIG.EQ.NA)  GO TO 60
   30 DO 55 I = 1,NTOT
      DO 55 K = 1,6
      WU(I,K) = SIGU(I,K)
   55 CONTINUE
      RETURN
   60 DO 65 I = NAP1,NTOT
      DO 65 K = 1,6
      SIGU(I,K) =  1.0
   65 CONTINUE
      GO TO 30
      END
C
      SUBROUTINE XASIGN
C ***   Modified 4.XII.92 to include Hg
C  WILL RECOGNIZE EITHER UPPER-CASE OR LOWER-CASE LETTERS
C  CALLED BY RDIN3, or by RD14A3, WHEN IFU1.EQ.0 (FIRST PASS-THROUGH FOR A 
C    GIVEN SET OF PARAMETERS).
C  ASSIGNS (WHEN NOT INCLUDED WITH INPUT) ATOMIC WEIGHTS AUTOMATICALLY
C    FOR FIRST 53 ELEMENTS AND D, W, Re, Os, Ir, Pt AND Hg, NOT INCLUDING
C    He, Ne, Ar, Kr and Tc.  FOR ALL OTHER ELEMENTS THE ATOMIC WEIGHT
C    MUST BE ASSIGNED EARLIER.  FURTHER, IF FOR ANY OF THESE ELEMENTS
C    THE ATOMIC WEIGHT INPUT IS 800., 999.9, OR NEGATIVE, THAT ELEMENT
C    WILL BE SKIPPED, SO THESE SPECIAL VALUES MAY BE INPUT FOR THEM.
C  If chem symbol of ith element is H or D, IHAT(i) is changed from 0 to 1
C *** 23.X.92  When IBYP is non-zero, this subroutine looks only at H and D
C ***     (to set IHAT) and will not assign any at wts.  All input at wts
C ***     will be changed so that all atoms have same wt (EXCEPT those of
C ***     weight 0.0, 800.0 and 999.9).
C *** Negative weights added to the exclusion EFM 9/29/98
C     ***************************************************
C  IF XASIGN DOES NOT RECOGNIZE AN ELEMENT, IT LEAVES THE INPUT VALUE OF
C    THE ATOMIC WEIGHT UNCHANGED.
C
C  THE FIRST NON-BLANK CHARACTERS IN THE ATOM NAME MUST BE THE CHEMICAL
C    SYMBOL FOR THE ELEMENT; THE PROGRAM EXAMINES THE FIRST FOUR COLUMNS
C    (SKIPPING BLANKS) AND LOOKS FOR THE STANDARD CHEMICAL ONE- OR TWO-
C    LETTER ELEMENTAL SYMBOL.
C  SETS AW NEGATIVE FOR ISOTROPIC ATOMS UNLESS INPUT AW = 800. OR 999.9
C
      COMMON//AIDX(3000)
      COMMON/ATPAR/X(150,3),WT(150),MULT(150),UOBS(150,6),SIGU(150,6),UC
     1ALC(150,6),NUORB(150),SIGB(150,6)
      COMMON /CONT1/ISET,NO,NMULT,NA,ICOUNT,NINPAR,NPARS,NINOBS,NANG,NTO
     1T,NPULT,NA1,IFU,IB,NONRIG,NS,ISIG,ISYM,ICORL,IFU1,N8,
     2  IEIG, IMAT, IOUT, IRECAL, IFREQ
      COMMON/CORDIN/ IRIDE, IMIN, IUNC, IHAT(150), NUNC(20),TUNC(20,3),
     1 TOR(3,3), XCG(3),IHPR
C     COMMON/CORDIC/ RIDA(20), RIDB(20), AMIN1(20), AMIN2(20),
C    1 UNC1(20), UNC2(20)
      COMMON/FORM/IFMX,IFMB,ILIST
C     COMMON/FORMC/FMSX(18),FMSB(18)
      COMMON/INOUTN/ NPAGE, KOUTP,  DIS, IAW
      COMMON/INOUTC/ NAME1, ATNAME(150),TISET(80),TITLE(80),ITBL(29),
     1 NAME2
      common/new/isigx,ETA, TK,I11, isigu,nafa(7),NONSY(7),AXMOM(7),
     1  NRBP(150),NCPD,NDAT,NESD, IBYP, IEXU, inegl
      DIMENSION ATXX(4),ASYM(21),NSYM(150),SSYM(15), ALPH(26),B22(150)
      DIMENSION ALCSYM(21), SLCSYM(15), ALPHLC(26)
      EQUIVALENCE  (AIDX(201), B22(1))
      CHARACTER*1 ATXX, BLK, ASYM, SSYM, ALPH, ALPHLC,SLCSYM, ALCSYM
      CHARACTER*4 NAME1,ATNAME,TISET*1,TITLE*1, ITBL*3,NAME2*5
      real mult
      DATA ALCSYM/'a','b','c','d','f','g','h','i','k','l','m','n','o',
     1   'p','s','t','v','z','r','w','y'/
      DATA   ASYM/'A','B','C','D','F','G','H','I','K','L','M','N','O',
     1   'P','S','T','V','Z','R','W','Y'/
      DATA   BLK/' '/
      DATA  ALPH/'A','B','C','D','E','F','G','H','I','J','K','L','M',
     1  'N','O','P','Q','R','S','T','U','V','W','X','Y','Z'/
      DATA ALPHLC/'a','b','c','d','e','f','g','h','i','j','k','l','m',
     1  'n','o','p','q','r','s','t','u','v','w','x','y','z'/
      DATA SSYM/'A','C','E','G','I','L','N','O','R','S','U','B','D',
     1  'H','T'/
      DATA SLCSYM/'a','c','e','g','i','l','n','o','r','s','u','b','d',
     1  'h','t'/
C
      N = 0
      NN = 0
      NISO = 0
      NSP = 0
      NB = 0
C  N = TALLY FOR ATOMS ASSIGNED ATOMIC WEIGHTS, NN FOR UNRECOGNIZED SYM-
C    BOLS (INCLUDING ALL BLANK), NB FOR ALL BLANK, NSP FOR SPECIAL INPUT
C    VALUES (800.0, 999.9, OR NEGATIVE), AND NISO FOR ISOTROPIC ATOMS
C    WHOSE WTS ARE SET NEGATIVE BY THIS SUBROUTINE
      IHPR = 0
C ***   IHPR ADDED 15.IV.87; SIGNALS PRESENCE OF ANY ANISO H OR D
      DO 9 I = 1,150
      NSYM(I) = 0
      IHAT(I) = 0
    9 CONTINUE
C ***  if IBYP non-zero, skip usual AtWt assignment
      if(IBYP.ne.0) go to 3500
      DO 3010 L = 1,NTOT
      IF(WT(L).EQ.800.0.OR.WT(L).EQ.999.9.OR.WT(L).LT.0.0) GO TO 2910
C  DO NOT ASSIGN WEIGHT IF IT ALREADY HAS A SPECIAL VALUE
      DO 3011 I=1,4
 3011  ATXX(I)=ATNAME(L)(I:I)
C   THE (I:I) IN PREV LINE EQUATES ATXX(I) WITH Ith CHARACTER OF ATNAME
C     (NOTE THAT ATXX IS CHARACTER*1, WHILE ATNAME IS CHARACTER*4)
      DO 2900 I = 1,4
      IF(ATXX(I).EQ.BLK) GO TO 2900
      II = I + 1
      DO 300 J = 1,21
      IF(ASYM(J).NE.ATXX(I).AND.ALCSYM(J).NE.ATXX(I)) GO TO 300
      GO TO (10,20,30,40,50,60,70,80,90,100,110,120,130,140,150,160,
     1   170,180,190,200,210) J
  300 CONTINUE
C *** IF HERE, THERE IS NO MATCH OF FIRST LETTER; UNRECOGNIZED ELEMENT
      GO TO 17
C *** FIRST LETTER IS A; ELEMENT IS AG, AL OR AS IF WT TO BE ASSIGNED.
   10 IF(I.EQ.4) GO TO 17
C ***  IF I = 4, A IS IN COLUMN 4 AND THERE IS NO SUCH ELEMENT
      IF(ATXX(II).NE.SSYM(4).AND.ATXX(II).NE.SLCSYM(4)) GO TO 12
      WT(L) = 107.87
      GO TO 2990
   12 IF(ATXX(II).NE.SSYM(6).AND.ATXX(II).NE.SLCSYM(6)) GO TO 14
      WT(L) = 26.98
      GO TO 2990
   14 IF(ATXX(II).NE.SSYM(10).AND.ATXX(II).NE.SLCSYM(10)) GO TO 17
      WT(L) = 74.92
      GO TO 2990
   17 NN = NN + 1
C *** SAVE SERIAL NUMBER OF UNRECOGNIZED ATOM FOR LATER PRINTING
      NSYM(NN) = L
      GO TO 3000
C ***  FIRST LETTER IS B; B OR BE OR BR, OR UNRECOGNIZED
   20 IF(I.EQ.4) GO TO 28
      IF(ATXX(II).NE.SSYM(3).AND.ATXX(II).NE.SLCSYM(3)) GO TO 23
      WT(L) = 9.01
      GO TO 2990
   23 IF(ATXX(II).NE.SSYM(9).AND.ATXX(II).NE.SLCSYM(9)) GO TO 26
      WT(L) = 79.9
      GO TO 2990
C *** ELEMENT IS NOT BE OR BR; EITHER B OR UNRECOGNIZED
   26 DO 27 LM = 1,26
      IF(ATXX(II).EQ.ALPH(LM).OR.ATXX(II).EQ.ALPHLC(LM)) GO TO 17
   27 CONTINUE
C *** ELEMENT IS BORON
   28 WT(L) = 10.81
      GO TO 2990
   30 IF(I.EQ.4) GO TO 39
      IF(ATXX(II).NE.SSYM(1).AND.ATXX(II).NE.SLCSYM(1)) GO TO 31
      WT(L) = 40.08
      GO TO 2990
   31 IF(ATXX(II).NE.SSYM(6).AND.ATXX(II).NE.SLCSYM(6)) GO TO 32
      WT(L) = 35.45
      GO TO 2990
   32 IF(ATXX(II).NE.SSYM(8).AND.ATXX(II).NE.SLCSYM(8)) GO TO 33
      WT(L) = 58.93
      GO TO 2990
   33 IF(ATXX(II).NE.SSYM(9).AND.ATXX(II).NE.SLCSYM(9)) GO TO 34
      WT(L) = 52.0
      GO TO 2990
   34 IF(ATXX(II).NE.SSYM(11).AND.ATXX(II).NE.SLCSYM(11)) GO TO 35
      WT(L) = 63.54
      GO TO 2990
   35 IF(ATXX(II).NE.SSYM(13).AND.ATXX(II).NE.SLCSYM(13)) GO TO 36
C     ELEMENT IS  Cd
      WT(L) = 112.40
      GO TO 2990
   36 DO 37 LM = 1,26
      IF(ATXX(II).EQ.ALPH(LM).OR.ATXX(II).EQ.ALPHLC(LM)) GO TO 17
   37 CONTINUE
C *** ELEMENT IS CARBON
   39 WT(L) = 12.01
      GO TO 2990
   40 IF(I.EQ.4) GO TO 43
      DO 42 LM = 1,26
      IF(ATXX(II).EQ.ALPH(LM).OR.ATXX(II).EQ.ALPHLC(LM)) GO TO 17
   42 CONTINUE
C *** FIRST LETTER IS D, NO SECOND LETTER IN COLS 2-4
   43 WT(L) = 2.01
      IHAT(L) = 1
      GO TO 2990
C *** FIRST LETTER IS F; ELEMENT F OR FE
   50 IF(I.EQ.4) GO TO 58
      IF(ATXX(II).NE.SSYM(3).AND.ATXX(II).NE.SLCSYM(3)) GO TO 55
      WT(L) = 55.85
      GO TO 2990
   55 DO 57 LM = 1,26
      IF(ATXX(II).EQ.ALPH(LM).OR.ATXX(II).EQ.ALPHLC(LM)) GO TO 17
   57 CONTINUE
C ***  FIRST LETTER F, NO SECOND LETTER IN COLUMNS 2-4
   58 WT(L) = 19.0
      GO TO 2990
   60 IF(I.EQ.4) GO TO 17
      IF(ATXX(II).NE.SSYM(1).AND.ATXX(II).NE.SLCSYM(1)) GO TO 63
      WT(L) = 69.72
      GO TO 2990
   63 IF(ATXX(II).NE.SSYM(3).AND.ATXX(II).NE.SLCSYM(3)) GO TO 17
      WT(L) = 72.59
      GO TO 2990
   70 IF(I.EQ.4) GO TO 76
      IF(ATXX(II).NE.SSYM(3).AND.ATXX(II).NE.SLCSYM(3)) GO TO 72
      WT(L) = 200.6
      GO TO 2990
   72 DO 74 LM = 1,26
      IF(ATXX(II).EQ.ALPH(LM).OR.ATXX(II).EQ.ALPHLC(LM)) GO TO 17
   74 CONTINUE
C *** FIRST LETTER IS H, NO SECOND LETTER IN COLS 2-4
   76 WT(L) = 1.01
      IHAT(L) = 1
      GO TO 2990
   80 IF(I.EQ.4) GO TO 88
      IF(ATXX(II).NE.SSYM(7).AND.ATXX(II).NE.SLCSYM(7)) GO TO 83
      WT(L) = 114.82
      GO TO 2990
   83 IF(ATXX(II).NE.SSYM(9).AND.ATXX(II).NE.SLCSYM(9)) GO TO 85
      WT(L) = 192.22
      GO TO 2990
   85 DO 87 LM = 1,26
      IF(ATXX(II).EQ.ALPH(LM).OR.ATXX(II).EQ.ALPHLC(LM)) GO TO 17
   87 CONTINUE
C *** FIRST LETTER IS I, NO SECOND LETTER IN COLS 2-4
   88 WT(L) = 126.9
      GO TO 2990
   90 IF(I.EQ.4) GO TO 93
      DO 92 LM = 1,26
      IF(ATXX(II).EQ.ALPH(LM).OR.ATXX(II).EQ.ALPHLC(LM)) GO TO 17
   92 CONTINUE
C *** FIRST LETTER IS K, NO SECOND LETTER IN COLS 2-4
   93 WT(L) = 39.1
      GO TO 2990
  100 IF(I.EQ.4) GO TO 17
      IF(ATXX(II).NE.SSYM(5).AND.ATXX(II).NE.SLCSYM(5)) GO TO 17
C *** FIRST LETTER IS L, SECOND IS I
      WT(L) = 6.94
      GO TO 2990
  110 IF(I.EQ.4) GO TO 17
C ***  FIRST LETTER IS M
      IF(ATXX(II).NE.SSYM(4).AND.ATXX(II).NE.SLCSYM(4)) GO TO 113
      WT(L) = 24.31
      GO TO 2990
  113 IF(ATXX(II).NE.SSYM(7).AND.ATXX(II).NE.SLCSYM(7)) GO TO 115
      WT(L) = 54.94
      GO TO 2990
  115 IF(ATXX(II).NE.SSYM(8).AND.ATXX(II).NE.SLCSYM(8)) GO TO 17
      WT(L) = 95.94
      GO TO 2990
  120 IF(I.EQ.4) GO TO 128
      IF(ATXX(II).NE.SSYM(1).AND.ATXX(II).NE.SLCSYM(1)) GO TO 123
      WT(L) = 22.99
      GO TO 2990
  123 IF(ATXX(II).NE.SSYM(5).AND.ATXX(II).NE.SLCSYM(5)) GO TO 125
      WT(L) = 58.71
      GO TO 2990
  125 IF(ATXX(II).NE.SSYM(12).AND.ATXX(II).NE.SLCSYM(12)) GO TO 126
      WT(L) = 92.91
      GO TO 2990
  126 DO 127 LM = 1,26
      IF(ATXX(II).EQ.ALPH(LM).OR.ATXX(II).EQ.ALPHLC(LM)) GO TO 17
  127 CONTINUE
C ***  FIRST LETTER IS N, NO SECOND LETTER IN COLS 2-4
  128 WT(L) = 14.01
      GO TO 2990
  130 IF(I.EQ.4) GO TO 133
      IF(ATXX(II).NE.SSYM(10).AND.ATXX(II).NE.SLCSYM(10)) GO TO 131
      WT(L) = 190.2
      GO TO 2990
  131 DO 132 LM = 1,26
      IF(ATXX(II).EQ.ALPH(LM).OR.ATXX(II).EQ.ALPHLC(LM)) GO TO 17
  132 CONTINUE
C *** FIRST LETTER IS O, NO SECOND LETTER IN COLS 2-4
  133 WT(L) = 16.00
      GO TO 2990
  140 IF(I.EQ.4) GO TO 148
      IF(ATXX(II).NE.SSYM(13).AND.ATXX(II).NE.SLCSYM(13)) GO TO 143
      WT(L) = 106.4
      GO TO 2990
  143 IF(ATXX(II).NE.SSYM(15).AND.ATXX(II).NE.SLCSYM(15)) GO TO 146
      WT(L) = 195.09
      GO TO 2990
  146 DO 147 LM = 1,26
      IF(ATXX(II).EQ.ALPH(LM).OR.ATXX(II).EQ.ALPHLC(LM)) GO TO 17
  147 CONTINUE
C *** FIRST LETTER IS P, NO SECOND LETTER IN COLS 2-4
  148 WT(L) = 30.97
      GO TO 2990
  150 IF(I.EQ.4) GO TO 159
      IF(ATXX(II).NE.SSYM(2).AND.ATXX(II).NE.SLCSYM(2)) GO TO 151
      WT(L) = 44.96
      GO TO 2990
  151 IF(ATXX(II).NE.SSYM(3).AND.ATXX(II).NE.SLCSYM(3)) GO TO 152
      WT(L) = 78.96
      GO TO 2990
  152 IF(ATXX(II).NE.SSYM(5).AND.ATXX(II).NE.SLCSYM(5)) GO TO 153
      WT(L) = 28.09
      GO TO 2990
  153 IF(ATXX(II).NE.SSYM(12).AND.ATXX(II).NE.SLCSYM(12)) GO TO 154
      WT(L) = 121.75
      GO TO 2990
  154 IF(ATXX(II).NE.SSYM(7).AND.ATXX(II).NE.SLCSYM(7)) GO TO 155
      WT(L) = 118.69
      GO TO 2990
  155 IF(ATXX(II).NE.SSYM(9).AND.ATXX(II).NE.SLCSYM(9)) GO TO 157
      WT(L) = 87.62
      GO TO 2990
C *** FIRST LETTER IS S, SECOND NOT C, E, I, B, N, OR R
  157 DO 158 LM = 1,26
      IF(ATXX(II).EQ.ALPH(LM).OR.ATXX(II).EQ.ALPHLC(LM)) GO TO 17
  158 CONTINUE
C *** NO SECOND LETTER IN COLS 2-4; ELEMENT IS SULFUR
  159 WT(L) = 32.06
      GO TO 2990
  160 IF(I.EQ.4) GO TO 17
      IF(ATXX(II).NE.SSYM(5).AND.ATXX(II).NE.SLCSYM(5)) GO TO 165
      WT(L) = 47.90
      GO TO 2990
  165 IF(ATXX(II).NE.SSYM(3).AND.ATXX(II).NE.SLCSYM(3)) GO TO 17
      WT(L) = 127.60
      GO TO 2990
  170 IF(I.EQ.4) GO TO 178
      DO 174 LM = 1,26
      IF(ATXX(II).EQ.ALPH(LM).OR.ATXX(II).EQ.ALPHLC(LM)) GO TO 17
  174 CONTINUE
C *** FIRST LETTER IS V, NO SECOND LETTER IN COLUMNS 2-4
  178 WT(L) = 50.94
      GO TO 2990
  180 IF(I.EQ.4) GO TO 17
      IF(ATXX(II).NE.SSYM(7).AND.ATXX(II).NE.SLCSYM(7)) GO TO 185
C *** FIRST LETTER IS Z, SECOND IS N
      WT(L) = 65.37
      GO TO 2990
  185 IF(ATXX(II).NE.SSYM(9).AND.ATXX(II).NE.SLCSYM(9)) GO TO 17
C *** FIRST LETTER IS Z, SECOND IS R
      WT(L) = 91.22
      GO TO 2990
  190 IF(I.EQ.4) GO TO 17
C ***  INITIAL LETTER IS  R
      IF(ATXX(II).NE.SSYM(12).AND.ATXX(II).NE.SLCSYM(12)) GO TO 192
      WT(L) = 85.47
      GO TO 2990
  192 IF(ATXX(II).NE.SSYM(3).AND.ATXX(II).NE.SLCSYM(3)) GO TO 194
      WT(L) = 186.21
      GO TO 2990
  194 IF(ATXX(II).NE.SSYM(14).AND.ATXX(II).NE.SLCSYM(14)) GO TO 196
      WT(L) = 102.91
      GO TO 2990
  196 IF(ATXX(II).NE.SSYM(11).AND.ATXX(II).NE.SLCSYM(11)) GO TO 17
      WT(L) = 101.07
      GO TO 2990
  200 IF(I.EQ.4) GO TO 204
      DO 202 LM = 1,26
      IF(ATXX(II).EQ.ALPH(LM).OR.ATXX(II).EQ.ALPHLC(LM)) GO TO 17
  202 CONTINUE
C *** FIRST LETTER IS W, NO SECOND LETTER IN COLUMNS 2-4
  204 WT(L) = 183.85
      GO TO 2990
  210 IF(I.EQ.4) GO TO 214
      DO 212 LM = 1,26
      IF(ATXX(II).EQ.ALPH(LM).OR.ATXX(II).EQ.ALPHLC(LM)) GO TO 17
  212 CONTINUE
C *** FIRST LETTER IS Y, NO SECOND LETTER IN COLUMNS 2-4
  214 WT(L) = 88.91
      GO TO 2990
 2900 CONTINUE
C ***  IF HERE, FOUR BLANKS AT START, UNRECOGNIZED ATOM
      NB = NB + 1
      NN = NN + 1
      NSYM(NN) = L
      GO TO 3000
 2910 NSP = NSP + 1
      IF(ABS(WT(L)).LT.2.2) IHAT(L) = 1
C ***  RECOGNIZE H OR D ON INPUT WHEN WT IS NEGATIVE AS WELL. NOTE THAT
C ***    ANY ATOM WITH WT -1. OR -2. WILL HENCE BE CONSIDERED H OR D BY
C ***    SUBROUTINE DISCOR, WHICH CHECKS "IHAT"
      GO TO 3010
C ***  TALLY ATOMS THAT HAVE BEEN ASSIGNED ATOMIC WEIGHTS
 2990 N = N + 1
C *** SET WEIGHT NEGATIVE FOR ISOTROPIC ATOMS
C ***        SET IHPR NON-ZERO IF ANISO H OR D PRESENT
 3000 IF(IB.LT.4) GO TO 3005
      IF(UOBS(L,2).NE.0.0.AND.IHAT(L).NE.0) IHPR = 1
      IF(UOBS(L,2).NE.0.0.OR.WT(L).LE.0.0) GO TO 3010
      NISO = NISO + 1
      WT(L) = -WT(L)
      GO TO 3010
 3005 IF(B22(L).NE.0.0.AND.IHAT(L).NE.0) IHPR = 1
      IF(B22(L).NE.0.0.OR.WT(L).LE.0.0) GO TO 3010
      NISO = NISO + 1
      WT(L) = - WT(L)
 3010 CONTINUE
C *** NOW PRINT NUMBERS OF ATOMS NOT ASSIGNED WTS HERE
      IF(NSP.EQ.0) GO TO 315
      WRITE(*,310) NSP
  310 FORMAT(' ',I4,' ATOMS HAD PREASSIGNED ATOMIC WTS OF 800.0, 999.9 O
     1R NEGATIVE')
  315 IF(NISO.EQ.0) GO TO 330
      WRITE(6,318) NISO
  318 FORMAT(' ',I4,' ISOTROPIC ATOMS HAD WEIGHTS MADE NEGATIVE')
  330 IF(NB.EQ.0) GO TO 350
      WRITE(*,320) NB
  320 FORMAT(' ',I4,' ATOMS HAD BLANK NAMES')
  350 IF(NN.EQ.0) GO TO 450
      DO 400 I = 1,150
      IF(NSYM(I).NE.0) GO TO 400
      KK = I
      GO TO 420
  400 CONTINUE
  420 IF(KK.EQ.1) GO TO 450
      K = KK - 1
      WRITE(*,430) NN
      WRITE(*,435) (NSYM(I), I = 1,K)
      write(*,436)
  430 FORMAT(' ','SERIAL NUMBERS OF THE',I4,' UNRECOGNIZED ATOMS THAT WE
     1RE NOT ASSIGNED ATOMIC WEIGHTS BY THIS PROGRAM ARE:',//)
  435 FORMAT(5X,20I6)
  436 format(10x,'(Atoms with weight 800., 999.9, or negative skipped.
     1  Isotropic atoms'/12x,'given negative weight later.)')
  450 WRITE(*,440) N
  440 FORMAT(' ',I4,'  ATOMS WERE ASSIGNED ATOMIC WEIGHTS')
      RETURN
 3500 NBY = 0
      do 3600, L = 1,ntot
C ***  here when IBYP.ne.0
C ***  leave wts of 0.0, 800., 999.9, but not neg wts, since neg wts
C ***     only signalled omission from inertial system
C *** Above comment is KNT, but EFM undid the decision about neg wts
C *** to match instructions; they say neg wts guarantee omission from
C *** the thermal motion analysis.  EFM change made 9/29/98
C *** EFM skipped isotropic atoms 1/4/99
      if(WT(L).LE.0.OR.WT(L).EQ.800.0.OR.WT(L).EQ.999.9) GO TO 3600
C *** skip neg wts, wts of 800 or 999.9
      if(UOBS(L,2).EQ.0.0) WT(L)=-WT(L)
      if(WT(L).LE.0) goto 3600
C *** in additiom, skip isotropic atoms with other weights,
C *** by making their weights negative; this is needed if the user
C *** uses unedited parameter files i.e. from SHELX (3/11/99)
      nby = nby + 1
      DO 3511 I=1,4
 3511  ATXX(I)=ATNAME(L)(I:I)
C   THE (I:I) IN PREV LINE EQUATES ATXX(I) WITH Ith CHARACTER OF ATNAME
C     (NOTE THAT ATXX IS CHARACTER*1, WHILE ATNAME IS CHARACTER*4)
      DO 3520 I = 1,4
      IF(ATXX(I).EQ.BLK) GO TO 3520
      IF(ATXX(I).NE.ASYM(4).and.ATXX(I).NE.ALCSYM(4)) go to 3515
      if(i.eq.4) go to 3510
C     KNT had j here instead of ii. Changed by EFM 12/10/98
      ii = i + 1
      DO 3512 LM = 1,26
      IF(ATXX(II).EQ.ALPH(LM).OR.ATXX(II).EQ.ALPHLC(LM)) GO TO 3515
 3512 CONTINUE
C ***   atom is D
 3510 IHAT(L) = 1
      GO TO 3520
 3515 IF(ATXX(I).NE.ASYM(7).AND.ATXX(I).NE.ALCSYM(7)) GO TO 3520
      IF(I.EQ.4) GO TO 3518
      J = I + 1
      DO 3517 LM = 1,26
      IF(ATXX(II).EQ.ALPH(LM).OR.ATXX(II).EQ.ALPHLC(LM)) GO TO 3520
 3517 CONTINUE
***          ATOM IS H
 3518 IHAT(L) = 1    
 3520 continue
      WT(L) = 10.0
 3600 CONTINUE
C ***   formerly printed NBY here (no of atoms assigned equal at wts)
      RETURN
      END
      SUBROUTINE MATNVV(A,N,NA,M,B,DETER)
C  DOUBLE-PRECISION VERSION OF MATINV, CALLED BY SOLVE
C    (CHANGES MADE BY KNT IN MATINV, JUNE 1984)
C     N = SIZE OF THE SQUARE MATRIX A AND VECTOR B
C        N MUST BE NO LARGER THAN NA, DIMENSION OF A AND B (LINE 40042)
C        NA, THE DIMENSION OF A AND B, IS DEFINED IN THE CALLING PROGRAM
C     M = 0  MATRIX INVERSION ONLY
C     M = 1 MATRIX INVERSION AND SOLUTION OF LINEAR EQUATION
C     B = RIGHT HAND SIDE OF SYSTEM OF LINEAR EQUATIONS
C   RESULTS:
C     A CONTAINS INVERTED MATRIX  A**-1
C     B CONTAINS SOLUTIONS
C     BB IS TEMPORARY DOUBLE-PRECISION VERSION OF B
C     DETERM = DETERMINANT
C     DETER = DETERM WHEN RETURNED TO SOLVE
C     IF DETERM = 0.0, IT MEANS THAT LARGEST AVAILABLE ELEMENT BECAME
C        0.0 AND NO RELIABLE RESULTS OBTAINED
C
      COMMON//AIDX(3000)
      COMMON/IAID1/IAIDX1(1000)
C     MATINV USES FOR MAX. DIMENSIONS OF MATRIX
C     COMMON// AIDX(801-880,1301-1540)  AND /IAID1/IAIDX1(360 - 439)
C     DUM = B   IN AIDX(801 - 880)
      DIMENSION IPIVOT(80), INDEX(80,2), PIVOT(80), BB(80)
      DIMENSION A(NA,NA),B(NA)
      EQUIVALENCE (IAIDX1(360),IPIVOT(1)),(AIDX(1381),INDEX(1,1))
      DOUBLE PRECISION  A,AMAX,AH,SWAP,PIVOT,DETERM,T,BB
C
C     INITIALIZATION
C
      DETERM=1.0
      DO 20 J=1,N
      BB(J) = B(J)
   20 IPIVOT(J)=0
      DO 550 I=1,N
C
C     SEARCH FOR PIVOT ELEMENT
      AMAX=0.0
      DO 105 J=1,N
      IF(IPIVOT(J).EQ.1)  GO TO 105
      DO 100 K = 1,N
      IF(IPIVOT(K).EQ.1)  GO TO 100
      IF(IPIVOT(K).GT.1)  GO TO 740
      AH = ABS(AMAX) - ABS(A(J,K))
      IF(AH.GE.0.)  GO TO 100
      IROW = J
      ICOLUM=K
      AMAX=A(J,K)
  100 CONTINUE
  105 CONTINUE
       IF (AMAX)110,800,110
  110 IPIVOT(ICOLUM)=IPIVOT(ICOLUM)+1
C
C     INTERCHANGE ROWS TO PUT PIVOT ELEMENT ON DIAGONAL
C
      IF (IROW-ICOLUM) 140, 260, 140
  140 DETERM=-DETERM
      DO 200 L=1,N
      SWAP=A(IROW,L)
      A(IROW,L)=A(ICOLUM,L)
  200 A(ICOLUM,L)=SWAP
      IF (M.EQ.0)  GO TO 260
      SWAP=BB(IROW)
      BB(IROW) = BB(ICOLUM)
      BB(ICOLUM) = SWAP
  260 INDEX(I,1)=IROW
      INDEX(I,2)=ICOLUM
      PIVOT(I)=A(ICOLUM,ICOLUM)
      DETERM=DETERM*PIVOT(I)
C
C     DIVIDE PIVOT ROW BY PIVOT ELEMENT
C
      A(ICOLUM,ICOLUM)=1.0
      DO 350 L=1,N
  350 A(ICOLUM,L)=A(ICOLUM,L)/PIVOT(I)
      IF (M.NE.0)  BB(ICOLUM) =BB(ICOLUM)/PIVOT(I)
C
C     REDUCE NON-PIVOT ROWS
C
      DO 550 L1=1,N
      IF(L1-ICOLUM) 400, 550, 400
  400 T=A(L1,ICOLUM)
      A(L1,ICOLUM)=0.0
      DO 450 L=1,N
  450 A(L1,L)=A(L1,L)-A(ICOLUM,L)*T
      IF (M.NE.0)  BB(L1) = BB(L1) - BB(ICOLUM)*T
  550 CONTINUE
C
C     INTERCHANGE COLUMNS
C
      DO 710 I=1,N
      L=N+1-I
      IF (INDEX(L,1)-INDEX(L,2)) 630, 710, 630
  630 JROW=INDEX(L,1)
      JCOLUM=INDEX(L,2)
      DO 705 K=1,N
      SWAP=A(K,JROW)
      A(K,JROW)=A(K,JCOLUM)
      A(K,JCOLUM)=SWAP
  705 CONTINUE
  710 CONTINUE
  740 DO 750 I = 1,N
      B(I) = BB(I)
  750 CONTINUE
      DETER = DETERM
      RETURN
  800 DETER=0.0
      RETURN
      END
C
      SUBROUTINE LOCAL(ILOC)
C ***  CALLED BY SOLVE and CALCUS WHENEVER ARGs ARE PRESENT
C ***    ILOC   is used for LABELLING OUTPUT
      COMMON/AIDPAR/AX(150,3),AUOBS(150,6),AUCALC(150,6),WU(150,6),
     1  WU1(150,6)
      COMMON//AIDX(3000)
      COMMON/CONT1/ISET,NO,NMULT,NA,ICOUNT,NINPAR,NPARS,NINOBS,NANG,NTOT
     1,NPULT,NA1,IFU,IB,NONRIG,NS,ISIG,ISYM,ICORL,IFU1,N8,
     2  IEIG, IMAT, IOUT, IRECAL, IFREQ
      COMMON/CONT3/ISOLV,NTOTS,CONSLV,SUMW,RWUDI,RMS,RMU,gof,sumsig,
     1  iscm,msd8
      COMMON/IAID1/ IAIDX1(1000)
      COMMON/INOUTN/ NPAGE, KOUTP,  DIS, IAW
      COMMON/INOUTC/ NAME1, ATNAME(150),TISET(80),TITLE(80),ITBL(29),
     1 NAME2
      COMMON/LOC/ VAF(7,3),PVEC(7,3),V5(7,3),VEC1(7,3)
      COMMON/LOCC/ATNX(7,2)
      common/locc_/BLLARG(7)
      common/new/isigx,ETA, TK,I11, isigu,nafa(7),NONSY(7),AXMOM(7),
     1  NRBP(150),NCPD,NDAT,NESD, IBYP, IEXU, inegl
      DIMENSION AO(80),IZ(5),IPAIR(7,7)
      DIMENSION  DEL(3),VH(3),VEC3(3), NAT(7,2)
      CHARACTER*4  ATNX
      CHARACTER*4 NAME1,ATNAME,TISET*1,TITLE*1, ITBL*3, NAME2*5
C ***
C ***  UNIT VECTORS FOR LOCAL AXIAL SYSTEM FOR EACH GROUP, I, WILL BE:
C ***     VEC1(I,J)   VECTOR PARALLEL TO LIBRATION AXIS (FROM DERNOP)
C ***     VAF(I,J)   VECTOR PARALLEL TO MOTION OF 1ST AFFECTED ATOM
C ***     PVEC(I,J)   UNIT VECTOR NORMAL TO FIRST TWO
      DO 800 I = 1,NTOT
      DO 800 J = 1,NONRIG
      DO 800 K = 1,2
      IF(ATNX(J,K).EQ.ATNAME(I))  NAT(J,K) = I
  800 CONTINUE
      DO 880 M =  1,NONRIG
      XL2 = 0.
      M1 = NAT(M,1)
      M2 = NAT(M,2)
C ***  M1,M2 ARE THUS SERIAL NOS, RESPECTIVELY, OF 2ND AXIS-DEFINING
C ***   ATOM (ATNX(I,1) IN RDIN4) AND FIRST ATOM AFFECTED BY MOTION OF
C ***   GROUP I (ATNX(I,2) IN RDIN4); CH SIGN DEL (40242), 30.XII.84
      DO 810 J = 1,3
      DEL(J) = AX(M2,J) - AX(M1,J)
      XL2 = XL2 + DEL(J)*DEL(J)
  810 CONTINUE
      XL2 = SQRT(XL2)
      DO 820 J = 1,3
      VH(J) = DEL(J)/XL2
  820 CONTINUE
      VEC3(1) = VEC1(M,2)*VH(3) - VEC1(M,3)*VH(2)
      VEC3(2) = VEC1(M,3)*VH(1) - VEC1(M,1)*VH(3)
      VEC3(3) = VEC1(M,1)*VH(2) - VEC1(M,2)*VH(1)
      SCVEC = 0.
      DO 830 J = 1,3
      SCVEC = SCVEC + VEC3(J)*VEC3(J)
  830 CONTINUE
      IF(SCVEC.NE.0) GO TO 835
      PRINT 838, ATNAME(M2), M
  838 FORMAT(' ','ATOM ',A4,' LIES ON AXIS FOR ARG NO.',
     1 I3,' ALTHOUGH SAID TO BE AFFECTED BY THE MOTION. STOP!')
      STOP
  835 SCVEC = SQRT(SCVEC)
      DO 840 J = 1,3
      VAF(M,J) = VEC3(J)/SCVEC
  840 CONTINUE
      VH(1) = VEC1(M,2)*VAF(M,3) - VEC1(M,3)*VAF(M,2)
      VH(2) = VEC1(M,3)*VAF(M,1) - VEC1(M,1)*VAF(M,3)
      VH(3) = VEC1(M,1)*VAF(M,2) - VEC1(M,2)*VAF(M,1)
      PV = 0.
      DO 850 J = 1,3
      PV = PV + VH(J)*VH(J)
  850 CONTINUE
      PV = SQRT(PV)
      DO 860 J = 1,3
      PVEC(M,J) = VH(J)/PV
  860 CONTINUE
  880 CONTINUE
C ***  NOW HAVE THE THREE UNIT VECTORS FOR EACH LOCAL SYSTEM
      if (isolv.ne.0.or.iexu.eq.1) return
      DO 900 I = 1,NONRIG
      PRINT 910,ILOC,I,(VEC1(I,J),J=1,3), (VAF(I,J),J=1,3),
     1   (PVEC(I,J),J=1,3)
  910 FORMAT(' ','FOR EQUIV. POSN.',I3,
     1 ', LOCAL REFERENCE SYSTEM VECTORS FOR GROUP',I2,' ARE:'/
     2       10X, 'PARALLEL TO LIBRATION AXIS:',20X,3F10.5/10X,
     3 'PARALLEL TO MOTION OF FIRST ATOM:',14X,3F10.5/10X,
     4 'NORMAL TO FIRST TWO AXES IN RT-HANDED SYSTEM:',2X,3F10.5)
  900 CONTINUE
  920 RETURN
      END
      BLOCK DATA
C        THIS SUBPROGRAM IS USED TO INITIALIZE DATA IN THE COMMON BLOCKS
C          'INOUTN' (VARIABLE 'ITBL') AND 'SYM' (VARIABLES 'SYMOP' AND
C          'EPSIJK'). THIS CAN BE DONE IN OTHER WAYS ON CDC MACHINES.
C             ALSO FOR INITIALIZING THE STANDARD INPUT FORMATS,
C             BUT THESE INOPERATIVE ON VAX SO ALL "COMMENTED" HERE.
      COMMON/INOUTN/ NPAGE, KOUTP,  DIS, IAW
      COMMON/INOUTC/ NAME1, ATNAME(150),TISET(80),TITLE(80),ITBL(29),
     1 NAME2
      COMMON/SYM/SYMOP(23,3,3),TMAT(3,3),RTMAT(3,3),EPSIJK(3,3,3),
     1 SYML(3)
      CHARACTER*4 NAME1,ATNAME,TISET*1,TITLE*1,ITBL*3,NAME2*5
C     COMMON/FORM/IFMX,IFMB,ILIST
C     COMMON/FORMC/ FMSX(18), FMSB(18)
C
C     DATA FMSX/'  (','3F8.','5,14','X,A4',',4X,','F5.1',',F5.','1)  ',
C    1 10*'    '/
C     DATA FMSB/' (6F','10.6',',I1)', 15*'    '/
C
      DATA EPSIJK/ 0., 0., 0., 0., 0.,-1., 0., 1., 0., 0., 0., 1., 0.,
     1 0., 0.,-1., 0., 0., 0.,-1., 0., 1., 0., 0., 0., 0., 0./
C
      DATA SYMOP/ 1., 1.,-1.,-1., 0., 0.,-1., 1., 1.,-1., 0., 0., 0.,
     1-1., 1., 0.,-1., 0., 0., 0., 0., 0., 0.,           0., 0., 0., 0.,
     2 1.,-1., 0., 1., 0.,-1., 1.,-1., 1.,-1., 1.,-1., 0., 1., 0., 0.,
     3 -.707106781,-1., 0.,       0., 0., 0., 0., 0., 0., 0., 0., 0.,
     4 0., 0., 0., 0., 0., 0., 0., 0., 0., 1., 1., -.707106781, 0.,-1.,
     5   0., 0., 0., 0., 1.,-1., 1., 0.,-1., 0.,-1., 1.,-1., 1.,-1., 1.,
     6 0., 0., 1., -.707106781, 0., 0.,-1.,     1.,-1., 1.,-1., 0., 0.,
     7 1.,-1.,-1., 1., 0., 0.,-1., 0., 0., 1.,-1., 0., 0.,  .707106781,
     8  .707106781, 0., 0.,      0., 0., 0., 0., 0., 0., 0., 0., 0., 0.,
     9 0., 0., 0., 0., 0., 0., 0., 1., 0., 0., -.707106781,-1., 0.,
     A       0., 0., 0., 0., 0., 0., 0., 0., 0., 0., 0., 0., 0., 0., 0.,
     B 0., 0., 1., 0., -.707106781, 1.,-1., 0.,0., 0., 0.,
     C 0., 0., 0., 0., 0., 0., 0., 0., 0., 0., 0., 0., 0., 0., 0., 1.,
     D -.707106781, 0., 0.,-1.,          1.,-1.,-1., 1.,-1.,-1.,-1.,-1.,
     E-1.,-1., 1., 1., 1., 1., 1., 1.,-1., 0., 0., 0., 0., 0., 0. /
C
      DATA  ITBL/'L11','L12','L13','L22','L23','L33','T11','T12','T13',
     1 'T22','T23','T33','S11','S12','S13','S21','S22','S23','S31','S32'
     2 ,'S33','0',' ','+','-',',','X','Y','Z'/
      END
C      
C ----- end of original code
C
      subroutine openf(ndat,nesd,i)
      common/cmdl_c/args(20)
      common/cmdl_i/iargs
      character*80 args,filename
      if(args(i) .eq. ' ') then
        write(*,'(/a/)')
     1 ' :: DataFileNames (prefixes) must be set on command line for "ne
     1w style" input !'
        call usage
        stop
      endif
      filename=args(i)(1:leng(args(i)))//'.par'
      open(ndat,file=filename,status='old',err=1)
      filename=args(i)(1:leng(args(i)))//'.sig'
      open(nesd,file=filename,status='old',err=1)
      return
1     write (*,'(a,a)') ' **** ERROR **** Cannot open ',filename 
      stop
      end

      subroutine openf1
      open(7,file='atoms.out')
      open(8,file='msd.out')
      end

      subroutine usage
        write(*,'(/a/a)')
     1 ' :: Command line syntax for "old style" input is : ',
     1 '       thma14 < InputFile  { > OutputFile }'
      write(*,'(/a/a)') 
     1 ' :: Command line syntax for "new style" input is : ',
     1 '       thma14 name1 name2 ... < InputFileName  { > OutputFileNam
     1e }'
        write(*,'(/a/a)')
     1' :: name1.par, name1.esd ... etc must exist in work directory',
     1' :: Order of names MUST follow that given in InputFile'
      end
C
C ---- these three routines use Salford Software specific calls
C
      subroutine date(dat)
      character*10 dat,edate@
      dat=edate@()
      end

      subroutine time(tim)
      character*8 time@,tim
      tim=time@()
      end

      subroutine cmdlin
      common/cmdl_c/args(20)
      common/cmdl_i/iargs
      character*80 arg_in,args,cmnam
      do i=1,20
        args(i)=' '
      enddo
      iargs=0
1     arg_in=cmnam()
      if(arg_in .eq. ' ') goto 2
      if(index(arg_in,'>') .ne. 0 .or. index(arg_in,'<') .ne. 0) goto 1
      iargs = iargs + 1
      if(iargs .gt. 20) then
        iargs = 20
        goto 2
      endif
      args(iargs) = arg_in
      goto 1
2     end
